unit uMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, CWindowThread, StdCtrls, ExtCtrls, ComCtrls, Spin;

type
  TMain = class(TForm)
    Button1: TButton;
    Panel1: TPanel;
    Button2: TButton;
    CheckBox1: TCheckBox;
    Memo1: TMemo;
    Label1: TLabel;
    Memo2: TMemo;
    Label2: TLabel;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    TrackBar1: TTrackBar;
    Label3: TLabel;
    TrackBar2: TTrackBar;
    Label4: TLabel;
    ComboBox1: TComboBox;
    Label5: TLabel;
    TrackBar3: TTrackBar;
    Label6: TLabel;
    Label7: TLabel;
    ComboBox2: TComboBox;
    CheckBox7: TCheckBox;
    Label8: TLabel;
    TrackBar4: TTrackBar;
    Button3: TButton;
    FontDialog1: TFontDialog;
    Bevel1: TBevel;
    Button4: TButton;
    Button5: TButton;
    FontDialog2: TFontDialog;
    FontDialog3: TFontDialog;
    ColorDialog1: TColorDialog;
    ColorDialog2: TColorDialog;
    Button6: TButton;
    Button7: TButton;
    SpinEdit1: TSpinEdit;
    Label9: TLabel;
    SpinEdit2: TSpinEdit;
    Label10: TLabel;
    Button8: TButton;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
    procedure Memo2Change(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure TrackBar3Change(Sender: TObject);
    procedure ComboBox2CloseUp(Sender: TObject);
    procedure ComboBox2Exit(Sender: TObject);
    procedure ComboBox2KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox2Select(Sender: TObject);
    procedure CheckBox7Click(Sender: TObject);
    procedure TrackBar4Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
    fCWT: TCWindowThread;
  public
    { Public declarations }
    procedure UpdateControls;
  end;

var
  Main: TMain;

implementation

{$R *.dfm}

procedure TMain.FormCreate(Sender: TObject);
begin
  FontDialog1.Font := Font;
  FontDialog2.Font := Font;
  FontDialog3.Font := Font;
  ComboBox1.Items.Clear;
  ComboBox1.Items.Add('pwtDefault');
  ComboBox1.Items.Add('pwtDesigned');
  ComboBox1.Items.Add('pwtTopLeft');
  ComboBox1.Items.Add('pwtBottomRight');
  fCWT := TCWindowThread.Create(self);
  UpdateControls;
end;

procedure TMain.Memo1Change(Sender: TObject);
begin
  fCWT.Text := Memo1.Text;
  UpdateControls;
end;

procedure TMain.Memo2Change(Sender: TObject);
begin
  fCWT.Caption := Memo2.Text;
  UpdateControls;
end;

procedure TMain.SpinEdit1Change(Sender: TObject);
begin
  fCWT.Width := SpinEdit1.Value;
  UpdateControls;
end;

procedure TMain.SpinEdit2Change(Sender: TObject);
begin
  fCWT.Height := SpinEdit2.Value;
  UpdateControls;
end;

procedure TMain.Timer1Timer(Sender: TObject);
begin
  if fCWT <> nil then
    UpdateControls;
end;

procedure TMain.TrackBar1Change(Sender: TObject);
begin
  fCWT.Percent := TrackBar1.Position;
  UpdateControls;
end;

procedure TMain.TrackBar2Change(Sender: TObject);
begin
  fCWT.Interval := TrackBar2.Position;
  UpdateControls;
end;

procedure TMain.TrackBar3Change(Sender: TObject);
begin
  fCWT.IconSize := TrackBar3.Position;
  UpdateControls;
end;

procedure TMain.TrackBar4Change(Sender: TObject);
begin
  fCWT.TotalTimeSec := TrackBar4.Position;
  UpdateControls;
end;

procedure TMain.Button1Click(Sender: TObject);
begin
  FreeAndNil(fCWT);
  UpdateControls;
end;

procedure TMain.Button2Click(Sender: TObject);
begin
  if fCWT = nil then
    fCWT := TCWindowThread.Create(self);
  UpdateControls;
end;

procedure TMain.Button3Click(Sender: TObject);
begin
  if FontDialog1.Execute then fCWT.CaptionFont := FontDialog1.Font;
  UpdateControls;
end;

procedure TMain.Button4Click(Sender: TObject);
begin
  if FontDialog2.Execute then fCWT.Font := FontDialog2.Font;
  UpdateControls;
end;

procedure TMain.Button5Click(Sender: TObject);
begin
  if FontDialog3.Execute then fCWT.TimerFont := FontDialog3.Font;
  UpdateControls;
end;

procedure TMain.Button6Click(Sender: TObject);
begin
  ColorDialog1.Color := fCWT.CaptionColor;
  if ColorDialog1.Execute then
    fCWT.CaptionColor := ColorDialog1.Color;
end;

procedure TMain.Button7Click(Sender: TObject);
begin
  ColorDialog2.Color := fCWT.Color;
  if ColorDialog2.Execute then
    fCWT.Color := ColorDialog2.Color;
end;

procedure TMain.Button8Click(Sender: TObject);
begin
  if fCWT = nil then
    fCWT := TCWindowThread.Create(self);
  fCWT.Canceled := False;
  UpdateControls;
  fCWT.StartTime := Now;
  fCWT.Enabled := True;
  fCWT.Visible := true;
  try
    Button8.Enabled := False;
    Application.ProcessMessages;
    while not fCWT.Canceled do
    begin
      Sleep(1000);
    end;
  finally
    Button8.Enabled := true;
    fCWT.Visible := False;
  end;
  UpdateControls;
end;

procedure TMain.CheckBox1Click(Sender: TObject);
begin
  fCWT.Visible := CheckBox1.Checked;
  fCWT.StartTime := NOW;
  UpdateControls;
end;

procedure TMain.CheckBox2Click(Sender: TObject);
begin
  fCWT.Enabled := CheckBox2.Checked;
  UpdateControls;
end;

procedure TMain.CheckBox3Click(Sender: TObject);
begin
  fCWT.AlphaShow := CheckBox3.Checked;
  UpdateControls;
end;

procedure TMain.CheckBox4Click(Sender: TObject);
begin
  fCWT.Ctl3d := CheckBox4.Checked;
  UpdateControls;
end;

procedure TMain.CheckBox5Click(Sender: TObject);
begin
  fCWT.UseSysFont := CheckBox5.Checked;
  UpdateControls;
end;

procedure TMain.CheckBox6Click(Sender: TObject);
begin
  fCWT.Canceled := CheckBox6.Checked;
  UpdateControls;
end;

procedure TMain.CheckBox7Click(Sender: TObject);
begin
  if CheckBox7.Checked then fCWT.Icon := Icon
                       else fCWT.Icon := nil;
  UpdateControls;
end;

procedure TMain.ComboBox1Change(Sender: TObject);
begin
  fCWT.Position := TPosWindowThread(ComboBox1.ItemIndex);
  UpdateControls;
end;

procedure TMain.ComboBox2CloseUp(Sender: TObject);
begin
  fCWT.IconResourceName := ComboBox2.Text;
  UpdateControls;
end;

procedure TMain.ComboBox2Exit(Sender: TObject);
begin
  fCWT.IconResourceName := ComboBox2.Text;
  UpdateControls;
end;

procedure TMain.ComboBox2KeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    fCWT.IconResourceName := ComboBox2.Text;
    UpdateControls;
    Key := #0;
  end;
end;

procedure TMain.ComboBox2Select(Sender: TObject);
begin
  fCWT.IconResourceName := ComboBox2.Text;
  UpdateControls;
end;

procedure TMain.UpdateControls;
var I: integer;
begin
  Button2.Enabled := fCWT = nil;
  Button1.Enabled := fCWT <> nil;
  Panel1.Enabled := fCWT <> nil;
  for I := 0 to Panel1.ControlCount - 1 do
  begin
    Panel1.Controls[I].Enabled := Panel1.Enabled;
  end;
  if fCWT <> nil then
  begin
    CheckBox1.Checked := fCWT.Visible;
    CheckBox2.Checked := fCWT.Enabled;
    CheckBox3.Checked := fCWT.AlphaShow;
    CheckBox4.Checked := fCWT.Ctl3d;
    CheckBox5.Checked := fCWT.UseSysFont;
    CheckBox6.Checked := fCWT.Canceled;
    TrackBar1.Position := fCWT.Percent;
    Label3.Caption := 'Percent: ' + inttostr(fCWT.Percent);
    TrackBar2.Position := fCWT.Interval;
    Label4.Caption := 'Interval: ' + inttostr(fCWT.Interval);
    TrackBar3.Position := fCWT.IconSize;
    Label6.Caption := 'IconSize: ' + inttostr(fCWT.IconSize);
    TrackBar4.Position := Round(fCWT.TotalTimeSec);
    Label8.Caption := 'TotalTimeSec: ' + Floattostr(fCWT.TotalTimeSec);

    CheckBox7.Checked := not fCWT.Icon.Empty;
    ComboBox2.Enabled := not CheckBox7.Checked;
    Label7.Enabled := not CheckBox7.Checked;

    if (fCWT.CaptionFont.Name = '') then
      Button3.ParentFont := True
    else
      Button3.Font := fCWT.CaptionFont;

    if (fCWT.Font.Name = '') then
      Button4.ParentFont := True
    else
      Button4.Font := fCWT.Font;

    if (fCWT.TimerFont.Name = '') then
      Button5.ParentFont := True
    else
      Button5.Font := fCWT.TimerFont;

    ComboBox1.ItemIndex := integer(fCWT.Position);
    ComboBox2.Text := fCWT.IconResourceName;
    Memo1.Text := fCWT.Text;
    Memo2.Text := fCWT.Caption;
    ComboBox1.ItemIndex := Integer(fCWT.Position);
    SpinEdit1.Value := fCWT.Width;
    SpinEdit2.Value := fCWT.Height;
  end;
end;

end.




