unit uMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ImgList, ImageListCep, StdCtrls, FormImageListCep, SpeedButtonCep,
  ActnList, ufImageIndex, ComCtrls, BitOp, Buttons;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ActionList1: TActionList;
    actExit: TAction;
    GroupBox1: TGroupBox;
    cbImageIndexNormal: TRadioButton;
    cbImageIndexPush: TRadioButton;
    cbImageIndexCheck: TRadioButton;
    cbImageIndexNormalHot: TRadioButton;
    cbImageIndexCheckDisable: TRadioButton;
    cbImageIndexDisable: TRadioButton;
    cbImageIndexCheckHot: TRadioButton;
    Label1: TLabel;
    cbDoubleBuffered: TCheckBox;
    GroupBox2: TGroupBox;
    TrackBar1: TTrackBar;
    Label2: TLabel;
    cbBorder: TComboBox;
    Label3: TLabel;
    cbButtonKind: TComboBox;
    Label4: TLabel;
    cAutoCheck: TCheckBox;
    cChecked: TCheckBox;
    cEnabled: TCheckBox;
    cTransparent: TCheckBox;
    cThemeEnabled: TCheckBox;
    mCaption: TMemo;
    tbSpacing: TTrackBar;
    Label5: TLabel;
    cbLayout: TComboBox;
    Label6: TLabel;
    cbStyle: TComboBox;
    Label7: TLabel;
    mMessages: TMemo;
    SpeedButton1: TSpeedButton;
    actOk: TAction;
    gbTImageListCep: TGroupBox;
    tbWidth: TTrackBar;
    tbHeight: TTrackBar;
    lWidth: TLabel;
    lHeight: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure actExitExecute(Sender: TObject);
    procedure IndexClick(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure cbDoubleBufferedClick(Sender: TObject);
    procedure controlChage(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure mCaptionChange(Sender: TObject);
    procedure Click(Sender: TObject);
    procedure Clicks(Sender: TObject);
    procedure DblClick(Sender: TObject);
    procedure DropDown(Sender: TObject);
    procedure HotChanged(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton1DblClick(Sender: TObject);
    procedure actOkExecute(Sender: TObject);
    procedure tbWidthChange(Sender: TObject);
    procedure tbHeightChange(Sender: TObject);
  private
    { Private declarations }
    fIMG: TImageListCep;
    fFormDlgSIL: TFormDlgSIL;
    fSpeedButtonCep1: TSpeedButtonCep;
    fSpeedButtonCep2: TSpeedButtonCep;
    fSpeedButtonCep3: TSpeedButtonCep;
    ffrmImageIndex: TfrmImageIndex;
    fControlUpdating: boolean;
    procedure UpdateImageIndex;
    procedure UpdateButton(Button: TSpeedButtonCep);
    procedure UpdateButtons;
    procedure UpdateControls;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure ImgChange(Sender: TObject);
    procedure ImageIndexChange(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{ TForm1 }

constructor TForm1.Create(AOwner: TComponent);
begin
  inherited;
  ffrmImageIndex := TfrmImageIndex.Create(GroupBox1);
  ffrmImageIndex.Name := 'ImageIndex';
  ffrmImageIndex.BorderStyle := bsNone;
  ffrmImageIndex.Align := alRight;
  ffrmImageIndex.Constraints.MinWidth := GroupBox1.ClientWidth - 155;
  ffrmImageIndex.Parent := GroupBox1;
  ffrmImageIndex.Visible := true;
  ffrmImageIndex.Width := ffrmImageIndex.Constraints.MinWidth;
  //ffrmImageIndex.actCancel.Visible := false;

  fSpeedButtonCep1 := TSpeedButtonCep.Create(self);
  fSpeedButtonCep1.Left := Button2.Left;
  fSpeedButtonCep1.Width := Button2.Width;
  fSpeedButtonCep1.Top := Label1.Top;
  fSpeedButtonCep1.Height := Button3.Height;
  fSpeedButtonCep1.Parent := self;
  fSpeedButtonCep1.Gliphs.ImageIndexNormalHot := 48;
  fSpeedButtonCep1.Gliphs.ImageIndexNormal := 44;
  fSpeedButtonCep1.Gliphs.ImageIndexPush := 46;
  fSpeedButtonCep1.Gliphs.ImageIndexDisable := 45;
  fSpeedButtonCep1.Gliphs.ImageIndexCheck := 47;
  fSpeedButtonCep1.Gliphs.ImageIndexCheckHot := 49;

  fSpeedButtonCep2 := TSpeedButtonCep.Create(self);
  fSpeedButtonCep2.Left := fSpeedButtonCep1.Left + 16;
  fSpeedButtonCep2.Width := Button2.Width - 16;
  fSpeedButtonCep2.Top := fSpeedButtonCep1.Top + 16;
  fSpeedButtonCep2.Height := Button3.Height;
  fSpeedButtonCep2.Action := actExit;
  fSpeedButtonCep2.Parent := self;
  fSpeedButtonCep1.BringToFront;

  fControlUpdating := true;
  try
    fSpeedButtonCep3 := TSpeedButtonCep.Create(self);
    fSpeedButtonCep3.Gliphs.ImageIndexNormalHot := 1;
    fSpeedButtonCep3.Left := fSpeedButtonCep2.Left + fSpeedButtonCep2.Width + 16;
    fSpeedButtonCep3.Width := SpeedButton1.Width;
    fSpeedButtonCep3.Top := Label1.Top;
    fSpeedButtonCep3.Height := SpeedButton1.Height;
    fSpeedButtonCep3.Caption := 'Some long name button';
    fSpeedButtonCep3.Parent := self;
    fSpeedButtonCep3.OnClick := Click;
    fSpeedButtonCep3.onClicks := Clicks;
    fSpeedButtonCep3.OnDblClick := DblClick;
    fSpeedButtonCep3.onHotChanged := HotChanged;

    tbSpacing.Position := fSpeedButtonCep3.Spacing;
    cbLayout.ItemIndex := integer(fSpeedButtonCep3.Layout);
    cbStyle.ItemIndex := integer(fSpeedButtonCep3.Style);
    tbSpacing.OnChange := mCaption.OnChange;
    mMessages.Text := '';
  finally
    fControlUpdating := False;
  end;
  UpdateControls;
end;

destructor TForm1.Destroy;
begin
  inherited;
end;

procedure TForm1.UpdateImageIndex;
begin
  ffrmImageIndex.onChange := nil;
  try
    ffrmImageIndex.ImageList := fIMG;
    if cbImageIndexNormal.Checked then
      ffrmImageIndex.ImageIndex := fSpeedButtonCep1.Gliphs.ImageIndexNormal
    else if cbImageIndexPush.Checked then
      ffrmImageIndex.ImageIndex := fSpeedButtonCep1.Gliphs.ImageIndexPush
    else if cbImageIndexCheck.Checked then
      ffrmImageIndex.ImageIndex := fSpeedButtonCep1.Gliphs.ImageIndexCheck
    else if cbImageIndexNormalHot.Checked then
      ffrmImageIndex.ImageIndex := fSpeedButtonCep1.Gliphs.ImageIndexNormalHot
    else if cbImageIndexCheckDisable.Checked then
      ffrmImageIndex.ImageIndex := fSpeedButtonCep1.Gliphs.ImageIndexCheckDisable
    else if cbImageIndexDisable.Checked then
      ffrmImageIndex.ImageIndex := fSpeedButtonCep1.Gliphs.ImageIndexDisable
    else if cbImageIndexCheckHot.Checked then
      ffrmImageIndex.ImageIndex := fSpeedButtonCep1.Gliphs.ImageIndexCheckHot;
  finally
    ffrmImageIndex.onChange := ImageIndexChange;
  end;
end;

procedure TForm1.ImageIndexChange(Sender: TObject);
begin
    if cbImageIndexNormal.Checked then
       fSpeedButtonCep1.Gliphs.ImageIndexNormal := ffrmImageIndex.ImageIndex
    else if cbImageIndexPush.Checked then
       fSpeedButtonCep1.Gliphs.ImageIndexPush := ffrmImageIndex.ImageIndex
    else if cbImageIndexCheck.Checked then
       fSpeedButtonCep1.Gliphs.ImageIndexCheck := ffrmImageIndex.ImageIndex
    else if cbImageIndexNormalHot.Checked then
       fSpeedButtonCep1.Gliphs.ImageIndexNormalHot := ffrmImageIndex.ImageIndex
    else if cbImageIndexCheckDisable.Checked then
       fSpeedButtonCep1.Gliphs.ImageIndexCheckDisable := ffrmImageIndex.ImageIndex
    else if cbImageIndexDisable.Checked then
       fSpeedButtonCep1.Gliphs.ImageIndexDisable := ffrmImageIndex.ImageIndex
    else if cbImageIndexCheckHot.Checked then
       fSpeedButtonCep1.Gliphs.ImageIndexCheckHot := ffrmImageIndex.ImageIndex;
end;


procedure TForm1.Button1Click(Sender: TObject);
var Pic: TPicture;
    B: TBitmap;
    i, N: integer;
begin
  if fIMG = nil then
  begin
    fIMG := TImageListCep.Create(self);
    fIMG.onChange := ImgChange;
    fIMG.Width := 32;
    fIMG.Height := 32;
    fIMG.ResourceNames.AddDefault;
    with TResourceName(fIMG.ResourceNames.Add) do
      Name := 'CEPEXPERTS';
    Pic := TPicture.Create;
    try
      try
        Pic.LoadFromFile(ExtractFileDir(ParamStr(0)) + '\REFRESHALL.bmp');
        N := Pic.Bitmap.Width div Pic.Bitmap.Height;
        fIMG.CustomImg.Width := Pic.Bitmap.Height;
        fIMG.CustomImg.Height := Pic.Bitmap.Height;
        B := TBitmap.Create;
        try
          B.Width := Pic.Bitmap.Height;
          B.Height := Pic.Bitmap.Height;
          B.Canvas.Brush.Color := clFuchsia;
          for i := 0 to N - 1 do
          begin
            B.Canvas.FillRect(Rect(0, 0, B.Width, B.Height));
            B.Canvas.CopyRect(Rect(0, 0, B.Width, B.Height),
                                       Pic.Bitmap.Canvas,
                                       Rect(I * B.Width, 0, (I + 1) * B.Width, B.Height));
            fIMG.CustomImg.AddMasked(B, clFuchsia);
          end;
        finally
          FreeAndNil(B);
        end;
      except
      end;
    finally
      FreeAndNil(Pic);
    end;
    fIMG.UpdateImages;
    UpdateImageIndex;
    ActionList1.Images := fIMG;
    SpeedButton1.Action := ActOk;
    SpeedButton1.OnClick := SpeedButton1Click;
    SpeedButton1.OnDblClick := SpeedButton1DblClick;
    fSpeedButtonCep2.Action := actExit;
    fSpeedButtonCep1.ImageList := fIMG;
    fSpeedButtonCep3.ImageList := fIMG;
    UpdateControls;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  FreeAndNil(fIMG);
  UpdateControls;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if fIMG <> nil then
  begin
    if fFormDlgSIL = nil then
      fFormDlgSIL := TFormDlgSIL.Create(self);
    fFormDlgSIL.ImageListCep := fIMG;
    fFormDlgSIL.ShowModal;
  end;
end;

procedure TForm1.ImgChange(Sender: TObject);
begin
  fSpeedButtonCep1.Width := fIMG.Width + 4;
  fSpeedButtonCep1.Height := fIMG.Height + 4;
end;

procedure TForm1.actExitExecute(Sender: TObject);
begin
  Close;
end;

procedure TForm1.IndexClick(Sender: TObject);
begin
  UpdateImageIndex;
end;

procedure TForm1.UpdateButtons;
begin
  if fControlUpdating then Exit;
  UpdateButton(fSpeedButtonCep1);
  UpdateButton(fSpeedButtonCep2);
  UpdateButton(fSpeedButtonCep3);
  fSpeedButtonCep3.Caption := mCaption.Text;
  fSpeedButtonCep3.Spacing := tbSpacing.Position;
  fSpeedButtonCep3.Layout := TButtonLayout(cbLayout.ItemIndex);
  fSpeedButtonCep3.Style := TCepButtonStyle(cbStyle.ItemIndex);
  SpeedButton1.Caption := mCaption.Text;
  SpeedButton1.Spacing := tbSpacing.Position;
  SpeedButton1.Down := cChecked.Checked;
  SpeedButton1.Enabled := cEnabled.Checked;
  SpeedButton1.Transparent := cTransparent.Checked;
  SpeedButton1.Layout := TButtonLayout(cbLayout.ItemIndex);
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  UpdateButtons;
end;

procedure TForm1.controlChage(Sender: TObject);
begin
  UpdateButtons;
  UpdateControls;
end;

procedure TForm1.cbDoubleBufferedClick(Sender: TObject);
begin
  DoubleBuffered := cbDoubleBuffered.Checked;
  ffrmImageIndex.DoubleBuffered := cbDoubleBuffered.Checked;
end;

procedure TForm1.UpdateButton(Button: TSpeedButtonCep);
begin
  if fControlUpdating then Exit;
  Button.Blend := TrackBar1.Position;
  Button.Border := TCepButtonBorder(cbBorder.ItemIndex);
  Button.ButtonKind := TCepButtonKind(cbButtonKind.ItemIndex);
  Button.AutoCheck := cAutoCheck.Checked;
  Button.Checked := cChecked.Checked;
  Button.Transparent := cTransparent.Checked;
  Button.Enabled := cEnabled.Checked;
  Button.ThemeEnabled := cThemeEnabled.Checked;
end;

procedure TForm1.UpdateControls;
begin
  if not fControlUpdating then
  begin
    fControlUpdating := True;
    try
      cbDoubleBuffered.Checked := DoubleBuffered;
      TrackBar1.Position := fSpeedButtonCep1.Blend;
      cbBorder.ItemIndex := integer(fSpeedButtonCep1.Border);
      cbButtonKind.ItemIndex := integer(fSpeedButtonCep1.ButtonKind);
      cAutoCheck.Checked := fSpeedButtonCep1.AutoCheck;
      cChecked.Checked := fSpeedButtonCep1.Checked;
      cEnabled.Checked := fSpeedButtonCep1.Enabled;
      cTransparent.Checked := fSpeedButtonCep1.Transparent;
      cThemeEnabled.Checked := fSpeedButtonCep1.ThemeEnabled;
      mCaption.Text := fSpeedButtonCep3.Caption;
      tbSpacing.Position := fSpeedButtonCep3.Spacing;
      gbTImageListCep.Enabled := fIMG <> nil;
      if fIMG <> nil then
      begin
        lWidth.Caption := Inttostr(fIMG.Width);
        lHeight.Caption := Inttostr(fIMG.Height);
        tbWidth.Position := fIMG.Width;
        tbHeight.Position := fIMG.Height;
      end;
    finally
      fControlUpdating := False;
    end;
  end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  ffrmImageIndex.Width := ffrmImageIndex.Constraints.MinWidth;
end;

procedure TForm1.mCaptionChange(Sender: TObject);
begin
  UpdateButtons;
  UpdateControls;
end;

procedure TForm1.Click(Sender: TObject);
begin
  mMessages.Lines.Add('onClick');
end;

procedure TForm1.Clicks(Sender: TObject);
begin
  mMessages.Lines.Add('onClicks');
end;

procedure TForm1.DblClick(Sender: TObject);
begin
  mMessages.Lines.Add('onDblClick');
end;

procedure TForm1.DropDown(Sender: TObject);
begin
  mMessages.Lines.Add('onDropDown');
end;

procedure TForm1.HotChanged(Sender: TObject);
begin
  mMessages.Lines.Add('onHotChanged');
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  mMessages.Lines.Add('onClick (standart)');
end;

procedure TForm1.SpeedButton1DblClick(Sender: TObject);
begin
  mMessages.Lines.Add('onDblClick (standart)');
end;

procedure TForm1.actOkExecute(Sender: TObject);
begin
  Invalidate;
end;

procedure TForm1.tbWidthChange(Sender: TObject);
begin
  if fIMG <> nil then fIMG.Width := tbWidth.Position;
  UpdateControls;
end;



procedure TForm1.tbHeightChange(Sender: TObject);
begin
  if fIMG <> nil then fIMG.Height := tbHeight.Position;
  UpdateControls;
end;

end.
