unit BitOp;
(*
 * Module:        a    
 *             c 32- 
 * Version:    2.2 (25.10.2008)
 * Author:      
 * Comments:         .
 *                    
 *              : roschinspb@mail.ru
 *             http://www.delphikingdom.com/asp/users.asp?ID=1271
 *             http://www.roschinspb.narod.ru
 *
 * Copyright:   2006, 2008 .
 *
 * Version:    2.2 (25.10.2008)
 * Realized:          Unicode
 *             . THasButtonBitmapHeader
 *
 * Version:    2.1 (18.09.2007)
 * Realized:      XP. .  ThemeEnabled   DrawBkTheme
 *               OnDrawBorder, OnDrawImage    .
 *               DrawBkTheme
 *)
interface
uses Windows, Classes, SysUtils, {$IFDEF VER130}{$ELSE}RTLConsts, {$ENDIF}
  Graphics,
  {$IFDEF VER130}{$ELSE}GraphUtil, {$ENDIF} //  5   GraphUtil
  GraphUtilEx,
  ImgList, Buttons;

resourcestring
  Errorpf32bit = '   32- ';
  ErrorInfo = '    ';
  NoApplication = '   Application';
const
  MaxButtons = 220; //    
  MinSize = 8; //  
  {$IFDEF VER130}
  SAssignError = 'Cannot assign a %s to a %s';
  WM_THEMECHANGED = $031A;
  {$ENDIF}
type
  TArrayColor = array[0..512] of TColor;
  PArrayColor = ^TArrayColor;
  TCepStateButton = (csbNormal, csbHot, csbPushed, csbDisabeled);
  TCepButtonBorderEx = (cbbNormal, cbbNoRigth, cbbNoLeft);
  TCepButtonBorder = (CepSingleBorder, CepFlatBorder, CepNoBorder, CepXPBorder);

//         
//Bit       
//P             .  P<>nil,
//             .
//BitInfo      .
procedure GetDib(Bit: TBitmap; var P: PArrayColor; var BitInfo: TBitmapInfo);
//      
//Bit       
//P             .  P<>nil,
//              
//BitInfo      .
procedure SetDib(Bit: TBitmap; var P: PArrayColor; var BitInfo: TBitmapInfo);
//     
function MixColor(C1, C2: TColor): TColor;
//   
procedure ColorToAlpha(var Dest; Color: TColor; Count: integer);
//    
procedure CopyAlphaColorNew(var Dest; var Source; SourceAlphaBlendValue: Byte; Count: integer; B: byte);

//         NumByte
//Source       .    32-
//          
//Dest        
//Count       
//NumByte     (0..3)     3.
procedure DwordToByte(Source: PArrayColor; Dest: PByteArray; Count: integer; NumByte: Byte);
//  . DwordToByte
procedure ByteToDword(Source: PByteArray; Dest: PArrayColor; Count: integer; NumByte: Byte);
//    (, ,  )
//PSource        
//PDest          
//Count        ( )
procedure BlurByteHor(PSource, PDest: PByteArray; Count: integer);
//    (, ,  )
//PSource        
//PDest          
//Count     
//Width     
procedure BlurByteVert(PSource, PDest: PByteArray; Count, Width: integer);

//    ""
//Source       
//BitInfoSource      
//TransparentColor  ,      
//           clNone,     
//CountBlur    (0   )
//AlphaBlendValue      (0    )
procedure BitmapToShadow(Source: PArrayColor;
  BitInfoSource: TBitmapInfo;
  TransparentColor: TColor;
  CountBlur: Byte = 1;
  AlphaBlendValue: Byte = 255);
//     c  
//Source       ,   .
//Dest         ,    .
//           32-  
//BitInfoSource, BitInfoDest  ,    
//X, Y         ,  .
//TransparentColor  ,      
//          b clNone,     
//AlphaBlendValue     (0    )
procedure CopyAlphaBitmap(Source, Dest: PArrayColor;
  BitInfoSource, BitInfoDest: TBitmapInfo;
  X, Y: integer;
  TransparentColor: TColor = clFuchsia;
  AlphaBlendValue: Byte = 255);
//     c   
//c   
//Source       ,   .
//Dest         ,    .
//           32-  
//BitInfoSource, BitInfoDest  ,    
//X, Y         ,  .
//TransparentColor  ,      
//          b clNone,     
//AlphaBlendValue     (0    )
//CountBlur    (0   )
//Offset      .
//           Offset<0,      (  RTL),
//             
procedure CopyShadowAlphaBitmap(Source, Dest: PArrayColor;
  BitInfoSource, BitInfoDest: TBitmapInfo;
  X, Y: integer;
  TransparentColor: TColor = clFuchsia;
  AlphaBlendValue: Byte = 255;
  CountBlur: Byte = 1;
  Offset: ShortInt = 1);
//  
//Dest         ,   
//           32-  
//Color    ,    
//Count       
procedure ColorToMonocrom(var Dest; Color: TColor; Count: integer);
//  .
//Dest         ,   
//           32-  
//Color    ,    
//Count       
procedure ColorToGray(var Dest; Color: TColor; Count: integer);
//   
//Dest         ,   
//BitInfoDest    
//Color    ,    
procedure ColorToDull(Dest: PArrayColor; BitInfoDest: TBitmapInfo; Color: DWORD);
//    
procedure DrawIcon(const Canvas: TCanvas; ARect: TRect; Icon: TIcon);
//     
procedure DrawDockCaption(const Canvas: TCanvas;
  CaptionRect: TRect;
  MarginLeft, MarginRight: integer;
  const Horizontal: boolean;
  Caption: string;
  const StartColor, EndColor, FontColor: TColor;
  const Focused: Boolean;
  const Icon: TIcon;
  const D: integer = 2);
procedure DrawPin(Canvas: TCanvas;
  ARect: TRect;
  Color: TColor;
  Pined: boolean);
// DrawBkTheme      Windows
function DrawBkTheme(DC: HDC; Rect: TRect; State: TCepStateButton; Flat, Checked: boolean;
  BorderEx: TCepButtonBorderEx;
  ClipRect: PRect = nil): boolean;

type
  ECepBitError = class(Exception)
  end;

  TRichImageList = class;

  //SelectedColor -   
  TOnDrawBorder = function(Sender: TRichImageList; Bitmap: TBitmap; ARect: TRect; var SelectedColor: TColor): boolean of object;
  TOnDrawImage = function(Sender: TRichImageList; Bitmap: TBitmap; ARect: TRect): boolean of object;

  //       
  TRichImageList = class(TGraphic)
  private
    fBuf: Pointer;
    fBlend: Byte;
    fOnDrawBorder: TOnDrawBorder;
    fOnDrawImage: TOnDrawImage;
    fDrawing: boolean;
    function GetBkColor: TColor;
    function GetBorder: TCepButtonBorder;
    function GetCaption: string;
    function GetChecked: boolean;
    function GetSelectedColor: TColor;
    function GetBorderColor: TColor;
    function GetEnabled: boolean;
    function GetHot: boolean;
    function GetImageList: TCustomImageList;
    function GetIndex: integer;
    function GetPushed: boolean;
    procedure SetBkColor(const Value: TColor);
    procedure SetBorder(const Value: TCepButtonBorder);
    procedure SetCaption(const Value: string);
    procedure SetChecked(const Value: boolean);
    procedure SetSelectedColor(const Value: TColor);
    procedure SetBorderColor(const Value: TColor);
    procedure SetEnabled(const Value: boolean);
    procedure SetHot(const Value: boolean);
    procedure SetImageList(const Value: TCustomImageList);
    procedure SetIndex(const Value: integer);
    procedure SetPushed(const Value: boolean);
    procedure SetBlend(const Value: Byte);
    function GetLayout: TButtonLayout;
    procedure SetLayout(const Value: TButtonLayout);
    function GetSpacing: byte;
    procedure SetSpacing(const Value: byte);
    procedure FlatBorder(ACanvas: TCanvas; R: TRect; Color: TColor; Push: boolean; Percent: integer = -1);
    function GetAdjusted: boolean;
    procedure SetAdjusted(const Value: boolean);
    procedure UpdateBitmap(var Bitmap: TBitmap; var ARect: TRect);
    procedure DrawText(ACanvas: TCanvas; var R: TRect; uFormat: Cardinal; Transparent: boolean);
    function GetThemeEnabled: boolean;
    procedure SetThemeEnabled(const Value: boolean);
    function GetCepButtonBorderEx: TCepButtonBorderEx;
    procedure SetCepButtonBorderEx(const Value: TCepButtonBorderEx);
  protected
    function GetEmpty: Boolean; override;
    function GetHeight: Integer; override;
    function GetPalette: HPALETTE; override;
    function GetTransparent: Boolean; override;
    function GetWidth: Integer; override;
    procedure SetHeight(Value: Integer); override;
    procedure SetPalette(Value: HPALETTE); override;
    procedure SetTransparent(Value: Boolean); override;
    procedure SetWidth(Value: Integer); override;
    function Equals(Graphic: TGraphic): Boolean; override;
    procedure Draw(ACanvas: TCanvas; const Rect: TRect); override;
    procedure GetRectIMG(ACanvas: TCanvas; var BitRect, TextRect: TRect); dynamic;
    function DoDrawBorder(Bitmap: TBitmap; ARect: TRect; var SelectedColor: TColor): boolean; virtual;
    function DoDrawImage(Bitmap: TBitmap; ARect: TRect): boolean; virtual;
  public
    constructor Create; override;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    procedure AssignTo(Dest: TPersistent); override;
    property Caption: string read GetCaption write SetCaption;
    property ImageList: TCustomImageList read GetImageList write SetImageList;
    property Index: integer read GetIndex write SetIndex;
    property Checked: boolean read GetChecked write SetChecked;
    property Hot: boolean read GetHot write SetHot;
    property Enabled: boolean read GetEnabled write SetEnabled;
    property Pushed: boolean read GetPushed write SetPushed;
    property Adjusted: boolean read GetAdjusted write SetAdjusted;
    property BorderColor: TColor read GetBorderColor write SetBorderColor;
    property SelectedColor: TColor read GetSelectedColor write SetSelectedColor;
    property BkColor: TColor read GetBkColor write SetBkColor;
    property Border: TCepButtonBorder read GetBorder write SetBorder;
    property Blend: Byte read fBlend write SetBlend;
    property Layout: TButtonLayout read GetLayout write SetLayout;
    property Spacing: byte read GetSpacing write SetSpacing;
    // ,     
    // XP,     CepSingleBorder  CepFlatBorder
    property ThemeEnabled: boolean read GetThemeEnabled write SetThemeEnabled;
    //  XP.     CepFlatBorder  
    //    XP
    property CepButtonBorderEx: TCepButtonBorderEx read GetCepButtonBorderEx write SetCepButtonBorderEx;
    //   True,    Windows XP.
    // :  ThemeEnabled    .
    //       , ..   ,
    //            
    function IsTheme: boolean;
    function DrawBorder(var Bitmap: TBitmap; ARect: TRect): TColor;
    procedure DrawImage(var Bitmap: TBitmap; var ARect: TRect);
    procedure DrawAll(var Bitmap: TBitmap; Font: TFont; ARect: TRect);
    procedure LoadFromStream(Stream: TStream); override;
    procedure SaveToStream(Stream: TStream); override;
    procedure LoadFromClipboardFormat(AFormat: Word; AData: THandle;
      APalette: HPALETTE); override;
    procedure SaveToClipboardFormat(var AFormat: Word; var AData: THandle;
      var APalette: HPALETTE); override;

    property OnDrawBorder: TOnDrawBorder read fOnDrawBorder write fOnDrawBorder;
    property OnDrawImage: TOnDrawImage read fOnDrawImage write fOnDrawImage;
  end;

//    
procedure ClearHasButtonBitmap;
//       XP (   )
function UnloadThemeLib: boolean;
//     WM_THEMECHANGED
function HookThemeChanged: boolean;

implementation
uses Messages, Forms;

//         XP
type
  TThemedElement = (
    teButton,
    teExplorerBar,
    teTaskBand,
    teTaskBar,
    teToolBar,
    teWindow
    );

const
  ThemeDataNames: array[TThemedElement] of PWideChar = (
    'button', // teButton
    'explorerbar', // teExplorerBar
    'taskband', // teTaskBand
    'taskbar', // teTaskBar
    'toolbar', // teToolBar
    'window' // teWindow
    );

var
  OpenThemeData: function(hwnd: HWND; pszClassList: LPCWSTR): THandle; stdcall;
  CloseThemeData: function(hTheme: THandle): HRESULT; stdcall;
  DrawThemeBackground: function(hTheme: THandle; hdc: HDC; iPartId, iStateId: Integer;
    const pRect: TRect; pClipRect: PRECT): HRESULT; stdcall;
  IsThemeActive: function: BOOL; stdcall;
  ThemesAvailable: boolean;
  ThemeLibrary: THandle;
  _ThemeData: array[TThemedElement] of THandle;
  HookObject: TObject;

procedure InitThemeInfo;
var T: TThemedElement;
begin
  OpenThemeData := nil;
  CloseThemeData := nil;
  DrawThemeBackground := nil;
  IsThemeActive := nil;
  ThemeLibrary := 0;
  ThemesAvailable := false;
  for T := Low(TThemedElement) to High(TThemedElement) do
    _ThemeData[T] := 0;
end;

function LoadThemeLib: boolean;
begin
  if (not ThemesAvailable) then
  begin
    ThemesAvailable := true;
    if (ThemeLibrary = 0) and
      (Win32Platform = VER_PLATFORM_WIN32_NT) and
      (((Win32MajorVersion = 5) and (Win32MinorVersion >= 1)) or (Win32MajorVersion > 5)) then
    begin
      ThemeLibrary := LoadLibrary('uxtheme.dll');
      if ThemeLibrary > 0 then
      begin
        OpenThemeData := GetProcAddress(ThemeLibrary, 'OpenThemeData');
        CloseThemeData := GetProcAddress(ThemeLibrary, 'CloseThemeData');
        DrawThemeBackground := GetProcAddress(ThemeLibrary, 'DrawThemeBackground');
        IsThemeActive := GetProcAddress(ThemeLibrary, 'IsThemeActive');
        if (@OpenThemeData <> nil) and
          (@CloseThemeData <> nil) and
          (@DrawThemeBackground <> nil) and
          (@IsThemeActive <> nil) then
        begin
          _ThemeData[teButton] := OpenThemeData(0, ThemeDataNames[teButton]);
        end;
      end;
    end;
    if _ThemeData[teButton] = 0 then
    begin
      UnloadThemeLib;
      ThemesAvailable := true;
    end;
  end;
  result := ThemeLibrary <> 0;
end;

function UnloadThemeLib: boolean;
begin
  result := false;
  if ThemeLibrary > 0 then
  begin
    if FreeLibrary(ThemeLibrary) then
    begin
      result := true;
      InitThemeInfo;
    end
    else
      RaiseLastOsError;
  end
  else
    InitThemeInfo;
end;

function ThemeData(Element: TThemedElement): THandle;
begin
  result := _ThemeData[Element];
  if (Result = 0) and LoadThemeLib then
  begin
    if _ThemeData[Element] = 0 then
      _ThemeData[Element] := OpenThemeData(0, ThemeDataNames[Element]);
    result := _ThemeData[Element];
  end;
end;

const
  BP_PUSHBUTTON = 1;
  PBS_NORMAL = 1;
  PBS_HOT = 2;
  PBS_PRESSED = 3;
  PBS_DISABLED = 4;
  PBS_DEFAULTED = 5;
  TP_BUTTON = 1;
  TP_DROPDOWNBUTTON = 2;
  TP_SPLITBUTTON = 3;
  TP_SPLITBUTTONDROPDOWN = 4;
  TP_SEPARATOR = 5;
  TP_SEPARATORVERT = 6;

  TS_NORMAL = 1;
  TS_HOT = 2;
  TS_PRESSED = 3;
  TS_DISABLED = 4;
  TS_CHECKED = 5;
  TS_HOTCHECKED = 6;
  { For Windows >= Vista }
  TS_NEARHOT = 7;
  TS_OTHERSIDEHOT = 8;

function DrawBkTheme(DC: HDC; Rect: TRect; State: TCepStateButton; Flat, Checked: boolean;
  BorderEx: TCepButtonBorderEx;
  ClipRect: PRect = nil): boolean;
const
  Parts: array[boolean, TCepButtonBorderEx] of integer =
  ((BP_PUSHBUTTON, BP_PUSHBUTTON, BP_PUSHBUTTON),
    (TP_BUTTON, TP_SPLITBUTTON, TP_SPLITBUTTONDROPDOWN));
  States: array[boolean, boolean, TCepStateButton] of integer =
  (((PBS_NORMAL, PBS_HOT, PBS_PRESSED, PBS_DISABLED),
    (TS_NORMAL, TS_HOT, TS_PRESSED, TS_DISABLED)),
    ((PBS_PRESSED, PBS_PRESSED, PBS_PRESSED, PBS_DISABLED),
    (TS_CHECKED, TS_HOTCHECKED, TS_PRESSED, TS_DISABLED)));
var H: THandle;
  RGN: HRGN;
  F: DWORD;
  Brush: HBrush;
  R: TRect;
begin
  result := DC <> 0;
  if result then
  begin
    if Flat then
      H := ThemeData(teToolBar)
    else
      H := ThemeData(teButton);
    result := H <> 0;
    if result then
    begin // 
      RGN := 0;
      if BorderEx = cbbNoLeft then
      begin
        RGN := CreateRectRgn(0, 0, 1, 1);
        DrawThemeBackground(H, DC, Parts[Flat, cbbNormal], States[Checked, Flat, State], Rect, ClipRect);
        GetClipRgn(DC, RGN);
        ExcludeClipRect(DC, Rect.Left + 2, Rect.Top + 3, Rect.Bottom - 3, Rect.Right - 3);
      end;
      result := DrawThemeBackground(H, DC, Parts[Flat, BorderEx], States[Checked, Flat, State], Rect, ClipRect) = S_OK;
      if RGN <> 0 then
      begin
        SelectClipRgn(DC, RGN);
        DeleteObject(RGN);
      end;
    end
    else
    begin //  
      if Flat and (State in [csbNormal, csbDisabeled]) and (not Checked) then exit;
      R := Rect;
      if Flat then
        inflateRect(R, -1, -1)
      else
        inflateRect(R, -2, -2);
      if Checked then
        Brush := CreateSolidBrush(ColorToRGB(cl3DLight))
      else
        Brush := CreateSolidBrush(ColorToRGB(clBtnFace));
      FillRect(DC, R, Brush);
      DeleteObject(Brush);
      if Checked or (State = csbPushed) then
      begin
        if Flat then
          F := BDR_SUNKENINNER
        else
          F := EDGE_SUNKEN;
      end
      else
      begin
        if Flat then
          F := BDR_RAISEDINNER
        else
          F := EDGE_RAISED;
      end;
      DrawEdge(DC, Rect, F, BF_RECT or BF_SOFT)
    end;
  end;
end;

function CheckBitInfo(BitInfo: TBitmapInfo; ShowError: boolean = true): boolean;
begin
  result := (BitInfo.bmiHeader.biSize >= sizeof(TBitmapInfoHeader)) and
    (BitInfo.bmiHeader.biPlanes = 1);
  if result then
  begin
    result := (BitInfo.bmiHeader.biBitCount = 32);
    if result then
    begin
      result := (BitInfo.bmiHeader.biWidth > 0) and
        (BitInfo.bmiHeader.biHeight > 0);
    end
    else if ShowError then
      raise ECepBitError.Create(Errorpf32bit);
  end
  else if ShowError then
    raise ECepBitError.Create(ErrorInfo);
end;

procedure GetDib(Bit: TBitmap; var P: PArrayColor; var BitInfo: TBitmapInfo);
var N: integer;
begin
  reallocMem(P, 0);
  if Bit.PixelFormat <> pf32Bit then raise ECepBitError.Create(Errorpf32bit);
  N := Bit.Height * Bit.Width;
  ReallocMem(P, SizeOf(P[0]) * N);
  FillChar(P^, SizeOf(P[0]) * N, 0);
  FillChar(BitInfo, SizeOf(BitInfo), 0);
  BitInfo.bmiHeader.biSize := sizeof(TBitmapInfoHeader);
  BitInfo.bmiHeader.biWidth := Bit.Width;
  BitInfo.bmiHeader.biHeight := Bit.Height;
  BitInfo.bmiHeader.biPlanes := 1;
  BitInfo.bmiHeader.biBitCount := 32;
  GetDIBits(Bit.Canvas.Handle, Bit.Handle, 0, Bit.Height, P, BitInfo, DIB_RGB_COLORS);
end;

procedure SetDib(Bit: TBitmap; var P: PArrayColor; var BitInfo: TBitmapInfo);
begin
  try
    if P <> nil then
    begin
      if Bit.PixelFormat <> pf32Bit then raise ECepBitError.Create(Errorpf32bit);
      Bit.Height := BitInfo.bmiHeader.biHeight;
      Bit.Width := BitInfo.bmiHeader.biWidth;
      SetDIBits(Bit.Canvas.Handle, Bit.Handle, 0, Bit.Height, P, BitInfo, DIB_RGB_COLORS);
    end;
  finally
    ReallocMem(P, 0);
    FillChar(BitInfo, SizeOf(BitInfo), 0);
  end;
end;

//     

function MixColor(C1, C2: TColor): TColor;
var H1, L1, S1, H2, L2, S2: Word;
begin
  {if C1=clNone then result:=C2
  else if C2=clNone then result:=C1
  else begin
      ColorRGBToHLS(ColorToRGB(C1),H1,L1,S1);
      ColorRGBToHLS(ColorToRGB(C2),H2,L2,S2);
      H1:=(H1+H2+1)div(2);
      L1:=(L1+L2+1)div(2);
      S1:=(S1+S2+1)div(2);
      result:=ColorHLSToRGB(H1,L1,S1);
  end;}
  if C1 = clDefault then
    result := ColortoRGB(C2)
  else if C2 = clDefault then
    result := ColorToRGB(C1)
  else
  begin
    C1 := ColorToRGB(C1);
    C2 := ColorToRGB(C2);
    H1 := (C1) and ($000000FF);
    L1 := (C1 shr 8) and ($000000FF);
    S1 := (C1 shr 16) and ($000000FF);
    H2 := (C2) and ($000000FF);
    L2 := (C2 shr 8) and ($000000FF);
    S2 := (C2 shr 16) and ($000000FF);
    H1 := (H1 + H2 + 1) div (2);
    L1 := (L1 + L2 + 1) div (2);
    S1 := (S1 + S2 + 1) div (2);
    result := (H1) or (L1 shl 8) or (S1 shl 16);
  end;
end;

//   
//    Color,      ,
//    

procedure ColorToAlpha(var Dest; Color: TColor; Count: integer);
  assembler;
asm
 cmp    eAx,0
 je     @NoParam
 cmp    eCx,0
 jle    @NoParam
 Push   eDi;
 Push   eSi;
 Push   eAx
 Push   eBx;
 Push   eCx;
 Push   eDx;
 mov    eDi,eAx;
 And    eDx,$00FFffFF
 @Cikl:
  mov   eAx,DS:eDi
  mov   eBx,eAx
  and   eAx,$00FFffFF
  cmp   eAx,eDx
  je    @Mask
//   or    eAx,$FF000000
//   mov   DS:eDi,eAx
  @M:
  add   eDi,4
  dec   eCx
  jA    @Cikl
  jmp   @Ends
 @Mask:
  xor   eBx,eBx
  //and   eBx,$FF000000
  mov   DS:eDi,eBx
  add   eDi,4
  dec   eCx
  jA    @Cikl
@Ends:
 Pop   eDx;
 Pop   eCx;
 Pop   eBx;
 pop   eAx;
 pop   eSi;
 pop   eDi;
@NoParam:
end;

var Blur1: PByteArray;
  Blur2: PByteArray;
  SizeBlurBuff: integer;
  Shadow: PArrayColor;
  SizeShadowBuff: integer;
  TransparentBuff: PArrayColor;
  SizeTransparentBuff: integer;
  SourceChanelBuff, DestChanelBuff: PByteArray;
  SizeChanelBuff: integer;

// B = 2, :     255
// B = 1, :      0,     ,
//                                                                  
// B = 0, :      0,      ,
//                                                                 

procedure CopyAlphaColorNew(var Dest; var Source; SourceAlphaBlendValue: Byte; Count: integer; B: byte);
var SizeChanel, i: integer;
  procedure SrsAmuldiv(var Source; SourceAlphaBlendValue: Byte; Count: integer; var Dest);
    assembler;
  asm
    Push   eDi;
    Push   eSi;
    Push   eAx
    Push   eBx;
    Push   eCx;
    Push   eDx;
    mov    eSi, eAx
    mov    eDi, Dest
    xor    eBx,eBx
    mov    Bl,Dl
   @CIKL:
     xor    eAx,eAx
     mov    Al, Ds:eSi
     xor    eDx,eDx
     mul    Bl
     add    Ax,254
     shr    Ax,8
     mov    Ds:eSi,Al
     mov    Ah, 255
     sub    Ah,Al
     mov    Ds:eDi, Ah
     inc    eSi
     inc    eDi
     DEC    eCx
     je    @ENDS
     xor    eAx,eAx
     mov    Al, Ds:eSi
     xor    eDx,eDx
     mul    Bl
     add    Ax,254
     shr    Ax,8
     mov    Ds:eSi,Al
     mov    Ah, 255
     sub    Ah,Al
     mov    Ds:eDi, Ah
     inc    eSi
     inc    eDi
     DEC    eCx
     je    @ENDS
     xor    eAx,eAx
     mov    Al, Ds:eSi
     xor    eDx,eDx
     mul    Bl
     add    Ax,254
     shr    Ax,8
     mov    Ds:eSi,Al
     mov    Ah, 255
     sub    Ah,Al
     mov    Ds:eDi, Ah
     inc    eSi
     inc    eDi
     DEC    eCx
     jne    @CIKL
   @ENDS:
    Pop   eDx;
    Pop   eCx;
    Pop   eBx;
    pop   eAx;
    pop   eSi;
    pop   eDi;
  end;
  procedure SrsRGBmuldiv(var Source; Count: integer);
    assembler;
  asm
    Push   eDi;
    Push   eSi;
    Push   eAx
    Push   eBx;
    Push   eCx;
    Push   eDx;
    mov    eSi, eAx  //eSi - Source
    mov    eCx, eDx  //eCx - Count
    add    eAx, eDx
    mov    eBx, eAx  //eBx - Source + Count
    add    eAx, eDx
    mov    eDi, eAx  //eDi - Source + 2Count
    add    eDi, eDx  //eDi - Source + 3Count
    mov    eDx, eAx  //eDx - Source + 2Count

    xor    eAx,eAx
   @CIKL:
    mov    Al, DS:[eSi]
    mul    byte ptr DS:[eDi]
    add    Ax,254
    shr    eAx,8
    mov    DS:[eSi], Al

    mov    Al, DS:[eBx]
    mul    byte ptr DS:[eDi]
    add    Ax,254
    shr    eAx,8
    mov    DS:[eBx], Al

    mov    Al, DS:[eDx]
    mul    byte ptr DS:[eDi]
    add    Ax,254
    shr    eAx,8
    mov    DS:[eDx], Al

    inc    eSi
    inc    eBx
    inc    eDx
    inc    eDi
    dec    eCx
    jne    @CIKL
   @ENDS:
    Pop   eDx;
    Pop   eCx;
    Pop   eBx;
    pop   eAx;
    pop   eSi;
    pop   eDi;
  end;
  procedure Added(var Source; var Dest; Count: integer);
    assembler;
  asm
    Push   eDi;
    Push   eSi;
    Push   eAx
    Push   eBx;
    Push   eCx;
    Push   eDx;
    mov    eSi, eAx
    mov    eDi, eDx

   @CIKL:
      mov    Al, DS:[eSi]
      add    Al, DS:[eDi]
      JNC    @M1
      mov    Al, 255
    @M1:  mov    DS:[eDi], Al
      inc    eSi
      inc    eDi

      mov    Al, DS:[eSi]
      add    Al, DS:[eDi]
      JNC    @M2
      mov    Al, 255
    @M2:  mov    DS:[eDi], Al
      inc    eSi
      inc    eDi

      mov    Al, DS:[eSi]
      add    Al, DS:[eDi]
      JNC    @M3
      mov    Al, 255
    @M3:  mov    DS:[eDi], Al
      inc    eSi
      inc    eDi

      mov    Al, DS:[eSi]
      add    Al, DS:[eDi]
      JNC    @M4
      mov    Al, 255
    @M4:  mov    DS:[eDi], Al
      inc    eSi
      inc    eDi

      dec    eCx
      jne    @CIKL
   @ENDS:
    Pop   eDx;
    Pop   eCx;
    Pop   eBx;
    pop   eAx;
    pop   eSi;
    pop   eDi;
  end;
  procedure ReplaceAlpa(var Source; var Dest; Count: integer);
    assembler;
  asm
    Push   eDi;
    Push   eSi;
    Push   eAx
    Push   eBx;
    Push   eCx;
    Push   eDx;
    mov    eSi, eAx
    mov    eDi, eDx
    mov    Al,B
    cmp    Al,0
    je     @CIKL2
   @CIKL1:
    mov    Bl,DS:eDi+3
    cmp    Bl,0
    jne    @M1
    mov    eBx,DS:eSi
    mov    eAx,eBx
    shr    eAx,24
    xor    eDx,eDx
    mul    SourceAlphaBlendValue
    add    Ax,254
    xor    Al,Al
    and    eBx,$00FFffFF
    shl    eAx,16
    or     eBx,eAx
    mov    DS:eDi,eBx
    @M1:
    add    eSi,4
    add    eDi,4
    dec    eCx
    jne    @CIKL1
    jmp    @ENDS
   @CIKL2:
    mov    Bl,DS:eSi+3
    cmp    Bl,0
    je    @M2
    mov    eBx,DS:eSi
    mov    eAx,eBx
    shr    eAx,24
    xor    eDx,eDx
    mul    SourceAlphaBlendValue
    add    Ax,254
    xor    Al,Al
    and    eBx,$00FFffFF
    shl    eAx,16
    or     eBx,eAx
    mov    DS:eDi,eBx
    @M2:
    add    eSi,4
    add    eDi,4
    dec    eCx
    jne    @CIKL2
   @ENDS:
    Pop   eDx;
    Pop   eCx;
    Pop   eBx;
    pop   eAx;
    pop   eSi;
    pop   eDi;
  end;
begin
  if Count <= 0 then Exit;
  SizeChanel := Count * 4;
  try
    if SizeChanel > SizeChanelBuff then
    begin
      SizeChanelBuff := SizeChanel;
      ReallocMem(SourceChanelBuff, SizeChanelBuff);
      ReallocMem(DestChanelBuff, SizeChanelBuff);
    end;

    for I := 0 to 3 do
    begin
      DwordToByte(@Source, @SourceChanelBuff^[i * Count], Count, i);
      DwordToByte(@Dest, @DestChanelBuff^[i * Count], Count, i);
    end;
    SrsAmuldiv(SourceChanelBuff^[3 * Count], SourceAlphaBlendValue, Count, DestChanelBuff^[3 * Count]);

    SrsRGBmuldiv(SourceChanelBuff^, Count);
    SrsRGBmuldiv(DestChanelBuff^, Count);
    Added(SourceChanelBuff^, DestChanelBuff^, Count);
    for I := 0 to 2 do
      ByteToDword(@DestChanelBuff^[i * Count], @Dest, Count, i);
    if B <> 2 then
      ReplaceAlpa(Source, Dest, Count)
    else
      ByteToDword(@DestChanelBuff^[3 * Count], @Dest, Count, 3);
  finally
  end;
end;

procedure DwordToByte(Source: PArrayColor; Dest: PByteArray; Count: integer; NumByte: Byte);
  assembler;
asm
  cmp    eAx,0
  je     @EXITS
  cmp    eDx,0
  je     @EXITS
  cmp    eCx,0
  jle    @EXITS
  push   eAx
  push   eCx
  push   eDi
  push   eSi
  mov    eSi,eAx
  xor    eAx,eAx
  mov    Al,NumByte
  cmp    Al,3
  ja     @ENDS
  mov    eDi,eDx
  add    eSi,eAx
 @CIKL:
  mov    Al,DS:eSi
  add    eSi,4
  mov    DS:eDi,Al
  inc    eDi
  dec    eCx
  je     @ENDS
  mov    Al,DS:eSi
  add    eSi,4
  mov    DS:eDi,Al
  inc    eDi
  dec    eCx
  je     @ENDS
  mov    Al,DS:eSi
  add    eSi,4
  mov    DS:eDi,Al
  inc    eDi
  dec    eCx
  jne    @CIKL
 @ENDS:
  pop    eSi
  pop    eDi
  pop    eCx
  pop    eAx
 @EXITS:
end;

procedure ByteToDword(Source: PByteArray; Dest: PArrayColor; Count: integer; NumByte: Byte);
  assembler;
asm
  cmp    eAx,0
  je     @EXITS
  cmp    eDx,0
  je     @EXITS
  cmp    eCx,0
  jle    @EXITS
  push   eAx
  push   eCx
  push   eDi
  push   eSi
  mov    eSi,eAx
  xor    eAx,eAx
  mov    Al,NumByte
  cmp    Al,3
  ja     @ENDS
  mov    eDi,eDx
  add    eDi,eAx
 @CIKL:
  mov    Al,DS:eSi
  inc    eSi
  mov    DS:eDi,Al
  add    eDi,4
  dec    eCx
  je     @ENDS
  mov    Al,DS:eSi
  inc    eSi
  mov    DS:eDi,Al
  add    eDi,4
  dec    eCx
  je     @ENDS
  mov    Al,DS:eSi
  inc    eSi
  mov    DS:eDi,Al
  add    eDi,4
  dec    eCx
  jne    @CIKL
 @ENDS:
  pop    eSi
  pop    eDi
  pop    eCx
  pop    eAx
 @EXITS:
end;

procedure BlurByteHor(PSource, PDest: PByteArray; Count: integer);
  assembler;
asm
  cmp    eAx,0
  je     @EXITS
  cmp    eDx,0
  je     @EXITS
  cmp    eCx,0
  jle    @EXITS
  cmp    eCx,1
  je     @ONE
  push   eAx
  push   eBx
  push   eCx
  push   eDx
  push   eDi
  push   eSi
  mov    eSi,eAx
  mov    eDi,eDx
  mov    Bx,3
  push   Bx

  xor    eBx,eBx
  xor    eDx,eDx
  mov    Dl,DS:[eSi]
  xor    eAx,eAx
  inc    eSi
  dec    eCx
  mov    Bh,Dl             //Bh  [i-2] 
  mov    Al,DS:[eSi]
  inc    eSi
  mov    Bl,Al             //Bl  [i-1] 
  add    eAx,eDx
  inc    eAx
  shr    eAx,1
  mov    DS:eDi,Al
  inc    eDi
  dec    eCx
  je     @ENDCIKL
  @CIKL:
    xor    eAx,eAx
    xor    eDx,eDx
    mov    Al,Bh
    mov    Dl,Bl
    add    eAx,eDx
    mov    Bh,Bl
    mov    Bl,DS:[eSi]
    mov    Dl,Bl
    add    eAx,eDx
    xor    eDx,eDx
    inc    eAx
    div    WORD PTR SS:eSP
    inc    eSi
    mov    DS:eDi,Al
    inc    eDi
    dec    eCx
    jne    @CIKL
 @ENDCIKL:
  xor    eAx,eAx
  mov    Al,Bh
  and    eBx,$000000FF
  add    eAx,eBx
  inc    eAx
  shr    eAx,1
  mov    DS:eDi,Al
 @ENDS:
  pop    Bx
  pop    eSi
  pop    eDi
  pop    eDx
  pop    eCx
  pop    eBx
  pop    eAx
  jmp    @EXITS
 @ONE:
  push   eAx
  mov    Al,DS:eAx
  mov    DS:eDx,Al
  pop    eAx
  jmp    @EXITS
 @EXITS:
end;

procedure BlurByteVert(PSource, PDest: PByteArray; Count, Width: integer);
  assembler;
asm
  cmp    eAx,0
  je     @EXITS
  cmp    eDx,0
  je     @EXITS
  cmp    eCx,0
  jle    @EXITS
  cmp    eCx,1
  je     @ONE
  push   eAx
  push   eBx
  push   eCx
  push   eDx
  push   eDi
  push   eSi
  mov    eSi,eAx
  mov    eDi,eDx
  mov    Bx,3
  push   Bx
  xor    eBx,eBx
  xor    eDx,eDx
  mov    Dl,DS:[eSi]
  xor    eAx,eAx
  add    eSi,Width
  dec    eCx
  mov    Bh,Dl             //Bh  [i-2] 
  mov    Al,DS:[eSi]
  add    eSi,Width
  mov    Bl,Al             //Bl  [i-1] 
  add    eAx,eDx
  inc    eAx
  shr    eAx,1
  mov    DS:eDi,Al
  add    eDi,Width
  dec    eCx
  je     @ENDCIKL
  @CIKL:
    xor    eAx,eAx
    xor    eDx,eDx
    mov    Al,Bh
    mov    Dl,Bl
    add    eAx,eDx
    mov    Bh,Bl
    mov    Bl,DS:[eSi]
    mov    Dl,Bl
    add    eAx,eDx
    xor    eDx,eDx
    inc    eAx
    div    WORD PTR SS:eSP
    add    eSi,Width
    mov    DS:eDi,Al
    add    eDi,Width
    dec    eCx
    jne    @CIKL
 @ENDCIKL:
  xor    eAx,eAx
  mov    Al,Bh
  and    eBx,$000000FF
  add    eAx,eBx
  inc    eAx
  shr    eAx,1
  mov    DS:eDi,Al
 @ENDS:
  pop    Bx
  pop    eSi
  pop    eDi
  pop    eDx
  pop    eCx
  pop    eBx
  pop    eAx
  jmp    @EXITS
 @ONE:
  push   eAx
  mov    Al,DS:eAx
  mov    DS:eDx,Al
  pop    eAx
  jmp    @EXITS
 @EXITS:
end;

//    ""
//Source       
//BitInfoSource      
//TransparentColor  ,      
//           clNone,     
//CountBlur    (0   )
//AlphaBlendValue      (0    )

procedure BitmapToShadow(Source: PArrayColor;
  BitInfoSource: TBitmapInfo;
  TransparentColor: TColor;
  CountBlur: Byte = 1;
  AlphaBlendValue: Byte = 255);
var
  SizeBlur, X, Y, I, A: integer;
begin
  if (AlphaBlendValue = 0) or
    (Source = nil) or
    (not CheckBitInfo(BitInfoSource)) then exit;
  try
    SizeBlur := BitInfoSource.bmiHeader.biWidth * BitInfoSource.bmiHeader.biHeight;
    if SizeBlur > SizeBlurBuff then
    begin
      SizeBlurBuff := SizeBlur;
      ReallocMem(Blur1, SizeBlurBuff);
      ReallocMem(Blur2, SizeBlurBuff);
    end;
    if TransparentColor <> $1FFFFFFF then
      ColorToAlpha(Source^, TransparentColor, SizeBlur);
    DwordToByte(Source, Blur1, SizeBlur, 3);
    for I := 0 to CountBlur - 1 do
    begin
      for Y := 0 to BitInfoSource.bmiHeader.biHeight - 1 do
        BlurByteHor(@Blur1^[Y * BitInfoSource.bmiHeader.biWidth],
          @Blur2^[Y * BitInfoSource.bmiHeader.biWidth],
          BitInfoSource.bmiHeader.biWidth);
      for X := 0 to BitInfoSource.bmiHeader.biWidth - 1 do
        BlurByteVert(@Blur2^[X],
          @Blur1^[X],
          BitInfoSource.bmiHeader.biHeight,
          BitInfoSource.bmiHeader.biWidth);
    end;
    fillchar(Source^, SizeBlur * 4, 0);
    if AlphaBlendValue < 255 then
    begin
      for X := 0 to SizeBlur - 1 do
      begin
        A := Blur1^[X] * AlphaBlendValue;
        Blur1^[X] := A shr 8;
      end;
    end;
    ByteToDword(Blur1, Source, SizeBlur, 3);
  finally
  end;
end;

//     c  
//Source       ,   .
//Dest         ,    .
//             32- !
//BitInfoSource, BitInfoDest  ,    
//X, Y         ,  .
//AlphaBlendValue     (0    )

procedure CopyAlphaBitmapInternal(Source, Dest: PArrayColor; BitInfoSource, BitInfoDest: TBitmapInfo; X, Y: integer; B: byte; AlphaBlendValue: Byte = 255);
var X1, W, Y1, H, DW, DH, SW, SH, D1, D2, I: integer;
begin
  if (Source = nil) or (Dest = nil) or (AlphaBlendValue = 0) then Exit;
  try
    DW := BitInfoDest.bmiHeader.biWidth;
    DH := BitInfoDest.bmiHeader.biHeight;
    SW := BitInfoSource.bmiHeader.biWidth;
    SH := BitInfoSource.bmiHeader.biHeight;
    if X >= 0 then
    begin
      W := DW - X;
      X1 := 0;
    end
    else
    begin
      W := DW;
      X1 := -X;
    end;
    if W + X1 > SW then W := SW - X1;
    if W <= 0 then Exit;
    if Y >= 0 then
    begin
      H := DH - Y;
      Y1 := 0;
    end
    else
    begin
      H := DH;
      Y1 := -Y;
    end;
    if H + Y1 > SH then H := SH - Y1;
    if H <= 0 then Exit;

    if Y < 0 then Y := 0;
    if X < 0 then X := 0;

    D1 := (SH - Y1 - 1) * SW + X1;
    D2 := (DH - Y - 1) * DW + X;
    for I := 0 to H - 1 do
    begin
      CopyAlphaColorNew(Dest^[D2], Source^[D1], AlphaBlendValue, W, B);
      Dec(D1, SW);
      Dec(D2, DW);
    end;
  finally
  end;
end;

procedure CopyAlphaBitmap(Source, Dest: PArrayColor;
  BitInfoSource, BitInfoDest: TBitmapInfo;
  X, Y: integer;
  TransparentColor: TColor = clFuchsia;
  AlphaBlendValue: Byte = 255);
var Size, Count: integer;
begin
  if (AlphaBlendValue = 0) or
    (Source = nil) or
    (Dest = nil) or
    (not CheckBitInfo(BitInfoSource)) or
    (not CheckBitInfo(BitInfoDest)) then exit;
  Count := BitInfoSource.bmiHeader.biWidth * BitInfoSource.bmiHeader.biHeight;
  if Count <= 0 then Exit;
  Size := Count * 4;
  if TransparentColor <> $1FFFFFFF then
  begin
    if Size > SizeTransparentBuff then
    begin
      SizeTransparentBuff := Size;
      ReallocMem(TransparentBuff, SizeTransparentBuff);
    end;
    Move(Source^, TransparentBuff^, Size);
    Source := TransparentBuff;
    ColorToAlpha(Source^, TransparentColor, Count);
  end;
  CopyAlphaBitmapInternal(Source, Dest, BitInfoSource, BitInfoDest, X, Y, 1, AlphaBlendValue);
end;

procedure CopyShadowAlphaBitmap(Source, Dest: PArrayColor;
  BitInfoSource, BitInfoDest: TBitmapInfo;
  X, Y: integer;
  TransparentColor: TColor = clFuchsia;
  AlphaBlendValue: Byte = 255;
  CountBlur: Byte = 1;
  Offset: ShortInt = 1);
var Size, Count, Dx, Dy: integer;
  AlphaBlendShadow: Byte;
begin
  if (AlphaBlendValue = 0) or
    (Source = nil) or
    (Dest = nil) or
    (not CheckBitInfo(BitInfoSource)) or
    (not CheckBitInfo(BitInfoDest)) then exit;
  Count := BitInfoSource.bmiHeader.biWidth * BitInfoSource.bmiHeader.biHeight;
  Size := Count * 4;
  AlphaBlendShadow := (AlphaBlendValue) div (3);
  if TransparentColor <> $1FFFFFFF then
  begin
    if Size > SizeTransparentBuff then
    begin
      SizeTransparentBuff := Size;
      ReallocMem(TransparentBuff, SizeTransparentBuff);
    end;
    Move(Source^, TransparentBuff^, Size);
    Source := TransparentBuff;
    ColorToAlpha(Source^, TransparentColor, Count);
  end;
  if (not ((CountBlur = 0) and (Offset = 0) and (AlphaBlendValue = 255))) and (AlphaBlendShadow > 0) then
  begin
    if Size > SizeShadowBuff then
    begin
      SizeShadowBuff := Size;
      ReallocMem(Shadow, SizeShadowBuff);
    end;
    Move(Source^, Shadow^, Size);
    BitmapToShadow(Shadow, BitInfoSource, $1FFFFFFF, CountBlur);
    Dx := Offset div 2;
    Dy := Abs(Offset) div 2;
    CopyAlphaBitmapInternal(Shadow, Dest, BitInfoSource, BitInfoDest, X + Dx, Y + Dy, 1, AlphaBlendShadow);
  end;
  if Offset < 0 then
    Dx := (Abs(Offset) + 1) div (2)
  else
    Dx := -(Abs(Offset) + 1) div (2);
  Dy := -(Abs(Offset) + 1) div (2);
  CopyAlphaBitmapInternal(Source, Dest, BitInfoSource, BitInfoDest, X + Dx, Y + Dy, 0, AlphaBlendValue);
end;

//  

procedure ColorToMonocrom(var Dest; Color: TColor; Count: integer);
  assembler;
asm
 cmp  eCx,0
 jle  @Ends
 push eDi
 push eAx;
 push eBx
 push eCx
 push eDx
 push eSi

 mov  eSi,eAx
 mov  eDi,eDx
 and  eDi,$00FFffFF
 @Cikl1:
   mov  eAx,DS:[ESI];
   mov  eBx,eAx
   and  eBx,$00FFffFF
   cmp  eBx,eDi
   je   @M1
    mov  eBx,eAx
    xor  eDx,eDx
    and  eAx,$000000FF

    shr  eBx,8
    add  eDx,eAx
    mov  Al,Bl
    shr  eBx,8
    add  eDx,eAx
    mov  Al,Bl
    add  eDx,eAx

    mov  eAx,eDx
    xor  eDx,eDx
    push eCx
    mov  eCx,3
    div  Cx
    pop  eCx
    cmp  eAx,255
    jb   @MM
     mov  eAx,255
    @MM:
    mov  Ah,Al
    mov  Bl,Al
    shl  eBx,16
    or  eAx,eBx

    mov  DS:[eSi],eAx
   @M1:
  Add  eSi,4
  dec  eCx
  jA   @Cikl1
 @EndCikl1:

 pop  eSi
 pop  eDx
 pop  eCx
 pop  eBx
 pop  eAx
 pop  eDi
 @ENDS:
end;

//  

procedure ColorToGray(var Dest; Color: TColor; Count: integer);
  assembler;
asm
 cmp  eCx,0
 jle  @Ends
 push eDi
 push eAx;
 push eBx
 push eCx
 push eDx
 push eSi

 mov  eSi,eAx
 mov  eDi,eDx
 and  eDi,$00FFffFF
 @Cikl1:
   mov  eAx,DS:[ESI];
   mov  eBx,eAx
   and  eBx,$00FFffFF
   cmp  eBx,eDi
   je   @M1
    mov  eBx,eAx
    xor  eDx,eDx
    and  eAx,$000000FF

    shr  eBx,8
    add  eDx,eAx
    mov  Al,Bl
    shr  eBx,8
    add  eDx,eAx
    mov  Al,Bl
    add  eDx,eAx
    add  eDx,170
    shr  eDx,2
    mov  eAx,eDx
    cmp  eAx,255
    jb   @MM
     mov  eAx,255
    @MM:
    mov  Ah,Al
    mov  Bl,Al
    shl  eBx,16
    or  eAx,eBx

    mov  DS:[eSi],eAx
   @M1:
  Add  eSi,4
  dec  eCx
  jA   @Cikl1
 @EndCikl1:

 pop  eSi
 pop  eDx
 pop  eCx
 pop  eBx
 pop  eAx
 pop  eDi
 @ENDS:
end;

//  , ,  
//Dest      32-  
//AlphaBlendValue    ,      
//Count       

procedure SetAlphaBlendValue(var Dest; AlphaBlendValue: Byte; Count: integer);
  assembler;
asm
 cmp  Count,0
 jle  @Ends
 push eDi
 push eAx;
 push eBx
 push eCx
 push eDx
 push eSi
 add  eAx,3
 mov  eSi,eAx
 mov  eCx,Count
 @Cikl1:
   mov  Al,DS:[ESI];
   cmp  Al,0
   jne  @M1
     mov  DS:[eSi],Dl
   @M1:
  Add  eSi,4
  dec  eCx
  jA   @Cikl1
 @EndCikl1:

 pop  eSi
 pop  eDx
 pop  eCx
 pop  eBx
 pop  eAx
 pop  eDi
 @ENDS:
end;

//   

procedure ColorToDull(Dest: PArrayColor; BitInfoDest: TBitmapInfo; Color: DWORD);
var xx, yy, D: integer;
  M, C, CC: TColor;
  Hue, Luminance, Saturation: Word;
begin
  if (Dest = nil) or
    (not CheckBitInfo(BitInfoDest)) then exit;
  M := Color and $00FFFFFF;
  for yy := 0 to BitInfoDest.bmiHeader.biHeight - 1 do
    for xx := 0 to BitInfoDest.bmiHeader.biWidth - 1 do
    begin
      D := (YY * BitInfoDest.bmiHeader.biWidth + XX);
      C := Dest^[D];
      CC := ($00FFFFFF) and (C);
      if CC <> M then
      begin
        ColorRGBToHLS(CC, Hue, Luminance, Saturation);
        CC := ColorHLSToRGB(Hue, Luminance, (Saturation) div (2));
        C := (DWORD(C) and ($FF000000)) or (DWORD(CC));
        Dest^[D] := C;
      end;
    end;
end;

function IconAllocated(Icon: TIcon): boolean;
begin
  result := (Icon <> nil)
    {$IFDEF VER130}
  and (Icon.Handle <> 0)
    {$ELSE}
  and (Icon.HandleAllocated)
    {$ENDIF}
end;

procedure DrawIcon(const Canvas: TCanvas; ARect: TRect; Icon: TIcon);
var
  FormBitmap: TBitmap;
  DestBitmap: TBitmap;
  ImageSize: Integer;
  X, Y, W, H: Integer;
begin
  if IconAllocated(Icon) then
  begin
    W := Abs(ARect.Right - ARect.Left);
    H := Abs(ARect.Bottom - ARect.Top);
    if H < W then
      W := H
    else
      H := W;
    ImageSize := W;
    ImageSize := ((ImageSize + 2) div (4)) * 4;
    X := ARect.Left + ((W - ImageSize) div (2));
    Y := ARect.Top + ((H - ImageSize) div (2));

    FormBitmap := nil;
    DestBitmap := TBitmap.Create;
    try
      FormBitmap := TBitmap.Create;
      DestBitmap.Width := ImageSize;
      DestBitmap.Height := ImageSize;
      DestBitmap.Canvas.Brush.Color := clFuchsia;
      DestBitmap.Canvas.FillRect(Rect(0, 0, DestBitmap.Width, DestBitmap.Height));
      DestBitmap.Transparent := false;
      FormBitmap.Width := Icon.Width;
      FormBitmap.Height := Icon.Height;
      FormBitmap.Canvas.Brush.Color := Canvas.Brush.Color;
      FormBitmap.Transparent := false;
      FormBitmap.Canvas.FillRect(Rect(0, 0, FormBitmap.Width, FormBitmap.Height));
      FormBitmap.Canvas.Draw(0, 0, Icon);
      ScaleImage(FormBitmap, DestBitmap, DestBitmap.Width / FormBitmap.Width);

      DestBitmap.TransparentColor := DestBitmap.Canvas.Pixels[0, DestBitmap.Height - 1];
        //DestBitmap.Transparent := True;

      BitBlt(Canvas.Handle, X, Y, ImageSize, ImageSize, DestBitmap.Canvas.Handle, 0, 0, SRCCOPY);
      ExcludeClipRect(Canvas.Handle, X, Y, X + ImageSize, Y + ImageSize);
      Canvas.FillRect(Rect(ARect.Left, ARect.Top, ARect.Left + W + 1, ARect.Top + H + 1));
      Canvas.Draw(X, Y, DestBitmap);
    finally
      FormBitmap.Free;
      DestBitmap.Free;
    end;
  end;
end;

//     

procedure DrawDockCaption(const Canvas: TCanvas;
  CaptionRect: TRect;
  MarginLeft, MarginRight: integer;
  const Horizontal: boolean;
  Caption: string;
  const StartColor, EndColor, FontColor: TColor;
  const Focused: Boolean;
  const Icon: TIcon;
  const D: integer = 2);
var TextRect: TRect;
  LogFont: TLogFont;
  NewFont, OldFont: HFont;
  H, ImageSize, X, Y: integer;
  diFlags: UINT;
  procedure DrawIcon;
  begin
    if IconAllocated(Icon) then
    begin
      if Horizontal then
      begin
        ImageSize := ((CaptionRect.Bottom - CaptionRect.Top - 1) div (4)) * 4;
        X := CaptionRect.Left + MarginLeft + 2;
        Y := (CaptionRect.Bottom + CaptionRect.Top - ImageSize + 1) div 2;
      end
      else
      begin
        ImageSize := ((CaptionRect.Right - CaptionRect.Left - 1) div (4)) * 4;
        X := (CaptionRect.Right + CaptionRect.Left - ImageSize + 1) div 2;
        Y := CaptionRect.Top + MarginLeft + 2;
      end;
      //  ,   
      diFlags := DI_NORMAL;
      DrawIconEx(Canvas.Handle, X, Y, Icon.Handle, ImageSize, ImageSize,
        0, 0, diFlags);
      if Horizontal then
        TextRect.Left := TextRect.Left + MarginLeft + ImageSize
      else
        TextRect.Top := TextRect.Top + MarginLeft + ImageSize;
      // If Horizontal then Inc(CaptionRect.Left,CaptionRect.Bottom-CaptionRect.Top)
      //               else Inc(CaptionRect.Top,CaptionRect.Right-CaptionRect.Left);
    end;
  end;
begin
  Canvas.Font.Color := FontColor;
  Canvas.Pen.Width := 1;
  Canvas.Pen.Color := MixColor(StartColor, EndColor);
  if Caption <> '' then
  begin
    if Focused then
      Canvas.Font.Style := Canvas.Font.Style + [fsBold]
    else
      Canvas.Font.Style := Canvas.Font.Style - [fsBold];
  end;
  TextRect := CaptionRect;
  if Horizontal then
  begin
    Dec(CaptionRect.Bottom);
    Inc(CaptionRect.Top);
    //   ( )
    //Canvas.MoveTo(CaptionRect.Left + 2, CaptionRect.Top + 2);
    //Canvas.LineTo(CaptionRect.Left + 2, CaptionRect.Bottom - 1);
    //  
    GradientFillCanvas(Canvas, StartColor, EndColor,
      Rect(CaptionRect.Left + 2, CaptionRect.Top + 1, CaptionRect.Right,
      CaptionRect.Bottom), gdVertical);
    // 
    Canvas.Pen.Color := GetShadowColor(Canvas.Pen.Color, -40);
    with CaptionRect do
    begin
      Canvas.Polyline([Point(Left + D + 1, Top),
        Point(Right - D, Top),
          Point(Right, Top + D),
          Point(Right, Bottom - D),
          Point(Right - D, Bottom),
          Point(Left + D + 1, Bottom),
          Point(Left + 1, Bottom - D),
          Point(Left + 1, Top + D),
          Point(Left + D + 1, Top)]);
    end;
    DrawIcon;
    if Caption <> '' then
    begin
      inc(TextRect.Left, MarginLeft);
      dec(TextRect.Right, MarginRight);
      if TextRect.Right - TextRect.Left > 12 then
      begin
        {$IFDEF VER130}
        Canvas.TextRect(TextRect, 0, 0, Caption);
        {$ELSE}
        {$IFDEF VER140}
        Canvas.TextRect(TextRect, 0, 0, Caption);
        {$ELSE}
        {$IFDEF VER150}
        Canvas.TextRect(TextRect, 0, 0, Caption);
        {$ELSE}
        Canvas.TextRect(TextRect, Caption, [tfEndEllipsis, tfVerticalCenter, tfSingleLine]);
        {$ENDIF}
        {$ENDIF}
        {$ENDIF}
      end;
    end;
  end
  else
  begin
    inc(CaptionRect.Top);
    Dec(CaptionRect.Right);
    GradientFillCanvas(Canvas, StartColor, EndColor,
      Rect(CaptionRect.Left + 2, CaptionRect.Top + 1, CaptionRect.Right,
      CaptionRect.Bottom), gdHorizontal);
    // 
    Canvas.Pen.Color := GetShadowColor(Canvas.Pen.Color, -20);
    with CaptionRect do
    begin
      Canvas.Polyline([Point(Left + D, Top),
        Point(Right - D, Top),
          Point(Right, Top + D),
          Point(Right, Bottom - D),
          Point(Right - D, Bottom),
          Point(Left + D, Bottom),
          Point(Left, Bottom - D),
          Point(Left, Top + D),
          Point(Left + D, Top)]);
    end;
    DrawIcon;
    if Caption <> '' then
    begin
      dec(TextRect.Bottom, MarginLeft);
      inc(TextRect.Top, MarginRight);
      if TextRect.Bottom - TextRect.Top > 12 then
      begin
        H := Canvas.TextHeight('Wp');
        GetObject(canvas.Font.Handle, SizeOf(LogFont), @LogFont);
        LogFont.lfEscapement := 900;
        OldFont := 0;
        NewFont := 0;
        try
          NewFont := CreateFontIndirect(LogFont);
          OldFont := SelectObject(Canvas.Handle, NewFont);
          H := (Abs(TextRect.Right - TextRect.Left) - H) div (2);
          if H < -2 then H := -2;
          inc(TextRect.Left, H - 1);
          TextRect.Right := TextRect.Bottom - TextRect.Top;
          TextRect.Top := TextRect.Bottom;
          windows.DrawText(Canvas.Handle, PChar(Caption), Length(Caption), TextRect, {DT_VCENTER OR} DT_END_ELLIPSIS or DT_NOCLIP);
        finally
          if OldFont <> 0 then SelectObject(Canvas.Handle, OldFont);
          DeleteObject(NewFont);
        end;
      end;
    end;
  end;
end;

procedure DrawPin(Canvas: TCanvas;
  ARect: TRect;
  Color: TColor;
  Pined: boolean);
begin
  Canvas.Pen.Color := Color;
  Canvas.Pen.Width := 1;
  with ARect do
  begin
    Inc(Top);
    if Pined then
    begin
      { Draw the top box }
      Canvas.MoveTo(Left + 1, Top + 4);
      Canvas.LineTo(Left + 1, Top);
      Canvas.LineTo(Left + 5, Top);
      Canvas.LineTo(Left + 5, Top + 5);
      { Draw the middle line }
      Canvas.MoveTo(Left, Top + 5);
      Canvas.LineTo(Left + 7, Top + 5);
      { Draw a depth line }
      Canvas.MoveTo(Left + 4, Top + 1);
      Canvas.LineTo(Left + 4, Top + 5);
      Canvas.MoveTo(Left + 3, Top + 6);
      Canvas.LineTo(Left + 3, Top + 6 + 4);
    end
    else
    begin
      Inc(Left, 2);
      { Draw the right box }
      Canvas.MoveTo(Left + 4, Top + 1);
      Canvas.LineTo(Left + 9, Top + 1);
      Canvas.LineTo(Left + 9, Top + 5);
      Canvas.LineTo(Left + 3, Top + 5);
      { Draw the middle line }
      Canvas.MoveTo(Left + 3, Top);
      Canvas.LineTo(Left + 3, Top + 7);
      { Draw a depth line }
      Canvas.MoveTo(Left + 4, Top + 4);
      Canvas.LineTo(Left + 9, Top + 4);
      Canvas.MoveTo(Left, Top + 3);
      Canvas.LineTo(Left + 3, Top + 3);
    end;
  end;
end;

{ TRichImageList }

type
  THasButtonBitmapHeader = record
    ImageList: TCustomImageList;
    Index: integer;
    Width, Height: Word;
    Checked, Hot, Enabled, Pushed, Transparent, Adjusted: boolean;
    BorderColor, SelectedColor, BkColor: TColor;
    Border: TCepButtonBorder;
    Layout: TButtonLayout;
    ThemeEnabled: boolean;
    CepButtonBorderEx: TCepButtonBorderEx;
    Spacing: Byte;
    Caption: array[0..255] of Char;
  end;
  THasButtonBitmap = record
    Header: THasButtonBitmapHeader;
    Bit: TBitmap;
  end;
  PHasButtonBitmap = ^THasButtonBitmap;
var
  AHasButtons: array of THasButtonBitmap;
  TmpBitmapImg, TmpBitmapBackground, TextBitmap: TBitmap;

////////////////////////////////////////////////////////////////
//,              //
////////////////////////////////////////////////////////////////

//    

function GetHasButtonBitmap(var V: THasButtonBitmap): boolean;
var i: integer;
begin
  result := false;
  for i := 0 to Length(AHasButtons) - 1 do
    if CompareMem(@V.Header, @AHasButtons[i].Header, SizeOf(AHasButtons[i].Header)) then
    begin
      V.Bit := AHasButtons[i].Bit;
      result := true;
      exit;
    end;
  V.Bit := nil;
end;

//       

function DeleteHasButtonBitmap(I: integer): boolean;
var j: integer;
begin
  result := false;
  if (I >= 0) and (I < Length(AHasButtons)) then
  begin
    if AHasButtons[i].Bit <> nil then FreeAndNil(AHasButtons[i].Bit);
    for j := i + 1 to Length(AHasButtons) - 1 do
      Move(AHasButtons[j], AHasButtons[j - 1], SizeOf(AHasButtons[j]));
    SetLength(AHasButtons, Length(AHasButtons) - 1);
    result := true;
  end;
end;

//     

function InsertHasButtonBitmap(var V: THasButtonBitmap): boolean;
var Bit: TBitmap;
  j: integer;
begin
  result := false;
  if Length(AHasButtons) >= MaxButtons then
  begin
    Bit := AHasButtons[0].Bit;
    for j := 1 to Length(AHasButtons) - 1 do
      Move(AHasButtons[j], AHasButtons[j - 1], SizeOf(AHasButtons[j]));
    J := Length(AHasButtons) - 1;
  end
  else
  begin
    Bit := nil;
    J := Length(AHasButtons);
    SetLength(AHasButtons, J + 1);
    AHasButtons[j].Bit := nil;
    //MessageBox(0,  PChar(inttostr(SizeOf(AHasButtons[j].Header.Caption)) + #13#10 +
    //                     inttostr(SizeOf(AHasButtons[j].Header)) + #13#10 +
    //                     inttostr(SizeOf(AHasButtons[j])) + #13#10), 'SizeOf(AHasButtons[j])', 0);
    result := true;
  end;
  try
    Move(V.Header, AHasButtons[j].Header, SizeOf(V.Header));
    if Bit = nil then
    begin
      Bit := TBitmap.Create;
      Bit.Transparent := false;
      Bit.TransparentColor := clFuchsia;
      Bit.TransparentMode := tmFixed;
      Bit.PixelFormat := pf32Bit;
    end;
    Bit.Width := V.Header.Width;
    Bit.Height := V.Header.Height;
    FreeAndNil(V.Bit);
    V.Bit := Bit;
    AHasButtons[j].Bit := Bit;
  except
    FreeAndNil(Bit);
    AHasButtons[j].Bit := nil;
    raise;
  end;
end;

//   

procedure ClearHasButtonBitmap;
begin
  while Length(AHasButtons) > 0 do
    DeleteHasButtonBitmap(Length(AHasButtons) - 1);
end;
////////////////////////////////////////////////////////////////////
//                              //
////////////////////////////////////////////////////////////////////

constructor TRichImageList.Create;
begin
  inherited;
  fBlend := 255;
  ReallocMem(fBuf, SizeOf(THasButtonBitmap));
  FillChar(fBuf^, SizeOf(THasButtonBitmap), 0);
  Spacing := 2;
end;

destructor TRichImageList.Destroy;
begin
  reallocMem(fBuf, 0);
  inherited;
end;

function TRichImageList.DoDrawBorder(Bitmap: TBitmap; ARect: TRect;
  var SelectedColor: TColor): boolean;
begin
  if @fOnDrawBorder <> nil then
    result := fOnDrawBorder(self, Bitmap, ARect, SelectedColor)
  else
    result := true;
end;

function TRichImageList.DoDrawImage(Bitmap: TBitmap; ARect: TRect): boolean;
begin
  if @fOnDrawImage <> nil then
    result := fOnDrawImage(self, Bitmap, ARect)
  else
    result := true;
end;

function TRichImageList.GetEnabled: boolean;
begin
  result := PHasButtonBitmap(fBuf)^.Header.Enabled;
end;

procedure TRichImageList.SetEnabled(const Value: boolean);
begin
  if PHasButtonBitmap(fBuf)^.Header.Enabled <> Value then
  begin
    PHasButtonBitmap(fBuf)^.Header.Enabled := Value;
    Changed(Self);
  end;
end;

function TRichImageList.GetHot: boolean;
begin
  result := PHasButtonBitmap(fBuf)^.Header.Hot;
end;

procedure TRichImageList.SetHot(const Value: boolean);
begin
  if PHasButtonBitmap(fBuf)^.Header.Hot <> Value then
  begin
    PHasButtonBitmap(fBuf)^.Header.Hot := Value;
    Changed(Self);
  end;
end;

function TRichImageList.GetImageList: TCustomImageList;
begin
  result := PHasButtonBitmap(fBuf)^.Header.ImageList;
end;

procedure TRichImageList.SetImageList(const Value: TCustomImageList);
begin
  if PHasButtonBitmap(fBuf)^.Header.ImageList <> Value then
  begin
    PHasButtonBitmap(fBuf)^.Header.ImageList := Value;
    Changed(Self);
  end;
end;

function TRichImageList.GetSelectedColor: TColor;
begin
  result := PHasButtonBitmap(fBuf)^.Header.SelectedColor;
end;

procedure TRichImageList.SetSelectedColor(const Value: TColor);
begin
  if PHasButtonBitmap(fBuf)^.Header.SelectedColor <> Value then
  begin
    PHasButtonBitmap(fBuf)^.Header.SelectedColor := Value;
    Changed(Self);
  end;
end;

function TRichImageList.GetPushed: boolean;
begin
  result := PHasButtonBitmap(fBuf)^.Header.Pushed;
end;

procedure TRichImageList.SetPushed(const Value: boolean);
begin
  if PHasButtonBitmap(fBuf)^.Header.Pushed <> Value then
  begin
    PHasButtonBitmap(fBuf)^.Header.Pushed := Value;
    Changed(Self);
  end;
end;

function TRichImageList.GetAdjusted: boolean;
begin
  result := PHasButtonBitmap(fBuf)^.Header.Adjusted;
end;

procedure TRichImageList.SetAdjusted(const Value: boolean);
begin
  if PHasButtonBitmap(fBuf)^.Header.Adjusted <> Value then
  begin
    PHasButtonBitmap(fBuf)^.Header.Adjusted := Value;
    Changed(Self);
  end;
end;

function TRichImageList.GetIndex: integer;
begin
  result := PHasButtonBitmap(fBuf)^.Header.Index;
end;

procedure TRichImageList.SetIndex(const Value: integer);
begin
  if PHasButtonBitmap(fBuf)^.Header.Index <> Value then
  begin
    PHasButtonBitmap(fBuf)^.Header.Index := Value;
    Changed(Self);
  end;
end;

function TRichImageList.GetCaption: string;
begin
  SetString(result,
    PChar(Addr(PHasButtonBitmap(fBuf)^.Header.Caption)),
    Length(PChar(Addr(PHasButtonBitmap(fBuf)^.Header.Caption))));
end;

function TRichImageList.GetCepButtonBorderEx: TCepButtonBorderEx;
begin
  result := PHasButtonBitmap(fBuf)^.Header.CepButtonBorderEx;
end;

procedure TRichImageList.SetCaption(const Value: string);
var L: integer;
  OldValue: string;
begin
  OldValue := GetCaption;
  if Value <> OldValue then
  begin
    L := Length(Value) * SizeOf(Value[1]);
    if L > SizeOf(PHasButtonBitmap(fBuf)^.Header.Caption) - 2 then
      L := SizeOf(PHasButtonBitmap(fBuf)^.Header.Caption) - 2;
    FillChar(PHasButtonBitmap(fBuf)^.Header.Caption,
      SizeOf(PHasButtonBitmap(fBuf)^.Header.Caption), 0);
    Move(Value[1], PHasButtonBitmap(fBuf)^.Header.Caption, L);
    Changed(Self);
  end;
end;

procedure TRichImageList.SetCepButtonBorderEx(const Value: TCepButtonBorderEx);
var V: TCepButtonBorderEx;
begin
  if ThemeEnabled then
    V := Value
  else
    V := cbbNormal;
  if PHasButtonBitmap(fBuf)^.Header.CepButtonBorderEx <> V then
  begin
    PHasButtonBitmap(fBuf)^.Header.CepButtonBorderEx := V;
    Changed(Self);
  end;
end;

function TRichImageList.GetBkColor: TColor;
begin
  result := PHasButtonBitmap(fBuf)^.Header.BkColor;
end;

procedure TRichImageList.SetBkColor(const Value: TColor);
begin
  if PHasButtonBitmap(fBuf)^.Header.BkColor <> Value then
  begin
    PHasButtonBitmap(fBuf)^.Header.BkColor := Value;
    Changed(Self);
  end;
end;

function TRichImageList.GetBorder: TCepButtonBorder;
begin
  result := PHasButtonBitmap(fBuf)^.Header.Border;
end;

procedure TRichImageList.SetBorder(const Value: TCepButtonBorder);
begin
  if PHasButtonBitmap(fBuf)^.Header.Border <> Value then
  begin
    PHasButtonBitmap(fBuf)^.Header.Border := Value;
    Changed(Self);
  end;
end;

function TRichImageList.GetChecked: boolean;
begin
  result := PHasButtonBitmap(fBuf)^.Header.Checked;
end;

procedure TRichImageList.SetChecked(const Value: boolean);
begin
  if PHasButtonBitmap(fBuf)^.Header.Checked <> Value then
  begin
    PHasButtonBitmap(fBuf)^.Header.Checked := Value;
    Changed(Self);
  end;
end;

function TRichImageList.GetBorderColor: TColor;
begin
  result := PHasButtonBitmap(fBuf)^.Header.BorderColor;
end;

procedure TRichImageList.SetBorderColor(const Value: TColor);
begin
  if PHasButtonBitmap(fBuf)^.Header.BorderColor <> Value then
  begin
    PHasButtonBitmap(fBuf)^.Header.BorderColor := Value;
    Changed(Self);
  end;
end;

function TRichImageList.GetEmpty: Boolean;
begin
  result := false;
end;

function TRichImageList.GetThemeEnabled: boolean;
begin
  result := PHasButtonBitmap(fBuf)^.Header.ThemeEnabled;
end;

function TRichImageList.GetTransparent: boolean;
begin
  result := PHasButtonBitmap(fBuf)^.Header.Transparent;
end;

procedure TRichImageList.SetThemeEnabled(const Value: boolean);
begin
  if PHasButtonBitmap(fBuf)^.Header.ThemeEnabled <> Value then
  begin
    PHasButtonBitmap(fBuf)^.Header.ThemeEnabled := Value;
    if Value then
    begin
      HookThemeChanged;
      PHasButtonBitmap(fBuf)^.Header.CepButtonBorderEx := cbbNormal;
    end;
    Changed(Self);
  end;
end;

procedure TRichImageList.SetTransparent(Value: boolean);
begin
  if PHasButtonBitmap(fBuf)^.Header.Transparent <> Value then
  begin
    PHasButtonBitmap(fBuf)^.Header.Transparent := Value;
    Changed(Self);
  end;
end;

function TRichImageList.GetHeight: Integer;
begin
  result := PHasButtonBitmap(fBuf)^.Header.Height;
end;

procedure TRichImageList.SetHeight(Value: Integer);
begin
  if PHasButtonBitmap(fBuf)^.Header.Height <> Value then
  begin
    PHasButtonBitmap(fBuf)^.Header.Height := Value;
    Changed(Self);
  end;
end;

function TRichImageList.GetWidth: Integer;
begin
  result := PHasButtonBitmap(fBuf)^.Header.Width;
end;

procedure TRichImageList.SetWidth(Value: Integer);
begin
  if PHasButtonBitmap(fBuf)^.Header.Width <> Value then
  begin
    PHasButtonBitmap(fBuf)^.Header.Width := Value;
    Changed(Self);
  end;
end;

function TRichImageList.GetLayout: TButtonLayout;
begin
  result := PHasButtonBitmap(fBuf)^.Header.Layout;
end;

procedure TRichImageList.SetLayout(const Value: TButtonLayout);
begin
  if PHasButtonBitmap(fBuf)^.Header.Layout <> Value then
  begin
    PHasButtonBitmap(fBuf)^.Header.Layout := Value;
    Changed(Self);
  end;
end;

function TRichImageList.GetSpacing: byte;
begin
  result := PHasButtonBitmap(fBuf)^.Header.Spacing;
end;

procedure TRichImageList.SetSpacing(const Value: byte);
begin
  if PHasButtonBitmap(fBuf)^.Header.Spacing <> Value then
  begin
    PHasButtonBitmap(fBuf)^.Header.Spacing := Value;
    Changed(Self);
  end;
end;

function TRichImageList.GetPalette: HPALETTE;
begin
  if (fBuf <> nil) and (GetHasButtonBitmap(PHasButtonBitmap(fBuf)^)) then
    result := PHasButtonBitmap(fBuf)^.Bit.Palette
  else
    result := 0;
end;

procedure TRichImageList.SetPalette(Value: HPALETTE);
begin
  if (GetHasButtonBitmap(PHasButtonBitmap(fBuf)^)) and
    (PHasButtonBitmap(fBuf)^.Bit.Palette <> Value) then
  begin
    PHasButtonBitmap(fBuf)^.Bit.Palette := Value;
    Changed(self);
  end;
end;

function TRichImageList.Equals(Graphic: TGraphic): Boolean;
begin
  result := false;
  if (fBuf <> nil) and (Graphic is TRichImageList) and (TRichImageList(Graphic).fBuf <> nil) then
    result := CompareMem(fBuf, TRichImageList(Graphic).fBuf, SizeOf(THasButtonBitmapHeader));
end;

procedure TRichImageList.Assign(Source: TPersistent);
var Need: boolean;
  function CopyTMP(Source: Pointer): boolean;
  var P: Pointer;
  begin
    result := false;
    if fBuf <> nil then
    begin
      P := nil;
      try
        ReallocMem(P, SizeOf(THasButtonBitmapHeader));
        if Source <> nil then
          Move(Source^, P^, SizeOf(THasButtonBitmapHeader))
        else
          FillChar(P^, SizeOf(THasButtonBitmapHeader), 0);
        result := not CompareMem(P, fBuf, SizeOf(THasButtonBitmapHeader));
        if result then Move(P^, fBuf^, SizeOf(THasButtonBitmapHeader));
      finally
        ReallocMem(P, 0);
      end;
    end;
  end;
begin
  Need := false;
  if fBuf <> nil then
  begin
    if Source <> nil then
    begin
      if (Source is TRichImageList) then
      begin
        Need := CopyTMP(TRichImageList(Source).fBuf);
        if fBlend <> TRichImageList(Source).fBlend then
        begin
          fBlend := TRichImageList(Source).fBlend;
          Need := true;
        end;
      end
      else
        raise EConvertError.CreateFmt(SAssignError, [Source.ClassName, ClassName]);
    end
    else
    begin
      Need := CopyTMP(nil);
      if fBlend <> 255 then
      begin
        fBlend := 255;
        Need := true;
      end;
    end;
  end;
  if Need then Changed(self);
end;

procedure TRichImageList.AssignTo(Dest: TPersistent);
begin
  if Dest is TRichImageList then
    Dest.Assign(self)
  else
    inherited;
end;

procedure TRichImageList.SetBlend(const Value: Byte);
begin
  if fBlend <> Value then
  begin
    fBlend := Value;
    Changed(self);
  end;
end;

procedure TRichImageList.DrawText(ACanvas: TCanvas; var R: TRect; uFormat: Cardinal; Transparent: boolean);
var W, H: integer;
  RR: TRect;
  C, CT: TColor;
  procedure DrawTextDC(DC: HDC; var R: TRect);
  var L: TButtonLayout;
    Len, Res: integer;
    Text: PChar;
  begin
    L := PHasButtonBitmap(fBuf)^.Header.Layout;
    if (Abs(R.Right - R.Left) > 3) and (Abs(R.Bottom - R.Top) > 3) then
    begin
      case L of
        blGlyphLeft: uFormat := uFormat or DT_Left;
        blGlyphRight: uFormat := uFormat or DT_Right;
        blGlyphTop, blGlyphBottom: uFormat := uFormat or DT_Center;
      end;
      uFormat := uFormat or DT_END_ELLIPSIS or DT_WORDBREAK;
      SetBkMode(DC, Windows.OPAQUE {TRANSPARENT});
      Text := PChar(Addr(PHasButtonBitmap(fBuf)^.Header.Caption));
      Len := Length(Text) { * SizeOf(Text[0])};
      Res := Windows.DrawText(DC,
        Text,
        Len, R, uFormat);
      if Res <= 0 then RaiseLastOsError;
    end;
  end;
begin
  W := R.Right - R.Left;
  H := R.Bottom - R.Top;
  if Transparent and ((uFormat and DT_CALCRECT) = 0) and (W > 3) and (H > 3) then
  begin
    if TextBitmap = nil then
    begin
      TextBitmap := TBitmap.Create;
      TextBitmap.PixelFormat := pf32bit;
      TextBitmap.TransparentMode := tmFixed;
      TextBitmap.Transparent := true;
    end;
    if (TextBitmap.Width < W) then TextBitmap.Width := W;
    if (TextBitmap.Height < H) then TextBitmap.Height := H;
    if IsTheme and
      (Hot or Checked or (Border = CepSingleBorder)) then
      C := ColorToRGB(clBtnFace)
    else
      C := ColorToRGB(BkColor);
    CT := GetTextColor(ACanvas.Handle);
    if C = CT then C := GetShadowColor(C, -10);

    TextBitmap.Canvas.Brush.Color := C;
    TextBitmap.Canvas.FillRect(Rect(0, 0, Width, Height));
    TextBitmap.Canvas.Font := ACanvas.Font;
    SetTextColor(TextBitmap.Canvas.Handle, CT);
    RR := Rect(0, 0, W, H);
    //  DrawTextDC(ACanvas.Handle,R);      TrueType
    DrawTextDC(TextBitmap.Canvas.Handle, RR);
    TextBitmap.TransparentColor := C;
    ACanvas.Draw(R.Left, R.Top, TextBitmap);
  end
  else
    DrawTextDC(ACanvas.Handle, R);
end;

//      ( )

procedure TRichImageList.GetRectIMG(ACanvas: TCanvas; var BitRect, TextRect: TRect);
var L: TButtonLayout;
  W, H, Wt, Ht, X, Y: integer;
  R: TRect;
begin
  L := PHasButtonBitmap(fBuf)^.Header.Layout;
  fillchar(TextRect, SizeOf(TextRect), 0);
  X := 0;
  Y := 0;
  Wt := 0;
  Ht := 0;
  if (ImageList = nil) and (Index = -1) and (Caption <> '') and (@fOnDrawImage = nil) then
  begin
    W := 0;
    H := 0;
  end
  else
  begin
    if (ImageList <> nil) and (Index >= 0) then
    begin
      W := ImageList.Width;
      H := ImageList.Height;
    end
    else
    begin
      if @fOnDrawImage = nil then
      begin
        W := (Width * 4) div (5);
        H := (Height * 4) div (5);
        if H < W then
          W := H
        else
          H := W;
      end
      else
      begin
        W := (Width div 2 - 1) * 2;
        H := (Height div 2 - 1) * 2;
      end;
      if W < 3 then
      begin
        W := 3;
        H := 3;
      end;
    end;
  end;
  if Caption <> '' then
  begin
    Wt := Width;
    Ht := Height;
    case L of
      blGlyphLeft, blGlyphRight: DEC(Wt, Spacing + 2 + W);
      blGlyphTop, blGlyphBottom: DEC(Ht, Spacing + 2 + H);
    end;
    if Border = CepSingleBorder then
    begin
      Dec(Wt, 2);
      Dec(Ht, 2);
    end;
    if (Wt > 0) and (Ht > 0) then
    begin
      R := Rect(0, 0, Wt, Ht);
      DrawText(ACanvas, R, DT_CALCRECT, false);
      Wt := R.Right;
      Ht := R.Bottom;
      if Wt < 3 then WT := 0;
      if Ht < 3 then HT := 0;
      case L of
        blGlyphLeft, blGlyphRight: if WT > 0 then inc(WT, Spacing);
        blGlyphTop, blGlyphBottom: if HT > 0 then inc(HT, Spacing);
      end;
    end;
  end;
  case L of
    blGlyphLeft:
      begin
        X := (Width - W - Wt + 1) div (2);
        if X < 0 then X := 0;
        if (X > 4) and (Border = CepXPBorder) then X := 4;
        Y := (Height - H + 1) div (2);
      end;
    blGlyphRight:
      begin
        X := (Width - W - Wt + 1) div (2);
        if X < 0 then X := 0;
        if (X > 4) and (Border = CepXPBorder) then X := 4;
        X := Width - X - W;
        Y := (Height - H + 1) div (2);
      end;
    blGlyphTop:
      begin
        X := (Width - W + 1) div (2);
        Y := (Height - H - Ht + 1) div (2);
        if Y < 0 then Y := 0;
      end;
    blGlyphBottom:
      begin
        X := (Width - W + 1) div (2);
        Y := Height - H - (Height - H - Ht + 1) div (2);
        if Y > Height - H then y := Height - H;
      end;
  end;
  BitRect := Rect(X, Y, X + W, Y + H);
  if (Wt > 0) and (Ht > 0) then
  begin
    case L of
      blGlyphLeft:
        begin
          X := X + W + Spacing;
          Y := (Height - Ht) div (2)-1;
          if Y < 0 then Y := 0;
        end;
      blGlyphRight:
        begin
          X := X - Spacing - Wt;
          Y := (Height - Ht) div (2)-1;
          if Y < 0 then Y := 0;
        end;
      blGlyphTop:
        begin
          X := (Width - Wt + 1) div (2);
          Y := Y + H + Spacing;
        end;
      blGlyphBottom:
        begin
          X := (Width - Wt + 1) div (2);
          Y := (Y - Spacing - Ht);
        end;
    end;
    TextRect := Rect(X, Y, X + Wt, Y + Ht);
    if (Pushed or Checked) and (Border <> CepXPBorder) then
    begin
      OffsetRect(TextRect, 1, 1);
    end;
  end;
end;

procedure TRichImageList.FlatBorder(ACanvas: TCanvas; R: TRect; Color: TColor; Push: boolean; Percent: integer = -1);
var C1, C2, C: TColor;
begin
  if Color <> clDefault then
  begin

    if Percent > -1 then
    begin
      C1 := GetShadowColor(Color, -(40 * Percent) div (50) + 50);
      C2 := GetHighLightColor(Color, (35 * Percent) div (75) - 35);
    end
    else if Percent = -1 then
    begin
      C1 := GetShadowColor(Color);
      C2 := GetHighLightColor(Color);
    end
    else
    begin
      C1 := GetShadowColor(Color, -(40 * Percent) div (50));
      C2 := GetHighLightColor(Color, (35 * Percent) div (75));
    end;

    ACanvas.Pen.Width := 1;
    ACanvas.Pen.Style := psSolid;
    if not Push then
    begin
      C := C2;
      C2 := C1;
      C1 := C;
    end;
    C := MixColor(C1, C2);
    ACanvas.Pen.Color := C1;
    ACanvas.MoveTo(R.Left, R.Bottom - 1);
    ACanvas.LineTo(R.Left, R.Top);
    ACanvas.LineTo(R.Right - 1, R.Top);
    ACanvas.Pen.Color := C2;
    ACanvas.LineTo(R.Right - 1, R.Bottom - 1);
    ACanvas.LineTo(R.Left, R.Bottom - 1);
    ACanvas.Pixels[R.Right - 1, R.Top] := C;
    ACanvas.Pixels[R.Left, R.Bottom - 1] := C;
  end;
end;

procedure TRichImageList.UpdateBitmap(var Bitmap: TBitmap; var ARect: TRect);
var W, H: integer;
begin
  W := Abs(ARect.Right - Arect.Left);
  H := Abs(ARect.Bottom - ARect.Top);
  if (W <= 0) or (H <= 0) then
  begin
    FreeAndNil(Bitmap);
  end
  else
  begin
    if Bitmap = nil then Bitmap := TBitmap.Create;
    Bitmap.PixelFormat := pf32bit;
    Bitmap.Width := W;
    Bitmap.Height := H;
    Bitmap.TransparentColor := clFuchsia;
    Bitmap.TransparentMode := tmFixed;
    Bitmap.Transparent := false;
    Bitmap.Canvas.Brush.Style := bsSolid;
    Bitmap.Canvas.Brush.Color := clFuchsia;
  end;
  ARect := Rect(0, 0, W, H);
end;

//     

function TRichImageList.DrawBorder(var Bitmap: TBitmap; ARect: TRect): TColor;
type TAColor = packed array[0..3] of Byte;
var R: TRect;
  C: TColor;
  CC: Byte;
  State: TCepStateButton;
begin
  result := clNone;
  UpdateBitmap(Bitmap, ARect);
  R := ARect;
  if Enabled then
  begin
    State := csbNormal;
    if Pushed then
      State := csbPushed
    else if Hot then
      State := csbHot;
  end
  else
    State := csbDisabeled;
  if DoDrawBorder(Bitmap, ARect, result) then
    case Border of
      CepSingleBorder:
        begin
          if IsTheme then
            DrawBkTheme(Bitmap.Canvas.Handle, ARect, State, false, Checked, CepButtonBorderEx)
          else
          begin
            C := BkColor;
            if (C = clDefault) or (C = clNone) then C := clBtnFace;
            FlatBorder(Bitmap.Canvas, R, C, Pushed or Checked, 190);
            if (Width > MinSize) and (Height > MinSize) then
            begin
              inflateRect(R, -1, -1);
              FlatBorder(Bitmap.Canvas, R, C, Pushed or Checked, 120);
            end;
          end;
        end;
      CepFlatBorder:
        begin
          if IsTheme then
          begin
            DrawBkTheme(Bitmap.Canvas.Handle, ARect, State, true, Checked, CepButtonBorderEx)
          end
          else
          begin
            if Hot or Pushed or Checked then
            begin
              C := BkColor;
              if (C = clDefault) or (C = clNone) then C := clBtnFace;
              FlatBorder(Bitmap.Canvas, R, C, Pushed or Checked);
            end;
          end;
        end;
      CepNoBorder:
        begin
          if not Transparent then
          begin
            C := BkColor;
            if (C = clDefault) or (C = clNone) then C := clBtnFace;
            Bitmap.Canvas.Brush.Color := C;
            OffsetRect(R, -R.Left, -R.Top);
            Bitmap.Canvas.FillRect(R);
          end;
        end;
      CepXPBorder:
        begin
          C := result;
          if Hot or Checked then
          begin //BorderColor - 
            if BorderColor <> clDefault then
            begin
              C := BorderColor;
            end
            else if SelectedColor <> clNone then
            begin
              C := GetShadowColor(SelectedColor, -30);
            end;
            if C <> clNone then
            begin
              if (not Enabled) and (BkColor <> clNone) then C := MixColor(C, BkColor);
              Bitmap.Canvas.Pen.Color := C;
              Bitmap.Canvas.Brush.Style := bsClear;
              Bitmap.Canvas.Pen.Width := 1;
              Bitmap.Canvas.Pen.Style := psSolid;
              Bitmap.Canvas.Rectangle(R.Left, R.Top, R.Right, R.Bottom);
              if BkColor <> clNone then
              begin
                C := MixColor(C, BkColor);
                Bitmap.Canvas.Pixels[R.Left, R.Top] := C;
                Bitmap.Canvas.Pixels[R.Right - 1, R.Top] := C;
                Bitmap.Canvas.Pixels[R.Left, R.Bottom - 1] := C;
                Bitmap.Canvas.Pixels[R.Right - 1, R.Bottom - 1] := C;
              end;
              InflateRect(R, -Bitmap.Canvas.Pen.Width, -Bitmap.Canvas.Pen.Width);
            end;
          end;
          if (not Transparent) or (Hot) or (Checked) then
          begin
            if Checked or Hot then
            begin
              if SelectedColor <> clDefault then
                C := SelectedColor
              else if BkColor <> clDefault then
                C := GetHighLightColor(BkColor)
              else
                C := clBtnHighlight;
            end
            else
            begin
              if BkColor <> clDefault then
                C := BkColor
              else
                C := clBtnFace;
            end;
            if (not Enabled) and (BkColor <> clNone) then C := MixColor(C, BkColor);

            if C <> clNone then
            begin //SelectedColor -   
              C := ColorToRGB(C);
              result := C;
              CC := TAColor(result)[0];
              TAColor(result)[0] := TAColor(result)[2];
              TAColor(result)[2] := CC;
              if Transparent then
                Bitmap.Canvas.Brush.Color := $00FF00FF
              else
                Bitmap.Canvas.Brush.Color := C;
              Bitmap.Canvas.Brush.Style := bsSolid;
              Bitmap.Canvas.FillRect(R);
            end;
          end;
        end;
    end;
end;

//    

procedure TRichImageList.DrawImage(var Bitmap: TBitmap; var ARect: TRect);
var i, X, Y, Index_, WW, HH, Size, H, D: integer;
  C: TColor;
  R: TRect;
begin
  if Border = CepXPBorder then
  begin
    InflateRect(ARect, 2, 2);
    X := 2;
    Y := 2;
  end
  else
  begin
    InflateRect(ARect, 1, 1);
    X := 1;
    Y := 1;
  end;
  R := ARect;
  OffsetRect(R, -R.Left, -R.Top);
  UpdateBitmap(Bitmap, R);
  Bitmap.Canvas.FillRect(R);
  if DoDrawImage(Bitmap, R) then
  begin
    case Border of
      CepSingleBorder, CepFlatBorder:
        begin
          if Pushed or Checked then
          begin
            INC(X);
            INC(Y);
          end;
        end;
      CepNoBorder:
        begin
          if (Pushed or Checked) and (Adjusted) then
          begin
            INC(X);
            INC(Y);
          end;
        end;
    end;
    if (Index >= 0) and (ImageList <> nil) then
    begin
      ImageList.Draw(Bitmap.Canvas, X, Y, Index, true);
    end
    else
    begin
      if Index < -1 then
      begin
        if enabled then
        begin
          if Hot then
            C := GetSysColor(COLOR_HOTLIGHT)
          else
            C := GetSysColor(COLOR_BTNTEXT);
        end
        else
          C := GetSysColor(COLOR_GRAYTEXT);
        Index_ := -Index;
        Bitmap.Canvas.Pen.Color := C;
        HH := Bitmap.Height - 2;
        WW := Bitmap.Width - 2;
        Size := HH;
        if WW < Size then
        begin
          Size := (2 * WW) div (5);
        end
        else
          Size := (2 * Size) div (5);
        H := HH;
        case Index_ of
          2..3: DrawChevron(Bitmap.Canvas, TScrollDirection(Index_ - 2), Point(X + (Size), Y), Size);
          4..5: DrawChevron(Bitmap.Canvas, TScrollDirection(Index_ - 2), Point(X, Y + (H) div (2)), Size);
          6..7: DrawArrow(Bitmap.Canvas, TScrollDirection(Index_ - 6), Point(X + 1 + (Size) div (2), Y), Size);
          8..9: DrawArrow(Bitmap.Canvas, TScrollDirection(Index_ - 6), Point(X + 1, Y + (H) div (4)), Size);
          10: DrawCheck(Bitmap.Canvas, Point(X, Y + (H) div (2)), (Size) div (2), false);
          11: DrawCheck(Bitmap.Canvas, Point(X, Y + (H) div (2)), (Size) div (2), true);
          12:
            begin
              Bitmap.Canvas.Brush.Color := C;
              D := (7 * Size) div (8);
              if D > 7 then D := 7;
              if D < 3 then D := 3;
              Y := Y + (HH - D);
              X := X + 1;
              for i := 0 to 2 do
                Bitmap.Canvas.Ellipse((i) * D + X - 1, Y, (i) * D + X + (D + 1) div (2) - 1, Y + (D + 1) div (2));
            end;
        end;
      end;
    end;
  end;
end;

procedure TRichImageList.DrawAll(var Bitmap: TBitmap; Font: TFont; ARect: TRect);
var R, BitRect, TextRect: TRect;
  CBk: TColor;
  Img, Bk: PArrayColor;
  BitInfoImg, BitInfoBk: TBitmapInfo;
  Count, CountBk: integer;
  X, Y: integer;
begin
  if fDrawing then Exit;
  fDrawing := true;
  try
    R := ARect;
    Img := nil;
    Bk := nil;
    UpdateBitmap(Bitmap, R);
    if Bitmap = nil then exit; //    
    //  
    if ((not Transparent) or IsTheme) or
      (Checked and ((Border <> CepNoBorder) or Adjusted)) then
    begin
      if Checked and (not IsTheme) and
        ((not Pushed) and (Border in [CepSingleBorder, CepFlatBorder])) then
      begin
        CBk := GetSelectedColor;
        if CBk = clDefault then
        begin
          CBk := BkColor;
          if CBk = clDefault then CBk := clBtnFace;
          if CBk <> clNone then CBk := GetHighLightColor(CBk);
        end;
      end
      else
      begin
        CBk := BkColor;
        if CBk = clDefault then CBk := clBtnFace;
      end;
    end
    else
      CBk := clNone;
    //   ,    ,  clFuchsia
    if (CBk <> clNone) then Bitmap.Canvas.Brush.Color := CBk;
    Bitmap.Canvas.FillRect(R);
    //    
    Bitmap.Canvas.Font := Font;
    GetRectIMG(Bitmap.Canvas, BitRect, TextRect);
    //  CepNoBorder  CepXPBorder     
    //       XP
    if (Border in [CepNoBorder, CepXPBorder]) or IsTheme then
    begin
      DrawBorder(Bitmap, ARect);
      if not Enabled then Bitmap.Canvas.Font.Color := clGrayText;
      DrawText(Bitmap.Canvas, TextRect, 0, Transparent or IsTheme);
    end;
    //  ,   
    if (@fOnDrawImage <> nil) or (Index <> -1) then
    begin
      // ,        
      DrawImage(TmpBitmapImg, BitRect);
      GetDib(TmpBitmapImg, Img, BitInfoImg);
      Count := BitInfoImg.bmiHeader.biWidth * BitInfoImg.bmiHeader.biHeight;
      SetAlphaBlendValue(Img^, 255, Count);
      ColorToAlpha(Img^, clFuchsia, Count);
      try
        GetDib(Bitmap, Bk, BitInfoBk);
        CountBk := BitInfoBk.bmiHeader.biWidth * BitInfoBk.bmiHeader.biHeight;
        SetAlphaBlendValue(Bk^, 255, CountBk);
        ColorToAlpha(Bk^, clFuchsia, CountBk);
        try
          //  ( )     
          X := BitRect.Left;
          Y := BitRect.Top;
          if Adjusted then
          begin
            case Border of
              CepSingleBorder:
                begin //, ,  
                  if Enabled then
                  begin //    ,   
                    if not Hot then
                      ColorToMonocrom(Img^, clFuchsia, Count);
                    CopyAlphaBitmap(Img, Bk, BitInfoImg, BitInfoBk, X, Y, clNone);
                  end
                  else
                  begin //   ,  ...    
                  //ColorToGray(Img^,clFuchsia,Count);
                    ColorToMonocrom(Img^, clFuchsia, Count);
                  //ColorToDull(Img,BitInfoImg,clFuchsia);
                    CopyAlphaBitmap(Img, Bk, BitInfoImg, BitInfoBk, X, Y, clNone, 100);
                  end;
                end;
              CepNoBorder, CepFlatBorder:
                begin //,   
                  if Enabled then
                  begin //    ,  ...  
                    if not Hot then ColorToDull(Img, BitInfoImg, clFuchsia);
                    CopyAlphaBitmap(Img, Bk, BitInfoImg, BitInfoBk, X, Y, clNone);
                  end
                  else
                  begin //   ,  ...  
                  //ColorToGray(Img^,clFuchsia,Count);
                    ColorToDull(Img, BitInfoImg, clFuchsia);
                    CopyAlphaBitmap(Img, Bk, BitInfoImg, BitInfoBk, X, Y, clNone, 100);
                  end;
                end;
              CepXpBorder:
                begin //    XP
                  if Enabled then
                  begin
                    if (Hot and (not Pushed)) and (Width > MinSize) and (Height > MinSize) then
                    begin //   ,     ,    
                      if (Width > MinSize + 1) and (Height > MinSize + 1) then
                        CopyShadowAlphaBitmap(Img, Bk, BitInfoImg, BitInfoBk, X, Y, clNone, 255, 1, 2)
                      else
                        CopyShadowAlphaBitmap(Img, Bk, BitInfoImg, BitInfoBk, X, Y, clNone, 255, 1, 1);
                    end
                    else
                    begin
                      CopyAlphaBitmap(Img, Bk, BitInfoImg, BitInfoBk, X, Y, clNone);
                    end;
                  end
                  else
                  begin
                    if Transparent then
                    begin
                    //ColorToGray(Img^,clFuchsia,Count);
                      ColorToDull(Img, BitInfoImg, clFuchsia);
                      CopyAlphaBitmap(Img, Bk, BitInfoImg, BitInfoBk, X, Y, clNone, 100);
                    end
                    else
                    begin
                    //ColorToMonocrom(Img^,clFuchsia,Count);
                      ColorToDull(Img, BitInfoImg, clFuchsia);
                      CopyAlphaBitmap(Img, Bk, BitInfoImg, BitInfoBk, X, Y, clnone, 100);
                    end;
                  end;
                end;
            end;
          end
          else
          begin
            CopyAlphaBitmap(Img, Bk, BitInfoImg, BitInfoBk, X, Y, clNone);
          end;
        finally
          SetDib(Bitmap, Bk, BitInfoBk);
        end;
      finally
        ReallocMem(Img, 0);
      end;
    end
    else
    begin
      GetDib(Bitmap, Bk, BitInfoBk);
      try
        CountBk := BitInfoBk.bmiHeader.biWidth * BitInfoBk.bmiHeader.biHeight;
        SetAlphaBlendValue(Bk^, 255, CountBk);
        ColorToAlpha(Bk^, clFuchsia, CountBk);
      finally
        SetDib(Bitmap, Bk, BitInfoBk);
      end;
    end;
    //     
    if (Border in [CepSingleBorder, CepFlatBorder]) and (not IsTheme) then
    begin
      //if Transparent or (Blend<255) then
      //begin
      R := Rect(0, 0, Bitmap.Width, Bitmap.Height);
      UpdateBitmap(TmpBitmapImg, R);
      TmpBitmapImg.Canvas.FillRect(R);
      TmpBitmapImg.Canvas.Font := Font;
      if not Enabled then TmpBitmapImg.Canvas.Font.Color := clGrayText;
      DrawText(TmpBitmapImg.Canvas, TextRect, 0, true);
      DrawBorder(TmpBitmapImg, ARect);
      GetDib(TmpBitmapImg, Img, BitInfoImg);
      try
        Count := BitInfoImg.bmiHeader.biWidth * BitInfoImg.bmiHeader.biHeight;
        SetAlphaBlendValue(Img^, 255, Count);
        ColorToAlpha(Img^, clFuchsia, Count);
        GetDib(Bitmap, Bk, BitInfoBk);
        try
          CopyAlphaBitmap(Img, Bk, BitInfoImg, BitInfoBk, 0, 0, clNone, 255);
        finally
          SetDib(Bitmap, Bk, BitInfoBk);
        end;
      finally
        ReallocMem(Img, 0);
      end;
      //end else
      //begin
      // if not Enabled then Bitmap.Canvas.Font.Color:=clGrayText;
      //  DrawText(Bitmap.Canvas,TextRect,0,Transparent);
      //  DrawBorder(Bitmap,ARect);
      //end;
    end;
  finally
    fDrawing := false;
  end;
end;

procedure TRichImageList.Draw(ACanvas: TCanvas; const Rect: TRect);
var Bitmap: TBitmap;
  R: TRect;
  Img, Bk: PArrayColor;
  BitInfoImg, BitInfoBk: TBitmapInfo;
begin
  Img := nil;
  Bk := nil;
  try
    if (ACanvas <> nil) and (fBuf <> nil) and (self <> nil) then
    begin
      if (not GetHasButtonBitmap(PHasButtonBitmap(fBuf)^)) then
      begin
        InsertHasButtonBitmap(PHasButtonBitmap(fBuf)^);
        DrawAll(PHasButtonBitmap(fBuf)^.Bit, ACanvas.Font, Rect);
      end;
      Bitmap := PHasButtonBitmap(fBuf)^.Bit;
      if (Transparent) or (fBlend < 255) then
      begin
        if fBlend > 0 then
        begin
          R := Rect;
          UpdateBitmap(TmpBitmapBackground, R);
          BitBlt(TmpBitmapBackground.Canvas.Handle, 0, 0, R.Right, R.Bottom,
            ACanvas.Handle, Rect.Left, Rect.Top, SRCCOPY);
          GetDib(TmpBitmapBackground, Bk, BitInfoBk);
          try
            GetDib(Bitmap, Img, BitInfoImg);
            try
              SetAlphaBlendValue(Bk^, 255, BitInfoBk.bmiHeader.biWidth * BitInfoBk.bmiHeader.biHeight);
              CopyAlphaBitmap(Img, Bk, BitInfoImg, BitInfoBk, 0, 0, clNone, fBlend);
            finally
              ReallocMem(Img, 0);
            end;
          finally
        // -    255   
        //for i:=0 to (BitInfoBk.bmiHeader.biHeight*BitInfoBk.bmiHeader.biWidth)-1 do begin
        // Bk^[i]:=GetNearestColor(ACanvas.Handle,(Bk^[i])and($00FFffFF));
        //end;
            SetDib(TmpBitmapBackground, Bk, BitInfoBk);
          end;
       //TmpBitmapBackground.PixelFormat:=pf8Bit;
       //UpdateColors(TmpBitmapBackground.Canvas.Handle);
          ACanvas.Draw(Rect.Left, Rect.Top, TmpBitmapBackground);
        end;
      end
      else
      begin
        ACanvas.Draw(Rect.Left, Rect.Top, Bitmap);
      end;
    end;
  except
    raise;
  end;
end;

procedure TRichImageList.SaveToClipboardFormat(var AFormat: Word; var AData: THandle;
  var APalette: HPALETTE);
begin
end;

procedure TRichImageList.LoadFromClipboardFormat(AFormat: Word; AData: THandle; APalette: HPALETTE);
begin
end;

procedure TRichImageList.SaveToStream(Stream: TStream);
begin
end;

procedure TRichImageList.LoadFromStream(Stream: TStream);
begin
end;

function TRichImageList.IsTheme: boolean;
begin
  result := ThemeEnabled and (Border in [CepSingleBorder, CepFlatBorder]) and LoadThemeLib;
end;

type
  THookThemeChanged = class(TObject)
  private
    fTICK_THEMECHANGED: Double;
    function DoThemeChanged(var Message: TMessage): Boolean;
  public
    constructor Create;
    destructor Destroy; override;
  end;

{ THookThemeChanged }

function HookThemeChanged: boolean;
begin
  result := HookObject <> nil;
  if not result then
  begin
    HookObject := THookThemeChanged.Create;
  end;
end;

constructor THookThemeChanged.Create;
begin
  fTICK_THEMECHANGED := GetTickCount;
  if Application <> nil then
  begin
    Application.HookMainWindow(DoThemeChanged);
  end
  else
    raise Exception.Create(NoApplication);
end;

destructor THookThemeChanged.Destroy;
begin
  if Application <> nil then
  begin
    Application.UnhookMainWindow(DoThemeChanged);
  end;
  inherited;
end;

function THookThemeChanged.DoThemeChanged(var Message: TMessage): Boolean;
begin
  result := false;
  if Message.Msg = WM_THEMECHANGED then
  begin
    if (GetTickCount - fTICK_THEMECHANGED) > 100 then
    begin
      UnloadThemeLib;
      ClearHasButtonBitmap;
      fTICK_THEMECHANGED := GetTickCount;
    end;
  end;
end;

initialization
  HookObject := nil;
  InitThemeInfo;
  TmpBitmapImg := nil;
  TmpBitmapBackground := nil;
  TextBitmap := nil;
  Blur1 := nil;
  Blur2 := nil;
  SizeBlurBuff := 0;
  Shadow := nil;
  SizeShadowBuff := 0;
  TransparentBuff := nil;
  SizeTransparentBuff := 0;
  SourceChanelBuff := nil;
  DestChanelBuff := nil;
  SizeChanelBuff := 0;

finalization
  FreeAndNil(HookObject);
  ReallocMem(DestChanelBuff, 0);
  ReallocMem(SourceChanelBuff, 0);
  ReallocMem(TransparentBuff, 0);
  ReallocMem(Shadow, 0);
  ReallocMem(Blur1, 0);
  ReallocMem(Blur2, 0);
  ClearHasButtonBitmap;
  FreeAndNil(TmpBitmapImg);
  FreeAndNil(TmpBitmapBackground);
  FreeAndNil(TextBitmap);
  UnloadThemeLib;

end.

