{$IFDEF DELPHI_2005_UP}{$REGION '   TSplashWindow,  TThreadWindow.     (-), ...'}{$ENDIF}
///	<summary>   TSplashWindow,   TThreadWindow.    
///	(-),     .</summary>
{$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
unit CSplashWindow;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  WindowThread, CWindowThread, Math;
resourcestring
  ErrorCount = '    TCSplashWindow.     ';
  ///	<summary>      </summary>
  TextDefaultValue = ': %ProductVersion%' + #13#10 +
                    '%LegalCopyright%' + #13#10 +
                    '%FileDescription%';
  ///	<summary>    </summary>
  CaptionDefaultValue = '%ProductName%';
const

  {$IFDEF DELPHI_2005_UP}{$REGION '      '}{$ENDIF}
  ///	<summary>      </summary>
  {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
  SplashName = 'SPLASH';

  {$IFDEF DELPHI_2005_UP}{$REGION '    '}{$ENDIF}
  ///	<summary>    </summary>
  {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
  DefaultHeight = 320;

  {$IFDEF DELPHI_2005_UP}{$REGION '    '}{$ENDIF}
  ///	<summary>    </summary>
  {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
  DefaultWidth = 256;

  {$IFDEF DELPHI_2005_UP}{$REGION ' ,          Version    ...'}{$ENDIF}
  ///	<summary>
  ///	  <para> ,          Version</para>
  ///	  <para>    : '%ProductName%'</para>
  ///	</summary>
  {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
  VersionInfoFields: array [0..11] of string = ('FileVersion',
                                               'Build',
                                               'Version',
                                               'CompanyName',
                                               'FileDescription',
                                               'InternalName',
                                               'LegalCopyright',
                                               'LegalTrademarks',
                                               'OriginalFilename',
                                               'ProductName',
                                               'ProductVersion',
                                               'Comments');

type

  {$IFDEF DELPHI_2005_UP}{$REGION ' TCSplashWindow     TSplashWindow        'SPLASH', ...'}{$ENDIF}
  ///	<summary> TCSplashWindow     TSplashWindow       
  ///	'SPLASH',  'SPLASH_XX' ( XX &#8212;    ),        
  ///	  ,      3 .</summary>
  ///	<remarks>
  ///	          TCSplashWindow   .
  ///	  <note type="important">     <b></b>       
  ///	      Application,   dfm-   . TCSplashWindow
  ///	     dfm-      DefaultSplashClassName.   
  ///	  ,     .</note>
  ///	</remarks>
  ///	<example>
  ///	  <para><b>unit</b> Unit2;</para>
  ///	  <para><b>interface</b></para>
  ///	  <para><b>uses</b> CSplashWindow;</para>
  ///	  <para><b>implementation</b></para>
  ///	  <para><b>initialization</b></para>
  ///	  <para>ShowSplash;</para>
  ///	  <para><b>end</b>.</para>
  ///	  <para>//</para>
  ///	  <para><b>program</b> ProjectSplash;</para>
  ///	  <para><b>uses</b></para>
  ///	  <para>Unit2 <b>in</b> '<i>Unit2.pas</i>',</para>
  ///	  <para>Forms, ...</para>
  ///	</example>
  ///	<seealso cref="TSplashWindow"></seealso>
  ///	<seealso cref="DefaultSplashClassName"></seealso>
  ///	<seealso cref="SplashWindow"></seealso>
  ///	<seealso cref="CWindowThread.TCWindowThread"></seealso>
  {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
  TCSplashWindow = class(TCWindowThread)
  private
    fResourceName: string;
    fStayOnTopSec: integer;
    fBitmap: TBitmap;
    procedure SetStayOnTopSec(const Value: integer);
  protected
    procedure SetBitmap(const Value: TBitmap); virtual;
    function CreateWindow: TCustomThreadWindow; override;
    procedure SetVisible(const Value: boolean); override;
  public

    {$IFDEF DELPHI_2005_UP}{$REGION ' '}{$ENDIF}
    ///	<summary> </summary>
    {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
    property Bitmap: TBitmap read fBitmap write SetBitmap;
  published
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    {$IFDEF DELPHI_2005_UP}{$REGION '   .   'SPLASH'.      ,   ...'}{$ENDIF}
    ///	<summary>   .   'SPLASH'.      ,
    ///	   DefaultInstance.</summary>
    ///	<remarks>         'SPLASH_XX' ( XX -   
    ///	).           .</remarks>
    ///	<seealso cref="DefaultInstance"></seealso>
    {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
    property ResourceName:string read fResourceName write fResourceName;
    property IconSize default 16;
    property Interval default 0;
    property AlphaShow default false;
    property UseSysFont default false;
    property Percent default 0;
    property Height default DefaultHeight;
    property Width default DefaultWidth;
    property Color default clBtnFace;
    property TotalTimeSec default 3;
    {$IFDEF DELPHI_2005_UP}{$REGION ' ( )        StayOnTop.'}{$ENDIF}
    ///	<summary> ( )         StayOnTop.</summary>
    ///	<remarks>    ,          
    ///	 .    ,    .</remarks>
    {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
    property StayOnTopSec: integer read fStayOnTopSec write SetStayOnTopSec default 2;
  end;

  {$IFDEF DELPHI_2005_UP}{$REGION '  '}{$ENDIF}
  ///	<summary>  </summary>
  ///	<seealso cref="TCSplashWindow"></seealso>
  {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
  TCSplashWindowClass = class of TCSplashWindow;
const
  {$IFDEF DELPHI_2005_UP}{$REGION ' ,     '}{$ENDIF}
  ///	<summary> ,     </summary>
  {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
  UM_GetBitmap = WM_USER + 113;

  {$IFDEF DELPHI_2005_UP}{$REGION '      '}{$ENDIF}
  ///	<summary>      </summary>
  {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
  UM_SetBitmap = WM_USER + 114;
type
  {$IFDEF DELPHI_2005_UP}{$REGION '   ,     '}{$ENDIF}
  ///	<summary>   ,     </summary>
  {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
  TUMGetSetBitmap = packed record
    Msg: Cardinal;
    IndexProp: Word;
    Part: Word;
    Value: TBitmap;
    Result: Longint;
  end;

  {$IFDEF DELPHI_2005_UP}{$REGION '   ,     .'}{$ENDIF}
  ///	<summary>   ,     .</summary>
  ///	<seealso cref="TThreadWindow"></seealso>
  {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
  TSplashWindow = class (TCustomThreadWindow)
  private
    fBkBitmap: TBitmap;
    fBitmap: TBitmap;
    fFirstShow:boolean;
    fStayOnTopSec: integer;
    procedure SetBitmap(const Value: TBitmap);
    function GetBitmap: TBitmap;
    procedure UMGetBitmap(var Message: TUMGetSetBitmap); message UM_GetBitmap;
    procedure UMSetBitmap(var Message: TUMGetSetBitmap); message UM_SetBitmap;
  protected
    procedure DrawWND(DC:HDC; ARect:TRect); override;
    procedure DrawCaption(DC: HDC; ARect: TRect; Text: PChar; Len:integer); override;
    procedure DrawText(DC: HDC; ARect: TRect; Text: PChar; Len:integer); override;
    procedure DrawIcon(DC: HDC; ARect: TRect; Icon: HIcon; Brush: HBrush); override;
    procedure DrawTime(DC: HDC; ARect: TRect; StartTime, TotalTime: TDateTime); override;
    procedure UpdateLayout(ClientRect: TRect; var ElementPos: TElementPos); override;
    procedure Change(var UpdateAreas: TUpdateAreas); override;
    function DefaultBoundsRect: TRect; override;
    procedure DrawBackground(DC: HDC; ARect: TRect; Ctl3D: boolean); override;
  public
    procedure AfterConstruction; override;
    destructor Destroy; override;

    {$IFDEF DELPHI_2005_UP}{$REGION ' '}{$ENDIF}
    ///	<summary> </summary>
    {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
    property Bitmap:TBitmap read GetBitmap write SetBitmap;
    property StayOnTopSec: integer read fStayOnTopSec write fStayOnTopSec;
  end;

var

  {$IFDEF DELPHI_2005_UP}{$REGION ' "" ,    SplashWindow.  nil,   TCSplashWindow.'}{$ENDIF}
  ///	<summary> "" ,    SplashWindow.  nil,  
  ///	TCSplashWindow.</summary>
  ///	<seealso cref="TCSplashWindowClass"></seealso>
  ///	<seealso cref="TCSplashWindow"></seealso>
  ///	<seealso cref="SplashWindow"></seealso>
  {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
  DefaultSplashClass: TCSplashWindowClass;

  {$IFDEF DELPHI_2005_UP}{$REGION ' ,     dfm ,    "" .    ...'}{$ENDIF}
  ///	<summary> ,     dfm ,    "" . 
  ///	  ,        DefaultSplashClass.</summary>
  ///	<seealso cref="DefaultSplashClass"></seealso>
  {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
  DefaultSplashClassName: string;
  {$IFDEF DELPHI_2005_UP}{$REGION ' ,         . Important Note:    ...'}{$ENDIF}
  ///	<summary>
  ///	  <para> ,         .</para>
  ///	  <note type="important">
  ///	    <para>     :</para>
  ///	    <para>1.  DefaultInstance,   0</para>
  ///	    <para>2.      (ENU, RUS  ..). . FindResourceHInstance</para>
  ///	    <para>3.   . . HInstance</para>
  ///	    <para>4.      (Dll  Bpl),  DefaultInstance = 0</para>
  ///	  </note>
  ///	</summary>
  {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
  DefaultInstance: HModule;


{$IFDEF DELPHI_2005_UP}{$REGION ' SplashWindow  ""  (  ,      ...'}{$ENDIF}
///	<summary> SplashWindow  ""  (  ,   
///	    ).     ,  .    
///	 DefaultSplashClass.</summary>
///	<returns>  -</returns>
///	<remarks>     ,    .    Free
///	.</remarks>
///	<seealso cref="TCSplashWindowClass"></seealso>
///	<seealso cref="DefaultSplashClass"></seealso>
///	<seealso cref="TCSplashWindow"></seealso>
///	<seealso cref="ShowSplash"></seealso>
{$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
function SplashWindow:TCSplashWindow;

{$IFDEF DELPHI_2005_UP}{$REGION '    .'}{$ENDIF}
///	<summary>    .</summary>
{$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
procedure ShowSplash;

{$IFDEF DELPHI_2005_UP}{$REGION '     ,    .   Objects   '}{$ENDIF}
///	<summary>     ,    .   Objects  
///	</summary>
///	<param name="Instance">     </param>
///	<param name="List">     </param>
///	<param name="lpType"> ,     .: RT_BITMAP</param>
///	<param name="Name"> (      Name)</param>
///	<seealso cref="Windows.RT_BITMAP"></seealso>
///	<seealso cref="Windows.RT_RCDATA"></seealso>
///	<seealso cref="Windows.RT_ICON"></seealso>
{$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
procedure EnumResources(Instance: LongWord; var List: TStringList; lpType: PChar; Name: string='');
{$IFDEF DELPHI_2005_UP}{$REGION '        ,   .'}{$ENDIF}
///	<summary>        ,   .</summary>
///	<param name="List">,    .</param>
///	<returns>     True</returns>
{$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
function EnumDLLs(List: TStringList):boolean;

procedure Register;

implementation
uses GraphUtilEx, InternalTimer, Forms;

var InternalSplash: TCSplashWindow;
    IsInitialization: boolean;
    CountCSplashWindow: integer;

procedure Register;
begin
  RegisterComponents('Cep', [TCSplashWindow]);
end;

type
  TTimerObject = class
  private
    fInternalTimer: TInternalTimer;
    fVersionList: TStringList;
    procedure InitVersionInfo;
  public
    procedure onTimer(Sender: TObject);
    constructor Create;
    destructor Destroy; override;
  end;

var
  TimerObject: TTimerObject;


{ TTimerObject }

constructor TTimerObject.Create;
begin
  fInternalTimer := TInternalTimer.Create(nil);
  fInternalTimer.ExecuteInterval(100, onTimer);
  InitVersionInfo;
end;

destructor TTimerObject.Destroy;
begin
  FreeAndNil(fInternalTimer);
  FreeAndNil(fVersionList);
  inherited;
end;

procedure TTimerObject.onTimer(Sender: TObject);
type TOwn = record
       Owner: TComponent;
       Index: integer;
     end;
var Style: LongInt;
    O: array of TOwn;
    C: TComponent;
begin
  if (InternalSplash <> nil) then
  begin
    if (not InternalSplash.Visible) then
      FreeAndNil(InternalSplash)
    else
    begin
      if (InternalSplash.Window <> nil) and
         (InternalSplash.Window.WND <> 0) and
         (Application <> nil) then
      begin
        Style := GetWindowLong(InternalSplash.Window.WND, GWL_STYLE);
        if (Style <> 0) and ((Style and WS_EX_TOPMOST) <> Style) then
        begin
          SetLength(O, 1);
          O[High(O)].Owner := Application;
          O[High(O)].Index := 0;
          while Length(O) > 0 do
          begin
            while O[High(O)].Index < O[High(O)].Owner.ComponentCount do
            begin
              C := O[High(O)].Owner.Components[O[High(O)].Index];
              if (C is TCustomForm) and (fsModal in TCustomForm(C).FormState) then
              begin
                //TCustomForm(C).SendToBack;
                TCustomForm(C).BringToFront;
              end;
              if C.ComponentCount > 0 then
              begin
                SetLength(O, Length(O) + 1);
                O[High(O)].Owner := C;
                O[High(O)].Index := 0;
                Continue;
              end;
              inc(O[High(O)].Index);
            end;
            SetLength(O, Length(O) - 1);
            if Length(O) > 0 then
              inc(O[High(O)].Index);
          end;
        end;
      end;
    end;
  end;
end;

//        
procedure TTimerObject.InitVersionInfo;
type T = array [0..1] of WORD;
var Size, Fake : DWORD;
    P : ^T;
    FileName:string;
    VersionInfo:Pointer;
    LangCharSet, Text, S, V : String;
    I, J: integer;

  function GetValue(const ValueName : String; var Buffer : Pointer) : Boolean;
  begin
     Result := VerQueryValue(VersionInfo, PChar(ValueName), Buffer, Size);
  end;

  function GetLocalValue(const ValueName : String) : String;
  var P : Pointer;
  begin
     if GetValue('\StringFileInfo\' + LangCharSet + '\' + ValueName, P) then
       Result := PChar(P)
     else
       Result := '';
  end;
  procedure AddStr(S: String);
  begin
    fVersionList.Values[S] := GetLocalValue(S);
  end;
  function DelEndZero(const S: string): string;
  begin
    Result := S;
    while (Length(Result)>1) and
          (AnsiChar(Result[Length(Result)]) in ['0', '.', ',']) do Delete(Result,Length(Result),1);
  end;

begin
  VersionInfo := nil;
  FileName := ParamStr(0);
  try
    Size := GetFileVersionInfoSize(PChar(FileName), Fake);
    if Size>0 then begin
     if fVersionList = nil then
       fVersionList := TStringList.Create
     else
       fVersionList.Clear;
     GetMem(VersionInfo, Size);
     if GetFileVersionInfo(PChar(FileName), 0, Size, VersionInfo) then
     begin
       GetValue('\VarFileInfo\Translation', Pointer(P));
       LangCharSet := Format('%.4x%.4x', [P^[0], P^[1]]);
       Text := '';
       S := Trim(GetLocalValue(VersionInfoFields[0]));
       fVersionList.Values[VersionInfoFields[0]] := S;
       fVersionList.Values[VersionInfoFields[1]] := DelEndZero(S);
       V := '';
       I := 1;
       for J := 0 to 1 do
       begin
         if V <> '' then V := V + '.';
         while (I < Length(S)) and (not (AnsiChar(S[i]) in ['.', ','])) do
         begin
           V := V + S[I];
           inc(I);
         end;
         inc(I);
       end;
       fVersionList.Values[VersionInfoFields[2]] := DelEndZero(V);;
       for I := 3 to High(VersionInfoFields) do
         AddStr(VersionInfoFields[I]);
     end;
    end;
  finally
    ReallocMem(VersionInfo,0);
  end;
end;




//     
function EnumResNameProc(Module: HMODULE;
  lpszType: LPCTSTR;
  lpszName: LPTSTR;
  lParam: LongInt): BOOL; stdcall;// safecall;
var List: TStringList;
begin
  result := (lParam <> 0) and (TObject(LParam) is TStringList);
  if result then
  begin
    List := TStringList(lParam);
    List.AddObject(lpszName, TObject(Module));
    result := true;
  end;
end;

//       
function EnumDLLs(List: TStringList):boolean;
type
  PPEB_LDR_DATA = ^TPEB_LDR_DATA;
  TPEB_LDR_DATA = Record
    Length: ULONG ;
    Initialized: UCHAR;
    SsHandle: Pointer;
    InLoadOrderModuleList: LIST_ENTRY;
    InMemoryOrderModuleList: LIST_ENTRY;
    InInitializationOrderModuleList: LIST_ENTRY;
    EntryInProgress: Pointer;
  end;
  TPEB = Packed Record
    InheritedAddressSpace: ByteBool;
    ReadImageFileExecOptions: ByteBool;
    BeingDebugged: ByteBool;
    Spare: ByteBool;
    Mutant: THANDLE;
    ImageBaseAddress: Pointer;
    LoaderData: PPEB_LDR_DATA;
  End;
  TLDR_MODULE = Packed Record
    InLoadOrderModuleList: LIST_ENTRY ;
    InMemoryOrderModuleList: LIST_ENTRY ;
    InInitializationOrderModuleList: LIST_ENTRY;
    BaseAddress: Pointer;
    EntryPoint: Pointer;
    SizeOfImage: ULONG ;
    FullDllName: PWideChar;
    BaseDllName: PWideChar;
    Flags: ULONG;
    LoadCount: WORD {USHORT};
    TlsIndex: WORD {USHORT};
    HashTableEntry: LIST_ENTRY;
    TimeDateStamp: ULONG;
  End;
var dummy: Cardinal;
    hProcess, H:THandle;
    Peb: TPEB;
    I: integer;
    Found: boolean;
    LDR: TPEB_LDR_DATA;
    LDM: TLDR_MODULE;
    S: WideString;
    Addr, StartAddr: Pointer;
  function GetPeb:DWORD; register;
  assembler; asm
    mov eax, FS:[$30]
  end;
begin
  result := false;
  if List<>nil then
  begin
    hProcess:=GetCurrentProcess;
    if hProcess <> 0 then
    begin
      Addr := Pointer(GetPeb);
      if ReadProcessMemory(hProcess, Addr, @Peb, SizeOf(Peb), dummy) then
      begin
        ReadProcessMemory(hProcess, Peb.LoaderData, @LDR, SizeOf(LDR), dummy);
        Addr := LDR.InLoadOrderModuleList.Flink;
        StartAddr := Addr;
        while (ReadProcessMemory(hprocess, Addr, @LDM, sizeof(LDM), dummy)) and
              (Addr <> nil) do
        begin
          if LDM.BaseDllName = nil then break;
          H := GetModuleHandleW(LDM.BaseDllName);
          if H <> 0 then
          begin
            S := LDM.BaseDllName;
            //if MessageBoxW(0, LDM.BaseDllName, 'DLL', MB_YESNO)<>IDYES then break;
            Found := False;
            for I := 0 to List.Count - 1 do
              if THandle(List.Objects[I]) = H then
              begin
                Found := True;
                break;
              end;
            if not Found then
              List.AddObject(S, Pointer(H));
          end;
          Addr := LDM.InLoadOrderModuleList.Flink;
          if StartAddr = Addr then Break;
        end;
        result := true;
      end;
    end;
  end;
end;

//      RT_BITMAP,    
//      Name
procedure EnumResources(Instance: LongWord; var List: TStringList; lpType: PChar; Name: string='');
var L:TStringList;
    i:integer;
  function ResourceNameToSize(Name:string):integer;
  var S:string;
      i,Code,Size:integer;
  begin
    S := Trim(Name);
    result := 0;
    I := 0;
    while (I<Length(S)) and (I<3) and
          (S[Length(S)-I]>='0')  and (S[Length(S)-I]<='9') do inc(I);
    if (I<Length(S)) and (S[Length(S)-I]='_') then
    begin
      S := Copy(S,Length(S)-I+1,I);
      if S<>'' then
      begin
        Val(S, Size, Code);
        if Code=0 then result := Size;
      end;
    end;
  end;
begin
  if List = nil then Exit;
  L := nil;
  try
    L := TStringList.Create;
    EnumResourceNames(Instance, lpType, @EnumResNameProc, integer(L));
    List.BeginUpdate;
    try
      for i := 0 to L.Count-1 do
        if List.IndexOf(L[i])=-1 then
        begin
          if (Name='') or (Copy(L[i], 1, Length(Name)) = Name) then
            List.AddObject(L[I],TObject(L.Objects[I]));
        end;
    finally
      List.EndUpdate;
    end;
  finally
    FreeAndNil(L);
  end;
end;

type TReaderEx = Class(TReader)
     public
       function CheckSignature: boolean;
     end;

{ TReaderEx }

function TReaderEx.CheckSignature: boolean;
var Signature: Longint;
    OldPos: integer;
const
  FilerSignature: packed array[1..4] of AnsiChar = AnsiString('TPF0');
begin
  OldPos := Position;
  Read(Signature, SizeOf(Signature));
  result := Signature = Longint(FilerSignature);
  if not result then Position := OldPos;
end;

//    
function ExtractComponent(Instance: LongWord;
                          ResourceName, ClassName, ComponentName: string;
                          Stream: TMemoryStream): boolean;
var  Resource: HGLOBAL;
     ResourceList: TStringList;
     RSRC: HRSRC;
     Size, StartPos, EndPos: Dword;
     RData, P: Pointer;
     St: TMemoryStream;
     I: Integer;
     Reader: TReaderEx;
     Writer: TWriter;
     IsComponent: boolean;
  procedure AddToList(Instance: LongWord);
  begin
    if ResourceName = '' then
      EnumResourceNames(Instance,
                        RT_RCDATA,
                        @EnumResNameProc,
                        LongInt(ResourceList))
    else
      ResourceList.AddObject(ResourceName, TObject(Instance));
  end;
  function FindComponent(ClassName, ComponentName: string;
                     var StartPos, EndPos: DWORD): boolean;
  var X: DWORD;
      ClName, CoName: string;
      Level, StartLevel: integer;
    function Eof: boolean;
    var VName: string;
    begin
      result := Reader.Position >= St.Size;
      if not Result then
      begin
        VName := Reader.ReadStr;
        if (VName = '') then
        begin
          while (Reader.Position < St.Size) and (integer(Reader.NextValue) = 0) and
                (Level > StartLevel) do
          begin
            dec(level);
            Reader.SkipValue;
          end;
          result := true
        end;
      end;
    end;
  begin
    ClassName := Trim(AnsiUpperCase(ClassName));
    ComponentName := Trim(AnsiUpperCase(ComponentName));
    Result := False;
    StartPos := 0;
    EndPos := 0;
    Level := 0;
    StartLevel := 0;
    repeat
      repeat
        X := Reader.Position;
        ClName := Trim(AnsiUpperCase(Reader.ReadStr));
      until (ClName <> '') or (Reader.Position >= St.Size);
      CoName := Trim(AnsiUpperCase(Reader.ReadStr));
      if ((ClassName = '') or (ClassName = ClName)) and
         ((ComponentName = '') or (CoName = ComponentName)) then
      begin
        StartPos := X;
        StartLevel := Level;
      end;
      if (CoName <> '') and (ClName <> '') then
        inc(Level);
      repeat
        if not EOF then
          Reader.SkipValue
        else
        begin
          if (StartPos > 0) and (StartLevel = Level) then
          begin
            EndPos := Reader.Position;
            result := True;
            Exit;
          end;
          break;
        end;
      until (Reader.Position >= St.Size);
    until (Reader.Position >= St.Size);
  end;
begin
  Result := False;
  ResourceList := nil;
  try
    ResourceList := TStringList.Create;
    if Instance = 0 then
      Instance := FindResourceHInstance(hInstance);
     AddToList(Instance);
    for I := 0 to ResourceList.Count - 1 do
    begin
      RSRC := FindResource(HMODULE(ResourceList.Objects[I]), PChar(ResourceList[I]), RT_RCDATA);
      if RSRC = 0 then Exit;
      Size := SizeofResource(Instance, RSRC);
      if Size <= 4 then Exit;
      Resource := LoadResource(Instance, RSRC);
      if Resource = 0 then RaiseLastOsError;
      RData := LockResource(Resource);
      if RData = nil then RaiseLastOsError;
      Reader := nil;
      St := TMemoryStream.Create;
      try
        St.WriteBuffer(RData^, Size);
        //St.Position := 0;
        //St.SaveToFile(ChangeFileExt(ParamStr(0), '.xxx'));
        St.Position := 0;
        Reader := TReaderEx.Create(St, 4096);
        try
          //  
          IsComponent := Reader.CheckSignature;
          //  Reader.ReadSignature;
          //  IsComponent := true;
        Except
          //             
          IsComponent := false;
        end;
        if IsComponent and FindComponent(ClassName, ComponentName, StartPos, EndPos) then
        begin
          Stream.Clear;
          Writer := TWriter.Create(Stream, 4096);
          try
            Writer.WriteSignature;
            Writer.FlushBuffer;
            St.Position := StartPos;
            Size := EndPos - StartPos;
            if Size > 0 then
            begin
              GetMem(P, EndPos - StartPos);
              try
                St.ReadBuffer(P^, Size);
                Stream.WriteBuffer(P^, Size);
                Size := 0;
                Stream.WriteBuffer(Size, SizeOf(Size));
              finally
                FreeMem(P);
              end;
            end;
          finally
            FreeAndNil(Writer);
          end;
          result := True;
          Exit;
        end;
      finally
        FreeAndNil(Reader);
        FreeAndNil(St);
      end;
    end;
  finally
    FreeAndNil(ResourceList);
  end;
end;

function SplashWindow:TCSplashWindow;
var SClass: TCSplashWindowClass;
    S, NewText, NewCaption: string;
    Stream: TMemoryStream;
    DLLs: TStringList;
    Resources: TStringList;
    I, J, N, MaxBitCount, MaxBitIndex, BitCount: integer;
    DC: HDC;
    Bitmap: TBitmap;
  function ExtractInternalSplash(Instance: HMODULE): boolean;
  begin
    Stream.Position := 0;
    result := ExtractComponent(Instance, '', S, '', Stream);
    if Result then
    try
      Stream.Position := 0;
      Stream.ReadComponent(InternalSplash);
    except
      //       
    end;
  end;
  function BitCountFromName(Name: string): integer;
  var S: string;
      I, Code: integer;
  begin
    Result := 0;
    S := '';
    I := Length(Name);
    while (I <= Length(Name)) and ((Name[I] >= '0') and (Name[I] <= '9')) do
    begin
      S := Name[I] + S;
      dec(I);
    end;
    if (I <= Length(Name)) and (Name[I] = '_') then
      Val(S, Result, Code);
  end;
  procedure AddInst(Instance: HModule);
  var I: integer;
  begin
    for I := 0 to DLLs.Count - 1 do
      if HModule(DLLs.Objects[I]) = Instance then
        Exit;
    DLLs.AddObject('', TObject(Instance));
  end;
begin
  if InternalSplash = nil then
  begin
    DLLs := nil;
    //    DefaultSplashClass,   ,  TCSplashWindow
    if DefaultSplashClass = nil then
      SClass := TCSplashWindow
    else
      SClass := DefaultSplashClass;
    IsInitialization := true;
    try
      //    ,      TCSplashWindow
      DLLs := TStringList.Create;
      if DefaultInstance <> 0 then
        AddInst(DefaultInstance);                // 1.   
      AddInst(FindResourceHInstance(hInstance)); // 2.    (RUS, ENU  ..)
      AddInst(hInstance);                        // 3.  
      if DefaultInstance = 0 then
        EnumDLLs(DLLs);                          // 4.  
      //  
      S := Trim(DefaultSplashClassName);
      if S = '' then
        S := SClass.ClassName;
      InternalSplash := SClass.Create(nil);
      //       (  ),   
      Stream := TMemoryStream.Create;
      try
        for I := 0 to DLLs.Count - 1 do
          if (ExtractInternalSplash(HMODULE(DLLs.Objects[I]))) then Break;
        if TimerObject = nil then
          TimerObject := TTimerObject.Create;
        if TimerObject.fVersionList <> nil then
        begin
          NewText := InternalSplash.Text;
          NewCaption := InternalSplash.Caption;
          for I := Low(VersionInfoFields) to High(VersionInfoFields) do
          begin
            NewText := sysutils.StringReplace(NewText,
                                   '%' + UpperCase(VersionInfoFields[I]) + '%',
                                   TimerObject.fVersionList.Values[VersionInfoFields[I]],
                                   [rfReplaceAll, rfIgnoreCase]);
            NewCaption := sysutils.StringReplace(NewCaption,
                                   '%' + UpperCase(VersionInfoFields[I]) + '%',
                                   TimerObject.fVersionList.Values[VersionInfoFields[I]],
                                   [rfReplaceAll, rfIgnoreCase]);
          end;
          InternalSplash.Text := NewText;
          InternalSplash.Caption := NewCaption;
        end;  
      finally
        Stream.Free;
      end;
      if InternalSplash.ResourceName <> '' then
      begin
        //    
        Resources := TStringList.Create;
        try
          for I := 0 to DLLs.Count - 1 do
          begin
            EnumResources(HMODULE(DLLs.Objects[I]), Resources, RT_BITMAP, InternalSplash.ResourceName);
          end;
          if Resources.Count > 0 then
          begin
            //      
            DC := GetDC(0);
            try
              BitCount := GetDeviceCaps(DC,COLORRES);
              if BitCount = 24 then BitCount := 32;
            finally
              ReleaseDC(0,DC);
            end;
            if BitCount=0 then BitCount := 32;
            //    ,     .
            //       <InternalSplash.ResourceName>_XX (     
            // ),    c  XX,     
            //    .
            // ,     <InternalSplash.ResourceName>,   .
            MaxBitIndex := 0;
            MaxBitCount := 0;
            for J := 0 to Resources.Count - 1 do
            begin
              N := BitCountFromName(Resources[J]);
              if (N > MaxBitCount) and (N <= BitCount) then
              begin
                MaxBitCount := N;
                MaxBitIndex := J;
              end;
              if N = BitCount then Break;
            end;
            Bitmap := TBitmap.Create;
            try
              Bitmap.LoadFromResourceName(HMODULE(Resources.Objects[MaxBitIndex]),
                                          Resources[MaxBitIndex]);
              InternalSplash.Bitmap := Bitmap;

            finally
              FreeAndNil(Bitmap);
            end;
          end;
        finally
          FreeAndNil(Resources);
        end;
      end;
    finally
      IsInitialization := False;
      FreeAndNil(DLLs);
    end;
  end;
  result := InternalSplash;
end;

procedure ShowSplash;
var I: integer;
begin
  if SplashWindow <> nil then
  begin
    InternalSplash.Visible := true;
    I := 0;
    while (InternalSplash.Window.WND = 0) and (I < 30) do
    begin
      Sleep(10);
      inc(I);
    end;
  end;
end;


{ TSplashWindow }

procedure TSplashWindow.AfterConstruction;
var F: TFont;
begin
  inherited;
  F := TFont.Create;
  try
    F.Size := 14;
    F.Name := 'Arial';
    CaptionFont := F.Handle;
    F.Size := 8;
    Font := F.Handle;
  finally
    FreeAndNil(F);
  end;
  Color := clNone;
  Interval := 0;
  Ctl3D := false;
  LowBlink := False;
  fFirstShow := true;
  AlphaShow := False;
  CaptionFontColor := ColorToRGB(clWindowText);
  CaptionColor := clNone;
  FontColor := ColorToRGB(clWindowText);
  IconSize := 16;
  StartTime := Now;
  Enabled := False;
end;

destructor TSplashWindow.Destroy;
var B1, B2: TBitmap;
begin
  B2 := fBkBitmap;
  B1 := fBitmap;
  inherited;
  if IsInitialization then FreeAndNil(InternalSplash);
  FreeAndNil(B1);
  FreeAndNil(B2);
end;

procedure TSplashWindow.DrawWND(DC: HDC; ARect: TRect);
begin
  OffsetRect(ARect, -ARect.Left, -ARect.Top);
  if (fBkBitmap = nil) or
     (fBkBitmap.Empty) or
     ((ARect.Right) <> fBkBitmap.Width) or
     ((ARect.Bottom) <> fBkBitmap.Height) then
  begin
    if fBkBitmap = nil then
    begin
      fBkBitmap := TBitmap.Create;
      fBkBitmap.PixelFormat := pf32bit;
      fBkBitmap.Transparent := False;
    end;
    fBkBitmap.Width := (ARect.Right);
    fBkBitmap.Height := (ARect.Bottom);
    fBkBitmap.Canvas.Lock;
    try
      inherited DrawWND(fBkBitmap.Canvas.Handle, ARect);
    finally
      fBkBitmap.Canvas.Unlock;
    end;
  end;
  fBkBitmap.Canvas.Lock;
  try
    windows.BitBlt(DC, 0, 0, fBkBitmap.Width, fBkBitmap.Height,
                   fBkBitmap.Canvas.Handle, 0, 0, SRCCOPY);
  finally
    fBkBitmap.Canvas.Unlock;
  end;
end;

function TSplashWindow.GetBitmap: TBitmap;
begin
  Result := nil;
  Perform(UM_GetBitmap, 0, LongInt(Result));
end;

procedure TSplashWindow.SetBitmap(const Value: TBitmap);
begin
  Perform(UM_SetBitmap, 0, LongInt(Value));
end;

procedure TSplashWindow.Change(var UpdateAreas: TUpdateAreas);
var D: Double;
begin
  inherited;
  if (TotalTime>0) and (StartTime>0) or (Canceled) then
  begin
    D := (TotalTime - (Now - StartTime)) * 24*60*60;
    D := D + 1;
    if (D < 0) or (Canceled) then
    begin
      Canceled := True;
      FreeAndNil(fBkBitmap);
      Stop;
      Exit;
    end
    else
    begin
      if D < 2 then AlphaBlendValue := Round(255 * D/2);
    end;
  end;
  if fFirstShow and (WND<>0) and
     ((fStayOnTopSec>=0) and (GetTickCount-ShowTick>DWORD(fStayOnTopSec * 1000))) then
  begin
    fFirstShow := false;
    SetWindowPos(WND, HWND_NOTOPMOST, 0,0,0,0,
                 SWP_NOMOVE {or SWP_NOREPOSITION {or SWP_NOSENDCHANGING} or SWP_NOSIZE or SWP_NOACTIVATE);
    SetWindowPos(WND, HWND_TOP, 0,0,0,0,
                 SWP_NOMOVE {or SWP_NOREPOSITION {or SWP_NOSENDCHANGING} or SWP_NOSIZE or SWP_NOACTIVATE);
  end;
  if UpdateAreas <> [] then
  begin
    if uaCaption in UpdateAreas then
      UpdateAreas := UpdateAreas + [uaAll];
    UpdateAreas := UpdateAreas + [uaWindow];
    if fBkBitmap <> nil then
      FreeAndNil(fBkBitmap);
  end;
end;

procedure TSplashWindow.UpdateLayout(ClientRect: TRect; var ElementPos: TElementPos);
var H,HH:integer;
    DC: HDC;
    R:TRect;
    OldF:HFont;
    S: string;
begin
  inherited;
  ElementPos.ProgressRect := Rect(ClientRect.Left + BorderWidth,
                                  ClientRect.Bottom - 2 * BorderWidth,
                                  ClientRect.Right - BorderWidth,
                                  ClientRect.Bottom - BorderWidth);
  if Percent < 0 then
    ElementPos.ProgressRect.Top := ElementPos.ProgressRect.Bottom;

  H := ElementPos.IconRect.Bottom - ElementPos.IconRect.Top;
  if H > 0 then
    ElementPos.IconRect := Rect(ElementPos.ProgressRect.Right - H,
                                BorderWidth,
                                ElementPos.ProgressRect.Right,
                                BorderWidth + H);

  H := ElementPos.Reserv.Bottom-ElementPos.Reserv.Top;
  if H > 0 then
    ElementPos.Reserv := Rect(ElementPos.IconRect.Left,
                              ElementPos.IconRect.Bottom + 1,
                              ClientRect.Right - BorderWidth,
                              ElementPos.IconRect.Bottom + 1 + H);



  ElementPos.TextRect.Top := ClientRect.Top + 2 * (ClientRect.Bottom - ClientRect.Top) div (3);
  ElementPos.TextRect.Bottom := ElementPos.ProgressRect.Top - 1;
  ElementPos.TextRect.Left := ClientRect.Left + BorderWidth;
  ElementPos.TextRect.Right := ClientRect.Right - BorderWidth;
  HH := 0;
  S := Caption;
  if S <> '' then
  begin
    DC := GetDC(0);
    try
      if CaptionFont<>0 then
      begin
        OldF := SelectObject(DC,CaptionFont);
        try
          R := Rect(ElementPos.TextRect.Left,0,ElementPos.TextRect.Right,2000);
          Windows.DrawText(DC, PChar(S), Length(S), R, DT_CALCRECT OR DT_WORDBREAK or DT_CENTER);
          HH := R.Bottom;
        finally
          SelectObject(DC,OldF);
        end;
      end;
    finally
        releaseDC(0,DC);
    end;
  end;
  ElementPos.CaptionRect.Left := ElementPos.TextRect.Left;
  ElementPos.CaptionRect.Right := ElementPos.TextRect.Right;
  ElementPos.CaptionRect.Top := Max(ElementPos.TextRect.Top-HH-BorderWidth,
                                    ClientRect.Top + BorderWidth);
  ElementPos.CaptionRect.Bottom := ElementPos.CaptionRect.Top+HH;
end;

function TSplashWindow.DefaultBoundsRect: TRect;
var R: TRect;
    W, H: integer;
begin
  R := inherited DefaultBoundsRect;
  if (fBitmap = nil) and (Owner is TCSplashWindow) then
    Bitmap := TCSplashWindow(Owner).Bitmap;
  if (fBitmap <> nil) and (Owner is TCSplashWindow) then
  begin
    W := R.Right - R.Left;
    W := Max(W, fBitmap.Width + 2 * BorderWidth) - W;
    H := R.Bottom - R.Top;
    H := Max(H, (fBitmap.Height * 3) div (2) + 2 * BorderWidth) - H;
    InflateRect(R, W div 2, H div 2);
    if (Color = Cardinal(clNone)) then
    begin
      if (not fBitmap.Transparent) then
      begin
        fBitmap.Canvas.Lock;
        try
          Color := fBitmap.Canvas.Pixels[0, fBitmap.Height - 1];
        finally
          fBitmap.Canvas.UnLock;
        end;
      end;
    end;
  end;
  Result := R;
end;

procedure TSplashWindow.DrawCaption(DC: HDC; ARect: TRect; Text: PChar;
  Len: integer);
begin
  SetBkMode(DC, TRANSPARENT);
  windows.DrawText(DC, PChar(Text), Len, ARect, DT_WORDBREAK OR DT_CENTER);
end;

procedure TSplashWindow.DrawIcon(DC: HDC; ARect: TRect; Icon: HIcon;
  Brush: HBrush);
begin
  if Icon <> 0 then begin
    Windows.DrawIconEx(DC,
      ARect.Left, ARect.Top,
      Icon,
      ARect.Right - ARect.Left, ARect.Bottom - ARect.Top,
      IconIndex, 0, DI_NORMAL);
  end;
end;

procedure TSplashWindow.DrawText(DC: HDC; ARect: TRect; Text: PChar;
  Len: integer);
var R: TRect;
    Y: integer;
begin
  SetBkMode(DC, TRANSPARENT);
  if Text <> nil then
  begin
    R := ARect;
    R.Bottom := R.Top + 65535;
    Windows.DrawText(DC, Text, Len, R, DT_CALCRECT OR DT_WORDBREAK or DT_CENTER);
    Y := ARect.Bottom - (R.Bottom - R.Top);
    Y := Min(ARect.Top, Y);
    Windows.ExcludeClipRect(DC, 0, 0, ARect.Right, ARect.Top);
    ARect.Top := Y;
    Windows.DrawText(DC, Text, Len, ARect, DT_WORDBREAK or DT_CENTER);
    SelectClipRgn(DC, 0);
  end;
end;

procedure TSplashWindow.DrawBackground(DC: HDC; ARect: TRect;
  Ctl3D: boolean);
var X, Y: integer;
begin
  inherited;
  if (fBitmap <> nil) and (not fBitmap.Empty) then
  begin
    X := (ARect.Left + ARect.Right - fBitmap.Width) div (2);
    Y := Min((ARect.Top + ARect.Bottom - fBitmap.Height) div (2), BorderWidth);
    fBitmap.Canvas.Lock;
    try
      BitBlt(DC, X, Y, fBitmap.Width, fBitmap.Height,
             fBitmap.Canvas.Handle, 0, 0, SRCCOPY);
    finally
      fBitmap.Canvas.UnLock;
    end;
  end;
end;

procedure TSplashWindow.UMGetBitmap(var Message: TUMGetSetBitmap);
begin
  Message.Value := fBitmap;
end;

procedure TSplashWindow.UMSetBitmap(var Message: TUMGetSetBitmap);
begin
  if Message.Value <> nil then
  begin
    if fBitmap = nil then
      fBitmap := TBitmap.Create;
    fBitmap.Assign(Message.Value);
    Invalidate(uaAll);
  end
  else
  begin
    if fBitmap <> nil then
    begin
      FreeAndNil(fBitmap);
      Invalidate(uaAll);
    end;
  end;
end;

procedure TSplashWindow.DrawTime(DC: HDC; ARect: TRect; StartTime,
  TotalTime: TDateTime);
begin
  SetBkMode(DC, TRANSPARENT);
  inherited;
end;

{ TCSplashWindow }

constructor TCSplashWindow.Create(AOwner: TComponent);
begin
  if not IsInitialization then
  begin
    if CountCSplashWindow>0 then
      raise Exception.Create(ErrorCount);
  end;
  inherited;
  if not IsInitialization then
  begin
    Inc(CountCSplashWindow);
  end;
  fStayOnTopSec := 2;
  Visible := False;
  Percent := 0;
  Interval := 0;
  AlphaShow := False;
  UseSysFont := false;
  IconSize := 16;

  TotalTimeSec := 3;
  Height := DefaultHeight;
  Width := DefaultWidth;
  Color := clBtnFace;
  Text := TextDefaultValue;
  Caption := CaptionDefaultValue;

  Font.Name := 'Arial';
  Font.Size := 9;
  CaptionFont.Size := 14;
  CaptionFont.Color := clWindowText;
  Font.Color := clWindowText;
  ClassWindow := TSplashWindow;
  ResourceName := SplashName;
end;

function TCSplashWindow.CreateWindow: TCustomThreadWindow;
begin
  result := inherited CreateWindow;
  try
    result.Canceled := False;
    result.Interval := Interval;
    result.AlphaShow := AlphaShow;
    TSplashWindow(result).StayOnTopSec := fStayOnTopSec;
  except
    result.Free;
    raise
  end;
end;

destructor TCSplashWindow.Destroy;
begin
  FreeAndNil(fBitmap);
  inherited;
  if not IsInitialization then
  begin
    if CountCSplashWindow>0 then Dec(CountCSplashWindow);
  end;
end;

procedure TCSplashWindow.SetBitmap(const Value: TBitmap);
begin
  if Value = nil then
    FreeAndNil(fBitmap)
  else
  begin
    if fBitmap = nil then
    begin
      fBitmap := TBitmap.Create;
    end;
    fBitmap.Assign(Value);

    if Width=DefaultWidth then
      Width := fBitmap.Width+16;
    if Height=DefaultHeight then
      Height := fBitmap.Height+140;
    if ColorToRGB(Color) = ColorToRGB(clBtnFace) then
      Color := fBitmap.Canvas.Pixels[0, fBitmap.Height-1];
  end;
  if Window is TSplashWindow then
    TSplashWindow(Window).Bitmap := fBitmap;
end;

procedure TCSplashWindow.SetStayOnTopSec(const Value: integer);
begin
  fStayOnTopSec := Value;
  if Window is TSplashWindow then
    TSplashWindow(Window).fStayOnTopSec := Value;
end;

procedure TCSplashWindow.SetVisible(const Value: boolean);
begin
  if Value <> Visible then
  begin
    Canceled := False;
    StartTime := Now;
    inherited;
  end;
end;

initialization
  TimerObject := nil;
  InternalSplash := nil;
  DefaultInstance := 0;
  CountCSplashWindow := 0;
  IsInitialization := False;

finalization
  IsInitialization := true;
  try
    FreeAndNil(InternalSplash);
    FreeAndNil(TimerObject);
  finally
    IsInitialization := false;
  end;

end.
