unit CepStyleActnCtrls;
(*
 * Module:          "Cep Style"
 * Version:    2.5 (02.12.2008)
 * Author:      
 * Comments:         .
 *                    
 *              : roschinspb@mail.ru
 *             http://www.delphikingdom.com/asp/users.asp?ID=1271
 *             http://www.roschinspb.narod.ru
 *
 * Copyright:   2006  2008 .
 *
 * Version:    2.5 (02.12.2008)
 * Realized:      SmallIcons,   TActionManager.LargeImages  ..
 *
 * Version:    2.0 (22.11.2007) b
 * Realized:    TGradientActionToolBar  TGradientActionMainMenuBar -
 *                 TControlBarCep
 *
 * Version:    1.6 (31.07.2007)
 * Realized:   1.     InternalLoadFromStream  InternalSaveToStream
 *             2.  TGradientActionToolBar  TGradientActionMainMenuBar
 *                TCustomGradientActionToolBar
 *              TCustomGradientActionMainMenuBar .
 *)
interface
{$I Directives.inc}
uses Windows, Types, Messages, SysUtils, Classes, Controls, ActnCtrls, ActnMan, ActnMenus, {XPStyleActnCtrls,}
  ActnColorMaps, XPActnCtrls, ActnList, ListActns, ExtCtrls, StrUtils,
  Graphics, GraphUtil, GraphUtilEx, StdActns, Contnrs, ToolWin,
  BandActn, Buttons, CustomizeDlg, BitOp, CepStyleUtl, ImageListCep, Math, ImgList;

resourcestring
  CapCustomize = ' ';
  ErrStreamFormat = '  ';
  ErrStreamVer = ' "%s"  ';
type
  TControlKind = (kcBtn, kcDDBtn, kcMenuBtn, kcMenuItem, kcARItem, kcCombo,
    kcSBtn, kcExpBtn, kcCustPop, kcPop, kcCMap, kcListCep, kcMulti);

  TBeforeDrawEvent = procedure (const Img: TRichImageList; MouseInControl: boolean) of object;

  //      
  TCepStyleActionBars = class(TActionBarStyleEx {TXPStyleActionBars})
  protected
    function ControlKind(ActionBar: TCustomActionBar;
      AnItem: TActionClientItem): TControlKind; virtual;
  public
    function GetColorMapClass(ActionBar: TCustomActionBar): TCustomColorMapClass; override;
    function GetControlClass(ActionBar: TCustomActionBar;
      AnItem: TActionClientItem): TCustomActionControlClass; override;
    function GetPopupClass(ActionBar: TCustomActionBar): TCustomPopupClass; override;
    function GetAddRemoveItemClass(ActionBar: TCustomActionBar): TCustomAddRemoveItemClass; override;
    function GetStyleName: string; override;
    function GetScrollBtnClass: TCustomToolScrollBtnClass; override;
  end;

  //   
  TCepStyleButton = class(TCustomButtonControl {TXPStyleButton}, IImg)
  private
    fImg: TRichImageList;
  protected
    procedure DrawBackground(var PaintRect: TRect); override;
    procedure DrawFrame(ARect: TRect; Down: Boolean); override;
    procedure DrawShadowedText(Rect: TRect; Flags: Cardinal; Text: string;
      TextColor, ShadowColor: TColor); override;
    procedure DrawGlyph(const Location: TPoint); override;
    procedure DrawLargeGlyph(Location: TPoint); override;
    function GetImageSize: TPoint; override;
  public
    destructor Destroy; override;
    constructor Create(AOwner: TComponent); override;
    function GetImg(Small: boolean = true): TRichImageList;
    function UpdateRichImageList(const Action: TBasicAction;
                                 const Small: boolean = true): TRichImageList;
    procedure FreeImg;
  end;

  //    
  TCepStyleDropDownBtn = class(TCustomDropDownButton {TXPStyleDropDownBtn}, IImg)
  private
    fImg: TRichImageList;
  protected
    procedure DrawBackground(var PaintRect: TRect); override;
    procedure DrawFrame(ARect: TRect; Down: Boolean); override;
    procedure DrawShadowedText(Rect: TRect; Flags: Cardinal; Text: string;
      TextColor, ShadowColor: TColor); override;
    procedure DrawGlyph(const Location: TPoint); override;
    procedure DrawLargeGlyph(Location: TPoint); override;
    function GetPopupClass: TCustomActionBarClass; override;
    function GetImageSize: TPoint; override;
  public
    destructor Destroy; override;
    constructor Create(AOwner: TComponent); override;
    function GetImg(Small: boolean = true): TRichImageList;
    function UpdateRichImageList(const Action: TBasicAction;
                                 const Small: boolean = true): TRichImageList;
    procedure FreeImg;
    procedure Click; override;
  end;

  /// <summary>
  ///     ,      
  /// </summary>
  TCepMultiActionBtn = class (TCepStyleDropDownBtn)
  private
    procedure AddSubItem(SubAction: TCustomAction);
  protected
    procedure SetActionClient(Value: TActionClientItem); override;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
  public
    constructor Create(AOwner: TComponent); override;
    function SubAction: TCustomAction;
  end;


  //    
  TCepStyleMenuButton = class(TCustomMenuButton {TXPStyleMenuButton}, IImg)
  private
    fImg: TRichImageList;
  protected
    procedure DrawBackground(var PaintRect: TRect); override;
    procedure DrawGlyph(const Location: TPoint); override;
    procedure DrawLargeGlyph(Location: TPoint); override;
    procedure DrawShadowedText(Rect: TRect; Flags: Cardinal; Text: string;
      TextColor, ShadowColor: TColor); override;
    function GetImageSize: TPoint; override;
  public
    destructor Destroy; override;
    function GetImg(Small: boolean = true): TRichImageList;
    function UpdateRichImageList(const Action: TBasicAction;
                                 const Small: boolean = true): TRichImageList;
    procedure FreeImg;
  end;

  //   
  TCepStylePopupMenu = class(TXPStylePopupMenu)
  protected
    function GetExpandBtnClass: TCustomMenuExpandBtnClass; override;
  end;

  //   ,  ,    
  TCepStyleExpandBtn = class(TXPStyleExpandBtn)
  protected
    procedure DrawBackground(var PaintRect: TRect); override;
    procedure DrawFrame(ARect: TRect; Down: Boolean); override;
  end;

  //     ,   
  TCepStyleAddRemoveItem = class({TCustomAddRemoveItem}TXPStyleAddRemoveItem, IImg)
  private
    fImg: TRichImageList;
  protected
    procedure DrawGlyph(const Location: TPoint); override;
    procedure DrawLargeGlyph(Location: TPoint); override;
    procedure DrawBackground(var PaintRect: TRect); override;
    function GetImageSize: TPoint; override;
  public
    destructor Destroy; override;
    function GetImg(Small: boolean = true): TRichImageList;
    function UpdateRichImageList(const Action: TBasicAction;
                                 const Small: boolean = true): TRichImageList;
    procedure FreeImg;
  end;

  //   ,       
  TCepStyleCustomizePopup = class(TXPStyleCustomizePopup)
  private
    FSeparatorItem: TActionClientItem;
    FARItem: TActionClientItem;
    FCustomizeItem: TActionClientItem;
    procedure CustomizeActionBarsExecute(Sender: TObject);
  protected
    function DoItemClicked(AnItem: TCustomActionControl): TActionClientItem; override;
    procedure SetActionClient(const Value: TActionClient); override;
    function GetAddRemoveItemClass: TCustomAddRemoveItemClass; override;
  public
    procedure CloseMenu; override;
    property ARItem: TActionClientItem read FARItem;
  end;

  //    
  TCepStyleMenuItem = class(TXPStyleMenuItem, IImg)
  private
    fImg: TRichImageList;
  protected
    procedure DrawBackground(var PaintRect: TRect); override;
    procedure DrawSeparator(const Offset: Integer); override;
    procedure DrawGlyph(const Location: TPoint); override;
    procedure DrawLargeGlyph(Location: TPoint); override;
    function GetImageSize: TPoint; override;
    procedure CalcLayout; override;
  public
    procedure Click; override;
    destructor Destroy; override;
    function GetImg(Small: boolean = true): TRichImageList;
    function UpdateRichImageList(const Action: TBasicAction;
                                 const Small: boolean = true): TRichImageList;
    procedure FreeImg;
  end;


  //    
  TCustomGradientActionToolBar = class(TCustomActionDockBar {TCustomActionToolBar}, IStreamPersist, ISysMenuEx)
  private
    fEnableClose: boolean;
    fonShowCustomize: TNotifyEvent;
    FPopupBar: TCustomActionBar;
    fHiddenItems: TStack;
    fItemsChanged: boolean;
    fOldBarHeight: integer;
    fOldBarWidth: integer;
    procedure SetEnableClose(const Value: boolean);
    procedure FreeHiddenItems;
  protected
    function GetFloatingDockSiteClass: TWinControlClass; override;
    procedure DrawBackground; override;
    procedure SetParent(AParent: TWinControl); override;
    procedure CustomAlignPosition(Control: TControl;
      var NewLeft, NewTop, NewWidth, NewHeight: Integer; var AlignRect: TRect;
      AlignInfo: TAlignInfo); override;
    function IsEnabledEx: boolean;
    function IsChevronEx: boolean;
    function CaptionEx: WideString;
    procedure ExecuteEx(X, Y: integer);
    function GetPopupClass: TCustomActionBarClass; virtual;
    procedure UpdateHiddenItems(var AHiddenItems: TStack); virtual;
    procedure Resize; override;
    function CanAutoSize(var NewWidth, NewHeight: Integer): Boolean; override;
    procedure AlignControls(AControl: TControl; var Rect: TRect); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure SaveToStream(Stream: TStream);
    procedure LoadFromStream(Stream: TStream);
    property onShowCustomize: TNotifyEvent read fonShowCustomize write fonShowCustomize;
    property EnableClose: boolean read fEnableClose write SetEnableClose default true;
    function CalcDockedWidth: Integer; override;
  published

  end;

  TGradientActionToolBar = class(TCustomGradientActionToolBar)
  public
    property Canvas;
  published
    property ActionManager;
    property Align default alTop;
    property AllowHiding default True;
    property Anchors;
    property BiDiMode;
    property Caption;
    property Color default clBtnFace;
    property ColorMap;
    property Constraints;
    property Cursor;
    property DragCursor;
    property DragKind default dkDock;
    property DragMode;
    property EdgeBorders default [];
    property EdgeInner;
    property EdgeOuter default esNone;
    property Enabled;
    property EnableClose;
    property Font;
    property HorzMargin;
    property HorzSeparator default True;
    property Orientation default boLeftToRight;
    property ParentBiDiMode;
    property ParentBackground default False;
    property ParentColor default False;
    property ParentFont;
    property ParentShowHint;
    property PersistentHotKeys default False;
    property PopupMenu;
    property ShowHint;
    property Spacing;
    property VertMargin;
    property Visible;
    property OnAlignInsertBefore;
    property OnAlignPosition;
    property OnControlCreated;
    property OnCanResize;
    property OnClick;
    property OnConstrainedResize;
    property OnContextPopup;
    property OnDockDrop;
    property OnDockOver;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnGetControlClass;
    property OnGetSiteInfo;
    property OnMouseActivate;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnPaint;
    property OnResize;
    property OnStartDock;
    property OnStartDrag;
    property OnUnDock;
    property onShowCustomize;
  end;

  TItemClicked = procedure(Sender: TCustomActionControl) of object;

  //    
  //    .
  TCustomGradientActionMainMenuBar = class({TCustomActionDockBar}TCustomActionMainMenuBar, IStreamPersist)
  private
    fonItemClicked: TItemClicked;
  protected
    function DoItemClicked(AnItem: TCustomActionControl): TActionClientItem; override;
    function GetFloatingDockSiteClass: TWinControlClass; override;

    procedure DrawBackground; override;
    procedure SetParent(AParent: TWinControl); override;
    function CanAutoSize(var NewWidth, NewHeight: Integer): Boolean; override;
  public
    constructor Create(AOwner: TComponent); override;
    function CalcDockedWidth: Integer; override;
    procedure SaveToStream(Stream: TStream);
    procedure LoadFromStream(Stream: TStream);
  published
    property onItemClicked: TItemClicked read fonItemClicked write fonItemClicked;
  end;

  TGradientActionMainMenuBar = class(TCustomGradientActionMainMenuBar)
    property Canvas;
  published
    property UseSystemFont default True;
    property ActionManager;
    property Align default alTop;
    property AllowHiding default False;
    property Anchors;
    property AnimateDuration default 150;
    property AnimationStyle default asDefault;
    property AutoFocus default True;
    property BiDiMode default bdLeftToRight;
    property Caption;
    property Color default clBtnFace;
    property ColorMap;
    property Constraints;
    property DragCursor;
    property DragKind default dkDock;
    property DragMode;
    property EdgeBorders default [];
    property EdgeInner default esRaised;
    property EdgeOuter default esLowered;
    property Enabled;
    property ExpandDelay default 4000;
    property Font;
    property HorzMargin;
    property ParentBiDiMode;
    property ParentBackground default False;
    property ParentColor default False;
    property ParentFont default False;
    property ParentShowHint;
    property PersistentHotKeys default False;
    property Shadows;
    property ShowHint;
    property Spacing;
    property VertMargin;
    property Visible;
    property WindowMenu;
    property OnAlignInsertBefore;
    property OnAlignPosition;
    property OnCanResize;
    property OnClick;
    property OnControlCreated;
    property OnConstrainedResize;
    property OnContextPopup;
    property OnDockDrop;
    property OnDockOver;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnEnterMenuLoop;
    property OnExit;
    property OnExitMenuLoop;
    property OnGetControlClass;
    property OnGetPopupClass;
    property OnGetSiteInfo;
    property OnMouseActivate;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnPaint;
    property OnPopup;
    property OnResize;
    property OnStartDock;
    property OnStartDrag;
    property OnUnDock;
  end;

  //TActionListCep -  ,   
  //  .     "Windows"
  TActionListCep = class(TCustomControlAction)
  private
    fCountUpdating: integer;
    fLinkedControls: TObjectList;
    function GetLinkedControlsCount: integer;
    procedure FindItemsByAction(List: TStringList);
    function AddControl(AItem: TActionClientItem; Control: TControl): boolean;
  protected
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure AddedLinkedControl(AControl: TControl); dynamic;
    procedure DeletedLinkedControl(AControl: TControl); dynamic;
    procedure RefreshItems; dynamic;
    procedure UpdateItem(Item: TActionClientItem); dynamic;
    function DeleteInternalItem(Item: TActionClientItem): boolean; virtual;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure BeginUpdate;
    procedure EndUpdate;
    property CountUpdating: integer read fCountUpdating;
    property LinkedControls: TObjectList read fLinkedControls; //   
    function AddLinkedControl(AControl: TControl): integer;
      //      .    
    function DeleteLinkedControl(Index: integer): integer; overload;
      //        
    function DeleteLinkedControl(AControl: TControl): integer; overload;
      //      
    property LinkedControlsCount: integer read GetLinkedControlsCount;
      //     
    procedure ClearInternal; dynamic;
      //     
  published
    property Caption;
    property Enabled;
    property HelpContext;
    property HelpKeyword;
    property HelpType;
    property Hint;
    property ImageIndex;
    property PopupMenu;
    property ShortCut;
    property SecondaryShortCuts;
    property Visible;
    property OnExecute;
    property OnHint;
    property OnUpdate;
  end;

  TMultiActionCep = class;
  TMultiActionItem = class;
  TMultiActionItemClass = class of TMultiActionItem;

  TMultiActionItems = class (TOwnedCollection)
  private
    function GetItem(Index: Integer): TMultiActionItem;
    procedure SetItem(Index: Integer; const Value: TMultiActionItem);
  protected
    procedure Notify(Item: TCollectionItem; Action: TCollectionNotification); override;
  public
    property Items[Index: Integer]: TMultiActionItem read GetItem write SetItem; default;
  end;

  TMultiActionItem = class (TCollectionItem)
  private
    fActionLink: TActionLink;
    procedure SetAction(const Value: TCustomAction);
    function GetAction: TCustomAction;
    function GetParentAction: TMultiActionCep;
  public
    constructor Create(Collection: TCollection); override;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    property ParentAction: TMultiActionCep read GetParentAction;
    function GetDisplayName: string; override;
  published
    property Action: TCustomAction read GetAction write SetAction;
  end;

  TMultiActionCep = class (TCustomControlAction)
  private
    fSubActions: TMultiActionItems;
    fItemIndex: integer;
    fSubImageIndex: integer;
    fSubImages: TCustomImageList;
    fSubEnabled: boolean;
    fSubVisible: boolean;
    fAutoUpdateProp: boolean;
    fChanged: boolean;
    procedure SetSubActions(const Value: TMultiActionItems);
    procedure SetItemIndex(const Value: integer);
    function GetSubAction: TCustomAction;
    procedure SetAutoUpdateProp(const Value: boolean);
  protected
    function GetItemClass: TMultiActionItemClass; virtual;
    procedure DoSubItemClick(Index: integer); virtual;
    procedure Change; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property SubAction: TCustomAction read GetSubAction;

    function Update: Boolean; override;
    function Execute: boolean; override;

    property SubImageIndex: integer read fSubImageIndex;
    property SubImages: TCustomImageList read fSubImages;
    property SubEnabled: boolean read fSubEnabled;
    property SubVisible: boolean read fSubVisible;
  published
    property SubActions: TMultiActionItems read fSubActions write SetSubActions;
    property ItemIndex: integer read fItemIndex write SetItemIndex default 0;
    property AutoUpdateProp: boolean read fAutoUpdateProp write SetAutoUpdateProp default true;
    property Caption;
    property Enabled;
    property HelpContext;
    property HelpKeyword;
    property HelpType;
    property Hint;
    property ImageIndex;
    property PopupMenu;
    property ShortCut;
    property SecondaryShortCuts;
    property Visible;
    property OnExecute;
    property OnHint;
    property OnUpdate;
  end;

  //TActionLinkedControlCep        .
  //           
  TActionLinkedControlCep = class(TAction)
  private
    fCreated: boolean;
    fControl: TControl;
    fInternal: boolean;
    fInvisibleEmpty: boolean;
    fInactiveEmpty: boolean;
    fNameAsControl: boolean;
    procedure SetControl(const Value: TControl);
    procedure SetInactiveEmpty(const Value: boolean);
    procedure SetInvisibleEmpty(const Value: boolean);
    procedure SetNameAsControl(const Value: boolean);
  protected
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    property Internal: boolean read fInternal write fInternal;
  public
    constructor Create(AOwner: TComponent; AControl: TControl); reintroduce;
    procedure AfterConstruction; override;
    destructor Destroy; override;
    function Update: Boolean; override;
    function Execute: boolean; override;
  published
    property Control: TControl read fControl write SetControl;
    property InactiveEmpty: boolean read fInactiveEmpty write SetInactiveEmpty default false;
    property InvisibleEmpty: boolean read fInvisibleEmpty write SetInvisibleEmpty default false;
    property NameAsControl: boolean read fNameAsControl write SetNameAsControl default false;
  end;




var
  CepStyle: TCepStyleActionBars;

procedure Register;
//    
procedure CrearAllInternalActions(ActionList: TCustomActionList);
// 
procedure ActionManagerSave(Stream: TStream; Manager: TCustomActionManager);
// 
procedure ActionManagerLoad(Stream: TStream; Manager: TCustomActionManager);
//      
//   ,     ,
// ,       .
//  ,       !
procedure UpdateActionBars(ActionManager: TCustomActionManager);
//     
procedure DrawGliphControl(ActionControl: TCustomActionControl;
  MouseInControl: boolean;
  const Location: TPoint;
  const onBeforeDraw: TBeforeDrawEvent = nil);
// /   
procedure InternalLoadFromStream(Stream: TStream; ABar: TCustomActionDockBar);
procedure InternalSaveToStream(Stream: TStream; ABar: TCustomActionDockBar);

implementation
uses Forms;

var
  InternalCustomizeAction: TCustomizeActionBars;
  DefControlClasses: array[TControlKind] of TClass =
  (TCepStyleButton {TXPStyleButton},
    TCepStyleDropDownBtn {TXPStyleDropDownBtn},
    TCepStyleMenuButton {TXPStyleMenuButton},
    TCepStyleMenuItem {TXPStyleMenuItem},
    TCepStyleAddRemoveItem {TXPStyleAddRemoveItem},
    TCustomComboControl,
    TXPStyleToolScrollBtn,
    TCepStyleExpandBtn {TXPStyleExpandBtn},
    TCepStyleCustomizePopup {TXPStyleCustomizePopup},
    TCepStylePopupMenu {TXPStylePopupMenu},
    TXPColorMap,
    TCepStyleDropDownBtn,
    TCepMultiActionBtn);
  InternalActionList: TCustomActionList;

procedure Register;
begin
  RegisterComponents('Cep', [TGradientActionToolBar]);
  RegisterComponents('Cep', [TGradientActionMainMenuBar]);
  RegisterActions('Window', [TActionListCep], nil);
  RegisterActions('Window', [TActionLinkedControlCep], nil);
  RegisterActions('List', [TMultiActionCep], nil);
  //procedure UnRegisterActions(const AClasses: array of TBasicActionClass);
end;

//    XPActnCtrls.  True,    

function IsMouseButtonPressed: Boolean;
begin
  Result := not (((GetAsyncKeyState(VK_RBUTTON) and $8000) = 0) and
    ((GetAsyncKeyState(VK_LBUTTON) and $8000) = 0));
end;

//       ActionBar`
//   ,  StartColor  EndColor
//    

procedure GetColorsInfo(Selected, Frame, Checked: boolean; ActionBar: TWinControl;
  var StartColor, EndColor: TColor;
  var Direction: TGradientDirection);
var
  SelColor: TColor;
  IDraw: IDrawBackground;
  DS: TBandDrawingStyle;
  GD: TGradientDirection;
  GS: TColor;
  GE: TColor;
  C: TColor;
begin
  Direction := gdHorizontal;
  StartColor := ColorToRGB(clBtnFace);
  EndColor := ColorToRGB(clBtnFace);
  if Frame then
    SelColor := $00C66931
  else
    SelColor := $00EFD3C6;
  if (ActionBar is TCustomActionDockBar) then
  begin
    if Frame and Selected then
      SelColor := ColorToRGB(TCustomActionDockBar(ActionBar).ColorMap.BtnFrameColor)
    else
      SelColor := ColorToRGB(TCustomActionDockBar(ActionBar).ColorMap.SelectedColor);

    if ActionBar.Parent.GetInterface(IDrawBackground, IDraw) then
    begin
      IDraw.ColorsInfo(DS, GD, GS, GE, C);
      Direction := GD;
      if (DS = dsGradient) then
      begin
        StartColor := ColorToRGB(GS);
        EndColor := ColorToRGB(GE);
      end
      else
      begin
        StartColor := ColorToRGB(C);
        EndColor := ColorToRGB(C);
      end;
    end
    else if ActionBar.Parent is TControlBar then
      with TControlBar(ActionBar.Parent) do
      begin
        Direction := GradientDirection;
        if (DrawingStyle = dsGradient) then
        begin
          StartColor := ColorToRGB(GradientStartColor);
          EndColor := ColorToRGB(GradientEndColor);
        end
        else
        begin
          StartColor := ColorToRGB(Color);
          EndColor := ColorToRGB(Color);
        end;
      end;
  end;
  if Selected or Checked then
  begin
    if (StartColor = EndColor) or (Frame and (Direction = gdHorizontal)) then
    begin
      StartColor := SelColor;
      EndColor := SelColor;
    end
    else
    begin
      StartColor := MixColor(StartColor, SelColor);
      if Frame then
      begin
        SelColor := MixColor(EndColor, SelColor);
      end;
      EndColor := MixColor(EndColor, SelColor);
    end;
    if Checked then
    begin
      StartColor := SelColor;
      EndColor := SelColor;
      if (not Selected) then
      begin
        StartColor := GetHighLightColor(StartColor, 10);
        EndColor := GetHighLightColor(EndColor, 10);
      end;
    end;
  end;
end;

//      
type
  TTmpCustomActionControl = class(TCustomActionControl);

procedure FillCustomActionControl(Selected, Frame: boolean; ActionControl: TCustomActionControl);
var
  R: TRect;
  C1, C2: TColor;
  D: TGradientDirection;
  A: boolean;
  IDraw: IDrawBackground;
begin
  A := Selected;
  if ActionControl <> nil then
    with TTmpCustomActionControl(ActionControl) do
    begin
      R := ClientRect;
      if (((Parent is TCustomGradientActionToolBar) or
        (Parent is TCustomGradientActionMainMenuBar)) and
        (TActionToolBar(Parent).Style is TCepStyleActionBars)) then
      begin
        //     
        if (not A) and (not Frame) and (not IsChecked) then
          Exit;
        GetColorsInfo(A, Frame, IsChecked, Parent, C1, C2, D)
      end
      else
        GetColorsInfo(A, Frame, IsChecked, nil, C1, C2, D);
      if IDraw <> nil then
        Exit;
      if C1 = C2 then
      begin
        Canvas.Brush.Color := C1;
        Canvas.Brush.Style := bsSolid;
        Canvas.FillRect(R);
      end
      else
      begin
        R := TActionToolBar(Parent).ClientRect;
        InflateRect(R, 1, 1);
        Dec(R.Left, 10);
        OffsetRect(R, -Left, -Top);
        GradientFillCanvas(Canvas, C1, C2, R, D);
      end;
    end;
end;

//       

procedure DrawFrameControl(ActiControl: TCustomActionControl; Pushed: boolean;
  DropDownButtonWidth: byte = 0);
var
  C1, C2: TColor;
  D: TGradientDirection;
begin
  if (ActiControl <> nil) and (Pushed) then
    with TTmpCustomActionControl(ActiControl) do
    begin
      if (IsChecked) and (not Enabled) then
      begin
        GetColorsInfo(false, true, true, TActionToolBar(Parent), C1, C2, D);
        Canvas.Pen.Color := MixColor(ActionBar.ColorMap.BtnFrameColor, MixColor(C1, C2));
      end
      else
        Canvas.Pen.Color := ActionBar.ColorMap.BtnFrameColor;
      Canvas.Pen.Style := psSolid;
      Canvas.Brush.Style := bsClear;
      Canvas.Rectangle(ClientRect);
      if DropDownButtonWidth > 0 then
      begin
        Canvas.MoveTo(ClientRect.Right - DropDownButtonWidth - 1, 1);
        Canvas.LineTo(ClientRect.Right - DropDownButtonWidth - 1, ClientRect.Bottom - 1);
      end;
    end;
end;

//        
//   

procedure DrawBackgroundControl(ActiControl: TCustomActionControl;
  MouseInControl: boolean; var PaintRect: TRect;
  DropDownButtonWidth: byte = 0);
var
  A: boolean;
  SDC: integer;
begin
  if ActiControl <> nil then
    with TTmpCustomActionControl(ActiControl) do
    begin
      A := Enabled and MouseInControl;
      SDC := SaveDC(Canvas.Handle);
      try
        inflateRect(PaintRect, -1, -1);
        ExcludeClipRect(Canvas.Handle, 0, 0, PaintRect.Left, ClientRect.Bottom);
        ExcludeClipRect(Canvas.Handle, PaintRect.Left, 0, ClientRect.Right, PaintRect.Top);
        ExcludeClipRect(Canvas.Handle, PaintRect.Right, PaintRect.Top, ClientRect.Right, ClientRect.Bottom);
        ExcludeClipRect(Canvas.Handle, PaintRect.Left, PaintRect.Bottom, ClientRect.Right, ClientRect.Bottom);
        FillCustomActionControl(A, false, ActiControl);
      finally
        RestoreDC(Canvas.Handle, SDC);
      end;
      if A then
      begin
        SDC := SaveDC(Canvas.Handle);
        try
          ExcludeClipRect(Canvas.Handle, PaintRect.Left, PaintRect.Top,
            PaintRect.Right - DropDownButtonWidth, PaintRect.Bottom);
          if DropDownButtonWidth > 1 then
            ExcludeClipRect(Canvas.Handle,
              PaintRect.Right - DropDownButtonWidth + 1, PaintRect.Top,
              PaintRect.Right, PaintRect.Bottom);

          FillCustomActionControl(A, true, ActiControl);
        finally
          RestoreDC(Canvas.Handle, SDC);
        end;
      end;
    end;
end;

procedure DrawBackgroundMenu(Item: TCustomActionControl;
  var PaintRect: TRect;
  MouseSelected: boolean);
var
  BannerRect, BGRect, SelRect: TRect;
  C1, C2: TColor;
  IsSel, Unused: boolean;
  procedure DrawSelBar(PaintRect: TRect; const IsTransparent: boolean);
  begin
    with TTmpCustomActionControl(Item) do
    begin
      Canvas.Pen.Width := 1;
      C2 := ActionBar.ColorMap.SelectedColor;
      C1 := MixColor(C2, C1);
      if IsTransparent then // 
      begin
        Canvas.Brush.Style := bsClear
      end
      else
      begin
        Canvas.Brush.Style := bsSolid;
        Canvas.Brush.Color := C2;
      end;
      if Enabled then
        Canvas.Pen.Color := ActionBar.ColorMap.BtnFrameColor
      else
        Canvas.Pen.Color := GetShadowColor(C1);
      Canvas.Rectangle(PaintRect);
    end;
  end;
begin
  if Item <> nil then
    with TTmpCustomActionControl(Item) do
    begin
      if MouseSelected and (Item.Action is TAction) and (not TAction(Item.Action).Enabled) then
        MouseSelected := False;

      Unused := (ActionClient = nil) or (ActionClient.Unused);
      if Unused then //   
        C1 := ActionBar.ColorMap.UnusedColor
      else
        C1 := ActionBar.ColorMap.Color;
      C2 := ActionBar {Menu}.ColorMap.MenuColor;

      if Item is TCustomMenuExpandBtn then
        IsSel := MouseSelected
      else
      begin
        IsSel := ((Selected and Enabled) or (Selected and not MouseSelected)) and
          (Enabled and not ActionBar.DesignMode) and
          (not Separator);
        if IsSel then
        begin
          DrawSelBar(ClientRect, true);
          inflateRect(PaintRect, -1, -1);
        end;
      end;

      BGRect := PaintRect;
      BannerRect := PaintRect;
      if TextBounds.Left > GlyphPos.X then
      begin
        BannerRect.Right := TextBounds.Left + 3;
        if BannerRect.Right > PaintRect.Right then
          BannerRect.Right := PaintRect.Right;
        BGRect.Left := BannerRect.Right;
      end
      else
      begin
        BannerRect.Left := TextBounds.Right - 3;
        if BannerRect.Left < 3 then
          BannerRect.Left := 3;
        BGRect.Right := BannerRect.Left;
      end;
      SelRect := BannerRect;

      Canvas.Brush.Style := bsSolid;
      GradientFillCanvas(Canvas, C1, C2, BannerRect, gdHorizontal);
      Canvas.Brush.Color := C1;
      if IsSel then
        Canvas.FillRect(Rect(1, 1, BannerRect.Left, Height - 1))
      else
        Canvas.FillRect(Rect(0, 0, BannerRect.Left, Height));
      Canvas.Brush.Color := C2;
      Canvas.FillRect(BGRect);

      if Item is TCustomMenuExpandBtn then
      begin //    
        if IsSel then
        begin
          InflateRect(PaintRect, -2, -3);
          DrawSelBar(PaintRect, false);
        end;
      end
      else if IsChecked then
      begin //    
        if IsSel then
          dec(SelRect.Right)
        else
          inflateRect(SelRect, -1, -1);
        if TextBounds.Left > GlyphPos.X then
          Dec(SelRect.Right, 6)
        else
          Inc(SelRect.Left, 6);
        if not HasGlyph then
          InflateRect(SelRect, -1, -2);
        DrawSelBar(SelRect, false);
      end;
    end;
end;

//    ,   
// 

procedure DisabeledTextColor(ActiControl: TCustomActionControl;
  var TextColor, ShadowColor: TColor);
var
  C1, C2, C: TColor;
  G: TGradientDirection;
begin
  if (ActiControl <> nil) then
    with TTmpCustomActionControl(ActiControl) do
    begin
      if Parent is TCustomActionDockBar then
        GetColorsInfo(False, False, IsChecked, TCustomActionDockBar(Parent), C1, C2, G)
      else
        GetColorsInfo(False, False, IsChecked, nil, C1, C2, G);
      if C1 = C2 then
      begin
        TextColor := GetShadowColor(C1);
        ShadowColor := GetHighLightColor(C1, 60);
      end
      else
      begin
        C := MixColor(C1, C2);
        TextColor := GetShadowColor(C, -70);
        ShadowColor := GetHighLightColor(C, 10);
      end;
    end;
end;

//  

procedure DrawDisabeledText(ActiControl: TCustomActionControl; Rect: TRect; Flags: Cardinal; Text: string);
var
  TextColor, ShadowColor: TColor;
begin
  if ActiControl <> nil then
    with TTmpCustomActionControl(ActiControl) do
    begin
      DisabeledTextColor(ActiControl, TextColor, ShadowColor);
      OffsetRect(Rect, 1, 1);
      Canvas.Font.Color := ShadowColor;
      Windows.DrawText(Canvas.Handle, PChar(Text), Length(Text), Rect, Flags);
      OffsetRect(Rect, -1, -1);
      Canvas.Font.Color := TextColor;
      Windows.DrawText(Canvas.Handle, PChar(Text), Length(Text), Rect, Flags);
    end;
end;

type
  TLargeRec = record
    Small: TCustomImageList;
    Large: TImageList;
    ImageChangeLink: TChangeLink;
    FirstChanged: boolean;
  end;

  TLargeImageLists = class(TComponent)
  private
    fImageLists: array of TLargeRec;
    function IndexByImageList(ImageList: TCustomImageList;
      Small: boolean): integer;
  protected
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure ChangeSmall(Sender: TObject);
  public
    procedure Delete(Index: integer);
    function GetLageImageList(SmallImageList: TCustomImageList): TImageList;
    destructor Destroy; override;
  end;

var
  LargeImageLists: TLargeImageLists;

  { TLargeImageLists }

procedure TLargeImageLists.Notification(AComponent: TComponent;
  Operation: TOperation);
var
  I: Integer;
begin
  inherited;
  if Operation = opRemove then
    for I := Length(fImageLists) - 1 downto 0 do
    begin
      if (fImageLists[I].Small = AComponent) or
        (fImageLists[I].Large = AComponent) then
        Delete(I);
    end;
end;

procedure TLargeImageLists.ChangeSmall(Sender: TObject);
var
  I: integer;
begin
  if Sender is TCustomImageList then
  begin
    I := IndexByImageList(TCustomImageList(Sender), true);
    if I >= 0 then
    begin
      if fImageLists[I].FirstChanged then
        fImageLists[I].FirstChanged := False
      else
        Delete(I);
    end;
  end;
end;

procedure TLargeImageLists.Delete(Index: integer);
begin
  if (Index >= 0) and (Index < Length(fImageLists)) then
  begin
    FreeAndNil(fImageLists[Index].Large);
    FreeAndNil(fImageLists[Index].ImageChangeLink);
    if (fImageLists[Index].Small <> nil) and
      (not (csDestroying in fImageLists[Index].Small.ComponentState)) then
      RemoveFreeNotification(fImageLists[Index].Small);
    Move(fImageLists[Index + 1],
      fImageLists[Index],
      (Length(fImageLists) - Index - 1) * sizeOf(fImageLists[0]));
    SetLength(fImageLists, Length(fImageLists) - 1);
  end;
end;

function TLargeImageLists.IndexByImageList(ImageList: TCustomImageList; Small: boolean): integer;
var
  I: Integer;
begin
  result := -1;
  if Small then
  begin
    for I := 0 to Length(fImageLists) - 1 do
      if ImageList = fImageLists[I].Small then
      begin
        result := I;
        Exit;
      end
  end
  else
    for I := 0 to Length(fImageLists) - 1 do
      if ImageList = fImageLists[I].Large then
      begin
        result := I;
        Exit;
      end
end;

destructor TLargeImageLists.Destroy;
begin
  while Length(fImageLists) > 0 do
    Delete(0);
  inherited;
end;

function SmallToLarge(X: integer): integer;
begin
  case X of
    8: Result := 12;
    16: Result := 24;
    24: Result := 32;
    32: Result := 48;
  else
    Result := (X * 3) div (2);
  end;
end;

function TLargeImageLists.GetLageImageList(SmallImageList: TCustomImageList): TImageList;
var
  I, J, W, H: integer;
  Img: TImageList;
  SourceBmp, DestBmp: TBitmap;
  Scale: Double;
  function CreateBmp(Width, Heigth: integer): TBitmap;
  begin
    Result := TBitmap.Create;
    Result.Width := Width;
    Result.Height := Heigth;
    Result.TransparentColor := ColorToRgb(clBtnFace);
    if Result.TransparentColor = 0 then
      Result.TransparentColor := Result.TransparentColor + 1
    else
      Result.TransparentColor := Result.TransparentColor - 1;
    Result.TransparentMode := tmFixed;
    Result.Transparent := true;
    Result.Canvas.Brush.Color := Result.TransparentColor;
  end;
begin
  I := IndexByImageList(SmallImageList, True);
  if I < 0 then
  begin
    Img := nil;
    SourceBmp := nil;
    DestBmp := nil;
    try
      I := Length(fImageLists);
      SetLength(fImageLists, I + 1);
      fImageLists[I].Small := SmallImageList;
      try
        Img := TImageList.Create(Self);
        Img.Width := SmallToLarge(SmallImageList.Width);
        Scale := Img.Width;
        Scale := Scale / SmallImageList.Width;
        Img.Height := Round(SmallImageList.Height * Scale);
        DestBmp := CreateBmp(Img.Width, Img.Height);
        if SmallImageList is TImageListCep then
        begin
          TImageListCep(SmallImageList).BeginUpdate;
          W := TImageListCep(SmallImageList).Width;
          H := TImageListCep(SmallImageList).Height;
          try
{$IFDEF DELPHI_2009_UP}
            TImageListCep(SmallImageList).SetSize(Img.Width, Img.Height);
{$ELSE}
            TImageListCep(SmallImageList).Width := Img.Width;
            TImageListCep(SmallImageList).Height := Img.Height;
{$ENDIF}
            TImageListCep(SmallImageList).UpdateImages(True);
            for J := 0 to SmallImageList.Count - 1 do
            begin
              DestBmp.Canvas.FillRect(Rect(0, 0, DestBmp.Width, DestBmp.Height));
              SmallImageList.Draw(DestBmp.Canvas, 0, 0, J);
              Img.AddMasked(DestBmp, DestBmp.TransparentColor);
            end;
          finally
{$IFDEF DELPHI_2009_UP}
            TImageListCep(SmallImageList).SetSize(W, H);
{$ELSE}
            TImageListCep(SmallImageList).Width := W;
            TImageListCep(SmallImageList).Height := H;
{$ENDIF}
            TImageListCep(SmallImageList).UpdateImages(True);
            TImageListCep(SmallImageList).EndUpdate;
          end;
        end
        else
        begin
          SourceBmp := CreateBmp(SmallImageList.Width, SmallImageList.Height);
          for J := 0 to SmallImageList.Count - 1 do
          begin
            SourceBmp.Canvas.FillRect(Rect(0, 0, SourceBmp.Width, SourceBmp.Height));
            SmallImageList.Draw(SourceBmp.Canvas, 0, 0, J);
            ScaleImage(SourceBmp, DestBmp, Scale);
            Img.AddMasked(DestBmp, DestBmp.TransparentColor);
          end;
        end;
        FreeNotification(SmallImageList);
        fImageLists[I].Large := Img;
        fImageLists[I].ImageChangeLink := TChangeLink.Create;
        fImageLists[I].ImageChangeLink.onChange := ChangeSmall;
        SmallImageList.RegisterChanges(fImageLists[I].ImageChangeLink);
        fImageLists[I].FirstChanged := true;
      except
        FreeAndNil(Img);
        fImageLists[I].Large := nil;
        Delete(I);
        raise;
      end;
    finally
      SourceBmp.Free;
      DestBmp.Free;
    end;
  end;
  result := fImageLists[I].Large;
end;

function GetLageImageList(ImageList: TCustomImageList): TImageList;
begin
  if LargeImageLists = nil then
    LargeImageLists := TLargeImageLists.Create(nil);
  result := LargeImageLists.GetLageImageList(ImageList);
end;

//,    TRichImageList  

function ImgByAction(var Img: TRichImageList;
  Action: TBasicAction;
  Small: boolean = true): TRichImageList;
begin
  if Img = nil then
  begin
    Img := TRichImageList.Create;
    Img.BorderColor := clNone;
    Img.SelectedColor := clNone;
    Img.BkColor := clNone;
    Img.Transparent := true;
    Img.Border := CepXPBorder;
    Img.Adjusted := true;
  end;
  result := Img;
  if (Img <> nil) then
  begin
    if Action is TCustomAction then
    begin
      if TCustomAction(Action).ActionList <> nil then
      begin
        if Small then
{$IFDEF DELPHI_2009_UP}
        begin
          if (TCustomAction(Action).ActionList is TCustomActionManager) then
            with TCustomActionManager(TCustomAction(Action).ActionList) do
            begin
              if TCustomAction(Action).Enabled then
                Img.ImageList := Images
              else
              begin
                if DisabledImages <> nil then
                  Img.ImageList := DisabledImages
                else
                  Img.ImageList := Images;
              end;
            end
        end
{$ELSE}
          Img.ImageList := TCustomAction(Action).ActionList.Images
{$ENDIF}
        else
{$IFDEF DELPHI_2009_UP}
        begin
          if (TCustomAction(Action).ActionList is TCustomActionManager) then
            with TCustomActionManager(TCustomAction(Action).ActionList) do
            begin
              if TCustomAction(Action).Enabled then
              begin
                if (LargeImages <> nil) then
                  Img.ImageList := LargeImages
                else
                  Img.ImageList := GetLageImageList(Images);
              end
              else
              begin
                if (LargeDisabledImages <> nil) then
                  Img.ImageList := LargeDisabledImages
                else if DisabledImages <> nil then
                  Img.ImageList := GetLageImageList(DisabledImages)
                else
                  Img.ImageList := GetLageImageList(Images);
              end;
            end
          else
            Img.ImageList := GetLageImageList(TCustomAction(Action).ActionList.Images);
        end
{$ELSE}
          Img.ImageList := GetLageImageList(TCustomAction(Action).ActionList.Images)
{$ENDIF}
      end
      else
        Img.ImageList := nil;
      Img.Index := TCustomAction(Action).ImageIndex
    end
    else
    begin
      Img.ImageList := nil;
      Img.Index := -1;
    end;
  end;
end;

//   

procedure DrawNormalGliph(const Location: TPoint;
                                MouseInControl: Boolean;
                                ActionControl: TCustomActionControl;
                          const onBeforeDraw: TBeforeDrawEvent);
var
  IsMenuItem: Boolean;
  X, Y, D, R: Integer;
  Img: TRichImageList;
  GetControlImg: IImg;
  MultiAction: TMultiActionCep;
  AEnabled: boolean;
begin
  with TTmpCustomActionControl(ActionControl) do
  begin
    IsMenuItem := ActionControl is TCustomMenuItem;
    if (ActionControl.ActionClient.HasGlyph) and
      GetInterface(IImg, GetControlImg) then
      Img := GetControlImg.GetImg(ActionControl.ActionClient.ActionClients.SmallIcons)
    else
      Img := nil;
    if Img <> nil then
    begin
      if (Img.ImageList = nil) then
        Img.ImageList := ActionClient.OwningCollection.ActionManager.Images;
      if (Img.Index <> ActionClient.ImageIndex) and (ActionClient.ImageIndex >= 0) then
        Img.Index := ActionClient.ImageIndex;
    end;
    if (ActionClient.ShowGlyph) and (Img <> nil) and (Img.ImageList <> nil) and (Img.Index >= 0) and (Img.Index <
      Img.ImageList.Count) then
    begin
      // 
      AEnabled := Enabled;
      Img.Hot := Enabled and (MouseInControl and (not ActionBar.DesignMode) and (not IsChecked or IsMenuItem));
      Img.Pushed := Enabled and MouseInControl and IsMouseButtonPressed;
      Img.Checked := IsChecked;
      if (ActionControl.ActionClient <> nil) and (ActionControl.ActionClient.Action is TMultiActionCep) then
      begin
        MultiAction := TMultiActionCep(ActionControl.ActionClient.Action);
        if MultiAction.SubAction <> nil then
        begin
          if (MultiAction.SubImages <> nil) and (MultiAction.SubImageIndex >= 0) then
          begin
            Img.ImageList := MultiAction.SubImages;
            Img.Index := MultiAction.SubImageIndex;
            if MultiAction.fChanged then
            begin
              MultiAction.fChanged := False;
              if MultiAction.SubImages is TImageListCep then
              begin
                //ClearHasButtonBitmap;
                //if csDesigning in MultiAction.ComponentState then
                //  TImageListCep(MultiAction.SubImages).UpdateAction(MultiAction.SubAction);
                if MultiAction.SubImageIndex >= TImageListCep(MultiAction.SubImages).Count then
                  TImageListCep(MultiAction.SubImages).UpdateImages;
              end;
            end;
          end;
        end;
        AEnabled := (MultiAction.SubEnabled) and (MultiAction.SubVisible);
      end;
      Img.Width := Img.ImageList.Width + 2;
      Img.Height := Img.ImageList.Height + 2;
      if AEnabled then
        Img.Blend := 255
      else
        Img.Blend := 150;
      Img.Enabled := AEnabled;
      if @onBeforeDraw <> nil then
        onBeforeDraw(Img, MouseInControl);
      if IsMenuItem then
        Canvas.Draw(Location.X, Location.Y, Img)
      else
        Canvas.Draw(Location.X, Location.Y, Img);
    end
    else if IsMenuItem then
    begin
      // ,  ,  
      if IsChecked then
      begin
        Canvas.Brush.Style := bsSolid;
        Canvas.Pen.Width := 1;
        R := (ClientHeight + 6) div (12);
        D := (2 * R + 1);
        Y := (ClientHeight - D) div (2);
        X := Location.X + 4;
        if Enabled then
          Canvas.Pen.Color := ActionBar.ColorMap.FontColor
        else
          Canvas.Pen.Color := ActionBar.ColorMap.DisabledFontColor;
        Canvas.Brush.Color := Canvas.Pen.Color;
        if (TCustomAction(ActionClient.Action).GroupIndex > 0) then
          Canvas.Ellipse(X, Y, X + D, Y + D)
        else
          DrawCheck(Canvas, Point(X, Y + R), R, false);
      end;
    end;
  end;
end;

//   ,   .

procedure UpdateControlGliph(ActionControl: TCustomActionControl);
//var Images: TCustomImageList;
//    Action: TActionLinkedControlCep;
//    Icon: HIcon;
begin
  {f (ActionControl.ActionBar <> nil) and
     (ActionControl.ActionBar.ActionManager <> nil) and
     (ActionControl.ActionBar.ActionManager.Images <> nil) then
  begin
    Images := ActionControl.ActionBar.ActionManager.Images;
    Action := TActionLinkedControlCep(ActionControl.ActionClient.Action);
    if (Action.Control is TWinControl) and
       (TWinControl(Action.Control).HandleAllocated) then
    begin
      Icon := CopyIcon(GetClassLong(TWinControl(Action.Control).Handle, GCL_HICON));
      if (Icon = 0) and
         (Action.Control is TForm) and
         (TForm(Action.Control).Icon <> nil) then
        Icon := CopyIcon(TForm(Action.Control).Icon.Handle);
      if Icon <> 0 then
      begin
        try
        finally
          DestroyIcon(Icon);
        end;
      end;
    end;
  end;}
end;

//     

procedure DrawGliphControl(ActionControl: TCustomActionControl;
  MouseInControl: boolean;
  const Location: TPoint;
  const onBeforeDraw: TBeforeDrawEvent = nil);
begin
  if (ActionControl <> nil) and (ActionControl.ActionClient <> nil) then
  begin
    if (not ActionControl.ActionClient.HasGlyph) and
      (ActionControl.ActionClient.Action is TActionLinkedControlCep) then
    begin
      UpdateControlGliph(ActionControl);
      DrawNormalGliph(Location, MouseInControl, ActionControl, onBeforeDraw)
    end
    else
      DrawNormalGliph(Location, MouseInControl, ActionControl, onBeforeDraw);
  end;
end;

{ TInternalARAction }
type
  TInternalARAction = class(TControlAction)
  public
    constructor Create(AOwner: TComponent); override;
  end;

constructor TInternalARAction.Create(AOwner: TComponent);
var
  C, H: string;
begin
  inherited;
  H := CapAR;
  SeparateCaption(C, H);
  Caption := C;
  Hint := H;
end;

var
  InternalARAction: TInternalARAction;

  { TCepStyleActionBars }
  {    }
  //      

function TCepStyleActionBars.ControlKind(ActionBar: TCustomActionBar;
  AnItem: TActionClientItem): TControlKind;
begin
  if (ActionBar is TCustomActionToolBar) or
     (ActionBar is TCustomGradientActionToolBar) then
  begin
     if (AnItem.Action is TMultiActionCep) then
      Result := kcMulti
    else if AnItem.HasItems then
      Result := kcDDBtn
    else if (AnItem.Action is TStaticListAction) or
      (AnItem.Action is TVirtualListAction) then
      Result := kcCombo
    else if (AnItem.Action is TActionListCep) then
      Result := kcListCep
    else
      Result := kcBtn;
  end
  else if ActionBar is TCustomActionMainMenuBar then
    Result := kcMenuBtn
  else if ActionBar is TCustomizeActionToolBar then
  begin
    if ActionBar is TCepStyleCustomizePopup then
    begin
      with ActionBar as TCepStyleCustomizePopup do
        if not Assigned(RootMenu) or
          (AnItem.ParentItem <> TCepStyleCustomizePopup(RootMenu).ARItem) then
          Result := kcMenuItem
        else
          Result := kcARItem;
    end
    else
    begin
      with ActionBar as TCustomizeActionToolbar do
        if not Assigned(RootMenu) or
          (AnItem.ParentItem <> TCustomizeActionToolBar(RootMenu).AdditionalItem) then
          Result := kcMenuItem
        else
          Result := kcARItem;
    end;
  end
  else if ActionBar is TCustomActionPopupMenu then
    if (AnItem.Action is TActionListCep) then
      Result := kcMenuItem
    else
      Result := kcMenuItem
  else
    Result := kcBtn;
end;

//     

function TCepStyleActionBars.GetAddRemoveItemClass(
  ActionBar: TCustomActionBar): TCustomAddRemoveItemClass;
begin
  result := TCustomAddRemoveItemClass(DefControlClasses[kcARItem]);
end;

//   

function TCepStyleActionBars.GetColorMapClass(ActionBar: TCustomActionBar): TCustomColorMapClass;
begin
  result := TCustomColorMapClass(DefControlClasses[kcCMap]);
end;

//   

function TCepStyleActionBars.GetControlClass(ActionBar: TCustomActionBar;
  AnItem: TActionClientItem): TCustomActionControlClass;
var
  CK: TControlKind;
begin
  CK := ControlKind(ActionBar, AnItem);
  result := TCustomActionControlClass(DefControlClasses[CK]);
end;

//        

function TCepStyleActionBars.GetPopupClass(ActionBar: TCustomActionBar): TCustomPopupClass;
begin
  if (ActionBar is TCustomGradientActionToolBar) or
    (ActionBar is TCustomActionToolBar) then
    Result := TCustomPopupClass(DefControlClasses[kcCustPop])
  else
    Result := TCustomPopupClass(DefControlClasses[kcPop]);
end;

//    

function TCepStyleActionBars.GetScrollBtnClass: TCustomToolScrollBtnClass;
begin
  result := TCustomToolScrollBtnClass(DefControlClasses[kcSBtn]);
end;

// ,     

function TCepStyleActionBars.GetStyleName: string;
begin
  result := 'Cep Style';
end;

type
  TTMPCustomActionToolBar = class(TCustomActionToolBar);
  //      
  //   ,     ,
  // ,       .
  //  ,       !

procedure UpdateActionBars(ActionManager: TCustomActionManager);
var
  i: integer;
begin
  if ActionManager <> nil then
  begin
    for I := 0 to ActionManager.ActionBars.Count - 1 do
      if ActionManager.ActionBars[i].ActionBar is TCustomActionToolBar then
        with TTMPCustomActionToolBar(ActionManager.ActionBars[i].ActionBar) do
        begin
          if (not DesignMode) and ((not AutoSizing) and (not Autosize)) then
          begin
            AutoSizing := true;
            AutoSize := false;
            AutoSizing := false {OldAutosizing};
            SetBounds(Left, Top, Width, Height);
            HideUnusedItems;
          end;
        end;
  end;
end;

{ TCepStyleButton }
{   }

constructor TCepStyleButton.Create(AOwner: TComponent);
begin
  inherited;
  Margins := Rect(2, 2, 2, 2);
end;

destructor TCepStyleButton.Destroy;
begin
  FreeImg;
  inherited;
end;

//     
//. .     

procedure TCepStyleButton.DrawBackground(var PaintRect: TRect);
var
  A: boolean;
begin
  A := (not (ActionBar.DesignMode)) and (MouseInControl) and
    (Assigned(ActionClient) and not ActionClient.Separator);
  DrawBackgroundControl(self, A, PaintRect);
end;

// 

procedure TCepStyleButton.DrawGlyph(const Location: TPoint);
begin
  DrawGliphControl(self, MouseInControl, Location);
end;

procedure TCepStyleButton.DrawLargeGlyph(Location: TPoint);
begin
  DrawGliphControl(self, MouseInControl, Location);
end;

//  

procedure TCepStyleButton.DrawShadowedText(Rect: TRect; Flags: Cardinal;
  Text: string; TextColor, ShadowColor: TColor);
begin
  DrawDisabeledText(self, Rect, Flags, Text);
end;

procedure TCepStyleButton.FreeImg;
begin
  FreeAndNil(fImg);
end;

function TCepStyleButton.GetImageSize: TPoint;
var Img: TRichImageList;
begin
  fillchar(Result, SizeOf(Result), 0);
  if (ActionClient <> nil) and (ActionClient.ActionClients <> nil) then
  begin
    Img := GetImg(ActionClient.ActionClients.SmallIcons);
    if (Img <> nil) and (Img.Index >= 0) and (Img.ImageList <> nil) then
    begin
      result.X := Img.ImageList.Width;
      result.Y := Img.ImageList.Height;
    end;
  end;
  if Result.Y = 0 then
    result := inherited GetImageSize;
end;

//   ,   

function TCepStyleButton.GetImg(Small: boolean = true): TRichImageList;
begin
  result := UpdateRichImageList(Action, Small);
end;

function TCepStyleButton.UpdateRichImageList(const Action: TBasicAction;
                                             const Small: boolean): TRichImageList;
begin
  result := ImgByAction(fImg, Action, Small);
end;

//       
//. .     

procedure TCepStyleButton.DrawFrame(ARect: TRect; Down: Boolean);
begin
  DrawFrameControl(Self, Down);
end;

{ TCepStyleDropDownBtn }
{    }

procedure TCepStyleDropDownBtn.Click;
begin
  //   TActionListCep,    
  //  ,      
  if Action is TActionListCep then
    DropDownClick
  else
    inherited;
end;

constructor TCepStyleDropDownBtn.Create(AOwner: TComponent);
begin
  inherited;
  Margins := Rect(2, 2, 2, 2);
end;

destructor TCepStyleDropDownBtn.Destroy;
begin
  FreeImg;
  inherited;
end;

procedure TCepStyleDropDownBtn.DrawBackground(var PaintRect: TRect);
var
  A: boolean;
begin
  A := (not (ActionBar.DesignMode)) and (MouseInControl) and
    (Assigned(ActionClient) and not ActionClient.Separator);
  DrawBackgroundControl(self, A, PaintRect, 9);
end;

procedure TCepStyleDropDownBtn.DrawFrame(ARect: TRect; Down: Boolean);
begin
  //   cDropDownButtonWidth = 9
  //        9
  // Borland      :)
  DrawFrameControl(Self, Down, 9);
end;

procedure TCepStyleDropDownBtn.DrawGlyph(const Location: TPoint);
begin
  DrawGliphControl(self, MouseInControl, Location);
end;

procedure TCepStyleDropDownBtn.DrawLargeGlyph(Location: TPoint);
begin
  DrawGliphControl(self, MouseInControl, Location);
end;

procedure TCepStyleDropDownBtn.DrawShadowedText(Rect: TRect; Flags: Cardinal;
  Text: string; TextColor, ShadowColor: TColor);
begin
  DrawDisabeledText(self, Rect, Flags, Text);
end;

procedure TCepStyleDropDownBtn.FreeImg;
begin
  FreeAndNil(fImg);
end;

function TCepStyleDropDownBtn.GetImageSize: TPoint;
var Img: TRichImageList;
begin
  fillchar(Result, SizeOf(Result), 0);
  if (ActionClient <> nil) and (ActionClient.ActionClients <> nil) then
  begin
    Img := GetImg(ActionClient.ActionClients.SmallIcons);
    if (Img <> nil) and (Img.Index >= 0) and (Img.ImageList <> nil) then
    begin
      result.X := Img.ImageList.Width;
      result.Y := Img.ImageList.Height;
    end;
  end;
  if Result.Y = 0 then
    result := inherited GetImageSize;
end;

function TCepStyleDropDownBtn.GetImg(Small: boolean = true): TRichImageList;
begin
  result := UpdateRichImageList(Action, Small);
end;

function TCepStyleDropDownBtn.UpdateRichImageList(const Action: TBasicAction;
                                                  const Small: boolean): TRichImageList;
begin
  result := ImgByAction(fImg, Action, Small);
end;

function TCepStyleDropDownBtn.GetPopupClass: TCustomActionBarClass;
begin
  Result := TCustomActionBarClass(DefControlClasses[kcPop]);
end;

{ TInternalCustomizeAction }
type
  TInternalCustomizeAction = class(TCustomizeActionBars)
  private
    procedure Close(Sender: TObject);
  protected
    function Execute: Boolean; override;
  public
  end;

  //      TCustomizeDlg

procedure TInternalCustomizeAction.Close(Sender: TObject);
begin
  UpdateActionBars(TCustomizeDlg(Sender).ActionManager);
end;

//      
// CustomizeDlg

function TInternalCustomizeAction.Execute: boolean;
begin
  result := inherited Execute;
  if result and (CustomizeDlg <> nil) then
    CustomizeDlg.OnClose := Close;
end;

{ TCepStyleCustomizePopup }
{ ,       }

procedure TCepStyleCustomizePopup.CloseMenu;
begin
  //   PopupStack   nil,     
  if PopupStack <> nil then
    inherited CloseMenu;
  // fSelectedItem := nil;
end;

//     ,    
// 

procedure TCepStyleCustomizePopup.SetActionClient(const Value: TActionClient);
  procedure RecreateItems;
  var
    ClientItem, NewClientItem: TActionClientItem;
    ABar: TCustomActionDockBar;
    I: integer;
  begin
    if not (csDestroying in ComponentState) and (Owner is TCustomActionDockBar) then
    begin
      with FARItem do
      begin
        ABar := TCustomActionDockBar(Owner);
        Items.BeginUpdate;
        try
          Items.Clear;
          for I := 0 to ABar.ActionClient.Items.Count - 1 do
          begin
            ClientItem := ABar.ActionClient.Items[I];
            if (ClientItem.Action <> nil) and (Parent <> nil) then
            begin
              NewClientItem := Items.Add;
              NewClientItem.Assign(ClientItem);
              NewClientItem.UsageCount := -1;
              if NewClientItem.Action is TMultiActionCep then
                NewClientItem.Items.Clear;
            end;
          end;
        finally
          Items.EndUpdate;
        end;
      end;
    end;
  end;
begin
  if Assigned(Value) and (RootMenu = self) then
  begin
    // 
    if (Value.Items.Count > 0) and (fSeparatorItem = nil) then
    begin
      fSeparatorItem := Value.Items.Add;
      fSeparatorItem.Caption := '-';
    end;
    //   / 
    if (FARItem = nil) and (Parent <> nil) then
    begin
      if InternalARAction = nil then
      begin
        InternalARAction := TInternalARAction.Create(nil);
      end;
      FARItem := Value.Items.Add;
      FARItem.UsageCount := -1;
      FARItem.Action := InternalARAction;
      RecreateItems;
    end;

    //   " " (CapCustomize)
    if InternalCustomizeAction = nil then
      InternalCustomizeAction := TInternalCustomizeAction.Create(nil);
    with TInternalCustomizeAction(InternalCustomizeAction) do
    begin
      CustomizeDlg.ActionManager := self.ActionManager;
      OnExecute := CustomizeActionBarsExecute;
      Caption := CapCustomize;
    end;
    FCustomizeItem := Value.Items.Add;
    with FCustomizeItem do
    begin
      Action := InternalCustomizeAction;
      UsageCount := -1;
    end;
  end;
  inherited;
  if FCustomizeItem <> nil then
    FCustomizeItem.Index := FCustomizeItem.Collection.Count - 1;
end;

//    
// TCustomizeFrm   TCustomizeDlg    CustomizeDlg

procedure TCepStyleCustomizePopup.CustomizeActionBarsExecute(Sender: TObject);
var
  ABar: TCustomGradientActionToolBar;
  OldAutoSizing: boolean;
begin
  if Sender is TCustomizeActionBars then
    with TCustomizeActionBars(Sender) do
    begin
      if (Self.RootMenu <> nil) and
        (Self.RootMenu.Parent is TCustomGradientActionToolBar) then
      begin
        ABar := TCustomGradientActionToolBar(Self.RootMenu.Parent);
        OldAutoSizing := ABar.AutoSizing;
      end
      else
      begin
        OldAutoSizing := false;
        ABar := nil;
      end;
      CustomizeDlg.StayOnTop := true;
      CustomizeDlg.Show;
      CustomizeDlg.CustomizeForm.Caption := Caption;
      if ABar <> nil then
        with ABar do
        begin
          AutoSizing := OldAutoSizing;
          if Assigned(onShowCustomize) then
            onShowCustomize(CustomizeDlg.CustomizeForm);
        end;
    end;
end;

function TCepStyleCustomizePopup.DoItemClicked(
  AnItem: TCustomActionControl): TActionClientItem;
var
  Item: TActionClientItem;
  ABar: TCustomActionBar;
  Need: boolean;
  function FindItem(MatchItem: TActionClientItem): TActionClientItem;
  var
    I: Integer;
    OwnerItems: TActionClients;
  begin
    Result := nil;
    OwnerItems := ABar.ActionClient.Items;
    for I := 0 to OwnerItems.Count - 1 do
      if OwnerItems[I].Action = MatchItem.Action then
      begin
        Result := OwnerItems[I];
        break;
      end;
  end;
begin
  ABar := nil;
  if RootMenu.ParentControl = nil then
  begin
    if RootMenu.Parent is TCustomActionBar then
      ABar := TCustomActionBar(RootMenu.Parent);
  end
  else
  begin
    ABar := RootMenu.ParentControl.ActionBar;
  end;
  Need := (ABar <> nil) and (not AnItem.Separator) and (AnItem is GetAddRemoveItemClass);
  if Need then
  begin
    Item := FindItem(AnItem.ActionClient);
    if Assigned(Item) then
    begin
      Item.Visible := not Item.Visible;
      if not Item.Visible then
        Item.Control.Visible := False;
    end
    else
    begin
      Item := TActionClientItem(ABar.ActionClient.Items.Insert(AnItem.ActionClient.Index));
      Item.Action := AnItem.ActionClient.Action;
    end;
    ABar.Realign;
    with ABar do
      ABar.SetBounds(Left, Top, Width, Height);

    //if AnItem.ActionClient = FResetItem then
    //begin
    //  CloseMenu;
    //  Result := AnItem.ActionClient;
    //  PostMessage(ABar.Handle, CM_RESETBAR, 0, 0);
     // FSelectedItem := nil;
    //end;
    Result := nil;
  end
  else
    Result := inherited DoItemClicked(AnItem);
end;

//       

function TCepStyleCustomizePopup.GetAddRemoveItemClass: TCustomAddRemoveItemClass;
begin
  result := TCustomAddRemoveItemClass(DefControlClasses[kcARItem]);
end;

{ TCepStyleMenuItem }
{   }

procedure TCepStyleMenuItem.CalcLayout;
var
  GliphSize: integer;
  P: TPoint;
begin
  inherited;
  GliphSize := 0;
  P := GlyphPos;
  if (Action is TCustomAction) and
    (TCustomAction(Action).ActionList <> nil) then
  begin
    if (TCustomAction(Action).ActionList.Images <> nil) and
      (TCustomAction(Action).ImageIndex >= 0) then
      GliphSize := GetImageSize.X;
    if GliphSize > 0 then
    begin
      Height := Min(Height, GliphSize + Margins.Top + Margins.Bottom);
      P.Y := (Height - GliphSize) div (2) + 2;
    end
    else
      P.Y := 0;
    if GliphSize > 28 then
      Dec(P.X, GliphSize - 28);
    GlyphPos := P;
  end;
end;

procedure TCepStyleMenuItem.Click;
var AAction: TMultiActionCep;
    I: integer;
    Item: TActionClientItem;
begin
  inherited;
  if (ActionClient <> nil) and (ActionClient.Action <> nil) then
  begin
    Item := ActionClient;
    repeat
      if Item.ParentItem is TActionClientItem then
        Item := TActionClientItem(Item.ParentItem)
      else
        Item := nil;
      if (Item <> nil) and
         (Item.Action is TMultiActionCep) then
      begin
        AAction := TMultiActionCep(Item.Action);
        for I := 0 to AAction.SubActions.Count - 1 do
          if AAction.SubActions[I].Action = ActionClient.Action then
          begin
            AAction.DoSubItemClick(I);
            if AAction.AutoUpdateProp then
              AAction.ItemIndex := I;
            Break;
          end;
      end;
    until Item = nil;
  end;
end;

destructor TCepStyleMenuItem.Destroy;
begin
  FreeImg;
  inherited;
end;

//   

procedure TCepStyleMenuItem.DrawBackground(var PaintRect: TRect);
begin
  DrawBackgroundMenu(self, PaintRect, MouseSelected);
end;

// 

procedure TCepStyleMenuItem.DrawGlyph(const Location: TPoint);
begin
  DrawGliphControl(self, Selected, Location);
end;

procedure TCepStyleMenuItem.DrawLargeGlyph(Location: TPoint);
begin
  DrawGliphControl(self, Selected, Location);
end;

//  

procedure TCepStyleMenuItem.DrawSeparator(const Offset: Integer);
var
  PaintRect: TRect;
begin
  PaintRect := BoundsRect;
  Canvas.Brush.Style := bsSolid;
  Canvas.Brush.Color := Menu.ColorMap.Color;
  Canvas.Pen.Color := ActionBar.ColorMap.Color {Menu.ColorMap.DisabledFontColor};
  Canvas.Pen.Width := 1;
  if ActionBar.DesignMode then
    Canvas.Pen.Color := GetShadowColor(Canvas.Pen.Color);
  Canvas.MoveTo(Offset, ClientHeight div 2);
  Canvas.LineTo(ClientWidth, ClientHeight div 2);
end;

procedure TCepStyleMenuItem.FreeImg;
begin
  FreeAndNil(fImg);
end;

function TCepStyleMenuItem.GetImageSize: TPoint;
var Img: TRichImageList;
begin
  fillchar(Result, SizeOf(Result), 0);
  if (ActionClient <> nil) and (ActionClient.ActionClients <> nil) then
  begin
    Img := GetImg(ActionClient.ActionClients.SmallIcons);
    if (Img <> nil) and (Img.Index >= 0) and (Img.ImageList <> nil) then
    begin
      result.X := Img.ImageList.Width;
      result.Y := Img.ImageList.Height;
    end;
  end;
  if Result.Y = 0 then
    result := inherited GetImageSize;
end;

function TCepStyleMenuItem.GetImg(Small: boolean = true): TRichImageList;
begin
  result := UpdateRichImageList(Action, Small);
end;

function TCepStyleMenuItem.UpdateRichImageList(const Action: TBasicAction;
                                               const Small: boolean): TRichImageList;
begin
  result := ImgByAction(fImg, Action, Small);
end;

{ TCepStyleAddRemoveItem }
{      }

destructor TCepStyleAddRemoveItem.Destroy;
begin
  FreeImg;
  inherited;
end;

//   ,   

procedure TCepStyleAddRemoveItem.DrawBackground(var PaintRect: TRect);
begin
  inc(PaintRect.Left, 16);
  DrawBackgroundMenu(self, PaintRect, MouseSelected);
end;

procedure TCepStyleAddRemoveItem.DrawGlyph(const Location: TPoint);
var
  I, X, Y: integer;
  IsVisible, Need: boolean;
  ABar: TCustomActionBar;
begin
  DrawGliphControl(self, false, Location);
  //     ,  
  //  .   
  //    
  IsVisible := false;
  Need := false;
  ABar := nil;
  if Menu.RootMenu.ParentControl = nil then
  begin
    if Menu.RootMenu.Parent is TCustomActionBar then
      ABar := TCustomActionBar(Menu.RootMenu.Parent);
  end
  else
  begin
    ABar := Menu.RootMenu.ParentControl.ActionBar;
  end;
  if ABar <> nil then
    with ABar.ActionClient do
    begin
      if ActionClient.Action <> nil then
        for I := 0 to Items.Count - 1 do
          if Items[I].Action = ActionClient.Action then
          begin
            IsVisible := Items[I].Visible;
            Need := true;
            Break;
          end;
    end;
  // ,     ,   
  if Need then
  begin
    X := 3;
    Y := (ClientHeight - 11) div (2);
    Canvas.Brush.Color := Menu.ColorMap.SelectedColor;
    Canvas.Pen.Color := ActionBar.ColorMap.BtnFrameColor;
    Canvas.Pen.Width := 1;
    Canvas.Rectangle(X, Y, X + 11, Y + 11);
    if IsVisible then
    begin
      Canvas.Pen.Color := Menu.ColorMap.FontColor;
      DrawCheck(Canvas, Point(X + 2, Y + 5), 2, false);
    end;
  end;
end;

procedure TCepStyleAddRemoveItem.DrawLargeGlyph(Location: TPoint);
begin
  DrawGlyph(Location);
end;

procedure TCepStyleAddRemoveItem.FreeImg;
begin
  FreeAndNil(fImg);
end;

function TCepStyleAddRemoveItem.GetImageSize: TPoint;
var Img: TRichImageList;
begin
  fillchar(Result, SizeOf(Result), 0);
  if (ActionClient <> nil) and (ActionClient.ActionClients <> nil) then
  begin
    Img := GetImg(ActionClient.ActionClients.SmallIcons);
    if (Img <> nil) and (Img.Index >= 0) and (Img.ImageList <> nil) then
    begin
      result.X := Img.ImageList.Width;
      result.Y := Img.ImageList.Height;
    end;
  end;
  if Result.Y = 0 then
    result := inherited GetImageSize;
end;

function TCepStyleAddRemoveItem.GetImg(Small: boolean = true): TRichImageList;
begin
  result := UpdateRichImageList(Action, Small);
end;

function TCepStyleAddRemoveItem.UpdateRichImageList(const Action: TBasicAction;
                                                    const Small: boolean): TRichImageList;
begin
  result := ImgByAction(fImg, Action, Small);
end;

{ TCepStylePopupMenu }

function TCepStylePopupMenu.GetExpandBtnClass: TCustomMenuExpandBtnClass;
begin
  result := TCustomMenuExpandBtnClass(DefControlClasses[kcExpBtn]);
end;

{ TCepStyleExpandBtn }
{      ,    }

procedure TCepStyleExpandBtn.DrawBackground(var PaintRect: TRect);
var
  TextRect: TRect;
begin
  TextRect := TextBounds;
  TextRect.Left := 24;
  TextBounds := TextRect;
  DrawBackgroundMenu(self,
    PaintRect,
    ((FState = bsDown) or not Flat or MouseInControl or IsChecked));

end;

procedure TCepStyleExpandBtn.DrawFrame(ARect: TRect; Down: Boolean);
begin
  //    DrawBackground
end;

{ TCepStyleMenuButton }

type
  TTMPActionMenuBarClass = class(TCustomActionMenuBar);

destructor TCepStyleMenuButton.Destroy;
begin
  FreeImg;
  inherited;
end;

procedure TCepStyleMenuButton.DrawBackground(var PaintRect: TRect);
var
  Offset: TPoint;
  Rgn: HRGN;
  N: integer;
  Points: array[0..5] of TPoint;
begin
  if (ActionBar is TCustomActionMenuBar) and
    (Menu.RootMenu is TCustomActionMenuBar) and
    TCustomActionMenuBar(ActionBar).InMenuLoop then
  begin
    if Selected then
      if ActionClient.ChildActionBar = nil then
      begin
        if TTMPActionMenuBarClass(Menu.RootMenu).PopupStack.Count = 1 then
        begin
          DrawBackgroundControl(self, true, PaintRect);
        end;
      end
      else
      begin
        Offset := Parent.ClientToScreen(BoundsRect.TopLeft);
        if Offset.Y >= ActionClient.ChildActionBar.BoundsRect.Bottom then
        begin
          Offset.Y := 1; // 
          Points[5].X := Width - 1;
          Points[5].Y := 0;
          Points[4].X := Width - 1;
          Points[4].Y := Height - 4;
          Points[3].X := Width - 4;
          Points[3].Y := Height - 1;
          Points[2].X := 3;
          Points[2].Y := Height - 1;
          Points[1].X := 0;
          Points[1].Y := Height - 4;
          Points[0].X := 0;
          Points[0].Y := 0;
          N := 2
        end
        else
        begin
          Offset.Y := Height - 2;
          Points[0].X := 0;
          Points[0].Y := Height;
          Points[1].X := 0;
          Points[1].Y := 3;
          Points[2].X := 3;
          Points[2].Y := 0;
          Points[3].X := Width - 4;
          Points[3].Y := 0;
          Points[4].X := Width - 1;
          Points[4].Y := 3;
          Points[5].X := Width - 1;
          Points[5].Y := Height;
          N := 3;
        end;
        Canvas.Brush.Color := Menu.ColorMap.BtnSelectedColor;
        RGN := 0;
        try
          RGN := windows.CreatePolygonRgn(Points, Length(Points), WINDING);
          if RGN = 0 then
            Canvas.Rectangle(0, 0, Width, Height)
          else
          begin
            Windows.FillRgn(Canvas.Handle, RGN, Canvas.Brush.Handle);
          end;
          Canvas.Pen.Color := ActionBar.ColorMap.FrameTopLeftOuter;
          Windows.Polyline(Canvas.Handle, Points, N + 1);
          Canvas.Pen.Color := ActionBar.ColorMap.FrameBottomRightOuter;
          Windows.Polyline(Canvas.Handle, Points[N], Length(Points) - N);
        finally
          DeleteObject(RGN);
        end;
        //InflateRect(PaintRect, -1 , -1);
      end;
  end
  else
  begin
    DrawBackgroundControl(self, MouseInControl, PaintRect);
    if IsChecked then
    begin
      DrawFrameControl(Self, true);
    end;
  end;
end;

procedure TCepStyleMenuButton.DrawGlyph(const Location: TPoint);
begin
  DrawGliphControl(self, Selected, Location);
end;

procedure TCepStyleMenuButton.DrawLargeGlyph(Location: TPoint);
begin
  DrawGliphControl(self, Selected, Location);
end;

procedure TCepStyleMenuButton.DrawShadowedText(Rect: TRect; Flags: Cardinal;
  Text: string; TextColor, ShadowColor: TColor);
begin
  DrawDisabeledText(self, Rect, Flags, Text);
end;

procedure TCepStyleMenuButton.FreeImg;
begin
  FreeAndNil(fImg);
end;

function TCepStyleMenuButton.GetImageSize: TPoint;
var Img: TRichImageList;
begin
  fillchar(Result, SizeOf(Result), 0);
  if (ActionClient <> nil) and (ActionClient.ActionClients <> nil) then
  begin
    Img := GetImg(ActionClient.ActionClients.SmallIcons);
    if (Img <> nil) and (Img.Index >= 0) and (Img.ImageList <> nil) then
    begin
      result.X := Img.ImageList.Width;
      result.Y := Img.ImageList.Height;
    end;
  end;
  if Result.Y = 0 then
    result := inherited GetImageSize;
end;

function TCepStyleMenuButton.GetImg(Small: boolean = true): TRichImageList;
begin
  result := UpdateRichImageList(Action, Small);
end;

function TCepStyleMenuButton.UpdateRichImageList(const Action: TBasicAction;
                                                 const Small: boolean): TRichImageList;
begin
  result := ImgByAction(fImg, Action, Small);
end;

{ TGradientActionToolBar }

procedure TCustomGradientActionToolBar.AlignControls(AControl: TControl;
  var Rect: TRect);
var W, H, T: integer;
begin
  inherited;
  H := Height;
  W := Width;
  if (Align in [alTop, alBottom]) or (Floating and (Align = alNone)) then
  begin
    T := GetBarHeight;
    if T <> fOldBarHeight then
    begin
      fOldBarHeight := T;
      H := fOldBarHeight;
    end;
  end;
  if (Align in [alLeft, alRight]) or (Floating and (Align = alNone)) then
  begin
    T := GetBarWidth;
    if T <> fOldBarWidth then
    begin
      fOldBarWidth := T;
      W := fOldBarWidth;
    end;
  end;
  if (W <> Width) or (H <> Height) then
    SetBounds(Left, Top, W, H);
end;

function TCustomGradientActionToolBar.CalcDockedWidth: Integer;
begin
  result := CalcDockedWidthInternal(Orientation, self);
end;

procedure TCustomGradientActionToolBar.FreeHiddenItems;
begin
  fItemsChanged := true;
  FreeAndNil(fHiddenItems);
end;

function TCustomGradientActionToolBar.CanAutoSize(var NewWidth,
  NewHeight: Integer): Boolean;
begin
  result := true;
  NewWidth := CalcDockedWidth;
  NewHeight := CalcDockedWidthInternal(Orientation, self, false);
end;

function TCustomGradientActionToolBar.CaptionEx: WideString;
var
  C, H: string;
begin
  H := Hint;
  SeparateCaption(C, H);
  if C = '' then
    C := Caption;
  result := C;
end;

type
  TStackEx = class(TStack)
  end;

  //    

procedure TCustomGradientActionToolBar.ExecuteEx(X, Y: integer);
var
  AC: TCustomizeActionClientItem;
  ACHiddend: TActionClientItem;
  I: Integer;
begin
  AC := nil;
  if Assigned(FPopupBar) or not Assigned(ActionClient) then
    Exit;
  try
    AC := TCustomizeActionClientItem.Create(ActionClient.Items);
    AC.Visible := False;
    UpdateHiddenItems(fHiddenItems);
    if Assigned(fHiddenItems) and (fHiddenItems.Count > 0) then
    begin
      for I := 0 to fHiddenItems.Count - 1 do
      begin
        ACHiddend := TStackEx(fHiddenItems).List[I];
        if Assigned(ACHiddend) then
          with AC.Items.Add do
          begin
            ChangesAllowed := caAllChanges;
            Action := ACHiddend.Action;
            Visible := true;
            UsageCount := -1;
          end;
      end;
    end;
    FPopupBar := GetPopupClass.Create(self);
    with FPopupBar as TCustomActionPopupMenu {TCustomizeActionToolBar} do
    begin
      ColorMap := Self.ColorMap;
      RootMenu := TCustomizeActionToolBar(FPopupBar);
      Parent := Self;
      //ParentControl := Self;
      ActionClient := AC;
      Expand(True);
      Popup(X, Y);
    end;
  finally
    FreeAndNil(FPopupBar);
    AC.Control.Free;
    AC.Free;
  end;
end;

function TCustomGradientActionToolBar.IsChevronEx: boolean;
begin
  if fItemsChanged then
    UpdateHiddenItems(fHiddenItems);
  result := (fHiddenItems <> nil) and (fHiddenItems.Count > 0);
end;

function TCustomGradientActionToolBar.IsEnabledEx: boolean;
begin
  result := Enabled and (Style is TCepStyleActionBars);
end;

constructor TCustomGradientActionToolBar.Create(AOwner: TComponent);
begin
  inherited;
  fItemsChanged := true;
  fEnableClose := true;
  Align := alTop;
  Height := 29;
  HorzMargin := 1;
  EdgeBorders := [];
  EdgeInner := esRaised;
  EdgeOuter := esNone;
  HorzSeparator := True;
  VertSeparator := True;
end;

procedure TCustomGradientActionToolBar.CustomAlignPosition(Control: TControl;
  var NewLeft, NewTop, NewWidth, NewHeight: Integer; var AlignRect: TRect;
  AlignInfo: TAlignInfo);
var
  OldWidth, OldHeight: integer;
begin
  OldWidth := NewWidth;
  OldHeight := NewHeight;
  inherited;
  if Orientation in [boTopToBottom, boBottomToTop] then
    NewWidth := OldWidth
  else
    NewHeight := OldHeight;
  FreeHiddenItems;
end;

destructor TCustomGradientActionToolBar.Destroy;
begin
  FreeAndNil(fHiddenItems);
  inherited;
end;

procedure TCustomGradientActionToolBar.DrawBackground;
var
  R: TRect;
  IDraw: IDrawBackground;
  Painted: boolean;
begin
  Painted := false;
  if (Parent <> nil) and (Parent.GetInterface(IDrawBackground, IDraw)) then
  begin
    R := ClientRect;
    Painted := Idraw.DrawBackgroundControl(self, Canvas, R);
  end;
  if Painted then
    Exit;
  if (Parent is TControlBar) and
    (Style is TCepStyleActionBars) then
  begin
    if TControlBar(Parent).DrawingStyle = ExtCtrls.dsGradient then
    begin
      R := ClientRect;
      InflateRect(R, 1, 1);
      Dec(R.Left, 10);
      GradientFillCanvas(Canvas,
        TControlBar(Parent).GradientStartColor,
        TControlBar(Parent).GradientEndColor,
        R,
        TControlBar(Parent).GradientDirection);
    end
    else
      inherited;
  end
  else
    inherited;
end;

function TCustomGradientActionToolBar.GetFloatingDockSiteClass: TWinControlClass;
begin
  Result := TXToolDockFormCep;
end;

function TCustomGradientActionToolBar.GetPopupClass: TCustomActionBarClass;
begin
  with Style as TActionBarStyleEx do
    Result := GetPopupClass(Self);
end;

type
  TTmpCustomDockForm = class(TCustomDockForm);
  TTmpWinControl = class(TWinControl);
const
  Sign: array[0..2] of char = 'Cep';
  SignVer: char = '0';

procedure InternalLoadFromStream(Stream: TStream; ABar: TCustomActionDockBar);
var
  IsDock: byte;
  V: boolean;
  Name: string;
  W: word;
  Top, Left, Width, Height: integer;
  vSign: array[0..2] of char;
  vSignVer: char;
  P: int64;
  S: string;
  C: TComponent;
  TmpForm: TTmpCustomDockForm;
  Dx, Dy: integer;
  function TmpManualFloat(var FloatHost: TTmpCustomDockForm; ScreenPos: TRect; AVisible: boolean): Boolean;
  begin
    with ABar do
    begin
      Result := (HostDockSite = nil) or TTmpWinControl(HostDockSite).DoUndock(nil, ABar);
      if Result then
      begin
        if FloatHost <> nil then
        begin
          FloatHost.DisableAlign;
          try
            FloatHost.BoundsRect := ScreenPos;
            OffsetRect(ScreenPos, -ScreenPos.Left, -ScreenPos.Top);
            Dec(ScreenPos.Right, Dx);
            Dec(ScreenPos.Bottom, Dy);
            FloatHost.ClientWidth := ScreenPos.Right;
            Dock(FloatHost, ScreenPos);
          finally
            //FloatHost.Repaint;
            //ABar.BoundsRect := ScreenPos;
            FloatHost.EnableAlign;
          end;
          FloatHost.Visible := AVisible;
        end
        else
          Dock(FloatHost, ScreenPos);
      end
      else
        FreeAndNil(FloatHost);
    end;
  end;
begin
  W := 0;
  Name := '';
  if Stream.Size - Stream.Position < 4 then
    Exit;

  P := Stream.Position;
  Stream.ReadBuffer(vSign, SizeOf(vSign));
  Stream.ReadBuffer(vSignVer, SizeOf(vSignVer));
  if (not CompareMem(@vSign, @Sign, SizeOf(vSign))) then
  begin
    Stream.Position := P;
    raise EReadError.Create(ErrStreamFormat);
  end;
  if vSignVer <> SignVer then
  begin
    S := vSignVer;
    S := Format(ErrStreamVer, [S]);
    Stream.Position := P;
    raise EReadError.Create(S);
  end;
  Stream.ReadBuffer(V, SizeOf(V));
  Stream.ReadBuffer(IsDock, SizeOf(IsDock));
  if IsDock <> 255 then
  begin
    Stream.ReadBuffer(W, SizeOf(W));
    SetLength(Name, W);
    Fillchar(Name[1], W, 0);
    Stream.ReadBuffer(Name[1], W);
  end;
  Stream.ReadBuffer(Left, SizeOf(Left));
  Stream.ReadBuffer(Top, SizeOf(Top));
  Stream.ReadBuffer(Width, SizeOf(Width));
  Stream.ReadBuffer(Height, SizeOf(Height));
  if IsDock = 0 then
  begin
    ABar.Width := Width;
    ABar.Height := Height;
    Dx := 0;
    Dy := 0;
    TmpForm := nil;
    if ABar.FloatingDockSiteClass.InheritsFrom(TCustomDockForm) then
    begin
      ABar.Visible := V;
      TmpForm := TTmpCustomDockForm(ABar.FloatingDockSiteClass.Create(Application));
      Dx := TmpForm.Width - TmpForm.ClientWidth;
      Dy := TmpForm.Height - TmpForm.ClientHeight;
      TmpManualFloat(TmpForm,
        Rect(Left,
        Top,
        Left + Width + Dx,
        Top + Height + Dy),
        V);
    end;
    if TmpForm = nil then
      ABar.ManualFloat(Rect(Left,
        Top,
        Left + Width + Dx,
        Top + Height + Dy));
  end
  else
  begin
    ABar.SetBounds(Left, Top, Width, Height);
  end;
  ABar.Visible := V;
  if IsDock <> 255 then
  begin
    if ABar.Owner <> nil then
    begin
      C := ABar.Owner.FindComponent(Name);
      if C is TWinControl then
        ABar.Parent := TWinControl(C);
    end;
  end;
end;

procedure InternalSaveToStream(Stream: TStream; ABar: TCustomActionDockBar);
var
  IsDock: byte;
  V: boolean;
  Name: string;
  W: word;
  Top, Left, Width, Height: integer;
begin
  if ABar = nil then
    Exit;
  Stream.WriteBuffer(Sign, SizeOf(Sign));
  Stream.WriteBuffer(SignVer, SizeOf(SignVer));
  V := ABar.Visible;
  Stream.WriteBuffer(V, SizeOf(V));
  if ABar.Parent is TCustomDockForm then
    IsDock := 0
  else if ABar.Parent is TCustomControlBar then
    IsDock := 1
  else if ABar.Parent = nil then
    IsDock := 255
  else
    IsDock := 2;
  if IsDock = 0 then
    Name := ABar.Parent.ClassType.ClassName
  else if IsDock = 255 then
    Name := ''
  else
    Name := ABar.Parent.Name;
  W := Length(Name);
  Stream.WriteBuffer(IsDock, SizeOf(IsDock));
  if IsDock <> 255 then
  begin
    Stream.WriteBuffer(W, SizeOf(W));
    Stream.WriteBuffer(Name[1], W);
  end;
  Width := ABar.Width;
  Height := ABar.Height;
  if IsDock = 0 then
  begin
    Left := TTmpCustomDockForm(ABar.Parent).Left;
    Top := TTmpCustomDockForm(ABar.Parent).Top;
    if V then
    begin
      //Dec(Width, TTmpCustomDockForm(ABar.Parent).Width-TTmpCustomDockForm(ABar.Parent).ClientWidth);
      //Dec(Height, TTmpCustomDockForm(ABar.Parent).Height-TTmpCustomDockForm(ABar.Parent).ClientHeight);
    end;
  end
  else
  begin
    Left := ABar.Left;
    Top := ABar.Top;
  end;
  Stream.WriteBuffer(Left, SizeOf(Left));
  Stream.WriteBuffer(Top, SizeOf(Top));
  Stream.WriteBuffer(Width, SizeOf(Width));
  Stream.WriteBuffer(Height, SizeOf(Height));
end;

procedure TCustomGradientActionToolBar.LoadFromStream(Stream: TStream);
begin
  InternalLoadFromStream(Stream, Self);
end;

procedure TCustomGradientActionToolBar.Resize;
begin
  inherited;
  FreeHiddenItems;
end;

procedure TCustomGradientActionToolBar.SaveToStream(Stream: TStream);
begin
  InternalSaveToStream(Stream, Self);
end;

procedure TCustomGradientActionToolBar.SetEnableClose(const Value: boolean);
begin
  fEnableClose := Value;
  if Parent is TXToolDockFormCep then
    TXToolDockFormCep(Parent).EnableClose := fEnableClose
  else if Parent is TCustomDockForm then
    with TTmpCustomDockForm(Parent) do
    begin
      if fEnableClose then
        BorderIcons := BorderIcons + [biSystemMenu]
      else
        BorderIcons := BorderIcons - [biSystemMenu];
    end;
end;

procedure TCustomGradientActionToolBar.SetParent(AParent: TWinControl);
begin
  inherited;
  EnableClose := fEnableClose;
end;

procedure TCustomGradientActionToolBar.UpdateHiddenItems(var AHiddenItems: TStack);
var
  I: Integer;
  R1, R2, R: TRect;
  S1, S2: integer;
  procedure AddItemToStack(Item: TActionClientItem);
  begin
    if AHiddenItems = nil then
      AHiddenItems := TStack.Create;
    AHiddenItems.Push(Item);
  end;
begin
  FreeAndNil(AHiddenItems);
  fItemsChanged := false;
  if Items = nil then
    Exit;

  for I := 0 to Items.Count - 1 do
    if (Items[I].Action <> nil) and (Items[I].Control <> nil) then
    begin
      if (not Items[I].Visible) then
        AddItemToStack(Items[I])
      else
      begin
        R1 := Items[I].Control.BoundsRect;
        R2 := ClientRect;
        IntersectRect(R, R1, R2);
        S1 := (R1.Right - R1.Left) * (R1.Bottom - R1.Top);
        S2 := (R.Right - R.Left) * (R.Bottom - R.Top);
        //   33% ,   
        if (S1 = 0) or (Round((S2 * 100) div (S1)) < 33) then
          AddItemToStack(Items[I]);
      end;
    end;
end;

{ TCustomGradientActionMainMenuBar }

function TCustomGradientActionMainMenuBar.CalcDockedWidth: Integer;
begin
  result := CalcDockedWidthInternal(Orientation, self);
end;

function TCustomGradientActionMainMenuBar.CanAutoSize(var NewWidth,
  NewHeight: Integer): Boolean;
begin
  result := true;
  NewWidth := CalcDockedWidth;
  NewHeight := CalcDockedWidthInternal(Orientation, self, false);
end;

constructor TCustomGradientActionMainMenuBar.Create(AOwner: TComponent);
//var
//  HotKeys: BOOL;
//  Hook: TWindowHook;
begin
  inherited Create(AOwner);
  EdgeInner := esRaised;
  EdgeOuter := esLowered;
end;

function TCustomGradientActionMainMenuBar.DoItemClicked(
  AnItem: TCustomActionControl): TActionClientItem;
begin
  if (Assigned(fonItemClicked)) and
    (Assigned(AnItem)) then
    fonItemClicked(AnItem);
  result := inherited DoItemClicked(AnItem);
end;

procedure TCustomGradientActionMainMenuBar.DrawBackground;
var
  R: TRect;
  IDraw: IDrawBackground;
  Painted: boolean;
begin
  Painted := false;
  if (Parent <> nil) and (Parent.GetInterface(IDrawBackground, IDraw)) then
  begin
    R := ClientRect;
    Painted := Idraw.DrawBackgroundControl(self, Canvas, R);
  end;
  if Painted then
    Exit;
  if (Parent is TControlBar) and
    (Style is TCepStyleActionBars) then
  begin
    if TControlBar(Parent).DrawingStyle = ExtCtrls.dsGradient then
    begin
      R := ClientRect;
      InflateRect(R, 1, 1);
      Dec(R.Left, 10);
      GradientFillCanvas(Canvas,
        TControlBar(Parent).GradientStartColor,
        TControlBar(Parent).GradientEndColor,
        R,
        TControlBar(Parent).GradientDirection);
    end
    else
      inherited;
  end
  else
    inherited;
end;

function TCustomGradientActionMainMenuBar.GetFloatingDockSiteClass: TWinControlClass;
begin
  Result := TXToolDockFormCep;
end;

procedure TCustomGradientActionMainMenuBar.LoadFromStream(Stream: TStream);
begin
  InternalLoadFromStream(Stream, Self);
end;

procedure TCustomGradientActionMainMenuBar.SaveToStream(Stream: TStream);
begin
  InternalSaveToStream(Stream, Self);
end;

procedure TCustomGradientActionMainMenuBar.SetParent(AParent: TWinControl);
begin
  inherited;
  if Parent is TXToolDockFormCep then
    TXToolDockFormCep(Parent).EnableClose := False
  else if Parent is TTmpCustomDockForm then
    TTmpCustomDockForm(Parent).BorderIcons := TTmpCustomDockForm(Parent).BorderIcons - [biSystemMenu];
end;

type
  TCustomActionManagerEx = class(TCustomActionManager)
  end;
  TCustomFormEx = class(TCustomForm)
  end;
  TCustomActionBarEx = class(TCustomActionDockBar)
  end;
  TControlEx = class(TControl)
  end;
  TCustomActionListEx = class(TCustomActionList)
  end;

  { TActionListCep }

type
  TLinkedControlsList = class(TObjectList)
  private
    fOwner: TActionListCep;
  protected
    procedure Notify(Ptr: Pointer; Action: TListNotification); override;
  public
    constructor Create(AOwner: TActionListCep); reintroduce;
    property Owner: TActionListCep read fOwner;
  end;

  { TLinkedControlsList -  ,   }

constructor TLinkedControlsList.Create(AOwner: TActionListCep);
begin
  inherited Create(false);
  fOwner := AOwner;
end;

procedure TLinkedControlsList.Notify(Ptr: Pointer; Action: TListNotification);
begin
  inherited;
  if (Ptr <> nil) and (fOwner <> nil) and (TObject(Ptr) is TControl) then
  begin
    case Action of
      lnAdded: fOwner.AddedLinkedControl(TControl(Ptr));
      lnDeleted: fOwner.AddedLinkedControl(TControl(Ptr));
    end;
  end;
end;

procedure TActionListCep.ClearInternal;
var
  List: TStringList;
  i, j: Integer;
  Item: TActionClientItem;
  Action: TActionLinkedControlCep;
begin
  List := TStringList.Create;
  try
    FindItemsByAction(List);
    for i := 0 to List.Count - 1 do
    begin
      if (List.Objects[i] <> nil) and
        (TActionClientItem(List.Objects[i]).Action is TActionListCep) then
      begin
        Item := (TActionClientItem(List.Objects[i]));
        j := 0;
        while J < Item.Items.Count do
          if (Item.Items[J].Action is TActionLinkedControlCep) and
            (TActionLinkedControlCep(Item.Items[J].Action).Internal) then
          begin
            Action := TActionLinkedControlCep(Item.Items[J].Action);
            Item.Items[J].Free;
            Action.Free;
            J := 0;
          end
          else
            inc(J);
      end;
    end;
  finally
    FreeAndNil(List);
  end;
end;

constructor TActionListCep.Create(AOwner: TComponent);
begin
  inherited;
  fLinkedControls := TLinkedControlsList.Create(self);
end;

destructor TActionListCep.Destroy;
begin
  BeginUpdate;
  try
    fLinkedControls.Clear;
  finally
    EndUpdate;
  end;
  FreeAndNil(fLinkedControls);
  inherited;
end;

procedure TActionListCep.BeginUpdate;
begin
  inc(fCountUpdating);
  if fCountUpdating = 1 then
    Updating;
end;

procedure TActionListCep.EndUpdate;
begin
  dec(fCountUpdating);
  if fCountUpdating = 0 then
  begin
    Updated;
    RefreshItems;
  end;
  if fCountUpdating <= 0 then
    fCountUpdating := 0;
end;

function TActionListCep.GetLinkedControlsCount: integer;
begin
  result := fLinkedControls.Count;
end;

function TActionListCep.AddLinkedControl(AControl: TControl): integer;
var
  i: integer;
begin
  result := -1;
  if AControl <> nil then
  begin
    for I := 0 to fLinkedControls.Count - 1 do
      if fLinkedControls[i] = AControl then
        Exit;
    fLinkedControls.Add(AControl);
    result := fLinkedControls.Count - 1;
  end;
end;

function TActionListCep.DeleteLinkedControl(Index: integer): integer;
begin
  result := -1;
  if (Index >= 0) and (Index < fLinkedControls.Count) then
  begin
    fLinkedControls.Delete(Index);
    result := fLinkedControls.Count - 1;
  end;
end;

function TActionListCep.DeleteLinkedControl(AControl: TControl): integer;
var
  i: integer;
begin
  result := -1;
  if AControl <> nil then
  begin
    i := 0;
    result := fLinkedControls.Count;
    while I < fLinkedControls.Count do
      if fLinkedControls[i] = AControl then
        fLinkedControls.Delete(I)
      else
        inc(I);
    if result = fLinkedControls.Count then
      result := -1;
  end;
end;

procedure TActionListCep.Notification(AComponent: TComponent; Operation: TOperation);
begin
  inherited;
  if (Operation = opRemove) and (AComponent is TControl) then
  begin
    DeleteLinkedControl(TControl(AComponent));
  end;
end;

procedure TActionListCep.AddedLinkedControl(AControl: TControl);
begin
  AControl.FreeNotification(Self);
  RefreshItems;
end;

procedure TActionListCep.DeletedLinkedControl(AControl: TControl);
begin
  AControl.RemoveFreeNotification(Self);
  RefreshItems;
end;

//    ,   

procedure TActionListCep.FindItemsByAction(List: TStringList);
var
  AM: TCustomActionManagerEx;
  AB: TCustomActionBarEx;
  I: integer;
  procedure ClientItemByAction(Parent: TObject);
  var
    Items: TActionClients;
    i: integer;
  begin
    Items := nil;
    if Parent is TCustomActionBar then
      Items := TCustomActionBarEx(Parent).Items;
    if Parent is TActionClientItem then
      Items := TActionClientItem(Parent).Items;
    if Items <> nil then
      for I := 0 to Items.Count - 1 do
        if Items[i].Action = self then
          List.AddObject(Items[i].Caption, Items[i])
        else if Items[i].Items.Count > 0 then
          ClientItemByAction(Items[i]);
  end;
begin
  if (List <> nil) and
    (ActionList is TCustomActionManager) then
  begin
    try
      AM := TCustomActionManagerEx(ActionList);
      List.Clear;
      for I := 0 to AM.ActionBars.Count - 1 do
        if AM.ActionBars[I].ActionBar is TCustomActionDockBar then
        begin
          AB := TCustomActionBarEx(AM.ActionBars[I].ActionBar);
          ClientItemByAction(AB);
        end;
    finally
    end;
  end;
end;

//     ,    

function TActionListCep.AddControl(AItem: TActionClientItem; Control: TControl): boolean;
var
  CurAction: TActionLinkedControlCep;
  NeedAdd: Boolean;
  I: Integer;
  NewItem: TActionClientItem;
  Act: TActionLinkedControlCep;
  AM: TCustomActionManagerEx;
begin
  result := false;
  if (Control <> nil) and (AItem <> nil) and (ActionList is TCustomActionManager) then
  begin
    AM := TCustomActionManagerEx(ActionList);
    NeedAdd := true;
    for I := 0 to AItem.Items.Count - 1 do
      if (AItem.Items[i].Action is TActionLinkedControlCep) and
        TActionLinkedControlCep(AItem.Items[i].Action).Internal then
      begin
        CurAction := TActionLinkedControlCep(AItem.Items[i].Action);
        if CurAction.Control = Control then
        begin
          NeedAdd := false;
          break;
        end;
      end;
    if NeedAdd then
    begin
      if InternalActionList = nil then
        InternalActionList := TCustomActionList.Create(nil);
      NewItem := AItem.Items.Add;
      Act := TActionLinkedControlCep.Create(self, Control);
      Act.Internal := true;
      if (Control is TCustomForm) and (TCustomFormEx(Control).FormStyle = fsMDIChild) and
        (Application <> nil) and (Application.MainForm is TCustomForm) and
        (Control.Parent = Application.MainForm) and
        (TCustomFormEx(Application.MainForm).FormStyle = fsMDIForm) then
        Act.GroupIndex := 260574;
      NewItem.Action := Act;
      NewItem.LastSession := AM.ActionBars.SessionCount;
      TCustomActionListEx(InternalActionList).AddAction(Act);
      result := true;
    end;
  end;
end;

//      .

procedure TActionListCep.RefreshItems;
var
  List: TStringList;
  i: integer;
begin
  if fCountUpdating = 0 then
  begin
    fCountUpdating := 1;
    try
      List := TStringList.Create;
      try
        FindItemsByAction(List);
        for I := 0 to List.Count - 1 do
          UpdateItem(TActionClientItem(List.Objects[I]));
      finally
        FreeAndNil(List);
      end;
      EnableDropdown := self.fLinkedControls.Count > 0;
    finally
      fCountUpdating := 0;
    end;
  end;
end;

//  

function TActionListCep.DeleteInternalItem(Item: TActionClientItem): boolean;
var
  CurAction: TActionLinkedControlCep;
begin
  result := false;
  if (Item <> nil) and (Item.Action is TActionLinkedControlCep) then
  begin
    CurAction := TActionLinkedControlCep(Item.Action);
    Item.Free;
    CurAction.Free;
    result := true;
  end;
end;

//    .

procedure TActionListCep.UpdateItem(Item: TActionClientItem);
var
  i: integer;
begin
  //  
  for I := 0 to fLinkedControls.Count - 1 do
    if fLinkedControls[i] is TControl then
      AddControl(Item, TControl(fLinkedControls[i]));
  //  ,    fLinkedControls
  I := 0;
  while I < Item.Items.Count do
  begin
    if (Item.Items[I].Action is TActionLinkedControlCep) and
      (TActionLinkedControlCep(Item.Items[I].Action).Internal) and
      ((TActionLinkedControlCep(Item.Items[I].Action).Control = nil) or
      (fLinkedControls.IndexOf(TActionLinkedControlCep(Item.Items[I].Action).Control) = -1)) then
    begin
      if not DeleteInternalItem(Item.Items[I]) then
        Inc(I);
    end
    else
      Inc(I);
  end;
end;

procedure CrearAllInternalActions(ActionList: TCustomActionList);
var
  i: integer;
begin
  if ActionList <> nil then
  begin
    for i := 0 to ActionList.ActionCount - 1 do
    begin
      if ActionList.Actions[i] is TActionListCep then
      begin
        TActionListCep(ActionList.Actions[i]).ClearInternal;
      end;
    end;
  end;
end;

{ TControlAction }

procedure TActionLinkedControlCep.AfterConstruction;
begin
  inherited;
  fCreated := true;
end;

constructor TActionLinkedControlCep.Create(AOwner: TComponent; AControl: TControl);
begin
  inherited Create(AOwner);
  Control := AControl;
end;

destructor TActionLinkedControlCep.Destroy;
begin
  if fControl <> nil then
    fControl.RemoveFreeNotification(Self);
  fControl := nil;
  inherited;
end;

procedure TActionLinkedControlCep.Notification(AComponent: TComponent; Operation: TOperation);
begin
  inherited;
  if (Operation = opRemove) and (AComponent = fControl) then
  begin
    fControl := nil;
    GroupIndex := 0;
    if (fCreated) and (([csUpdating, csDestroying] * ComponentState) = []) then
    begin
      if (not Internal) and (Owner is TActionListCep) then
        TActionListCep(Owner).RefreshItems
      else
        Update;
    end;
  end;
end;

procedure TActionLinkedControlCep.SetControl(const Value: TControl);
begin
  if fControl <> Value then
  begin
    if fControl <> nil then
      RemoveFreeNotification(Self);
    fControl := Value;
    if fControl <> nil then
    begin
      if ((Caption = '') or (Caption = Name)) and
        (Trim(TControlEx(Control).Caption) <> '') then
        Caption := Copy(TControlEx(Control).Caption, 1, 64);
      if Hint = '' then
        Hint := TControlEx(Control).Hint;
      if HelpContext = 0 then
        HelpContext := TControlEx(Control).HelpContext;
    end;
    if fControl <> nil then
      fControl.FreeNotification(Self);
    if (Control is TCustomForm) and
      (TCustomFormEx(Control).FormStyle = fsMDIChild) then
      GroupIndex := 260574
    else
      GroupIndex := 0;
    if (fCreated) and (([csUpdating, csDestroying] * ComponentState) = []) then
    begin
      if (not Internal) and (Owner is TActionListCep) then
        TActionListCep(Owner).RefreshItems
      else
        Update;
    end;
  end;
end;

procedure TActionLinkedControlCep.SetInactiveEmpty(const Value: boolean);
begin
  if fInactiveEmpty <> Value then
  begin
    fInactiveEmpty := Value;
    if (fCreated) and (([csUpdating, csDestroying] * ComponentState) = []) then
      Update;
  end;
end;

procedure TActionLinkedControlCep.SetInvisibleEmpty(const Value: boolean);
begin
  if fInvisibleEmpty <> Value then
  begin
    fInvisibleEmpty := Value;
    if (fCreated) and (([csUpdating, csDestroying] * ComponentState) = []) then
      Update;
  end;
end;

procedure TActionLinkedControlCep.SetNameAsControl(const Value: boolean);
begin
  if fNameAsControl <> Value then
  begin
    fNameAsControl := Value;
    if (fCreated) and (([csUpdating, csDestroying] * ComponentState) = []) then
      Update;
  end;
end;

function TActionLinkedControlCep.Execute: boolean;
begin
  result := inherited Execute;
  if Control <> nil then
  begin
    result := true;
    Enabled := true;
    if fControl is TCustomForm then
    begin
      if not TCustomFormEx(Control).Visible then
        TCustomFormEx(Control).Show;
      if TCustomFormEx(Control).WindowState = wsMinimized then
        ShowWindow(TCustomFormEx(Control).Handle, SW_RESTORE);
      TCustomFormEx(Control).BringToFront;
      if TCustomFormEx(Control).Enabled then
        TCustomFormEx(Control).SetFocus;
    end
    else
    begin
      Control.Visible := true;
      try
        if (Control is TWinControl) and
          (TWinControl(Control).Enabled) and
          (TWinControl(Control).CanFocus) then
          TWinControl(Control).SetFocus;
      except
        result := false;
      end;
    end;
  end;
end;

function TActionLinkedControlCep.Update: Boolean;
var
  C: boolean;
begin
  result := false;
  if not fCreated then
    Exit;
  result := inherited Update;
  if Control <> nil then
  begin
    Enabled := true;
    if fNameAsControl then
    begin
      if Trim(TControlEx(Control).Caption) <> '' then
        Caption := Copy(TControlEx(Control).Caption, 1, 64);
      Hint := TControlEx(Control).Hint;
      HelpContext := TControlEx(Control).HelpContext;
    end;
    if Control is TCustomForm then
    begin
      if TCustomFormEx(Control).FormStyle = fsMdiChild then
        C := TCustomForm(Control).Active
      else
        C := TControlEx(Control).Visible;
    end
    else
      C := TControlEx(Control).Visible;
    if C <> Checked then
      Checked := C;
    result := true;
  end
  else
  begin
    if ([csReading] * ComponentState = []) then
    begin
      if fInactiveEmpty then
        Enabled := false
      else
        result := true;
      if fInvisibleEmpty then
        Visible := false;
    end;
  end;
end;

const
  SignAM: packed array[0..2] of Char = 'AMS';

procedure ActionManagerSave(Stream: TStream; Manager: TCustomActionManager);
var
  S: TMemoryStream;
  Size, I: integer;
  N: SmallInt;
  VSign: packed array[0..2] of Char;
  IStream: IStreamPersist;
begin
  if (Stream <> nil) and (Manager <> nil) then
  begin
    S := TMemoryStream.Create;
    try
      Manager.ActionBars.SessionCount := Manager.ActionBars.SessionCount + 1;
      CrearAllInternalActions(Manager);
      Manager.SaveToStream(S);
      Size := S.Size;
      Move(SignAM, VSign, sizeOf(VSign));
      S.Position := 0;
      Stream.Write(VSign, SizeOf(VSign));
      Stream.Write(Size, SizeOf(Size));
      Stream.WriteBuffer(S.Memory^, Size);
      N := 0;
      for I := 0 to Manager.ActionBars.Count - 1 do
        if (Manager.ActionBars[i].ActionBar <> nil) and
          (Manager.ActionBars[i].ActionBar.GetInterface(IStreamPersist, IStream)) then
          inc(N);
      Stream.Write(N, SizeOf(N));
      I := 0;
      while I < N do
      begin
        if (Manager.ActionBars[i].ActionBar <> nil) and
          (Manager.ActionBars[i].ActionBar.GetInterface(IStreamPersist, IStream)) then
        begin
          IStream.SaveToStream(Stream);
        end;
        inc(I);
      end;
    finally
      FreeAndNil(S);
    end;
  end;
end;

function PrioritySort(List: TStringList; Index1, Index2: Integer): Integer;
begin
  Result := AnsiCompareText(List.Names[Index1], List.Names[Index2]);
end;

procedure ActionManagerLoad(Stream: TStream; Manager: TCustomActionManager);
var
  S: TMemoryStream;
  Size, I, J: integer;
  N: SmallInt;
  VSign: packed array[0..2] of Char;
  IStream: IStreamPersist;
  OldPos: Int64;
  P: Pointer;
begin
  if (Stream <> nil) and (Manager <> nil) then
  begin
    OldPos := Stream.Position;
    S := TMemoryStream.Create;
    try
      try
        Stream.ReadBuffer(VSign, SizeOf(VSign));
        if CompareMem(@VSign, @SignAM, SizeOf(SignAM)) then
        begin
          Stream.ReadBuffer(Size, SizeOf(Size));
          GetMem(P, Size);
          try
            Stream.ReadBuffer(P^, Size);
            S.WriteBuffer(P^, Size);
            S.Position := 0;
            Manager.LoadFromStream(S);
            Manager.PrioritySchedule.CustomSort(PrioritySort);
            for I := 0 to Manager.PrioritySchedule.Count - 1 do
              with Manager.PrioritySchedule do
                Objects[I] := Pointer(StrToInt(Values[Names[I]]));

          finally
            FreeMem(P, Size);
          end;
          Stream.ReadBuffer(N, SizeOf(N));
          I := 0;
          J := 0;
          while I < N do
          begin
            while J < Manager.ActionBars.Count do
              if (Manager.ActionBars[j].ActionBar <> nil) and
                (Manager.ActionBars[j].ActionBar.GetInterface(IStreamPersist, IStream)) then
                break
              else
                inc(J);
            if (J < Manager.ActionBars.Count) and
              (Manager.ActionBars[j].ActionBar.GetInterface(IStreamPersist, IStream)) then
            begin
              IStream.LoadFromStream(Stream);
              inc(I);
              inc(J);
            end
            else
              break;
          end;
        end
        else
          raise EReadError.Create(ErrStreamFormat);
      finally
        FreeAndNil(S);
      end;
    except
      Stream.Position := OldPos;
      raise;
    end;
  end;
end;

{ TMultiActionItems }

function TMultiActionItems.GetItem(Index: Integer): TMultiActionItem;
begin
  result := TMultiActionItem(inherited GetItem(Index));
end;

procedure TMultiActionItems.Notify(Item: TCollectionItem; Action: TCollectionNotification);
begin
  if Owner is TMultiActionCep then
  begin
    TMultiActionItem(Item).Action := nil;
  end;
end;

procedure TMultiActionItems.SetItem(Index: Integer;
  const Value: TMultiActionItem);
begin
  inherited SetItem(Index, Value);
end;

{ TMultiActionItem }

procedure TMultiActionItem.Assign(Source: TPersistent);
begin
  if Source <> nil then
  begin
    if Source is TMultiActionItem then
      Action := TMultiActionItem(Source).Action
    else
      inherited;
  end
  else
    Action := nil;
end;

constructor TMultiActionItem.Create(Collection: TCollection);
begin
  inherited;
end;

destructor TMultiActionItem.Destroy;
begin
  FreeAndNil(fActionLink);
  inherited;
end;

function TMultiActionItem.GetAction: TCustomAction;
begin
  if (fActionLink <> nil) and (fActionLink.Action is TCustomAction) then
    Result := TCustomAction(fActionLink.Action)
  else
    Result := nil;
end;

function TMultiActionItem.GetDisplayName: string;
begin
  if Action = nil then
    result := inherited GetDisplayName
  else
  begin
    if Action.Caption <> '' then
      result := Action.Caption
    else
      result := Action.Name;
  end;
end;

function TMultiActionItem.GetParentAction: TMultiActionCep;
begin
  if (Collection is TOwnedCollection) and (TOwnedCollection(Collection).Owner is TMultiActionCep) then
    result := TMultiActionCep(TOwnedCollection(Collection).Owner)
  else
    result := nil;
end;

procedure TMultiActionItem.SetAction(const Value: TCustomAction);
var AParentAction: TMultiActionCep;
begin
  if Value <> GetAction then
  begin
    AParentAction := ParentAction;
    if Value = nil then
    begin
      if AParentAction <> nil then
        GetAction.RemoveFreeNotification(AParentAction);
      fActionLink.Free;
      fActionLink := nil;
    end
    else
    begin
      if fActionLink = nil then
        fActionLink := TActionLink.Create(Self);
      fActionLink.Action := Value;
      if AParentAction <> nil then
        fActionLink.Action.FreeNotification(AParentAction);
    end;
  end;
end;

{ TMultiActionCep }

procedure TMultiActionCep.Change;
begin
  inherited;
  fChanged := True;
end;

constructor TMultiActionCep.Create(AOwner: TComponent);
var AClass: TMultiActionItemClass;
begin
  inherited;
  fAutoUpdateProp := True;
  AClass := GetItemClass;
  if AClass = nil then AClass := TMultiActionItem;
  fSubActions := TMultiActionItems.Create(Self, AClass);
end;

destructor TMultiActionCep.Destroy;
begin
  FreeAndNil(fSubActions);
  inherited;
end;

procedure TMultiActionCep.DoSubItemClick(Index: integer);
begin

end;

function TMultiActionCep.GetItemClass: TMultiActionItemClass;
begin
  result := nil;
end;

function TMultiActionCep.GetSubAction: TCustomAction;
begin
  Result := nil;
  if (fSubActions <> nil) and (ItemIndex >= 0) and (ItemIndex < fSubActions.Count) then
    Result := SubActions[ItemIndex].Action
end;

procedure TMultiActionCep.SetAutoUpdateProp(const Value: boolean);
begin
  if fAutoUpdateProp <> Value then
  begin
    fAutoUpdateProp := Value;
    if fAutoUpdateProp then Update;
  end;
end;

procedure TMultiActionCep.SetItemIndex(const Value: integer);
begin
  fItemIndex := Value;
end;

procedure TMultiActionCep.SetSubActions(const Value: TMultiActionItems);
begin
  if Value <> nil then
    fSubActions.Assign(Value)
  else
    fSubActions.Clear;
end;

type   TActionClientLinkEx = class (TActionClientLink);

function TMultiActionCep.Update: Boolean;
var AAction: TCustomAction;
    NewSubImageIndex: integer;
    NewSubImages: TCustomImageList;
    NewSubEnabled: boolean;
    NewSubVisible: boolean;
  I: Integer;
  Link: TBasicActionLink;
begin
  AAction := SubAction;
  if AAction <> nil then
  begin
    AAction.Update;
    if fAutoUpdateProp then
    begin
      Caption := AAction.Caption;
      Hint := AAction.Hint;
      HelpContext := AAction.HelpContext;
      HelpKeyword := AAction.HelpKeyword;
      HelpType := AAction.HelpType;
      Checked := AAction.Checked;
      AutoCheck := AAction.AutoCheck;
      ShortCut := AAction.ShortCut;
      SecondaryShortCuts := AAction.SecondaryShortCuts;
    end;
    NewSubImageIndex := AAction.ImageIndex;
    if AAction.ActionList <> nil then
      NewSubImages := AAction.ActionList.Images
    else
    begin
      if ActionList <> nil then
        NewSubImages := ActionList.Images
      else
        NewSubImages := nil;
    end;
    NewSubEnabled := AAction.Enabled;
    NewSubVisible := AAction.Visible;
  end
  else
  begin
    NewSubImageIndex := ImageIndex;
    if ActionList <> nil then
      NewSubImages := ActionList.Images
    else
      NewSubImages := nil;
    NewSubEnabled := Enabled;
    NewSubVisible := Visible;
  end;
  if (NewSubImageIndex <> fSubImageIndex) or
     (NewSubImages <> fSubImages) or
     (NewSubEnabled <> fSubEnabled) or
     (NewSubVisible <> fSubVisible) then
  begin
    fSubImageIndex := NewSubImageIndex;
    fSubImages := NewSubImages;
    fSubEnabled := NewSubEnabled;
    fSubVisible := NewSubVisible;
    for I := 0 to FClients.Count - 1 do
    begin
      Link := TObject(FClients.List[I]) as TBasicActionLink;
      if (Link is TActionClientLink) and (TActionClientLinkEx(Link).FClient <> nil) then
      begin
        TActionClientLinkEx(Link).FClient.Refresh;
      end;
    end;
  end;
  Result := inherited Update;
end;

function TMultiActionCep.Execute: boolean;
var AAction: TCustomAction;
    I: integer;
begin
  Result := False;
  AAction := SubAction;
  if AAction <> nil then
  begin
    AAction.Update;
    if AAction.Enabled then
    begin
      Result := AAction.Execute;
      for I := 0 to SubActions.Count - 1 do
        if SubActions[I].Action = AAction then
        begin
          ItemIndex := I;
          Break;
        end;
    end;
  end
  else
    result := inherited Execute;
end;

{ TCepMultiActionBtn }

constructor TCepMultiActionBtn.Create(AOwner: TComponent);
begin
  inherited;
  if ActionClient <> nil then
    ActionClient.Items.HideUnused := False;
end;

procedure TCepMultiActionBtn.AddSubItem(SubAction: TCustomAction);
var
  NewItem: TActionClientItem;
  J: Integer;
  isFound: Boolean;
begin
  if (SubAction <> nil) and (ActionClient <> nil) then
  begin
    isFound := False;
    for J := 0 to ActionClient.Items.Count - 1 do
      if ActionClient.Items[J].Action = SubAction then
      begin
        ActionClient.Items[J].UsageCount := -1;
        isFound := True;
        Break;
      end;
    if not isFound then
    begin
      NewItem := ActionClient.Items.Add;
      NewItem.Action := SubAction;
      NewItem.UsageCount := -1;
    end;
  end;
end;

procedure TCepMultiActionBtn.Notification(AComponent: TComponent; Operation: TOperation);
var I: integer;
begin
  inherited;
  if (AComponent is TCustomAction) and (Action is TMultiActionCep) then
  begin
    if Operation = opRemove then
    begin
      for I := TMultiActionCep(Action).SubActions.Count - 1 downto 0 do
      begin
        if AComponent = TMultiActionCep(Action).SubActions[I].Action then
          TMultiActionCep(Action).SubActions.Delete(I);
      end;
      if ActionClient <> nil then
      begin
        for I := ActionClient.Items.Count - 1 downto 0 do
        begin
          if ActionClient.Items[I].Action = AComponent then
            ActionClient.Items.Delete(I);
        end;
      end;
    end
    else
    begin
      for I := 0 to TMultiActionCep(Action).SubActions.Count - 1 do
      begin
        if AComponent = TMultiActionCep(Action).SubActions[I].Action then
          AddSubItem(TMultiActionCep(Action).SubActions[I].Action);
      end;
    end;
  end;
end;

procedure TCepMultiActionBtn.SetActionClient(Value: TActionClientItem);
var I: integer;
    SubAction: TCustomAction;
    Action: TMultiActionCep;
begin
  inherited;
  if (Value <> nil) and (Value.Action is TMultiActionCep) then
  begin
    if not (csDesigning in ComponentState) then
    begin
      Action := TMultiActionCep(Value.Action);
      ActionClient.Items.HideUnused := False;
      for I := 0 to Action.SubActions.Count - 1 do
      begin
        SubAction := Action.SubActions[I].Action;
        AddSubItem(SubAction);
      end;
    end;
  end;
end;

function TCepMultiActionBtn.SubAction: TCustomAction;
begin
  if (ActionClient <> nil) and (ActionClient.Action is TMultiActionCep) then
    result := TMultiActionCep(ActionClient.Action).SubAction
  else
    result := nil;
end;

initialization
  InternalActionList := nil;
  InternalCustomizeAction := nil;
  InternalARAction := nil;
  LargeImageLists := nil;
  CepStyle := TCepStyleActionBars.Create;
  RegisterActnBarStyle(CepStyle);
finalization
  UnRegisterActnBarStyle(CepStyle);
  CepStyle.Free;
  InternalARAction.Free;
  InternalCustomizeAction.Free;
  InternalActionList.Free;
  LargeImageLists.Free;
end.

