unit CepStyleUtl;
(*
 * Module:           TXToolDockFormCep,    ""
 *                "Drag and Dock"  .
 * Version:    1.0 (14.11.2007) b
 * Author:      
 * Comments:         .
 *                    
 *              : roschinspb@mail.ru
 *             http://www.delphikingdom.com/asp/users.asp?ID=1271
 *             http://www.roschinspb.boom.ru
 *
 * Copyright:   Cep Po 2007 .
 *)

interface
uses Windows, Messages, BitOp, Classes, Controls, Graphics, GraphUtil, ExtCtrls, ActnMan,
     ActnCtrls, Forms, Themes, SpeedButtonCep, InternalTimer,
     StdCtrls;
{$I Directives.inc}
resourcestring
  TextSysMenuEx = '';
  CapAR = '/ |,   ';
Const
  SC_SysMenuEx = WM_USER + 113;
  IDEventTimer = WM_USER + 114;
  UM_RESIZED = WM_USER + 115;
Type

  //     TRichImageList
  IImg=interface ['{01F38FA0-B41A-4A43-BA8F-937FBB008088}']
    function GetImg(Small: boolean = true): TRichImageList;
    function UpdateRichImageList(const Action: TBasicAction;
                                 const Small: boolean = true): TRichImageList;
    procedure FreeImg;
  end;

  //     
  //IStreamCustomActionDockBar = interface ['{9EBE575F-8A39-43D6-8D74-F2DDD1BA2335}']
  //  procedure SaveToStream(Stream: TStream);
  //  procedure LoadFromStream(Stream: TStream);
  //end;

  //       
  //  ,    
  IDrawBackground = interface ['{2DA77A6D-4700-4CC9-BA76-7044DEEBC4B4}']
    function DrawBackgroundControl(Control: TControl; Canvas: TCanvas; ARect: TRect): boolean;
    procedure ColorsInfo(var ADrawingStyle: TBandDrawingStyle;
                         var AGradientDirection: TGradientDirection;
                         var AGradientStartColor: TColor;
                         var AGradientEndColor: TColor;
                         var AColor: TColor);
    function InsetsControl(const Control: TControl; var Insets: TRect):boolean;
  end;

  //         
  ISysMenuEx = interface ['{ED79395D-BE41-4C97-8B9C-0E133B4E31CD}']
    function IsEnabledEx: boolean;
    function IsChevronEx: boolean;
    function CaptionEx: WideString;
    procedure ExecuteEx(X, Y: integer);
  end;

  //  
  TSpecialKind = (skControlBarDropDown, skCaptionClose, skCaptionDropDown, skCaptionPin);
  TSpeedButtonCepSpecial = class (TSpeedButtonCep)
  private
    fActive: boolean;
    function OnDrawBorder(Sender: TRichImageList; Bitmap:TBitmap; ARect:TRect; var SelectedColor: TColor): boolean;
    function OnDrawImage(Sender: TRichImageList; Bitmap:TBitmap; ARect:TRect):boolean;
    procedure DrawThemed(Canvas: TCanvas; ARect: TRect);
    function GetSpecialKind: TSpecialKind;
    procedure SetActive(const Value: boolean);
    procedure SetSpecialKind(const Value: TSpecialKind);
    procedure UpdateBlend;
    procedure DrawCustomed(Canvas: TCanvas; ARect: TRect);
  protected
    procedure HotChanged; override;
  public
    constructor Create(AOwner: TComponent); override;
    property Active: boolean read fActive write SetActive;
    property SpecialKind: TSpecialKind read GetSpecialKind write SetSpecialKind;
  end;

  // 
  TXToolDockFormCep = class (TCustomDockForm)
  private
    fClient: TControl;
    fButtonClose: TSpeedButtonCepSpecial;
    fSysButton: TSpeedButtonCepSpecial;
    fEnableClose: boolean;
    FUpdatingSize: boolean;
    fOldCtl3D: Boolean;
    fOldRect: TRect;
    fEnableSysButton: boolean;
    fClientRect: TRect;
    fCaptionRect: TRect;
    fTextRect: TRect;
    fLastHitTest: integer;
    fCaptionPushed: boolean;
    fUpdateInterval: integer;
    fTimer: THandle;
    fSysButtonPushed: boolean;
    fTmpTimer: TInternalTimer;
    fTextCaption: WideString;
    procedure SetEnableClose(const Value: boolean);
    procedure ModifySystemMenu;
    function GetNcSize(var Dx, Dy: integer): boolean;
    function UpdateRGN(ARect: TRect): boolean;
    procedure WMNCCreate(var Message: TWMNCCreate); message WM_NCCreate;
    procedure WMACTIVATEAPP(var Message: TWMACTIVATEAPP); message WM_ACTIVATEAPP;
    procedure WMNCPAINT(var Message: TWMNCPAINT); message WM_NCPAINT;
    procedure WMACTIVATE(var Message: TWMACTIVATE); message WM_ACTIVATE;
    procedure WMERASEBKGND(var Message: TWMERASEBKGND); message WM_ERASEBKGND;
    procedure WMNCHITTEST(var Message: TWMNCHITTEST); message WM_NCHITTEST;
    procedure WMNCRBUTTONDOWN(var Message: TWMRBUTTONDOWN); message WM_NCRBUTTONDOWN;
    procedure WMNCRBUTTONUP(var Message: TWMRBUTTONUP); message WM_NCRBUTTONUP;
    procedure WMSETTEXT(var Message: TWMSETTEXT); message WM_SETTEXT;
    procedure WMTIMER(var Message: TWMTIMER); message WM_TIMER;
    procedure UMRESIZED(var Message: TMessage); message UM_RESIZED;
    procedure WMSYSCOMMAND(var Message: TWMSYSCOMMAND); message WM_SYSCOMMAND;
    procedure CMActionUpdate(var Message: TMessage); message CM_ACTIONUPDATE;
    procedure SetEnableSysButton(const Value: boolean);
    procedure InvalidateButtons;
    procedure SetUpdateInterval(const Value: integer);
    procedure KillTimer;
    procedure SetTimer;
    procedure SetSysButtonPushed(const Value: boolean);
    function NewFormSize(Dx, Dy: Integer; var NewWidth, NewHeight: Integer): boolean;
    procedure ExecuteEx;
    procedure OnCloseClick(Sender: TObject);
    procedure OnSysClick(Sender: TObject);
    procedure AfterExecuteEx(Sender: TObject);
  protected
    procedure DoAddDockClient(Client: TControl; const ARect: TRect); override;
    function CanAutoSize(var NewWidth, NewHeight: Integer): Boolean; override;
    procedure ClientAdded(Client: TControl; const ARect: TRect); virtual;
    function CanResize(var NewWidth, NewHeight: Integer): Boolean; override;
    procedure AlignControls(AControl: TControl; var Rect: TRect); override;
    procedure Resize; override;
    property EnableSysButton: boolean read fEnableSysButton write SetEnableSysButton;
    procedure CreateWindowHandle(const Params: TCreateParams); override;
    procedure DestroyWindowHandle; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function CloseQuery: Boolean; override;
    procedure Paint; override;
    //C EnableClose ,    
    property EnableClose: boolean read fEnableClose write SetEnableClose;
    //     IsEnabledEx
    property UpdateInterval:integer read fUpdateInterval write SetUpdateInterval;
    property SysButtonPushed: boolean read fSysButtonPushed write SetSysButtonPushed;
    property AlphaBlend;
    property AlphaBlendValue;
  end;

  //       
  TDragDockObjectCep = class (TDragDockObjectEx)
  private
  protected
    procedure AdjustDockRect(ARect: TRect); override;
    procedure DrawDragDockImage; override;
    procedure EraseDragDockImage; override;
  public
    destructor Destroy; override;
  end;


//    '|'   
procedure SeparateCaption(var Caption, Hint:string);
//    
function CalcDockedWidthInternal(Orientation: TBarOrientation; Bar: TCustomActionDockBar; IsWidth: boolean = true): integer;

var Ctl3dFloatForms: boolean;
    MoveToCursor: boolean;

implementation

uses SysUtils, Math, UxTheme;

type
  TCustomActionDockBarEx = class (TCustomActionDockBar)
  end;
  TControlEx = class (TControl)
  end;
  TWinControlEx = class (TWinControl)
  end;
  TCustomFormEx = class (TCustomForm)
  end;

procedure SeparateCaption(var Caption, Hint:string);
var i: integer;
begin
  i := Pos('|', Hint);
  if I>0 then
  begin
    Caption := Copy(Hint, 1, i - 1);
    system.Delete(Hint, 1, i);
  end else
    Caption := Hint
end;

function CalcDockedWidthInternal(Orientation: TBarOrientation; Bar: TCustomActionDockBar; IsWidth: boolean = true): integer;
var
  Item: TActionClientItem;
  W: integer;
  Vert, CalcMax: boolean;
begin
  result := 0;
  Vert := Orientation in [boTopToBottom, boBottomToTop];
  CalcMax := (Vert and IsWidth) or ((not Vert) and (not IsWidth));
  if Bar <> nil then
  with TCustomActionDockBarEx(Bar) Do
  begin
    Item := FindFirstVisibleItem;
    while Assigned(Item) do
    begin
      if Item.Control <> nil then
      begin
        if IsWidth then W := Item.Control.Width
                   else W := Item.Control.Height;
        if CalcMax then
        begin
          if result < W then
            result := W;
        end
        else
          inc(result, W + Spacing);
      end;
      Item := FindNextVisibleItem(Item);
    end;
    if not CalcMax then Dec(result, Spacing);
    
    if IsWidth then
      inc(Result, HorzMargin * 2 + 1) //      1 
    else
      inc(Result, VertMargin * 2);
  end;
end;


{ TSpeedButtonCepSpecial }

constructor TSpeedButtonCepSpecial.Create(AOwner: TComponent);
begin
  inherited;
  Border := CepXPBorder;
  Transparent := true;
  List.OnDrawBorder := OnDrawBorder;
  List.OnDrawImage := OnDrawImage;
  Color := clNone;
  UpdateBlend;
end;

procedure TSpeedButtonCepSpecial.DrawCustomed(Canvas: TCanvas; ARect: TRect);
var Size, W, H: integer;
    Vert: boolean;
    Pt: TPoint;
  procedure DoDrawBarDropDown(Dx, Dy: integer);
  begin
    if Vert then Pt := Point((ARect.Left+ARect.Right-Size-1)div(2), ARect.Bottom - Size - 4)
            else Pt := Point(ARect.Right - 2*Size - 4, (Height - Size + 1) div (2));
    inc(Pt.X, Dx);
    inc(Pt.Y, Dy);
    DrawArrow(Canvas, sdDown, Pt, Size);
    if Checked then
    begin
      if Vert then Pt := Point((ARect.Left+ARect.Right-Size-1)div(2), 4)
              else Pt := Point(4, (ARect.Top+ARect.Bottom-2*Size + 1) div (2));
      inc(Pt.X, Dx);
      inc(Pt.Y, Dy);
      if Vert then
        DrawChevron(Canvas, sdRight, Pt, Size)
      else
        DrawChevron(Canvas, sdDown, Pt, Size)
    end;
  end;
begin
  Canvas.Pen.Color := BtnFrameColor;
  case SpecialKind of
    skControlBarDropDown: begin
      W := ARect.Right - ARect.Left;
      H := ARect.Bottom - ARect.Top;
      Size := (Min(W, H) - 6) div (2);
      Vert := H >= W;
      Canvas.Pen.Color := GetHighLightColor(Color);
      DoDrawBarDropDown(-1, -1);
      Canvas.Pen.Color := Font.Color;
      DoDrawBarDropDown(0, 0);
    end;
    skCaptionClose: begin
      if (ARect.Right - ARect.left) mod 2 = 0 then
      begin
        Dec(ARect.right);
        Dec(ARect.bottom);
      end;
      Canvas.Pen.Width := 2;
      Canvas.MoveTo(ARect.Left + 2, ARect.Top + 2);
      Canvas.LineTo(ARect.Right - 2, ARect.Bottom - 2);
      Canvas.MoveTo(ARect.Right - 2, ARect.Top + 2);
      Canvas.LineTo(ARect.Left + 2, ARect.Bottom - 2);
    end;
    skCaptionDropDown: begin
      Pt := Point(ARect.Left + 3, (ARect.Bottom + ARect.Top - (Size div 3) + 1) div (2));
      Size := (ARect.Right - ARect.Left - 6) div (2);
      DrawArrow(Canvas, sdDown, Pt, Size);
    end;
    skCaptionPin: begin
      DrawPin(Canvas, ARect, BtnFrameColor, Checked);
    end;
  end;
end;

function GetState(Button:TSpeedButtonCep): integer;
var State: TCepStateButton;
begin
  with Button do
  if Enabled then
  begin
    State := csbNormal;
    if Pushed then State := csbPushed
              else if Hot then State := csbHot;
  end else State := csbPushed{csbDisabeled};
  result := Ord(State) + 1;
end;

procedure TSpeedButtonCepSpecial.DrawThemed(Canvas: TCanvas; ARect: TRect);
const Elements: array [TSpecialKind] of TThemedElement =
       (teExplorerBar, teWindow, teComboBox, teWindow);
      Parts: array [TSpecialKind] of Integer =
       (7, WP_SMALLCLOSEBUTTON, CP_DROPDOWNBUTTON, WP_SMALLCLOSEBUTTON);
      States: array [TSpecialKind] of Integer =
       (DFCS_SCROLLCOMBOBOX, DFCS_BUTTONPUSH or DFCS_CAPTIONCLOSE, DFCS_SCROLLCOMBOBOX, WP_SMALLCLOSEBUTTON);
      Types: array [TSpecialKind] of Integer =
       (DFC_SCROLL, DFC_CAPTION, DFC_SCROLL, WP_SMALLCLOSEBUTTON);
var DW: DWORD;
    Element: TThemedElementDetails;
begin
  if ThemeServices.ThemesEnabled then
  begin
    Element.Element := Elements[SpecialKind];
    Element.Part := Parts[SpecialKind];
    Element.State := GetState(self);
    ThemeServices.DrawElement(Canvas.handle, Element, ARect, nil);
    if SpecialKind <> skCaptionClose then
    begin
      Canvas.Pixels[ARect.Left, ARect.Top] := clFuchsia;
      Canvas.Pixels[ARect.Right - 1, ARect.Top] := clFuchsia;
      Canvas.Pixels[ARect.Left, ARect.Bottom - 1] := clFuchsia;
      Canvas.Pixels[ARect.Right - 1, ARect.Bottom - 1] := clFuchsia;
    end;
  end
  else
  begin
    DW := States[SpecialKind];
    if Hot then DW := DW or DFCS_HOT;
    if Pushed then DW := DW or DFCS_PUSHED or DFCS_HOT;
    if not Enabled then DW := DW or DFCS_INACTIVE;
    Windows.DrawFrameControl(Canvas.Handle, ARect, Types[SpecialKind], DW);
  end;
end;

function TSpeedButtonCepSpecial.GetSpecialKind: TSpecialKind;
begin
  result := TSpecialKind(ButtonKind);
end;

procedure TSpeedButtonCepSpecial.HotChanged;
begin
  inherited;
  UpdateBlend;
end;

function TSpeedButtonCepSpecial.OnDrawBorder(Sender: TRichImageList;
  Bitmap: TBitmap; ARect: TRect; var SelectedColor: TColor): boolean;
begin
  if ThemeEnabled and
    (Enabled or (not ThemeServices.ThemesEnabled)) and
    (SpecialKind <> skCaptionPin) then
  begin
    result := false;
    DrawThemed(Bitmap.Canvas, ARect);
  end else begin
   if SpecialKind = skControlBarDropDown then
   begin
     if Hot then
     begin
       Bitmap.Canvas.Brush.Color := self.SelectedColor;
       Bitmap.Canvas.Pen.Color := BtnFrameColor;
       Bitmap.Canvas.Rectangle(ARect);
     end;
     result := false;
   end else result := checked;
  end;
end;

function TSpeedButtonCepSpecial.OnDrawImage(Sender: TRichImageList;
  Bitmap: TBitmap; ARect: TRect): boolean;
begin
  if ThemeEnabled and (Enabled or (not ThemeServices.ThemesEnabled)) then result := false
  else
  begin
    result := false;
    if ThemeEnabled and (SpecialKind <> skCaptionPin) then
    begin
      DrawThemed(Bitmap.Canvas, ARect);
    end else
    begin
      DrawCustomed(Bitmap.Canvas, ARect);
    end;
  end;
end;

procedure TSpeedButtonCepSpecial.SetActive(const Value: boolean);
begin
  if fActive <> value then
  begin
    fActive := Value;
    UpdateBlend;
  end;
end;

procedure TSpeedButtonCepSpecial.SetSpecialKind(const Value: TSpecialKind);
begin
  ButtonKind := TCepButtonKind(Value);
  UpdateBlend;
end;

procedure TSpeedButtonCepSpecial.UpdateBlend;
begin
  if (SpecialKind <> skControlBarDropDown) and ((ThemeEnabled and (not ThemeServices.ThemesEnabled)) or (fActive) or (Hot) or (not Enabled)) then
    Blend := 255
  else
    if SpecialKind = skControlBarDropDown then
      Blend := 128
    else
      Blend := 192;
end;

{ TXToolDockFormCep }

constructor TXToolDockFormCep.Create(AOwner: TComponent);
begin
  inherited;
  Visible := false;
  fOldCtl3D := not Ctl3dFloatForms;
  Ctl3D := Ctl3dFloatForms;
  Color := clBtnFace;
  Position := poDesigned;
  EnableSysButton := true;
  UpdateInterval := 100;
end;

procedure TXToolDockFormCep.CreateWindowHandle(const Params: TCreateParams);
var W: DWORD;
begin
  inherited;
  W := GetWindowLong(Handle, GWL_STYLE);
  W := W and (not WS_CAPTION);
  SetWindowLong(Handle, GWL_STYLE, W);
  InvalidateButtons;
  SetTimer;
end;

procedure TXToolDockFormCep.DestroyWindowHandle;
begin
  KillTimer;
  inherited;
end;

function TXToolDockFormCep.GetNcSize(var Dx, Dy: integer):boolean;
begin
  result := HandleAllocated;
  if result then
  begin
    Dx := Width - ClientWidth;
    Dy := Height - ClientHeight +  GetSystemMetrics(SM_CYSMCAPTION);
  end;
end;

function TXToolDockFormCep.UpdateRGN(ARect: TRect): boolean;
var RGN: HRGN;
    ChangedRect: boolean;
begin
  result := false;
  OffsetRect(ARect, -ARect.Left, -ARect.Top);
  ChangedRect := not CompareMem(@fOldRect, @ARect, SizeOf(ARect));
  if (Ctl3d <> fOldCtl3d) or ChangedRect then
  begin
    fOldRect := ARect;
    if Ctl3d and (Ctl3d <> fOldCtl3d) then
    begin
      Windows.SetWindowRgn(Handle, 0, true);
    end else
    begin
      if ChangedRect and (not Ctl3d) then
      begin
        RGN := windows.CreateRoundRectRgn(ARect.Left, ARect.Top, ARect.Right+1, ARect.Bottom, 4, 4);
        Windows.SetWindowRgn(Handle, RGN, True);
        result := true;
      end;
      if ChangedRect then InvalidateRect(Handle, nil, true);
    end;
    fOldCtl3d := Ctl3d;
  end;
end;

procedure TXToolDockFormCep.AlignControls(AControl: TControl; var Rect: TRect);
var X, Y: integer;
  function Need(Control: TControl): boolean;
  var i: integer;
  begin
    result := (Control <> nil);// and ((AControl = nil) or (AControl = Control));
    if result then
    begin
      result := false;
      for I := 0 to ControlCount - 1 do
        if Controls[I] = Control then
        begin
          result := Controls[I].Visible;
          exit;
        end;
    end;
  end;
begin
  if FUpdatingSize then Exit;
  if AControl = nil then
  begin
    Windows.GetClientRect(Handle, fClientRect);
    fCaptionRect := fClientRect;
    fCaptionRect.Bottom := GetSystemMetrics(SM_CYSMCAPTION);
    fClientRect.Top := fCaptionRect.Bottom;
  end;
  if (ControlCount > 0) then
  begin
    if Need(fClient) then
    Begin
      TControlEx(fClient).SetBounds(fClientRect.Left,
                                    fClientRect.Top,
                                    fClientRect.Right - fClientRect.Left,
                                    fClientRect.Bottom - fClientRect.Top);
    End;
    X := fCaptionRect.Right;
    Y := (fCaptionRect.Bottom + fCaptionRect.Top - fButtonClose.Height) div (2);
    if Need(fButtonClose) then
    begin
      Dec(X, fButtonClose.Width + 3);
      fButtonClose.SetBounds(X, Y, fButtonClose.Width, fButtonClose.Height);
    end;
    if Need(fSysButton) then
    begin
      Dec(X, fSysButton.Width + 1);
      fSysButton.SetBounds(X, Y, fSysButton.Width, fSysButton.Height);
    end;
    fTextRect := fCaptionRect;
    X := Max(X, fCaptionRect.Bottom - fCaptionRect.Top);
    fTextRect.Right := X - 1;
  end else inherited;
end;

function TXToolDockFormCep.CanAutoSize(var NewWidth,
  NewHeight: Integer): Boolean;
begin
  result := false;
  if (ControlCount > 0) and (fClient is TWinControl) then
  begin
    result := TWinControlEx(fClient).CanAutoSize(NewWidth, NewHeight);
  end;
end;

procedure TXToolDockFormCep.UMRESIZED(var Message: TMessage);
var Dx, Dy: integer;
    NewWidth, NewHeight: integer;
begin
  GetNcSize(Dx, Dy);
  NewWidth := Width;
  NewHeight := Height;
  if NewFormSize(Dx, Dy, NewWidth, NewHeight) then
    SetBounds(Left, Top, NewWidth, NewHeight);
  FreeAndNil(fTMPTimer);
end;

function TXToolDockFormCep.CanResize(var NewWidth, NewHeight: Integer): Boolean;
var Dx, Dy: integer;
begin
  if FUpdatingSize then
  begin
    result := true;
    exit;
  end;
  result := inherited CanResize(NewWidth, NewHeight);
  if result and (ControlCount > 0) and GetNcSize(Dx, Dy) and (fClient <> nil) then
  begin
    Result := NewFormSize(Dx, Dy, NewWidth, NewHeight);
  end;
end;

procedure TXToolDockFormCep.ClientAdded(Client: TControl; const ARect: TRect);
var Dx, Dy, NewHeight, NewWidth: integer;
    MousePos: TPoint;
begin
    if GetNcSize(Dx, Dy) then
    begin
      NewHeight := Abs(ARect.Bottom - ARect.Top);
      NewWidth := Abs(ARect.Right - ARect.Left);
      inc(NewWidth, Dx);
      inc(NewHeight, Dy);
      if Client is TCustomActionDockBar then
        with TCustomActionDockBarEx(Client) do
        begin
          Align := alNone;
          if Orientation in [boTopToBottom, boBottomToTop] then
            Orientation := boLeftToRight;
          TCustomActionDockBarEx(Client).AutoSizing := true;
          SetBounds(ClientRect.Left, ClientRect.Top, NewWidth - Dx, NewHeight - Dy);
          NewWidth := Width + Dx;
          NewHeight := Height + Dy;
        end
      else
      begin
        if Client is TCustomForm then
          TCustomForm(Client).BorderStyle := bsNone;
        SetBounds(Left - (Dx div (2)), Top - (Dy - (Dx) div (2)), NewWidth, NewHeight);
      end;
      if MoveToCursor then
      begin
        MousePos := Mouse.CursorPos;
        SetBounds(MousePos.X - Dx,
                  MousePos.Y - (Dy div 2),
                  NewWidth,
                  NewHeight);
        MoveToCursor := false;          
      end;
    end;
  if not (csLoading in ComponentState) then
    Visible := Client.Visible;
end;

function TXToolDockFormCep.CloseQuery: Boolean;
begin
  if Assigned(onCloseQuery) then result := inherited CloseQuery
                            else result := EnableClose and (not SysButtonPushed);
end;

procedure TXToolDockFormCep.CMActionUpdate(var Message: TMessage);
var I: integer;
begin
  inherited;
  if (Message.Result = 0) and (ControlCount > 0) then
  begin
    for I := 0 to ControlCount - 1 do
      if (Controls[I] is TWinControl) and
         (TWinControl(Controls[I]).HandleAllocated) and
         (TWinControl(Controls[I]).Enabled) then
      begin
        Message.Result := SendMessage(TWinControl(Controls[I]).Handle,
                                      Message.Msg,
                                      Message.WParam,
                                      Message.LParam);
      end;
  end;
end;

destructor TXToolDockFormCep.Destroy;
var SysMenu: HMENU;
begin
  SysMenu := GetSystemMenu(Handle, False);
  DeleteMenu(SysMenu, SC_SysMenuEx, MF_BYCOMMAND);
  FreeAndNil(fTmpTimer);
  inherited;
end;

procedure TXToolDockFormCep.DoAddDockClient(Client: TControl;
  const ARect: TRect);
var
  S: string;
  I: Integer;
begin
  fClient := Client;
  if DockClientCount = 1 then
  begin
    with Client do
    begin
      SetString(S, nil, GetTextLen + 1);
      GetTextBuf(PChar(S), Length(S));
      for I := 1 to Length(S) do
        if (S[I] = #13) or (S[I] = #10) then
        begin
          SetLength(S, I - 1);
          Break;
        end;
    end;
    Caption := S;
  end;
  Client.Parent := Self; //  inherited DoAddDockClient(Client, ARect);
  Client.Align := alClient;
  ClientAdded(Client, ARect);
  Perform(WM_TIMER, IDEventTimer, 0);
  if (Client is TCustomForm) and (biSystemMenu in TCustomFormEx(Client).BorderIcons) then
  begin
    EnableClose := true;
  end;
  InvalidateButtons;
end;

procedure InternalRect(Canvas: TCanvas; var ARect: TRect; State: integer; Active: boolean; var C: TColor);
var Pen, OldPen: HPen;
    OldBrush: HBrush;
begin
  if State = 3 then
  begin
    if Active then C := GetShadowColor(MixColor(clActiveCaption, clGradientActiveCaption), 5)
              else C := GetShadowColor(MixColor(clInactiveCaption, clGradientInactiveCaption), 5);
  end else
  begin
    if Active then
      C := ColorToRGB(clCaptionText)
    else
      C := ColorToRGB(clInactiveCaptionText);
  end;
  if State in [1, 2] then
  begin
    if State = 2 then offsetRect(ARect, 1, 1);
    OldPen := 0;
    OldBrush := 0;
    Pen := CreatePen(ps_Solid, 1, C);
    try
      OldPen := SelectObject(Canvas.Handle, Pen);
      OldBrush := SelectObject(Canvas.Handle, GetStockObject(NULL_BRUSH));
      Rectangle(Canvas.Handle, ARect.Left, ARect.Top, ARect.Right, ARect.Bottom);
    finally
      SelectObject(Canvas.Handle, OldBrush);
      SelectObject(Canvas.Handle, OldPen);
      DeleteObject(Pen);
    end;
  end;
end;

procedure TXToolDockFormCep.ModifySystemMenu;
var
  SysMenu: HMENU;
  MENUITEMINFO: TMENUITEMINFO;
  SysMenuEx: ISysMenuEx;
  MF: integer;
  TextSysMenu, TextCaption: WideString;
  function TestMenu(Id: integer; ByCommand: boolean = true):boolean;
  begin
    FillChar(MENUITEMINFO, SizeOf(MENUITEMINFO), 0);
    MENUITEMINFO.cbSize := SizeOf(MENUITEMINFO);
    MENUITEMINFO.fMask := MIIM_TYPE;
    result := GetMenuItemInfo(SysMenu, Id, not ByCommand, MENUITEMINFO);
  end;
  procedure DelMenu(Id: integer; ByCommand: boolean = true);
  begin
    if TestMenu(Id, ByCommand) then
    begin
      if ByCommand then
        DeleteMenu(SysMenu, Id, MF_BYCOMMAND)
      else
        DeleteMenu(SysMenu, Id, MF_BYPOSITION);
    end;
  end;
begin
  if not (csDesigning in ComponentState) and (HandleAllocated) then
  begin
    SysMenu := GetSystemMenu(Handle, False);
    DelMenu(SC_TASKLIST);
    DelMenu(SC_MAXIMIZE);
    DelMenu(SC_MINIMIZE);
    DelMenu(SC_MOVE);
    DelMenu(SC_RESTORE);
    if fEnableSysButton and
      (ControlCount > 0) and
      (fClient <> nil) and
      (fClient.GetInterface(ISysMenuEx, SysMenuEx)) then
    begin
      //
      TextCaption := SysMenuEx.CaptionEx;
      if fTextCaption <> TextCaption then
      begin
        fTextCaption := TextCaption;
        SetWindowTextW(Handle, PWideChar(fTextCaption));
      end;
      //  
      if (not SysButtonPushed) and SysMenuEx.IsEnabledEx then
        MF := MF_ENABLED
      else
        MF := MF_DISABLED or MF_GRAYED;
      TextSysMenu := TextSysMenuEx;
      if not TestMenu(SC_SysMenuEx) then
      begin
        //
        if TestMenu(0, false) and ((MENUITEMINFO.fType and MFT_SEPARATOR) <> MFT_SEPARATOR) then
          InsertMenu(SysMenu, 0, MF_BYPOSITION or MF_SEPARATOR, SC_SEPARATOR, '');
        // 
        InsertMenuW(SysMenu, 0, MF_BYPOSITION OR MF, SC_SysMenuEx, PWideChar(TextSysMenu))
      end else
        EnableMenuItem(SysMenu, SC_SysMenuEx, MF_BYCOMMAND or MF);
    end else
    begin
      if TestMenu(0, false) and ((MENUITEMINFO.fType and MFT_SEPARATOR) = MFT_SEPARATOR) then
        DeleteMenu(SysMenu, 0, MF_BYPOSITION);
      if TestMenu(1, false) and ((MENUITEMINFO.fType and MFT_SEPARATOR) = MFT_SEPARATOR) then
        DeleteMenu(SysMenu, 1, MF_BYPOSITION);
      if TestMenu(SC_SysMenuEx) then
        DeleteMenu(SysMenu, SC_SysMenuEx, MF_BYCOMMAND);
    end;
    if fEnableClose and (not SysButtonPushed) then
      EnableMenuItem(SysMenu, SC_CLOSE, MF_BYCOMMAND or MF_ENABLED)
    else
      EnableMenuItem(SysMenu, SC_CLOSE, MF_BYCOMMAND or MF_DISABLED or MF_GRAYED);
  end;
end;

procedure TXToolDockFormCep.Resize;
var R: TRect;
begin
  inherited;
  if HandleAllocated then
  begin
    windows.GetWindowRect(Handle, R);
    UpdateRGN(R);
    PostMessage(Handle, UM_RESIZED, 0, 0);
  end;
end;

procedure TXToolDockFormCep.SetEnableClose(const Value: boolean);
begin
  if fEnableClose <> Value then
  begin
    fEnableClose := Value;
    if HandleAllocated then
    begin
      ModifySystemMenu;
      InvalidateButtons;
    end;
  end;
end;

procedure TXToolDockFormCep.SetEnableSysButton(const Value: boolean);
begin
  if fEnableSysButton <> Value then
  begin
    fEnableSysButton := Value;
    if HandleAllocated then
    begin
      InvalidateButtons;
      ModifySystemMenu;
    end;
  end;
end;

procedure TXToolDockFormCep.SetSysButtonPushed(const Value: boolean);
begin
  if fSysButtonPushed <> Value then
  begin
    fSysButtonPushed := Value;
    InvalidateButtons;
    ModifySystemMenu;
  end;
end;

procedure TXToolDockFormCep.KillTimer;
begin
  if (fTimer <> 0) and HandleAllocated then
  begin
    if not Windows.KillTimer(Handle, IDEventTimer) then
      RaiseLastOsError
    else
      fTimer := 0;
  end;
end;

procedure TXToolDockFormCep.SetTimer;
begin
  if (fUpdateInterval > 0) and HandleAllocated then
  begin
    fTimer := Windows.SetTimer(Handle, IDEventTimer, fUpdateInterval, nil);
    if fTimer = 0 then
      RaiseLastOsError;
  end;
end;

procedure TXToolDockFormCep.SetUpdateInterval(const Value: integer);
begin
  if fUpdateInterval <> Value then
  begin
    KillTimer;
    fUpdateInterval := Value;
    SetTimer;
  end;
end;

procedure TXToolDockFormCep.WMNCCreate(var Message: TWMNCCreate);
begin
  inherited;
  ModifySystemMenu;
end;

procedure TXToolDockFormCep.InvalidateButtons;
var SysMenuEx: ISysMenuEx;
    W, H: integer;
  procedure UpdateButton(Button: TSpeedButtonCepSpecial; Enabled: boolean);
  begin
    if Active then
      Button.BtnFrameColor := GetSysColor(COLOR_CAPTIONTEXT)
    else
      Button.BtnFrameColor := GetSysColor(COLOR_INACTIVECAPTIONTEXT);
    Button.Enabled := Enabled;
    if (Button.Width <> W) or (Button.Height <> H) then
    begin
      Button.Width := W;
      Button.Height := H;
    end;
    Button.ThemeEnabled := Ctl3D;
  end;
begin
  W := ((fCaptionRect.Bottom - fCaptionRect.Top) div (2) - 1) * 2 - 1;
  H := W -1;
  if fButtonClose = nil then
  begin
    fButtonClose := TSpeedButtonCepSpecial.Create(self);
    fButtonClose.SetSpecialKind(skCaptionClose);
    fButtonClose.OnClick := OnCloseClick;
    UpdateButton(fButtonClose, fEnableClose);
    fButtonClose.Parent := self;
  end else UpdateButton(fButtonClose, fEnableClose);
  if fEnableSysButton and
    (ControlCount > 0) and
    (fClient <> nil) and
    (fClient.GetInterface(ISysMenuEx, SysMenuEx)) then
  begin
    if fSysButton = nil then
    begin
      fSysButton := TSpeedButtonCepSpecial.Create(self);
      fSysButton.SetSpecialKind(skCaptionDropDown);
      fSysButton.OnClick := OnSysClick;
      UpdateButton(fSysButton, fEnableSysButton and (not SysButtonPushed));
      fSysButton.Parent := self;
    end else UpdateButton(fSysButton, fEnableSysButton and (not SysButtonPushed));
  end else FreeAndNil(fSysButton);
  if fButtonClose <> nil then fButtonClose.Active := Active;
  if fSysButton <> nil then fSysButton.Active := Active;
end;

procedure TXToolDockFormCep.WMNCHITTEST(var Message: TWMNCHITTEST);
var Pt: TPoint;
    i: integer;
  function CheckButton(Control: TControl): boolean;
  begin
    result := (Control <> nil) and (Control.Visible) and (PtInRect(Control.BoundsRect, Pt));
  end;
begin
  inherited;
  Pt.X := Message.XPos;
  Pt.Y := Message.YPos;
  Pt := ScreenToClient(Pt);
  for I := 0 to ControlCount - 1 do
    if Controls[i] is TSpeedButtonCepSpecial and
       CheckButton(Controls[i]) then
    begin
      Message.Result := HTCLIENT;
      break;
    end;
  if (ControlCount > 0) and (fClient is TCustomActionDockBar) then
  begin
    if Message.Result in [HTTOP, HTTOPLEFT, HTTOPRIGHT, HTCLOSE] then Message.Result := HTCAPTION;
    if Message.Result in [HTBOTTOM] then Message.Result := HTBORDER;
    if Message.Result in [HTBOTTOMLEFT] then Message.Result := HTLEFT;
    if Message.Result in [HTBOTTOMRIGHT] then Message.Result := HTRIGHT;
  end;
  fLastHitTest := Message.Result;
end;

//      
procedure TXToolDockFormCep.WMACTIVATE(var Message: TWMACTIVATE);
begin
  inherited;
  Perform(WM_NCPAINT,0,0);
  InvalidateButtons;
  InvalidateRect(Handle, nil, true);
end;

procedure TXToolDockFormCep.WMNCPAINT(var Message: TWMNCPAINT);
var Brush, OldBrush: HBrush;
    Pen, OldPen: HPen;
    DC: HDC;
    RGN: HRGN;
    WndRect, CliRect: TRect;
    H, Dx, Dy: integer;
    ElemDetails: TThemedElementDetails;
    C: TColor;
begin
  GetWindowRect(Handle, WndRect);
  windows.GetClientRect(Handle, CliRect);
  Dx := ((WndRect.Right - WndRect.Left) - (CliRect.Right - CliRect.Left)) div (2);
  Dy := ((WndRect.Bottom - WndRect.Top) - (CliRect.Bottom - CliRect.Top)) div (2);
  OffsetRect(WndRect, -WndRect.Left, -WndRect.Top);
  OffsetRect(CliRect, Dx, Dy);
  if not Ctl3d then
  begin
    DC := GetWindowDC(Handle);
    try
      OldBrush := 0;
      OldPen := 0;
      if Active then C := ColorToRGB(clActiveBorder)
                else C := ColorToRGB(clInactiveBorder);
      ExcludeClipRect(DC, CliRect.Left, CliRect.Top, CliRect.Right, CliRect.Bottom);
      RGN := CreateRectRgn(0,0,0,0);
      try
        if GetWindowRGN(Handle, RGN) <> ERROR then
        begin
          InflateRect(WndRect, -1, -1);
          Brush := CreateSolidBrush(C);
          try
            FillRect(DC, WndRect, Brush);
          finally
            DeleteObject(Brush);
          end;
          //  
          Brush := CreateSolidBrush(GetShadowColor(C, -90));
          try
            FrameRgn(DC, RGN, Brush, 1, 1);
          finally
            DeleteObject(Brush);
          end;
        end else
        begin
          if Active then
            Pen := CreatePen(ps_Solid, 1, ColorToRGB(clHighlight))
          else
            Pen := CreatePen(ps_Solid, 1, ColorToRGB(clWindowFrame));
          Brush := CreateSolidBrush(ColorToRGB(Color));
          try
            Rectangle(DC, WndRect.Left, WndRect.Top, WndRect.Right, WndRect.Bottom);
          finally
            SelectObject(DC, OldPen);
            SelectObject(DC, OldBrush);
            DeleteObject(Pen);
            DeleteObject(Brush);
          end;
        end;
      finally
        DeleteObject(RGN);
      end;
    finally
      SelectClipRGN(DC, 0);
      ReleaseDC(Handle, DC);
    end;
  end else
  begin
    if ThemeServices.ThemesEnabled then
    begin
      DC := GetWindowDC(Handle);
      try
        if Active then
          ElemDetails := ThemeServices.GetElementDetails(twSmallCaptionActive)
        else
          ElemDetails := ThemeServices.GetElementDetails(twSmallCaptionInactive);
        ExcludeClipRect(DC, CliRect.Left, CliRect.Top, CliRect.Right, CliRect.Bottom);
        H := WndRect.Bottom;
        WndRect.Bottom := CliRect.Top + GetSystemMetrics(SM_CYSMCAPTION);
        ThemeServices.DrawElement(DC, ElemDetails, WndRect);
        CliRect := Rect(0, WndRect.Bottom, Dy, H);
        if Active then
          ElemDetails := ThemeServices.GetElementDetails(twSmallFrameLeftActive)
        else
          ElemDetails := ThemeServices.GetElementDetails(twSmallFrameLeftInactive);
        ThemeServices.DrawElement(DC, ElemDetails, CliRect);
        CliRect := Rect(WndRect.Right - Dx, WndRect.Bottom, WndRect.Right, H);
        if Active then
          ElemDetails := ThemeServices.GetElementDetails(twSmallFrameRightActive)
        else
          ElemDetails := ThemeServices.GetElementDetails(twSmallFrameRightInactive);
        ThemeServices.DrawElement(DC, ElemDetails, CliRect);
        CliRect := Rect(1, H - Dy, WndRect.Right - 1, H);
        if Active then
          ElemDetails := ThemeServices.GetElementDetails(twSmallFrameBottomActive)
        else
          ElemDetails := ThemeServices.GetElementDetails(twSmallFrameBottomInactive);
        ThemeServices.DrawElement(DC, ElemDetails, CliRect);
      finally
        ReleaseDC(Handle, DC);
      end;
    end else Inherited;
  end;
end;

procedure TXToolDockFormCep.WMNCRBUTTONDOWN(var Message: TWMRBUTTONDOWN);
begin
  if fLastHitTest = HTCAPTION then
    fCaptionPushed := true;
  inherited;
end;

procedure TXToolDockFormCep.WMNCRBUTTONUP(var Message: TWMRBUTTONUP);
begin
  inherited;
  if fLastHitTest = HTCAPTION then
  begin
    if fCaptionPushed then
    begin
      ModifySystemMenu;
      SendMessage(Handle, WM_SYSCOMMAND, SC_KEYMENU, VK_SPACE);
    end;
  end;
  fCaptionPushed := false;
end;

procedure TXToolDockFormCep.WMSETTEXT(var Message: TWMSETTEXT);
begin
  InvalidateRect(Handle, @fCaptionRect, true);
  inherited;
end;

procedure TXToolDockFormCep.WMSYSCOMMAND(var Message: TWMSYSCOMMAND);
begin
  if Message.CmdType = SC_SysMenuEx then ExecuteEx
                                    else inherited;
end;

procedure TXToolDockFormCep.WMTIMER(var Message: TWMTIMER);
begin
  if HandleAllocated then
  begin
    ModifySystemMenu;
    InvalidateButtons;
  end;
  inherited;
end;

procedure TXToolDockFormCep.WMACTIVATEAPP(var Message: TWMACTIVATEAPP);
begin
  if Message.Active then
  begin
    //   ,   " "
    SetWindowPos(Handle, HWND_TOPMOST,
                 0, 0, 0, 0,
                 SWP_NOMOVE or SWP_NOSIZE or SWP_NOACTIVATE or SWP_NOSENDCHANGING);
  end else
  begin
    //    ,    
    //      
    SetWindowPos(Handle, GetForegroundWindow,
                 0, 0, 0, 0,
                 SWP_NOMOVE or SWP_NOSIZE or SWP_NOACTIVATE or SWP_NOSENDCHANGING);
    SetWindowPos(Handle, HWND_NOTOPMOST,
                 0, 0, 0, 0,
                 SWP_NOMOVE or SWP_NOSIZE or SWP_NOACTIVATE or SWP_NOSENDCHANGING);
  end;
  inherited;
end;

procedure TXToolDockFormCep.WMERASEBKGND(var Message: TWMERASEBKGND);
begin
  Message.Result :=  1;
end;

procedure TXToolDockFormCep.Paint;
var Dx, Dy, IconSize: integer;
    StartColor, EndColor: TColor;
    Icon: HIcon;
  procedure DrawCaptionBk;
  const Orientation: array  [Boolean] of TGradientDirection = (gdVertical, gdHorizontal);
  var ElemDetails: TThemedElementDetails;
      R: TRect;
  begin
    if ThemeServices.ThemesEnabled and Ctl3d then
    begin
      if Active then
        ElemDetails := ThemeServices.GetElementDetails(twSmallCaptionActive)
      else
        ElemDetails := ThemeServices.GetElementDetails(twSmallCaptionInactive);
      R := Rect(-Dx, -Dy, Width + Dx, fCaptionRect.Bottom);
      ThemeServices.DrawElement(Canvas.handle, ElemDetails, R);
    end else
    begin
      if Active then
      begin
        StartColor := clGradientActiveCaption ;
        EndColor := clActiveCaption;
      end else
      begin
        StartColor := clGradientInactiveCaption ;
        EndColor := clInactiveCaption;
      end;
      Canvas.Pen.Color := EndColor;
      //  
      R := fCaptionRect;
      inc(R.Bottom);
      if Ctl3D then
      begin
        GradientFillCanvas(Canvas, StartColor, EndColor, R, Orientation[ctl3d]);
      end
      else
      begin
        R := fCaptionRect;
        Canvas.Pen.Color := Color;
        OffsetRect(R, -1, -1);
        Canvas.MoveTo(R.Left, R.Bottom);
        Canvas.LineTo(R.Right + 1, R.Bottom);

        Canvas.Pixels[R.Right, R.Top + 1] := Color;
        Canvas.Pixels[R.Left, R.Top + 1] := Color;
        Canvas.Pixels[R.Right, R.Bottom - 1] := Color;
        Canvas.Pixels[R.Left, R.Bottom - 1] := Color;
        DrawDockCaption(Canvas,
                        R,
                        0,0,
                        true,
                        '',
                        StartColor,
                        EndColor,
                        Canvas.Pen.Color,
                        False,
                        nil,
                        1);
      end;
    end;
    DrawIconEx(Canvas.Handle, fCaptionRect.Left + 3, fCaptionRect.Top + 1, Icon, IconSize, IconSize,
               0, 0, DI_NORMAL);
  end;
  procedure DrawCaption(DC: HDC);
  var
    A:Array [0..512] of WideChar;
    P: PWideChar;
    NonClientMetrics: TNonClientMetrics;
    FontInfo: tagLOGFONT;
    Siz: DWORD;
    Font, OldFont: HFONT;
    R: TRect;
  begin
    // 
    SetBkMode(DC, TRANSPARENT);
    FillChar(A,SizeOf(A),0);
    P := @A;
    windows.GetWindowTextW(Handle, P, High(A));
    if P <> '' then
    begin
      R := fTextRect;
      inc(R.Left, IconSize + 3);
      if R.Right - R.Left > Dx then
      begin
        if Active then
          SetTextColor(DC, ColorToRGB(clCaptionText))
        else
          SetTextColor(DC, ColorToRGB(clInactiveCaptionText));
        {$IFDEF DELPHI_2010_UP}
          Siz := NonClientMetrics.SizeOf;
        {$ELSE}
          Siz := SizeOf(NonClientMetrics);
        {$ENDIF}
        FillChar(NonClientMetrics, Siz, 0);
        NonClientMetrics.cbSize := Siz;
        if SystemParametersInfo(SPI_GETNONCLIENTMETRICS, 0, @NonClientMetrics, 0) then
        with NonClientMetrics do FontInfo := lfSmCaptionFont;
        Font := CreateFontIndirect(FontInfo);
        OldFont := SelectObject(DC,Font);
        try
          DrawTextW(DC, P, -1, R, DT_END_ELLIPSIS or DT_PATH_ELLIPSIS);
        finally
          SelectObject(DC,OldFont);
          DeleteObject(Font);
        end;
      end;
    end;
  end;

begin
  inherited;
  if (fClient is TCustomForm) and (TCustomFormEx(fClient).Icon <> nil) and
     (TCustomFormEx(fClient).Icon.HandleAllocated) then
  begin
    Icon := TCustomFormEx(fClient).Icon.Handle;
    iconSize := ((fCaptionRect.Bottom - fCaptionRect.Top - 1) div (4)) * 4;
  end else
  begin
    Icon := 0;
    IconSize := 0;
  end;   
  
  Dx := (Width - ClientWidth) div (2);
  Dy := (Height - ClientHeight) div (2);
  DrawCaptionBk;
  DrawCaption(Canvas.Handle);
  canvas.Brush.Color := Color;
  Canvas.FillRect(fClientRect);
end;

procedure TXToolDockFormCep.AfterExecuteEx(Sender: TObject);
begin
  Resize;
end;

procedure TXToolDockFormCep.ExecuteEx;
var
  Pt: TPoint;
  SysMenuEx: ISysMenuEx;
begin
  if (not SysButtonPushed) and (ControlCount > 0) and (fClient <> nil) and (fClient.GetInterface(ISysMenuEx, SysMenuEx)) and (SysMenuEx.IsEnabledEx) then
  begin
    Pt.X := fCaptionRect.Left;
    Pt.Y := fCaptionRect.Bottom;
    Pt := ClientToScreen(Pt);
    try
      SysButtonPushed := True;
      SysMenuEx.ExecuteEx(Pt.X, Pt.Y);
      if fTmpTimer = nil then
        fTmpTimer := TInternalTimer.Create(self);
      fTmpTimer.ExecuteDelay(100, AfterExecuteEx);
    finally
      SysButtonPushed := false;
    end;
  end;
end;

function TXToolDockFormCep.NewFormSize(Dx, Dy: Integer; var NewWidth, NewHeight: Integer): boolean;
var
  Bar: TCustomActionDockBarEx;
  W: Integer;
  MHeight: Integer;
  MWidth: Integer;
  H: Integer;
  procedure UpdateSize(var W: integer; MinW, MaxW, Frame: integer);
  begin
    if MinW > 0 then
      W := Max(W, MinW + Frame);
    if MaxW > 0 then
      W := Min(W, MaxW + Frame);
  end;
begin
  if fClient is TCustomActionDockBar then
  begin
    Bar := TCustomActionDockBarEx(fClient);
    FUpdatingSize := true;
    try
      MWidth := CalcDockedWidthInternal(Bar.Orientation, Bar, true);
      MHeight := CalcDockedWidthInternal(Bar.Orientation, Bar, false);
      with Bar do
      begin
        W := Min(MWidth, NewWidth - Dx);
        H := Min(MHeight, NewHeight - Dy);
        self.DisableAlign;
        try
          if (Orientation in [boLeftToRight, boRightToLeft]) then
            SetBounds(Left, Top, W, 128)
          else
            SetBounds(Left, Top, 0, H);
          NewWidth := Width + Dx;
          NewHeight := Height + Dy;
        finally
          self.EnableAlign;
        end;
      end;
      result := (Width <> NewWidth) or (Height <> NewHeight);
    finally
      FUpdatingSize := false;
    end;
  end else
  begin
    if fClient is TControl then
    begin
      result := TControlEx(fClient).CanResize(NewWidth, NewHeight);
      if result then
      begin
        UpdateSize(NewWidth,
                   TControlEx(fClient).Constraints.MinWidth,
                   TControlEx(fClient).Constraints.MaxWidth,
                   Dx);
        UpdateSize(NewHeight,
                   TControlEx(fClient).Constraints.MinHeight,
                   TControlEx(fClient).Constraints.MaxHeight,
                   Dy);
      end;
    end else result := true;
  end;
end;

procedure TXToolDockFormCep.OnCloseClick(Sender: TObject);
begin
  if EnableClose then Close;
end;

procedure TXToolDockFormCep.OnSysClick(Sender: TObject);
begin
  ExecuteEx;
end;

{ TDragDockObjectCep }

procedure TDragDockObjectCep.AdjustDockRect(ARect: TRect);
begin
 // inherited;
 //  -  ,      -
 //    ,  
 //  .
end;

destructor TDragDockObjectCep.Destroy;
var Form: TCustomForm;
begin
  if Control.Parent is TCustomForm then
  begin
    Form := TCustomForm(Control.Parent);
    if Form is TXToolDockFormCep then TXToolDockFormCep(Form).AlphaBlend := false;
  end;
  inherited;
end;

procedure TDragDockObjectCep.DrawDragDockImage;
begin
  inherited DrawDragDockImage;
end;

procedure TDragDockObjectCep.EraseDragDockImage;
begin
  inherited EraseDragDockImage
end;

initialization
  Ctl3dFloatForms := false;
  MoveToCursor := false;

end.
