unit CepUtils;

(*
  * Module:             
  * Version:    1.0.0.0 (14.11.2008)
  * Author:      
  *                   .
  *                    
  *              : roschinspb@mail.ru
  *             http://www.delphikingdom.com/asp/users.asp?ID=1271
  *             http://www.roschinspb.narod.ru
  *
  * Copyright:   2008
  *
  * Version:    1.0.0.0 (14.11.2008)
  * Realized:   
*)
interface

{$I Directives.inc}

uses Windows,
  Messages,
  Graphics,
  Controls,
  SysUtils,
  Classes,
  {$IFNDEF DELPHI_2005_UP}OldVersions,{$ENDIF}
  Registry,
  SHFolder,
  Masks;

resourcestring
  _mC = ' (%s)';
  _min = ' (nn:ss.zzz)';
  _Hour = ' (hh:nn:ss)';
  StrENoFolder = '  "%s"  ';
  StrExecute = ': ';
  StrOut = '  : ';
  StrExitCode = ' : %d';
  STR_CREATE_PIPE_ERROR = '  pipe';
  STR_SHELLPROCESSCREATEERROR = '   %s';
  StrOk = 'Ok.';

const
  SignW: word = $FEFF;

  RootKeys: array[0..3] of THandle = (HKEY_CLASSES_ROOT, HKEY_CURRENT_USER, HKEY_LOCAL_MACHINE, HKEY_USERS
    { , HKEY_CURRENT_CONFIG });
  RootNames: array[0..3] of string = ('HKEY_CLASSES_ROOT', 'HKEY_CURRENT_USER', 'HKEY_LOCAL_MACHINE', 'HKEY_USERS'
    { , HKEY_CURRENT_CONFIG });
  ShortRootNames: array[0..3] of string = ('HKCR', 'HKCU', 'HKLM', 'HKU'
    { , HKEY_CURRENT_CONFIG });


var
  FreqCPU: Double;

  //   .  InitFreqCPU 
  //   ,    CountCPUtoSTR
procedure InitFreqCPU(Delay: DWORD = 440);
//     ,   
//  .
// OldCountCPU          
// ,    CountCPU.      
//   
// :
// var T: int64;
// S: string;
// begin
// CountCPU(T);
// ...
// T := CountCPU(T);
// S := CountCPUtoSTR(T);
// end;
function CountCPU(var OldCountCPU: int64): int64;
//   ,  
// CountCPU    
function CountCPUtoSTR(CountCPU: int64): string;

function ExecuteProcess(FileName, Params, Dir: WideString; Comment: string; LogStream: TStream = nil): boolean;

type
  TFolderFunctionObj = function(const FileName: string; const FileTime: TFileTime; const Size: int64): boolean of object;
function EnumerateFiles(FolderName, Mask: string; Attr: integer; Proc: TFolderFunctionObj): boolean; overload;
function EnumerateReestr(FolderName, Mask: string; Key, Name, Data: boolean; Proc: TFolderFunctionObj): boolean; overload;

{$IFDEF DELPHI_2009_UP}
type
  TFolderFunctionRef = reference to function(const FileName: string; const FileTime: TFileTime; const Size: int64): boolean;
function EnumerateFiles(FolderName, Mask: string; Attr: integer; Proc: TFolderFunctionRef): boolean; overload;
function EnumerateReestr(FolderName, Mask: string; Key, Name, Data: boolean; Proc: TFolderFunctionRef): boolean; overload;
{$ENDIF}
function Scale(DestWidth, DestHeight, SourceWidth, SourceHeight: integer): Double;

implementation

// OldCountCPU:             -    ,
//    -    
//  :        

function CountCPU(var OldCountCPU: int64): int64;
  assembler;
asm
  push  eBx
  push  eCx
  push  eSi
  mov   eSi,eAx

  db $0F;          // eAx -   eDx -  
  db $31;

  mov   eCx,Ds:[eSi]
  mov   eBx,Ds:[eSi+4]
  mov   Ds:[eSi],eAx
  mov   Ds:[eSi+4],eDx

  sub   eAx,eCx
  sbb   eDx,eBx
  mov   eCx,99
  xor   eBx,eBx
  sub   eAx,eCx
  sbb   eDx,eBx
  pop   eSi
  pop   eCx
  pop   eBx
end;

//      
// Delay:                    C    

procedure InitFreqCPU(Delay: DWORD = 440);
var
  N: DWORD;
  T, NN: int64;
begin
  N := GetTickCount;
  while N = GetTickCount do
    ;
  CountCPU(T);
  N := GetTickCount;
  while N > GetTickCount - Delay do
    ;
  // Sleep(Delay);
  NN := CountCPU(T);
  NN := (NN + Delay * 500) div (Delay * 1000);
  FreqCPU := NN;
end;

// CountCPU:                
//  :    

function CountCPUtoSTR(CountCPU: int64): string;
var
  T: TDateTime;
  TT: Double;
  TS: string;
begin
  if (FreqCPU <> 0) then
  begin
    T := CountCPU;
    T := T / (FreqCPU);
    if T < 2000 then
      TS := Format(_mC, [inttostr(Round(T))])
    else
    begin
      TT := T / 1000000;
      if TT < 3000 then
        DateTimeToString(TS, _min, TT / 86400)
      else
        DateTimeToString(TS, _Hour, TT / 86400)
    end;
    result := TS;
  end
  else
    result := 'FreqCPU=0';
end;

function EnumerateFiles(FolderName, Mask: string; Attr: integer; Proc: TFolderFunctionObj): boolean;
var
  CurrentFolder, Path, FileName, TmpMask: string;
  F: array of TSearchRec;
  R, Level, I: integer;
  Canceled: boolean;
  MaskObj: TMask;
  procedure UpLevel(FileName: string);
  begin
    CurrentFolder := FileName;
    inc(Level);
    SetLength(F, Level + 1);
    FillChar(F[Length(F) - 1], SizeOf(F[Length(F) - 1]), 0);
    Path := IncludeTrailingPathDelimiter(CurrentFolder) + '*.*';
    R := FindFirst(Path, Attr, F[Level]);
  end;
  procedure DownLevel;
  begin
    if F[Level].Name <> '' then
      FindClose(F[Level]);
    Dec(Level);
    SetLength(F, Level + 1);
    R := 0;
    I := Length(CurrentFolder);
    while (I > 0) and (CurrentFolder[I] <> PathDelim) do
      Dec(I);
    if (I > 0) then
      Delete(CurrentFolder, I, Length(CurrentFolder))
    else
      Exit;
    if Level >= 0 then
      R := FindNext(F[Level]);
  end;

begin
  Canceled := False;
  TmpMask := AnsiLowerCase(Mask);
  FolderName := ExcludeTrailingPathDelimiter(FolderName);
  if not DirectoryExists(FolderName) then
    raise EOSError.CreateFmt(StrENoFolder, [FolderName]);
  if Mask = '' then
    Mask := '*.*';
  Level := -1;
  MaskObj := TMask.Create(Mask);
  try
    UpLevel(FolderName);
    while (Level >= 0) and (not Canceled) do
    begin
      if R <> 0 then
        DownLevel
      else
      begin
        while (R = 0) and (not Canceled) do
        begin
          FileName := IncludeTrailingPathDelimiter(CurrentFolder) + F[Level].Name;
          if (F[Level].Name <> '.') and (F[Level].Name <> '..') then
          begin
            if (F[Level].Attr and faDirectory) = faDirectory then
            begin
              UpLevel(FileName);
            end
            else
            begin
              if (AnsiLowerCase(F[Level].Name) = TmpMask) or (MaskObj.Matches(F[Level].Name)) then
              begin
                if Assigned(Proc) then
                  Canceled := not Proc(FileName, F[Level].FindData.ftLastWriteTime, F[Level].Size);
              end;
            end;
          end;
          R := FindNext(F[Level]);
        end;
      end;
    end;
  finally
    for Level := Length(F) - 1 downto 0 do
    begin
      try
        FindClose(F[Level]);
      except
        Continue;
      end;
    end;
    FreeAndNil(MaskObj);
  end;
  result := not Canceled;
end;

type
  TStringListCep = class(TStringList)
  end;

function EnumerateReestr(FolderName, Mask: string; Key, Name, Data: boolean; Proc: TFolderFunctionObj): boolean;
var
  Registry: TRegistry;
  RootKeyName, Folder: string;
  I: integer;
  MaskObj: TMask;

  function GetRootKeyName: string;
    {$IFNDEF DELPHI_2010_UP}
  const
    KeyNames: array[HKEY_CLASSES_ROOT..HKEY_DYN_DATA] of string = (
      'HKEY_CLASSES_ROOT', 'HKEY_CURRENT_USER', 'HKEY_LOCAL_MACHINE',
      'HKEY_USERS', 'HKEY_PERFORMANCE_DATA', 'HKEY_CURRENT_CONFIG', 'HKEY_DYN_DATA');
    {$ENDIF}
  begin
    {$IFDEF DELPHI_2010_UP}
    Result := Registry.RootKeyName;
    {$ELSE}
    if (Registry.RootKey >= HKEY_CLASSES_ROOT) and (Registry.RootKey <= HKEY_DYN_DATA) then
      Result := KeyNames[Registry.RootKey]
    else
      Result := '';
    {$ENDIF}
  end;
  procedure ExtractRootFolder(const Text: string; var RootKeyName, Folder: string);
  var
    X: integer;
  begin
    X := Pos('\', Text);
    if X = 0 then
      X := Pos('/', Text);
    if X = 0 then
    begin
      RootKeyName := Text;
      Folder := '';
    end
    else
    begin
      RootKeyName := Copy(Text, 1, X - 1);
      Folder := Copy(Text, X + 1, Length(Text));
    end;
  end;
  function doFind: boolean;
  type
    TReg = record
      List: TStringList;
      I: integer;
    end;
  var
    Level, l, I, VInt: integer;
    F: array of TReg;
    Opened, Finded: boolean;
    V: TRegKeyInfo;
    Path, S: string;
    ValueNames: TStringList;
    ValueFinded: TStringList;
    function UpLevel: boolean;
    var
      List: TStringListCep;
    begin
      inc(Level);
      if Level <= Length(F) then
      begin
        List := TStringListCep(F[Level - 1].List);
        List.Clear;
      end
      else
      begin
        SetLength(F, Level);
        List := TStringListCep.Create;
        List.Sorted := True;
        F[Level - 1].List := List;
      end;
      try
        Registry.GetKeyNames(List);
        F[Level - 1].I := 0;
        result := List.Count > 0;
      except
        Dec(Level);
        result := False;
      end;
    end;
    procedure DownLevel;
    begin
      if Level > 0 then
      begin
        F[Level - 1].List.Clear;
        Dec(Level);
      end;
      if Level > 0 then
      begin
        inc(F[Level - 1].I);
        Registry.CloseKey;
      end;
    end;
    function Open: boolean;
    var
      l: integer;
    begin
      if Registry.CurrentKey <> 0 then
      begin
        result := Registry.OpenKeyReadOnly(F[Level - 1].List[F[Level - 1].I]);
      end
      else
      begin
        Path := Folder;
        for l := 0 to Level - 1 do
          Path := Path + '\' + F[l].List[F[l].I];
        result := Registry.OpenKeyReadOnly(Path);
      end;
    end;

  begin
    result := True;
    while (Length(Folder) > 0) and (Folder[Length(Folder)] = '\') do
      Delete(Folder, Length(Folder), 1);

    Level := 0;
    if UpLevel then
    begin
      ValueNames := TStringList.Create;
      ValueFinded := TStringList.Create;
      ValueFinded.Sorted := True;
      try
        while Level > 0 do
        begin
          ValueNames.Clear;
          ValueFinded.Clear;
          Opened := Open;
          //     
          if Opened then
            Finded := Key and ((MaskObj = nil) or (MaskObj.Matches(F[Level - 1].List[F[Level - 1].I])))
          else
            Finded := False;
          //    , / 
          if (Opened) and (Name or Data) then
          begin
            Registry.GetValueNames(ValueNames);
            for I := 0 to ValueNames.Count - 1 do
              //    
              if Name and ((MaskObj = nil) or MaskObj.Matches(ValueNames[I])) then
              begin
                Finded := True;
                ValueFinded.Add(ValueNames[I]);
              end
              else
              begin
                //    
                case Registry.GetDataType(ValueNames[I]) of
                  rdString, rdExpandString: S := Registry.ReadString(ValueNames[I]);
                  rdInteger:
                    begin
                      VInt := Registry.ReadInteger(ValueNames[I]);
                      S := inttostr(VInt);
                    end;
                else
                  S := '';
                end;
                if (S <> '') and ((MaskObj = nil) or (MaskObj.Matches(S))) then
                begin
                  Finded := True;
                  ValueFinded.Add(ValueNames[I]);
                end;
              end;
          end;
          if Finded then
          begin
            if Assigned(Proc) then
            begin
              Registry.GetKeyInfo(V);
              Path := GetRootKeyName;
              if Folder <> '' then
                Path := Path + '\' + Folder;
              for l := 0 to Level - 1 do
                Path := Path + '\' + F[l].List[F[l].I];

              if ValueFinded.Count = 0 then
                result := Proc(Path + '\', V.FileTime, 0)
              else
              begin
                for I := 0 to ValueFinded.Count - 1 do
                begin
                  result := Proc(Path + '\' + QuotedStr(ValueFinded[I]), V.FileTime,
                    Registry.GetDataSize(ValueFinded[I]));
                  if not result then
                    Break;
                end;
              end;
            end
            else
              result := False;
            if not result then
              Exit;
          end;
          if (not Opened) or (not UpLevel) then
          begin
            if Opened then
              Registry.CloseKey;
            inc(F[Level - 1].I);
            while (Level > 0) and (F[Level - 1].I >= F[Level - 1].List.Count) do
              DownLevel;
          end;
        end;
      finally
        FreeAndNil(ValueNames);
        FreeAndNil(ValueFinded);
        for I := 0 to Length(F) - 1 do
          FreeAndNil(F[I].List);
      end;
    end;
  end;

begin
  result := False;
  Registry := TRegistry.Create;
  try
    if Mask = '' then
      MaskObj := nil
    else
      MaskObj := TMask.Create(Mask);
    try
      if FolderName = '' then
      begin
        if not (Key or Name or Data) then
        begin
          result := True;
          Exit;
        end;
        for I := low(RootKeys) to high(RootKeys) do
        begin
          Registry.RootKey := RootKeys[I];
          if not Registry.OpenKeyReadOnly('') then
            raise EOSError.CreateFmt(StrENoFolder, [FolderName]);
          result := doFind;
          Registry.CloseKey;
          if not result then
            Exit;
        end;
      end
      else
      begin
        ExtractRootFolder(FolderName, RootKeyName, Folder);
        RootKeyName := Trim(UpperCase(RootKeyName));
        for I := low(RootNames) to high(RootNames) do
        begin
          if RootNames[I] = RootKeyName then
          begin
            Registry.RootKey := RootKeys[I];
            if not Registry.OpenKeyReadOnly(Folder) then
              raise EOSError.CreateFmt(StrENoFolder, [FolderName]);
            if not (Key or Name or Data) then
            begin
              result := True;
              Exit;
            end;
            result := doFind;
            Registry.CloseKey;
            Exit;
          end;
        end;
        raise EOSError.CreateFmt(StrENoFolder, [FolderName]);
      end;
    finally
      FreeAndNil(MaskObj);
    end;
  finally
    FreeAndNil(Registry);
  end;
end;

{$IFDEF DELPHI_2009_UP}
type TFakeObj = class
     public
       fProc: TFolderFunctionRef;
       function func(const FileName: string; const FileTime: TFileTime; const Size: int64): boolean;
     end;
     function TFakeObj.func(const FileName: string; const FileTime: TFileTime; const Size: int64): boolean;
     begin
       result := fProc(FileName, FileTime, Size);
     end;


function EnumerateFiles(FolderName, Mask: string; Attr: integer; Proc: TFolderFunctionRef): boolean; overload;
var
  Obj: TFakeObj;
  AFolderFunction: TFolderFunctionObj;
begin
  Obj := nil;
  try
    if @Proc <> nil then
    begin
      Obj := TFakeObj.Create;
      Obj.fProc := Proc;
      AFolderFunction := Obj.func;
    end
    else
      AFolderFunction := nil;
    result := EnumerateFiles(FolderName, Mask, Attr, AFolderFunction);
  finally
    FreeAndNil(Obj);
  end;
end;

function EnumerateReestr(FolderName, Mask: string; Key, Name, Data: boolean; Proc: TFolderFunctionRef): boolean;
  overload;
var
  Obj: TFakeObj;
  AFolderFunction: TFolderFunctionObj;
begin
  Obj := nil;
  try
    if @Proc <> nil then
    begin
      Obj := TFakeObj.Create;
      Obj.fProc := Proc;
      AFolderFunction := Obj.func;
    end
    else
      AFolderFunction := nil;
    result := EnumerateReestr(FolderName, Mask, Key, Name, Data, AFolderFunction);
  finally
    FreeAndNil(Obj);
  end;
end;
{$ENDIF}

function ExecuteProcess(FileName, Params, Dir: WideString; Comment: string; LogStream: TStream = nil): boolean;
var
  SecAttr: TSecurityAttributes;
  StartupInfoW: _STARTUPINFOW;
  StartupInfoA: _STARTUPINFOA;
  ProcessInfo: TProcessInformation;
  PipeIn, PipeOut: THandle;
  pwParams, pwDir: PWideChar;
  pParams, pDir: PAnsiChar;
  DirA, ParamsA, OutText: AnsiString;
  OutTextW: WideString;
  S: string;
  P: Pointer;
  AvailableBytes, BytesRead: Cardinal;
  R, Code: Cardinal;
  AnsiStream: TMemoryStream;
  procedure WriteToLog(ClassName, Message: string; MessageType: Char);
  var
    S: string;
    MsgW: WideString;
    MsgA: AnsiString;
  begin
    if LogStream <> nil then
    begin
      if MessageType <> #0 then
        S := MessageType + '. '
      else
        S := '';
      if ClassName <> '' then
      begin
        S := S + '[' + ClassName + ']' + #13#10;
      end;
      S := S + Message;
      StringReplace(S, #13#10, #13#10 + '   ', [rfReplaceAll]);
      S := S + #13#10;
      if Win32Platform = VER_PLATFORM_WIN32_NT then
      begin
        MsgW := S;
        LogStream.WriteBuffer(MsgW[1], SizeOf(MsgW[1]) * Length(MsgW));
      end
      else
      begin
        MsgA := AnsiString(S);
        LogStream.WriteBuffer(MsgA[1], SizeOf(MsgA[1]) * Length(MsgA));
      end;
    end;
  end;

  procedure CloseHandleZero(var Handle: THandle);
  begin
    if Handle <> 0 then
    begin
      if (not CloseHandle(Handle)) then
        WriteToLog('CloseHandle', SysErrorMessage(GetLastError), 'W');
      Handle := 0;
    end;
  end;

begin
  AnsiStream := nil;
  if Comment = '' then
  begin
    S := StrExecute + #13#10 + ExcludeTrailingPathDelimiter(Dir) + '>';
    if AnsiUpperCase(ExtractFileDir(FileName)) = AnsiUpperCase(ExcludeTrailingPathDelimiter(Dir)) then
      S := S + '"' + ExtractFileName(FileName) + '"'
    else
      S := S + '"' + FileName + '"';
    S := S + ' ' + Params + #13#10;
  end
  else
  begin
    S := Comment;
  end;
  if (LogStream <> nil) and (LogStream.Position = 0) and (Win32Platform = VER_PLATFORM_WIN32_NT) then
    LogStream.WriteBuffer(SignW, SizeOf(SignW));

  WriteToLog('', S, 'I');

  FillChar(SecAttr, SizeOf(SecAttr), 0);
  SecAttr.nLength := SizeOf(SecAttr);
  SecAttr.bInheritHandle := True;
  PipeOut := 0;
  PipeIn := 0;
  FillChar(StartupInfoW, SizeOf(StartupInfoW), 0);
  FillChar(StartupInfoA, SizeOf(StartupInfoA), 0);
  StartupInfoW.cb := SizeOf(StartupInfoW);
  StartupInfoA.cb := SizeOf(StartupInfoA);
  StartupInfoW.wShowWindow := SW_HIDE;
  StartupInfoA.wShowWindow := SW_HIDE;
  FillChar(ProcessInfo, SizeOf(ProcessInfo), 0);
  Params := Trim(FileName + ' ' + Params);
  result := True;
  try
    try
      if not CreatePipe(PipeIn, PipeOut, @SecAttr, 0) then
        raise EOSError.Create(STR_CREATE_PIPE_ERROR + #13#10 + SysErrorMessage(GetLastError));
      if Win32Platform = VER_PLATFORM_WIN32_NT then
      begin
        pwParams := PWideChar(Params);
        if Dir <> '' then
          pwDir := PWideChar(Dir)
        else
          pwDir := nil;
        StartupInfoW.hStdOutput := PipeOut;
        StartupInfoW.dwFlags := STARTF_USESHOWWINDOW or STARTF_USESTDHANDLES;
        if not CreateProcessW(nil, pwParams, @SecAttr, @SecAttr, True, CREATE_NEW_CONSOLE or IDLE_PRIORITY_CLASS,
          nil, pwDir, StartupInfoW, ProcessInfo) then
        begin
          S := Params;
          S := Format(STR_SHELLPROCESSCREATEERROR, [S]);
          raise EOSError.Create(S + #13#10 + SysErrorMessage(GetLastError));
        end
      end
      else
      begin
        DirA := AnsiString(Dir);
        ParamsA := AnsiString(Params);
        pParams := PAnsiChar(ParamsA);
        if DirA <> '' then
          pDir := PAnsiChar(DirA)
        else
          pDir := nil;
        StartupInfoA.hStdOutput := PipeOut;
        StartupInfoA.dwFlags := STARTF_USESHOWWINDOW or STARTF_USESTDHANDLES;
        if not CreateProcessA(nil, pParams, @SecAttr, @SecAttr, True, CREATE_NEW_CONSOLE or IDLE_PRIORITY_CLASS, nil,
          pDir, StartupInfoA, ProcessInfo) then
        begin
          S := Params;
          S := Format(STR_SHELLPROCESSCREATEERROR, [S]);
          raise EOSError.Create(S + #13#10 + SysErrorMessage(GetLastError));
        end
      end;
      P := nil;
      try
        repeat
          R := WaitForSingleObject(ProcessInfo.hProcess, 40);
          if PeekNamedPipe(PipeIn, nil, 0, nil, @AvailableBytes, nil) then
          begin
            if (AvailableBytes > 0) then
            begin
              ReallocMem(P, AvailableBytes + 1);
              if ReadFile(PipeIn, P^, AvailableBytes, BytesRead, nil) and (LogStream <> nil) then
              begin
                if AnsiStream = nil then
                  AnsiStream := TMemoryStream.Create;
                AnsiStream.WriteBuffer(P^, BytesRead);
              end;
            end
          end
          else
            RaiseLastOsError;
        until ((R = WAIT_FAILED) or (R = WAIT_OBJECT_0)) and (AvailableBytes = 0);
      finally
        ReallocMem(P, 0);
        try
          if (AnsiStream <> nil) and (AnsiStream.Size > 0) and (LogStream <> nil) then
          begin
            WriteToLog('', StrOut, 'I');
            SetLength(OutText, AnsiStream.Size);
            Move(AnsiStream.Memory^, OutText[1], AnsiStream.Size);
            OutText := OutText + #13#10;
            if Win32Platform = VER_PLATFORM_WIN32_NT then
            begin
              OutTextW := WideString(OutText);
              LogStream.WriteBuffer(OutTextW[1], SizeOf(OutTextW[1]) * Length(OutTextW));
            end
            else
            begin
              LogStream.WriteBuffer(OutText[1], SizeOf(OutText[1]) * Length(OutText));
            end;
          end;
        finally
          FreeAndNil(AnsiStream);
        end;
      end;
      if not GetExitCodeProcess(ProcessInfo.hProcess, Code) then
        RaiseLastOsError;
      result := Code = 0;
      if result then
        WriteToLog('', StrOk, 'I')
      else
      begin
        S := Format(StrExitCode, [Code]);
        WriteToLog('', S, 'E')
      end;
    finally
      CloseHandleZero(ProcessInfo.hProcess);
      CloseHandleZero(ProcessInfo.hThread);
      CloseHandleZero(PipeIn);
      CloseHandleZero(PipeOut);
    end;
  except
    on E: Exception do
    begin
      WriteToLog(E.ClassName, E.Message, 'E');
      result := False;
      if LogStream = nil then
        raise;
    end;
  end;
end;

function Scale(DestWidth, DestHeight, SourceWidth, SourceHeight: integer): Double;
var Scale2: Double;
begin
  result := 0;
  if (SourceWidth = 0) or (SourceHeight = 0) then Exit;
  result := DestWidth / SourceWidth;
  Scale2 := DestHeight / SourceHeight;
  if Scale2 < result then result := Scale2;
  if Abs(result - 1) < 0.01 then result := 1;
end;

initialization

  FreqCPU := 0;

finalization

end.

