unit ControlBarCep;
(*
 * Module:         
 * Version:    2.5 (23.11.2008)
 * Author:      
 * Comments:         .
 *                    
 *             email: roschinspb@mail.ru
 *             http://www.delphikingdom.com/asp/users.asp?ID=1271
 *             http://www.roschinspb.narod.ru
 *
 * Copyright:   Cep Po 2007  2008 .
 *
 * Version:    2.5 (23.11.2008)
 * Realized:      Delphi 2009.
 *
 * Version:    1.0.0.0 (05.12.2007)
 *)
interface
{$I Directives.Inc}
uses Windows, Messages, RTLConsts, Types, Classes, SysUtils, Controls, Math, ActnMan,
  Graphics, GraphUtil, ExtCtrls, Themes, Forms,
  AlignBandsUtl, CepStyleUtl, ActnCtrls, InternalTimer, BitOp;

const
  CrHandMoved = 204;
  CrHandMoveable = 200;
  CrHand = 245;
  DropDownSize = 9;
  UM_CHANGED = WM_USER + 113;
  UM_EXECUTEDEX = WM_USER + 114;

type
  TMoveState = (msNone, msMove, msSize);
  TControlBarCep = class;
  TSysButtonClass = class of TSpeedButtonCepSpecial;
  TBandCepStyleClass = class of TBandCepStyle;

  //TBandCepStyle      
  //.  TControlBarCepStyle     
  //.      Bands: TBandsCepStyle.
  //     TBandCepStyle   
  TBandCepStyle = class(TBandItem)
  private
    fButtonCollection: TOwnedCollection;
    fDropDownEnabled: boolean;
    fDropDownPushed: boolean;
    fDestroying: boolean;
    fHint: string;
    function GetControlBarCepStyle: TControlBarCep;
    function GetButtonCollection: TOwnedCollection;
    function GetEnabled: boolean;
    procedure SetEnabled(const Value: boolean);
    function GetButtonCount: integer;
    function GetButtons(Index: integer): TSpeedButtonCepSpecial;
    function GetDropDownVisible: boolean;
    procedure SetDropDownVisible(const Value: boolean);
    procedure SetDropDownEnabled(const Value: boolean);
    procedure SetDropDownPushed(const Value: boolean);
    function GetDropDownChevron: boolean;
    procedure SetDropDownChevron(const Value: boolean);
    procedure onDropDownClick(Sender: TObject);
    property Parent: TControlBarCep read GetControlBarCepStyle;
    //    
    property ButtonCollection: TOwnedCollection read GetButtonCollection;
  protected
    // PaintToCanvas      
    procedure PaintToCanvas(Canvas: TCanvas;
      const OffsetX: integer = 0;
      const OffsetY: integer = 0); virtual;
    //     
    //   
    function GetBandButtonClass(Kind: TSpecialKind): TSysButtonClass; virtual;
    procedure UpdateSysArea;
    procedure ExecuteEx;
  public
    constructor Create(Collection: TCollection); override;
    destructor Destroy; override;
    function ButtonByKind(Kind: TSpecialKind): TSpeedButtonCepSpecial;
    property Enabled: boolean read GetEnabled write SetEnabled;
    property ButtonCount: integer read GetButtonCount;
    property Buttons[Index: integer]: TSpeedButtonCepSpecial read GetButtons;

    property Hint: string read fHint write fHint;
    property DropDownVisible: boolean read GetDropDownVisible write SetDropDownVisible;
    property DropDownEnabled: boolean read fDropDownEnabled write SetDropDownEnabled;
    property DropDownPushed: boolean read fDropDownPushed write SetDropDownPushed;
    property DropDownChevron: boolean read GetDropDownChevron write SetDropDownChevron;
  end;

  //   
  TBandsCepStyle = class(TBandItems)
  private
    function GetControlBarCepStyle: TControlBarCep;
    function GetItem(Index: Integer): TBandCepStyle;
  protected
  public
    procedure DoAligned; override;
    property Parent: TControlBarCep read GetControlBarCepStyle;
    property Items[Index: Integer]: TBandCepStyle read GetItem; default;
  end;

//      .
  TControlBarCep = class(TWinControl, IDrawBackground)
  private
    fBands: TBandsCepStyle;
    FCornerEdge: TCornerEdge;
    FGradientStartColor: TColor;
    FGradientDirection: TGradientDirection;
    FGradientEndColor: TColor;
    FDrawingStyle: TBandDrawingStyle;
    fFixed: boolean;
    FOnBandPaint: TBandPaintEvent;
    fAutoHeight, fAutoWidth: integer;
    fAligned: boolean;
    fMoveState: TMoveState;
    fPushIndex: integer;
    fPushPoint: TPoint;
    fInternalTimer: TInternalTimer;
    fSizeTick: DWORD;
    fTimer: THandle;
    fUpdateInterval: integer;
    fControlsLoaded: boolean;
    fRowSize: integer;
    fOldIsVert: Boolean;

    fDockedSysButtonPushed: boolean;
    fDockedControl: TControl;
    fDockedPoint: TSmallPoint;
    fDockedRect: TRect;
    FOnBeginBandMove: TBeginBandMoveEvent;

    function GetBands: TBandsCepStyle;
    procedure SetCornerEdge(const Value: TCornerEdge);
    procedure SetDrawingStyle(const Value: TBandDrawingStyle);
    procedure SetGradientDirection(const Value: TGradientDirection);
    procedure SetGradientEndColor(const Value: TColor);
    procedure SetGradientStartColor(const Value: TColor);
    procedure RepaintAllocated;
    procedure SetFixed(const Value: boolean);
    procedure UpdateCursor(HT: Integer);
    procedure CMControlChange(var Message: TCMControlChange); message CM_ControlChange;
    procedure CMCOLORCHANGED(var Message: TMessage); message CM_COLORCHANGED;
    procedure WMERASEBKGND(var Message: TWMERASEBKGND); message WM_ERASEBKGND;
    procedure SetPushIndex(const Value: integer);
    procedure KillTimer;
    procedure SetTimer;
    procedure SetUpdateInterval(const Value: integer);
    procedure WMTIMER(var Message: TWMTIMER); message WM_TIMER;
    procedure UMCHANGED(var Message: TMessage); message UM_CHANGED;
    procedure UMEXECUTEDEX(var Message: TMessage); message UM_EXECUTEDEX;
    procedure SetControlsLoaded(const Value: boolean);
    procedure AddControl(Control: TControl; R: TRect);
    function GetRowSize: integer;
    procedure SetRowSize(const Value: integer);
    procedure BandsChanged;
    procedure UpdateWH(Control: TControl; var W, H: Integer);
    procedure AllignButtonCollection;
  protected
    procedure AdjustSize; override;
    procedure AlignControls(AControl: TControl; var ARect: TRect); override;
    function CanAutoSize(var NewWidth, NewHeight: Integer): Boolean; override;
    procedure Resize; override;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure CreateWindowHandle(const Params: TCreateParams); override;
    procedure DestroyWindowHandle; override;
    procedure SetParent(AParent: TWinControl); override;

    procedure DoBandPaint(Control: TControl; Canvas: TCanvas; var ARect: TRect;
      var Options: TBandPaintOptions); virtual;
    procedure PaintWindow(DC: HDC); override;
    function GetBandClass: TBandCepStyleClass; virtual;
    function DrawBackgroundControl(Control: TControl; Canvas: TCanvas; ARect: TRect): boolean;
    procedure ColorsInfo(var ADrawingStyle: TBandDrawingStyle;
      var AGradientDirection: TGradientDirection;
      var AGradientStartColor: TColor;
      var AGradientEndColor: TColor;
      var AColor: TColor);
    function InsetsControl(const Control: TControl; var Insets: TRect): boolean;

    function HitTest(const X, Y: integer; var BandIndex: integer): Longint; dynamic;
    procedure UpdateBandsProperties; dynamic;
    procedure BeginMove(Control: TControl; X, Y: integer; ARect: TRect);
    procedure MouseMove(Shift: TShiftState; X: Integer; Y: Integer); override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X: Integer; Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X: Integer; Y: Integer); override;
    procedure DblClick; override;

    procedure DockOver(Source: TDragDockObject; X, Y: Integer; State: TDragState;
      var Accept: Boolean); override;
    //  ,      
    property PushIndex: integer read fPushIndex write SetPushIndex;
    property ControlsLoaded: boolean read fControlsLoaded write SetControlsLoaded;
    procedure Loaded; override;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;

    function DoBeginBandMove(Control: TControl): Boolean; dynamic;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    //    
    function BandByControl(const Control: TControl): TBandCepStyle;
    // 
    property Bands: TBandsCepStyle read GetBands;
    property UpdateInterval: integer read fUpdateInterval write SetUpdateInterval;


  published
    //   ,   
    property CornerEdge: TCornerEdge read FCornerEdge
      write SetCornerEdge default ceMedium;
    property DrawingStyle: TBandDrawingStyle read FDrawingStyle
      write SetDrawingStyle default dsGradient;
    property GradientDirection: TGradientDirection read FGradientDirection
      write SetGradientDirection default gdVertical;
    property GradientStartColor: TColor read FGradientStartColor
      write SetGradientStartColor default clDefault;
    property GradientEndColor: TColor read FGradientEndColor
      write SetGradientEndColor default clDefault;
    property RowSize: integer read GetRowSize write SetRowSize default 32;
    property Fixed: boolean read fFixed write SetFixed default false;
    property Autosize default true;
    property ParentColor default true;
    property Align default alTop;

    property OnBandPaint: TBandPaintEvent read FOnBandPaint write FOnBandPaint;
    property OnBeginBandMove: TBeginBandMoveEvent read FOnBeginBandMove write FOnBeginBandMove;

    property Anchors;
    property BevelEdges;
    property BevelInner;
    property BevelOuter;
    property BevelKind;
//    property BevelWidth;
//    property BorderWidth;
    property Color nodefault;
    property Constraints;
    property Ctl3d;
    property DockSite;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property ParentBackground default True;
    property ParentCtl3d default true;
    property ParentFont;
    property ParentShowHint;

//    property Picture;
    property PopupMenu;
//    property RowSnap;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnAlignInsertBefore;
    property OnAlignPosition;
//    property OnBandDrag;
//    property OnBandInfo;
//    property OnBandMove;
//    property OnBeginBandMove;
//    property OnEndBandMove;
    property OnCanResize;
    property OnClick;
    property OnConstrainedResize;
    property OnContextPopup;
    property OnDockDrop;
    property OnDockOver;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnGetSiteInfo;
    property OnMouseActivate;
    property OnMouseDown;
    property OnMouseEnter;
    property OnMouseLeave;
    property OnMouseMove;
    property OnMouseUp;
//    property OnPaint;
    property OnResize;
    property OnStartDock;
    property OnStartDrag;
    property OnUnDock;

  end;

procedure Register;

implementation
{$R CursorHand.RES}

procedure Register;
begin
  RegisterComponents('Cep', [TControlBarCep]);
end;

function LoadCursorEx(Name: WideString): HCURSOR;
begin
  result := LoadImageW(hInstance, PWideChar(Name), IMAGE_CURSOR, 0, 0, LR_LOADTRANSPARENT);
  if result = 0 then
    raiseLastOsError;
end;

{ TButtonCepSpecialItem }
type
  //     
  TBandButton = class(TCollectionItem)
  private
    fButton: TSpeedButtonCepSpecial;
    fButtonClass: TSysButtonClass;
    fKind: TSpecialKind;
    function GetButton: TSpeedButtonCepSpecial;
  protected
    procedure SetCollection(Value: TCollection); override;
  public
    constructor Create(Collection: TCollection; ButtonClass: TSysButtonClass; Kind: TSpecialKind); reintroduce;
    destructor Destroy; override;
    //  (  )
    property Button: TSpeedButtonCepSpecial read GetButton;
  end;

constructor TBandButton.Create(Collection: TCollection; ButtonClass: TSysButtonClass; Kind: TSpecialKind);
begin
  if (Collection = nil) or (not (Collection.Owner is TBandCepStyle)) then
    raise Exception.Create(ErrInputParam);
  inherited Create(Collection);
  if ButtonClass = nil then fButtonClass := TSpeedButtonCepSpecial
  else fButtonClass := ButtonClass;
  fKind := Kind;
end;

destructor TBandButton.Destroy;
begin
  FreeAndNil(fButton);
  inherited;
end;

function TBandButton.GetButton: TSpeedButtonCepSpecial;
var ControlBar: TControlBarCep;
begin
  if (fButton = nil) and
    (Collection <> nil) and
    (Collection.Owner is TBandCepStyle) then
  begin
    ControlBar := TBandCepStyle(Collection.Owner).Parent;
    if (ControlBar <> nil) and (not (csDestroying in ControlBar.ComponentState)) then
    begin
      fButton := fButtonClass.Create(ControlBar);
      fButton.SpecialKind := fKind;
      fButton.Cursor := crArrow;
      fButton.Parent := ControlBar;
    end { else
      raise Exception.Create(ErrInputParam)};
  end;
  result := fButton;
end;

procedure TBandButton.SetCollection(Value: TCollection);
begin
  if ((Value <> nil) and (Value.Owner is TBandCepStyle)) then
  begin
    inherited;
    if fButton <> nil then
      fButton.Parent := TBandCepStyle(Value.Owner).Parent;
  end
  else if (Value <> nil) then raise Exception.Create(ErrInputParam)
  else inherited;
end;

{ TBandButtons }
type
  TBandButtons = class(TOwnedCollection)
  private
    function GetButtons(Index: integer): TSpeedButtonCepSpecial;
  public
    constructor Create(AOwner: TPersistent);
    function Add(ButtonClass: TSysButtonClass; Kind: TSpecialKind): TBandButton;
    property Buttons[Index: integer]: TSpeedButtonCepSpecial
    read GetButtons; default;
  end;

function TBandButtons.Add(ButtonClass: TSysButtonClass; Kind: TSpecialKind): TBandButton;
var Parent: TWinControl;
begin
  if ItemClass.InheritsFrom(TBandButton) then
  begin
    Parent := nil;
    if (Owner is TBandCepStyle) then
      Parent := TBandCepStyle(Owner).Parent;
    if Parent = nil then
      raise Exception.Create(ErrInputParam)
    else
      Result := TBandButton.Create(self, ButtonClass, Kind);
  end else
    raise Exception.Create(ErrInputParam);
end;

constructor TBandButtons.Create(AOwner: TPersistent);
begin
  if not (AOwner is TBandCepStyle) then
    raise Exception.Create(ErrInputParam);
  inherited Create(AOwner, TBandButton);
end;

function TBandButtons.GetButtons(Index: integer): TSpeedButtonCepSpecial;
begin
  result := TBandButton(Items[Index]).Button;
end;

{ TDockTimer }
type
  TDockTimer = class(TInternalTimer)
  private
    fSource: TDragDockObject;
    fControl: TControl;
    fDocking: boolean;
    procedure DoDock(Sender: TObject);
    procedure DoUnDock(Sender: TObject);
  public
    procedure Dock(Source: TDragDockObject);
    procedure UnDock(Control: TControl);
  end;

  TCustomActionDockBarEx = class(TCustomActionDockBar);


procedure TDockTimer.Dock(Source: TDragDockObject);
begin
  fSource := Source;
  if (Handle = 0) or (not fDocking) then
  begin
    fDocking := true;
    ExecuteDelay(300, DoDock);
  end;
end;

procedure TDockTimer.DoDock(Sender: TObject);
var Bar: TControlBarCep;
  R: TRect;
  W, H, X, Y: integer;
  Pt: TPoint;
  DockForm: TCustomDockForm;
  OldBoundsRect: TRect;
begin
  if (fSource <> nil) and (Owner is TControlBarCep) then
  begin
    Bar := TControlBarCep(Owner);
    with Bar do
    begin
      fDockedSysButtonPushed := false;
      if Bands = nil then Exit;
      Pt := Mouse.CursorPos;
      Pt := ScreenToClient(Pt);
      X := Pt.X;
      Y := Pt.Y;
      try
        if fSource.Control.Parent is TCustomDockForm then
          DockForm := TCustomDockForm(fSource.Control.Parent)
        else
          DockForm := nil;
        fDockedSysButtonPushed := (DockForm is TXToolDockFormCep) and
          (TXToolDockFormCep(DockForm).SysButtonPushed);
        R := fSource.DockRect;
        R.TopLeft := ScreenToClient(R.TopLeft);
        R.BottomRight := ScreenToClient(R.BottomRight);
        OldBoundsRect := R;
        if Bands.IsVert then
        begin
          Y := Max(Y, R.Top - 2);
          Y := Min(Y, R.Bottom - 2);
          X := (R.Left + R.Right) div (2);
        end else
        begin
          X := Max(X, R.Left - 8);
          X := Min(X, R.Right - 2);
          Y := (R.Top + R.Bottom) div (2);
        end;
        W := OldBoundsRect.Right - OldBoundsRect.Left;
        H := OldBoundsRect.Bottom - OldBoundsRect.Top;
        UpdateWH(fSource.Control, W, H);
        if fSource.Control is TCustomActionDockBar then
        begin
          if Bands.IsVert then
          begin
            TCustomActionDockBar(fSource.Control).Orientation := boTopToBottom;
            W := 0;
            H := 2096;
          end
          else
          begin
            TCustomActionDockBar(fSource.Control).Orientation := boLeftToRight;
            H := 0;
            W := 2096;
          end;
          if TCustomActionDockBarEx(fSource.Control).CanAutoSize(W, H) then
          begin
            UpdateWH(fSource.Control, W, H);
            R := Rect(R.Left, R.Top, R.Left + W, R.Top + H);
          end;
        end;
        //R := Rect(R.Left, R.Top, R.Left + W, R.Top + H);
      finally
        fDockedControl := fSource.Control;
        fSource.Control.Parent := Bar;
        fSource.Control.EndDrag(false);
        FreeAndNil(DockForm);
        fDockedPoint := PointToSmallPoint(Point(X, Y));
        fDockedRect := R;
      end;
    end;
  end;
end;

procedure TDockTimer.DoUnDock(Sender: TObject);
var Bar: TControlBarCep;
  Band: TBandCepStyle;
  R: TRect;
  SysButtonPushed: boolean;
begin
  if (fControl <> nil) and (Owner is TControlBarCep) then
  begin
    Bar := TControlBarCep(Owner);
    with Bar do
    begin
      Band := TBandCepStyle(Bands.BandByControl(fControl));
      SysButtonPushed := (Band <> nil) and (Band.DropDownPushed);
      R := fControl.BoundsRect;
      fMoveState := msNone;
      R.TopLeft := ClientToScreen(R.TopLeft);
      R.BottomRight := ClientToScreen(R.BottomRight);
      MouseCapture := false;
      MoveToCursor := true;
      fControl.ManualFloat(R);
      R.TopLeft := fControl.ClientToScreen(R.TopLeft);
      R.BottomRight := fControl.ClientToScreen(R.BottomRight);
      fControl.BeginDrag(True);
      if fControl.Parent is TXToolDockFormCep then
        TXToolDockFormCep(fControl.Parent).SysButtonPushed := SysButtonPushed;
      PushIndex := -1;
    end;
  end;
end;

procedure TDockTimer.UnDock(Control: TControl);
begin
  fControl := Control;
  if (Handle = 0) or (fDocking) then
  begin
    fDocking := False;
    ExecuteDelay(50, DoUnDock);
  end;
end;


{ TBandCepStyle }

function TBandCepStyle.ButtonByKind(Kind: TSpecialKind): TSpeedButtonCepSpecial;
var
  I: Integer;
begin
  result := nil;
  for I := 0 to ButtonCollection.Count - 1 do
  begin
    if (TBandButton(fButtonCollection.Items[I]).Button <> nil) and
      (TBandButton(fButtonCollection.Items[I]).Button.SpecialKind = Kind) then
    begin
      result := TBandButton(fButtonCollection.Items[I]).Button;
      exit;
    end;
  end;
end;

constructor TBandCepStyle.Create(Collection: TCollection);
begin
  inherited;
end;

destructor TBandCepStyle.Destroy;
begin
  fDestroying := true;
  FreeAndNil(fButtonCollection);
  inherited;
end;

function TBandCepStyle.GetBandButtonClass(Kind: TSpecialKind): TSysButtonClass;
begin
  result := nil;
end;

function TBandCepStyle.GetButtonCount: integer;
begin
  if (fButtonCollection = nil) or (fDestroying) then
    result := 0
  else
    result := fButtonCollection.Count;
end;

function TBandCepStyle.GetButtons(Index: integer): TSpeedButtonCepSpecial;
begin
  if (Index >= 0) and (Index < ButtonCount) then
    result := TBandButtons(ButtonCollection)[Index]
  else
    raise EListError.CreateFmt(SListIndexError, [Index]);
end;

function TBandCepStyle.GetButtonCollection: TOwnedCollection;
var ControlBar: TControlBarCep;
begin
  ControlBar := Parent;
  if (not fDestroying) and
    (ControlBar <> nil) and
    (not (csDestroying in ControlBar.ComponentState)) and
    (fButtonCollection = nil) then
  begin
    fButtonCollection := TBandButtons.Create(self);
  end;
  result := fButtonCollection;
end;

function TBandCepStyle.GetControlBarCepStyle: TControlBarCep;
begin
  if Collection is TBandsCepStyle then
    result := TBandsCepStyle(Collection).Parent
  else
    result := nil;
end;

function TBandCepStyle.GetEnabled: boolean;
begin
  if Control <> nil then result := Control.Enabled
  else result := false;
end;

procedure TBandCepStyle.onDropDownClick(Sender: TObject);
begin
  ExecuteEx;
end;

procedure TBandCepStyle.UpdateSysArea;
var Kind: TSpecialKind;
  Size: integer;
  Button: TSpeedButtonCepSpecial;
begin
  Size := 0;
  for Kind := Low(TSpecialKind) to High(TSpecialKind) do
  begin
    Button := ButtonByKind(Kind);
    if (Button <> nil) and (Button.Visible) then
    begin
      if Kind = skControlBarDropDown then inc(Size, DropDownSize)
      else inc(Size, GetSystemMetrics(SM_CYSMICON));
    end;
  end;
  if SysArea <> Size then
  begin
    SysArea := Size;
    //if Parent <> nil then Parent.AllignButtonCollection;
  end;
end;

procedure TBandCepStyle.ExecuteEx;
var
  Pt: TPoint;
  SysMenuEx: ISysMenuEx;
  Button: TSpeedButtonCepSpecial;
  Handle: THandle;
  ControlExecuted: TControl;
begin
  if (not DropDownPushed) and (Control <> nil) and (Control.GetInterface(ISysMenuEx, SysMenuEx)) and (SysMenuEx.IsEnabledEx) then
  begin
    Button := ButtonByKind(skControlBarDropDown);
    if Parent <> nil then
    begin
      if Button <> nil then
      begin
        Pt.X := Button.Left;
        Pt.Y := Button.Top + Button.Height;
      end else
      begin
        Pt.X := Control.Left;
        Pt.Y := Control.Top + Control.Height;
      end;
      Pt := Parent.ClientToScreen(Pt);
    end else Pt := Mouse.CursorPos;
    Handle := 0;
    ControlExecuted := nil;
    try
      DropDownPushed := true;
      ControlExecuted := Control;
      if (Parent <> nil) then Handle := Parent.Handle;
      SysMenuEx.ExecuteEx(Pt.X, Pt.Y);
    finally
      if Handle <> 0 then PostMessage(Handle, UM_EXECUTEDEX, Integer(ControlExecuted), 0);
    end;
  end;
end;

function TBandCepStyle.GetDropDownVisible: boolean;
begin
  result := ButtonByKind(skControlBarDropDown) <> nil;
end;

procedure TBandCepStyle.SetDropDownVisible(const Value: boolean);
var SysButtonClass: TSysButtonClass;
begin
  if Value <> DropDownVisible then
  begin
    if Value then
    begin
      SysButtonClass := GetBandButtonClass(skControlBarDropDown);
      if SysButtonClass = nil then
        SysButtonClass := TSpeedButtonCepSpecial;
      TBandButtons(ButtonCollection).Add(SysButtonClass, skControlBarDropDown).Button.OnClick := onDropDownClick;
    end else
    begin
      ButtonByKind(skControlBarDropDown).Free;
    end;
    UpdateSysArea;
  end;
end;

function TBandCepStyle.GetDropDownChevron: boolean;
var Button: TSpeedButtonCepSpecial;
begin
  Button := ButtonByKind(skControlBarDropDown);
  if Button <> nil then
    result := Button.Checked
  else
    result := false;
end;

procedure TBandCepStyle.SetDropDownChevron(const Value: boolean);
var Button: TSpeedButtonCepSpecial;
begin
  Button := ButtonByKind(skControlBarDropDown);
  if Button <> nil then
    Button.Checked := Value;
end;

procedure TBandCepStyle.SetDropDownEnabled(const Value: boolean);
var Button: TSpeedButtonCepSpecial;
begin
  fDropDownEnabled := Value;
  if DropDownVisible then
  begin
    Button := ButtonByKind(skControlBarDropDown);
    if Button <> nil then
      Button.Enabled := DropDownEnabled and (not DropDownPushed);
  end;
end;

procedure TBandCepStyle.SetDropDownPushed(const Value: boolean);
var Button: TSpeedButtonCepSpecial;
begin
  fDropDownPushed := Value;
  if DropDownVisible then
  begin
    Button := ButtonByKind(skControlBarDropDown);
    if Button <> nil then
      Button.Enabled := DropDownEnabled and (not DropDownPushed);
  end;
end;

//  

procedure TBandCepStyle.PaintToCanvas(Canvas: TCanvas;
  const OffsetX: integer = 0;
  const OffsetY: integer = 0);
var Options: TBandPaintOptions;
  R: TRect;
  ElemDetails: TThemedElementDetails;
  StartColor, EndColor, C: TColor;
  DS: TBandDrawingStyle;
  D: integer;
  GrDir: TGradientDirection;
  Hor: boolean;
  procedure UpdateGrabberRect;
  begin
    R := HandRect;
    Hor := (R.Right - R.Left) > (R.Bottom - R.Top);
    OffsetRect(R, OffsetX, OffsetY);
    if ThemeServices.ThemesEnabled and (Parent.DrawingStyle = dsNormal) then
    begin
      if Hor then
        InflateRect(R, -3, -1)
      else
        InflateRect(R, -1, -3);
    end else
    begin
      InflateRect(R, -3, -3);
      if Hor then inc(R.Bottom) else inc(R.Right);
    end;
  end;
  procedure DrawGrabber;
  var C: TColor;
  begin
    with Canvas do
    begin
      C := MixColor(StartColor, EndColor);
      Pen.Color := GetShadowColor(EndColor);
      MoveTo(R.Left, R.Bottom);
      LineTo(R.Right, R.Bottom);
      LineTo(R.Right, R.Top);
      Pen.Color := GetHighlightColor(StartColor);
      LineTo(R.Left, R.Top);
      LineTo(R.Left, R.Bottom);
      inc(R.Left, 1);
      inc(R.Top, 1);
      Brush.Color := C;
      FillRect(R);
    end;
  end;

begin
  if Parent = nil then Exit;
  Parent.ColorsInfo(DS, GrDir, StartColor, EndColor, C);
  //  
  if DS = dsGradient then
    Options := [bpoGradient, bpoRoundRect]
  else
    Options := [bpoFrame];
  if not Parent.Fixed then Options := Options + [bpoGrabber];
  // 
  R := BoundsRect;
  OffsetRect(R, OffsetX, OffsetY);
  try
    Parent.DoBandPaint(Control, Canvas, R, Options);
  except
    on E: EAbort do Exit;
  end;
  //  
  with Canvas do
  begin
    // 
    if bpoFrame in Options then
    begin
      if ThemeServices.ThemesEnabled then
      begin
        ElemDetails := ThemeServices.GetElementDetails(ttbButtonHot);
        ThemeServices.DrawElement(Handle, ElemDetails, R);
      end else
        DrawEdge(Handle, R, BDR_RAISEDINNER, BF_RECT);
    end;
    //    
    if bpoRoundRect in Options then
    begin
      D := Integer(Parent.CornerEdge);
      BeginPath(Handle);
      case Parent.CornerEdge of
        ceNone:
          Polyline([Point(R.Left, R.Top),
            Point(R.Right, R.Top),
              Point(R.Right, R.Bottom),
              Point(R.Left, R.Bottom),
              Point(R.Left, R.Top)]);
        ceSmall, ceMedium, ceLarge:
          Polyline([Point(R.Left + D, R.Top),
            Point(R.Right - D, R.Top),
              Point(R.Right, R.Top + D),
              Point(R.Right, R.Bottom - D - 1),
              Point(R.Right - D - 1, R.Bottom),
              Point(R.Left + D + 1, R.Bottom),
              Point(R.Left, R.Bottom - D - 1),
              Point(R.Left, R.Top + D),
              Point(R.Left + D, R.Top)]);
      end;
      EndPath(Handle);
      SelectClipPath(Handle, RGN_COPY);
    end else
      D := Pen.Width;
    if bpoGradient in Options then
    begin
      GradientFillCanvas(Canvas, GetHighlightColor(StartColor),
        GetShadowColor(EndColor), R, GrDir);
      D := (D + 1) div (2);
      InflateRect(R, -D, -D);
      GradientFillCanvas(Canvas, StartColor, EndColor,
        R, GrDir);
      InflateRect(R, D, D);
    end;
    if bpoGrabber in Options then
    begin
      if ThemeServices.ThemesEnabled and (Parent.DrawingStyle = dsNormal) then
      begin
        UpdateGrabberRect;
        if Hor then
          ElemDetails := ThemeServices.GetElementDetails(trGripperVert)
        else
          ElemDetails := ThemeServices.GetElementDetails(trGripper);
        ThemeServices.DrawElement(Handle, ElemDetails, R);
      end else
      begin
        UpdateGrabberRect;
        DrawGrabber;
      end;
    end;
  end;
end;

procedure TBandCepStyle.SetEnabled(const Value: boolean);
begin
  if Control <> nil then Control.Enabled := Value;
end;

{ TBandsCepStyle }

procedure TBandsCepStyle.DoAligned;
var ControlBar: TControlBarCep;
  W, H: integer;
  Need: boolean;
begin
  ControlBar := Parent;
  Need := (ControlBar <> nil) and (ControlBar.Autosize) and (ControlBar.HandleAllocated) and
    ((ControlBar.ControlState * [csCreating, csAligning]) = []) and
    ((ControlBar.ComponentState * [csLoading, csReading, csDestroying, csDesigning]) = []);
  inherited;
  if Need and (not ControlBar.AlignDisabled) then
  begin
    H := BandList.BoundsRect.Bottom - BandList.BoundsRect.Top;
    W := H;
    inc(H, ControlBar.Height - ControlBar.ClientHeight);
    inc(W, ControlBar.Width - ControlBar.ClientWidth);
    case ControlBar.Align of
      alTop, alBottom: begin
          if (ControlBar.fAutoHeight <> H) or ((ControlBar.ClientHeight = 0) and (H > 0)) then
          begin
            ControlBar.fAutoHeight := H;
            ControlBar.Realign;
          end;
        end;
      alRight, alLeft: begin
          if ControlBar.fAutoWidth <> W then
          begin
            ControlBar.fAutoWidth := W;
            ControlBar.Realign;
          end;
        end;
    end;
  end;
end;

function TBandsCepStyle.GetControlBarCepStyle: TControlBarCep;
begin
  if Owner is TControlBarCep then result := TControlBarCep(Owner)
  else result := nil;
end;

function TBandsCepStyle.GetItem(Index: Integer): TBandCepStyle;
begin
  result := TBandCepStyle(inherited GetItem(Index));
end;

{ TControlBarCepStyle }

procedure TControlBarCep.AdjustSize;
var OldIsVert, NewIsVert: boolean;
begin
  if Bands <> nil then
  begin
    OldIsVert := Bands.IsVert;
    NewIsVert := Align in [alRight, alLeft];
    if OldIsVert = NewIsVert then inherited
    else
    begin
      FreeAndNil(fBands);
      BandsChanged;
    end;
  end;
end;

procedure TControlBarCep.Loaded;
begin
  inherited;
  fOldIsVert := Align in [alLeft, alRight];
  ControlsLoaded := true;
  if Autosize then
  begin
    fAutoHeight := 0;
    fAutoWidth := 0;
  end;
end;

procedure TControlBarCep.AlignControls(AControl: TControl;
  var ARect: TRect);
var
  Band: TBandCepStyle;
  R1, R2: TRect;
    //Designed: boolean;
begin
  if fAligned then Exit;
  fAligned := true;
  //Designed := csDesigning in ComponentState;
  try
    if (AControl <> nil) and
      (Bands <> nil) and
      (not (AControl is TSpeedButtonCepSpecial)) then
    begin
      Band := BandByControl(AControl);
      if Band <> nil then
      begin
        R1 := Band.ClientRect;
        R2 := AControl.BoundsRect;
        if not CompareMem(@R1, @R2, SizeOf(R1)) then
        begin
          Band.ClientRect := R2;
          if Autosize then
          begin
            fAutoHeight := 0;
            fAutoWidth := 0;
          end;
          UpdateBandsProperties;
        end;
      end;
    end;
    if (not (AControl is TSpeedButtonCepSpecial)) then
    begin
      inherited;
{$IFDEF DELPHI_2009_UP}
      if Showing then AdjustSize;
{$ENDIF}
    end;
    AllignButtonCollection;
  finally
    fAligned := false;
  end;
end;

function TControlBarCep.CanAutoSize(var NewWidth,
  NewHeight: Integer): Boolean;
begin
  Result := True;
  if HandleAllocated and (not (csDesigning in ComponentState)) then
  begin
    if (Bands <> nil) and (Bands.Count > 0) then
    begin
      case Align of
        alNone, alTop, alBottom: NewHeight := fAutoHeight;
        alLeft, alRight: NewWidth := fAutoWidth;
        alClient, alCustom: result := inherited CanAutoSize(NewWidth, NewHeight);
      end;
    end else
    begin
      case Align of
        alNone, alTop, alBottom: NewHeight := 0;
        alLeft, alRight: NewWidth := 0;
        alClient, alCustom: result := inherited CanAutoSize(NewWidth, NewHeight);
      end;
    end;
  end else result := false; // inherited CanAutoSize(NewWidth, NewHeight);
end;

procedure TControlBarCep.Resize;
begin
  inherited;
  BandsChanged;
end;

procedure TControlBarCep.UMCHANGED(var Message: TMessage);
var lpMsg: TMsg;
  I, J, N, H: integer;
  AControls: array of TControl;
  Band: TBandCepStyle;
  Need: boolean;
  procedure DoSize;
  begin
    if Autosize and (not (csDesigning in ComponentState)) then
    begin
      if Bands.Count = 0 then
        H := 0
      else
        H := Bands.BandList.BoundsRect.Bottom - Bands.BandList.BoundsRect.Top;
      case Align of
        alTop, alBottom:
          begin
            if H > 0 then
              Inc(H, Height - ClientHeight);
            if (fAutoHeight <> H) or ((ClientHeight = 0) and (H > 0)) then
            begin
              fAutoHeight := H;
              Realign;
            end;
          end;
        alRight, alLeft:
          begin
            if H > 0 then
              Inc(H, Width - ClientWidth);
            if fAutoWidth <> H then
            begin
              fAutoWidth := H;
              Realign;
            end;
          end;
      end;
    end;
  end;
begin
  if (ControlsLoaded) and (not fAligned) and (Bands.UpdateCount = 0) and (not Bands.BandList.Alligning) then
  begin
    if not PeekMessage(lpMsg, Handle, UM_CHANGED, UM_CHANGED, PM_NOREMOVE) then
    begin
      if Bands <> nil then
      begin
        fAligned := true;
        Bands.BandList.BeginUpdate;
        DisableAlign;
        try
          I := 0;
          while I < Bands.Count do
          begin
            Band := Bands[I];
            Need := true;
            for J := 0 to ControlCount - 1 do
              if Band.Control = Controls[J] then
              begin
                Need := false;
                break;
              end;
            if Need then
              FreeAndNil(Band)
            else Inc(I);
          end;
          N := 0;
          //   
          for I := 0 to ControlCount - 1 do
            if (not (Controls[I] is TSpeedButtonCepSpecial)) and (Bands.BandByControl(Controls[I]) = nil) then
            begin
              Inc(N);
              SetLength(AControls, N);
              AControls[N - 1] := Controls[I];
            end;
          //    
          for I := 0 to N - 1 do
            if (fOldIsVert <> Bands.IsVert) and (AControls[I] is TCustomActionDockBar) then
              AddControl(AControls[I], Rect(AControls[I].Top,
                AControls[I].Left,
                AControls[I].Top + AControls[I].Height,
                AControls[I].Left + AControls[I].Width))
            else
            begin
              if fDockedControl = AControls[I] then
                AddControl(AControls[I], fDockedRect)
              else
                AddControl(AControls[I], AControls[I].BoundsRect);
            end;
          fOldIsVert := Bands.IsVert;
          Bands.BeginUpdate;
          try
            Band := BandByControl(fDockedControl);
            if Band <> nil then
            begin
              SendMessage(Handle, WM_LBUTTONUP, MK_LBUTTON, Message.LParam);
              SendMessage(Handle, WM_LBUTTONDOWN, MK_LBUTTON, Message.LParam);
              if Band is TBandCepStyle then
              begin
                TBandCepStyle(Band).DropDownPushed := fDockedSysButtonPushed;
                Band.ClientRect := fDockedRect;
              end;
              BeginMove(Band.Control, fDockedPoint.x, fDockedPoint.y, fDockedRect);
            end;
            UpdateBandsProperties;
            Bands.BoundsRect := ClientRect;
            DoSize;
          finally
            Bands.EndUpdate;
          end;
        finally
          fDockedControl := nil;
          fAligned := false;
          EnableAlign;
          Bands.BandList.EndUpdate;
        end;
        RepaintAllocated;
      end;
    end;
  end;
end;

procedure TControlBarCep.UMEXECUTEDEX(var Message: TMessage);
var Band: TBandItem;
begin
  if fBands <> nil then
  begin
    Band := Bands.BandByControl(TControl(Pointer(Message.WParam)));
    if Band is TBandCepStyle then
    begin
      TBandCepStyle(Band).DropDownPushed := false;
      UpdateBandsProperties;
      if Band.Control is TCustomActionDockBar then
        TCustomActionDockBarEx(Band.Control).AutoSizing := false;
    end;
  end;
end;

procedure TControlBarCep.BandsChanged;
begin
  PostMessage(Handle, UM_CHANGED, 0, 0);
end;

function TControlBarCep.BandByControl(const Control: TControl): TBandCepStyle;
var I: integer;
begin
  result := nil;
  if (Control <> nil) and (Bands <> nil) then
  begin
    for I := 0 to Bands.Count - 1 do
      if Bands[I].Control = Control then
      begin
        if Bands[I] is TBandCepStyle then
        begin
          result := Bands[I];
          exit;
        end;
      end;
  end;
end;

procedure TControlBarCep.AllignButtonCollection;
var
  ButtonCollection: TBandButtons;
  Button: TSpeedButtonCepSpecial;
  W: Integer;
  J: Integer;
  I: Integer;
  R2, R1: TRect;
begin
  DisableAlign;
  try
    for I := 0 to Bands.Count - 1 do
    begin
      R1 := Bands[I].SysRect;
      R2 := R1;
      ButtonCollection := TBandButtons(Bands[I].ButtonCollection);
      for J := 0 to Bands[I].ButtonCount - 1 do
      begin
        Button := ButtonCollection[J];
        if Button.Visible then
        begin
          if Button.SpecialKind = skControlBarDropDown then
            W := DropDownSize
          else
            W := GetSystemMetrics(SM_CYSMICON);
          if Bands.IsVert then
          begin
            R1.Top := R1.Bottom - W;
            Button.BoundsRect := R1;
            R1.Bottom := R1.Top - 1;
            R1.Top := R2.Top;
          end
          else
          begin
            R1.Left := R1.Right - W;
            Button.BoundsRect := R1;
            R1.Right := R1.Left - 1;
            R1.Left := R2.Left;
          end;
        end;
      end;
    end;
  finally
    EnableAlign;
  end;
end;

procedure TControlBarCep.UpdateWH(Control: TControl; var W, H: Integer);
begin
  if Control is TCustomActionDockBar then
  begin
    if Bands.IsVert then
    begin
      if ((W + 4) >= RowSize) and ((W + 4) < RowSize * 2) then
        Dec(W, 6);
    end
    else
    begin
      if ((H + 4) >= RowSize) and ((H + 4) < RowSize * 2) then
        Dec(H, 6);
    end;
  end;
end;

type
  TControlEx = class(TControl)

  end;

procedure TControlBarCep.UpdateBandsProperties;
var
  I: Integer;
  Band: TBandCepStyle;
  SysMenuEx: ISysMenuEx;
begin
  Bands.BeginUpdate;
  try
    for I := 0 to Bands.Count - 1 do
    begin
      Band := Bands[I];
      if Band.Control <> nil then
      begin
        Band.Visible := Band.Control.Visible;
        Band.Enabled := Band.Control.Enabled;
        Band.MinWidth := Band.Control.Constraints.MinWidth;
        Band.MinHeight := Band.Control.Constraints.MinHeight;
        Band.DropDownVisible := Band.Visible and Band.Control.GetInterface(ISysMenuEx, SysMenuEx) and SysMenuEx.IsEnabledEx;
        Band.DropDownEnabled := Band.Enabled and Band.Control.Enabled;
        Band.DropDownChevron := Band.DropDownVisible and SysMenuEx.IsChevronEx;
        if Band.DropDownVisible then
        begin
          Band.ButtonByKind(skControlBarDropDown).Hint := TextSysMenuEx;
          Band.Hint := SysMenuEx.CaptionEx;
        end;
        if Band.Control is TCustomActionDockBar then
        begin
          if Bands.IsVert then
            TCustomActionDockBar(Band.Control).Orientation := boTopToBottom
          else
            TCustomActionDockBar(Band.Control).Orientation := boLeftToRight;
        end;
      end;
    end;
  finally
    Bands.EndUpdate;
  end;
end;

function TControlBarCep.DrawBackgroundControl(Control: TControl;
  Canvas: TCanvas; ARect: TRect): boolean;
var Band: TBandCepStyle;
begin
  result := false;
  if Canvas = nil then Exit;
  Band := BandByControl(Control);
  if Band = nil then Exit;
  Band.PaintToCanvas(Canvas, -Band.ClientRect.Left, -Band.ClientRect.Top);
  result := true;
end;

procedure TControlBarCep.CMCOLORCHANGED(var Message: TMessage);
begin
  RepaintAllocated;
end;

procedure TControlBarCep.CMControlChange(var Message: TCMControlChange);
begin
  inherited;
  if (Message.Control is TSpeedButtonCepSpecial) then Exit;
  if not Message.Inserting then
  begin
    if fBands <> nil then
      Bands.BandByControl(Message.Control).Free;
    if csDestroying in ComponentState then Exit;
  end else
  begin
    if (not ControlsLoaded) or (csDestroying in ComponentState) then Exit;
  end;
  BandsChanged;
end;

procedure TControlBarCep.ColorsInfo(var ADrawingStyle: TBandDrawingStyle;
  var AGradientDirection: TGradientDirection; var AGradientStartColor,
  AGradientEndColor, AColor: TColor);
begin
  ADrawingStyle := DrawingStyle;
  AGradientDirection := self.GradientDirection;
  AGradientStartColor := self.GradientStartColor;
  AGradientEndColor := self.GradientEndColor;
  AColor := self.Color;
  if Bands.IsVert then
  begin
    if AGradientDirection = gdVertical then
      AGradientDirection := gdHorizontal
    else
      AGradientDirection := gdVertical;
  end;
  if AGradientStartColor = clDefault then
    AGradientStartColor := GetHighlightColor(Color);
  if AGradientEndColor = clDefault then
    AGradientEndColor := GetShadowColor(Color);
end;

function TControlBarCep.InsetsControl(const Control: TControl;
  var Insets: TRect): boolean;
var Band: TBandCepStyle;
begin
  Band := BandByControl(Control);
  result := Band <> nil;
  if result then
    Insets := Band.IntInsets;
end;

function TControlBarCep.HitTest(const X, Y: integer;
  var BandIndex: integer): Longint;
var Pt: TPoint;
  i, j: integer;
  R: TRect;
begin
  Pt := Point(X, Y);
  BandIndex := -1;
  Result := HTCLIENT;
  for I := 0 to Bands.Count - 1 do
    with Bands[I] do
      if PtInRect(BoundsRect, Pt) then
      begin
        BandIndex := I;
        if Enabled and Visible then
        begin
          if not fFixed then
          begin
            for J := 0 to Bands[I].ButtonCount - 1 do
              if PtInRect(Bands[I].Buttons[J].BoundsRect, Pt) and
                (Bands[I].Buttons[J].Enabled) and
                (Bands[I].Buttons[J].Visible) then
                Exit;
            if PtInRect(HandRect, Pt) then result := HTCAPTION;
            R := BoundsRect;
            if Bands.IsVert then
              R.Top := R.Bottom - Insets.Right
            else
              R.Left := R.Right - Insets.Right;
            if PtInRect(R, Pt) then result := HTBOTTOMRIGHT;
          end;
          Exit;
        end;
      end;
end;

procedure TControlBarCep.BeginMove(Control: TControl; X, Y: integer;
  ARect: TRect);
var Band: TBandCepStyle;
  procedure UpdateBand;
  begin
    Band.ClientRect := ARect;
    PushIndex := Band.Index;
    UpdateCursor(HTCAPTION);
    MouseCapture := true;
  end;
begin
  PushIndex := -1;
  Band := BandByControl(Control);
  fPushPoint := Point(ARect.Left - X,
    ARect.Top - Y);
  fMoveState := msMove;
  if Band = nil then
  begin
    Bands.BeginUpdate;
    try
      Control.Parent := self;
      Control.BoundsRect := ARect;
    finally
      Bands.EndUpdate;
      Band := BandByControl(Control);
    end;
  end;
  if Band <> nil then
  begin
    UpdateBand;
  end;
end;

procedure TControlBarCep.UpdateCursor(HT: Integer);
var F: boolean;
begin
  if ((Cursor = crSizeWE) or
    (Cursor = crSizeNS) or
    (Cursor = crDefault) or
    (Cursor = crHandMoveable) or
    (Cursor = crHandMoved)) and
    (Bands <> nil) then
  begin
    case fMoveState of
      msNone: case HT of
          HTCAPTION: Cursor := crHandMoveable;
          HTBOTTOMRIGHT: if Bands.IsVert then
              Cursor := crSizeNS
            else
              Cursor := crSizeWE;
        else
          Cursor := crDefault;
        end;
      msMove:
        begin
          F := MouseCapture;
          if Cursor <> crHandMoved then
          begin
            if Bands.BandList <> nil then
              Bands.BandList.Init;
            MouseCapture := false;
            Cursor := crHandMoved;
            MouseCapture := F;
          end;
        end;
      msSize: if Bands.IsVert then
          Cursor := crSizeNS
        else
          Cursor := crSizeWE;
    end;
  end;
end;

procedure TControlBarCep.MouseDown(Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var HT: Longint;
  I: integer;
begin
  if Button = mbLeft then
  begin
    HT := HitTest(X, Y, I);
    if I >= 0 then
    begin
      PushIndex := I;
      if (Ht in [HTCAPTION, HTBOTTOMRIGHT]) and
        (DoBeginBandMove(Bands[I].Control)) then
      begin
        if (Ht = HTCAPTION) then
        begin
          BeginMove(Bands[I].Control, X, Y, Bands[I].ClientRect);
        end;
        if (Ht = HTBOTTOMRIGHT) then
        begin
          fMoveState := msSize;
          if Bands.IsVert then
            fPushPoint := Point(Bands[I].ClientRect.Left - X,
              Bands[I].ClientRect.Bottom - Y)
          else
            fPushPoint := Point(Bands[I].ClientRect.Right - X,
              Bands[I].ClientRect.Top - Y);
          UpdateCursor(HT);
        end;
      end;
    end;
  end;
  inherited;
end;

procedure TControlBarCep.MouseMove(Shift: TShiftState; X, Y: Integer);
var HT: Longint;
  I: integer;
  ClRect, R, RR: TRect;
  W, H: integer;
  Control: TControl;
  Pt: TPoint;
begin
  inherited;
  if fMoveState = msNone then
  begin
    HT := HitTest(X, Y, I);
    if (HT = HTCAPTION) and (ShowHint) and (I >= 0) then
    begin
      if (Hint <> Bands[I].Hint) then
      begin
        Application.CancelHint;
        Hint := Bands[I].Hint;
        //Application.ActivateHint(Point(X,Y));
      end;
    end else Hint := '';
    if (Ht in [HTCAPTION, HTBOTTOMRIGHT]) and
      (not DoBeginBandMove(Bands[I].Control)) then
    begin
      HT := 0;
    end;
    UpdateCursor(HT);
    Exit;
  end;
  if (PushIndex >= 0) and (PushIndex < Bands.Count) then
  begin
    Control := Bands[PushIndex].Control;
    R := Bands[PushIndex].ClientRect;
    W := R.Right - R.Left;
    H := R.Bottom - R.Top;
    Pt := Point(X, Y);
    ClRect := ClientRect;
    InflateRect(ClRect, Bands.RowSize div 2, Bands.RowSize div 2);
    if (fMoveState = msMove) then
    begin
      R.Left := X + fPushPoint.X;
      R.Top := Y + fPushPoint.Y;
      R.Right := R.Left + W;
      R.Bottom := R.Top + H;
    end;
    if (fMoveState = msSize) then
    begin
      if Bands.IsVert then
        R.Bottom := Y + fPushPoint.Y
      else
        R.Right := X + fPushPoint.X;
      if not ((fSizeTick = 0) or ((GetTickCount - fSizeTick) > 50)) then Exit;
      if UpdateInterval = 0 then UpdateBandsProperties;
    end;
    RR := Bands[PushIndex].ClientRect;
    if not CompareMem(@RR, @R, SizeOf(R)) then
    begin
      Bands.BeginUpdate;
      DisableAlign;
      try
        if PtInRect(ClRect, Pt) then
        begin
          Bands[PushIndex].ClientRect := R;
          if fInternalTimer <> nil then
            fInternalTimer.Stop;
        end else
        begin
          if (not Bands[PushIndex].DropDownPushed) and
            (TControlEx(Bands[PushIndex].Control).DragKind = dkDock) then
          begin
            if fInternalTimer = nil then
              fInternalTimer := TDockTimer.Create(self);
            TDockTimer(fInternalTimer).UnDock(Control);
          end;
        end;
      finally
        EnableAlign;
        Bands.EndUpdate;
        if (fMoveState = msSize) then
        begin
          R := Bands[PushIndex].ClientRect;
          if (RR.Left <> R.Left) or (RR.Top <> R.Top) and
            ((fSizeTick = 0) or ((GetTickCount - fSizeTick) > 100)) then
            fSizeTick := GetTickCount
          else
            fSizeTick := 0;
        end;
      end;
    end;
  end;
end;

procedure TControlBarCep.MouseUp(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
  if Button = mbLeft then
  begin
    fMoveState := msNone;
    UpdateCursor(HTCLIENT);
  end;
  inherited;
end;

procedure TControlBarCep.Notification(AComponent: TComponent;
  Operation: TOperation);
var I, J: integer;
begin
  inherited;
  if (fBands <> nil) and (Operation = opRemove) and (AComponent is TSpeedButtonCepSpecial) then
  begin
    for I := 0 to fBands.Count - 1 do
      if fBands[I].fButtonCollection <> nil then
        for J := fBands[I].fButtonCollection.Count - 1 downto 0 do
          if TBandButton(fBands[I].fButtonCollection.Items[J]).fButton = AComponent then
          begin
            TBandButton(fBands[I].fButtonCollection.Items[J]).fButton := nil;
            fBands[I].fButtonCollection.Items[J].Free;
          end;
  end;
end;

procedure TControlBarCep.DockOver(Source: TDragDockObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  inherited;
  Accept := Accept and (not ((Source.Control.Parent is TXToolDockFormCep) and
    (TXToolDockFormCep(Source.Control.Parent).SysButtonPushed)));
  if (not Accept) and (fInternalTimer <> nil) then
    fInternalTimer.Stop;
  if Accept then
  begin
    case State of
      dsDragEnter: begin
          if fInternalTimer = nil then
            fInternalTimer := TDockTimer.Create(self);
          TDockTimer(fInternalTimer).Dock(Source);
        end;
      dsDragLeave: begin
          if (fInternalTimer <> nil) then
            fInternalTimer.Stop;
        end;
      dsDragMove: begin
        end;
    end;
  end;
end;

constructor TControlBarCep.Create(AOwner: TComponent);
begin
  inherited;
  DoubleBuffered := true;
  DragKind := dkDock;
  fRowSize := 32;
  Align := alTop;
  AutoSize := true;
  ParentColor := true;
  Ctl3d := true;
  ParentCtl3d := true;
  ControlStyle := ControlStyle + [csAcceptsControls];
  DockSite := true;
  fUpdateInterval := 300;
  fCornerEdge := ceMedium;
  FDrawingStyle := dsGradient;
  FGradientDirection := gdVertical;
  FGradientStartColor := clDefault;
  FGradientEndColor := clDefault;
end;

procedure TControlBarCep.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.Style := Params.Style or WS_CLIPCHILDREN;
end;

procedure TControlBarCep.CreateWindowHandle(const Params: TCreateParams);
begin
  inherited;
  SetTimer;
end;

procedure TControlBarCep.DestroyWindowHandle;
begin
  KillTimer;
  inherited;
end;

procedure TControlBarCep.DblClick;
var Pt: TPoint;
  I: integer;
  R: TRect;
begin
  inherited;
  if not Fixed then
  begin
    Pt := Mouse.CursorPos;
    Pt := ScreenToClient(Pt);
    if HitTest(Pt.X, Pt.Y, I) = HTCAPTION then
    begin
      if (not Bands[I].DropDownPushed) and
        (TControlEx(Bands[I].Control).DragKind = dkDock) then
      begin
        R := Bands[I].ClientRect;
        R.TopLeft := ClientToScreen(R.TopLeft);
        R.BottomRight := ClientToScreen(R.BottomRight);
        //OffsetRect(R, -GetSystemMetrics(SM_CXFRAME)*10, -(GetSystemMetrics(SM_CYCAPTION)));
        //SendMessage(Handle, WM_LBUTTONUP, MK_LBUTTON, Integer(PointToSmallPoint(Pt)));
        Bands[I].Control.ManualFloat(R);
      end;
    end;
  end;
end;

destructor TControlBarCep.Destroy;
begin
  FreeAndNil(fBands);
  inherited;
end;

function TControlBarCep.GetBandClass: TBandCepStyleClass;
begin
  result := nil;
end;

function TControlBarCep.GetBands: TBandsCepStyle;
var BandClass: TBandCepStyleClass;
begin
  if (not (csDestroying in ComponentState)) and (fBands = nil) then
  begin
    BandClass := GetBandClass;
    if BandClass = nil then BandClass := TBandCepStyle;
    fBands := TBandsCepStyle.Create(self, BandClass);
    fBands.BeginUpdate;
    try
      fBands.RowSize := fRowSize;
      fRowSize := fBands.RowSize;
      if Align in [alRight, alLeft] then
        fBands.Orientation := boTopToBottom
      else
        fBands.Orientation := boLeftToRight;
    finally
      fBands.EndUpdate;
    end;
  end;
  result := fBands;
end;

function TControlBarCep.GetRowSize: integer;
begin
  result := fRowSize;
end;

procedure TControlBarCep.RepaintAllocated;
var
  I: Integer;
begin
  if HandleAllocated then
    Repaint;
  if fBands <> nil then
    for I := 0 to fBands.Count - 1 do
      if (fBands[I].Control <> nil) and
        (fBands[I].Control is TWinControl) and
        (TWinControl(fBands[I].Control).HandleAllocated) then
      begin
        TWinControl(fBands[I].Control).Repaint;
      end;
end;

procedure TControlBarCep.DoBandPaint(Control: TControl; Canvas: TCanvas;
  var ARect: TRect; var Options: TBandPaintOptions);
begin
  if Assigned(FOnBandPaint) then
    FOnBandPaint(Self, Control, Canvas, ARect, Options);
end;

function TControlBarCep.DoBeginBandMove(Control: TControl): Boolean;
begin
  Result := True;
  if Assigned(FOnBeginBandMove) then
    FOnBeginBandMove(Self, Control, Result);
end;

procedure TControlBarCep.SetCornerEdge(const Value: TCornerEdge);
begin
  if FCornerEdge <> Value then
  begin
    FCornerEdge := Value;
    RepaintAllocated;
  end;
end;

procedure TControlBarCep.AddControl(Control: TControl; R: TRect);
var Band: TBandCepStyle;
  W, H: integer;
  OldOrientation: TBarOrientation;
begin
  if (not (Control is TSpeedButtonCepSpecial)) and (Control <> nil) then
  begin
    Band := BandByControl(Control);
    if Band <> nil then Exit;
    DisableAlign;
    Bands.BeginUpdate;
    try
      W := R.Right - R.Left;
      H := R.Bottom - R.Top;
      if (Control is TCustomActionDockBar) and (Control <> fDockedControl) then
      begin
        OldOrientation := TCustomActionDockBar(Control).Orientation;
        if Bands.IsVert then
          TCustomActionDockBar(Control).Orientation := boTopToBottom
        else
          TCustomActionDockBar(Control).Orientation := boLeftToRight;
        if (OldOrientation <> TCustomActionDockBar(Control).Orientation) then
        begin
          if Bands.IsVert then
          begin
            W := 0;
            H := 2096;
          end else
          begin
            H := 0;
            W := 2096;
          end;
          TCustomActionDockBarEx(Control).CanAutoSize(W, H);
        end;
        TCustomActionDockBarEx(Control).AutoSizing := false;
      end;
      UpdateWH(Control, W, H);
      Control.SetBounds(R.Left, R.Top, W, H);
      Bands.Add(Control);
    finally
      Bands.EndUpdate;
      EnableAlign;
    end;
  end;
end;

procedure TControlBarCep.SetControlsLoaded(const Value: boolean);
begin
  if fControlsLoaded <> Value then
  begin
    if Value then
      BandsChanged
    else
      FreeAndNil(fBands);
    fControlsLoaded := Value;
  end;
end;

procedure TControlBarCep.SetDrawingStyle(const Value: TBandDrawingStyle);
begin
  if FDrawingStyle <> Value then
  begin
    FDrawingStyle := Value;
    RepaintAllocated;
  end;
end;

procedure TControlBarCep.SetFixed(const Value: boolean);
begin
  if fFixed <> Value then
  begin
    fFixed := Value;
    RepaintAllocated;
  end;
end;

procedure TControlBarCep.SetGradientDirection(
  const Value: TGradientDirection);
begin
  if FGradientDirection <> Value then
  begin
    FGradientDirection := Value;
    RepaintAllocated;
  end;
end;

procedure TControlBarCep.SetGradientEndColor(const Value: TColor);
begin
  if FGradientEndColor <> Value then
  begin
    FGradientEndColor := Value;
    RepaintAllocated;
  end;
end;

procedure TControlBarCep.PaintWindow(DC: HDC);
var
  I: Integer;
  Canvas: TCanvas;
begin
  Canvas := TCanvas.Create;
  try
    Canvas.Handle := DC;
    Canvas.Brush.Color := Color;
    Canvas.FillRect(ClientRect);
    for I := 0 to Bands.Count - 1 do
      if Bands[I].Visible then
      begin
        Bands[I].PaintToCanvas(Canvas);
      end;
  finally
    Canvas.Handle := 0;
    FreeAndNil(Canvas);
  end;
end;

procedure TControlBarCep.WMERASEBKGND(var Message: TWMERASEBKGND);
  procedure DrawDesignBorder;
  var Pen, OldPen: HPen;
    OldBrush, Brush: HBrush;
  begin
    Pen := 0;
    Brush := 0;
    OldBrush := 0;
    OldPen := 0;
    try
      if csDesigning in ComponentState then
        Pen := CreatePen(PS_DOT, 1, GetShadowColor(clBtnFace))
      else
        Pen := CreatePen(ps_Solid, 1, ColorToRGB(Color));
      try
        Brush := CreateSolidBrush(ColorToRGB(Color));
        OldBrush := SelectObject(Message.DC, Brush);
        OldPen := SelectObject(Message.DC, Pen);
        Rectangle(Message.DC, 0, 0, ClientWidth, ClientHeight);
      finally
        SelectObject(Message.DC, OldBrush);
        SelectObject(Message.DC, OldPen);
      end;
    finally
      DeleteObject(Pen);
      DeleteObject(Brush);
    end;
  end;
begin
//  inherited;
  if (fBands = nil) or (fBands.Count = 0) then
  begin
    DrawDesignBorder;
  end else
  begin
    Message.Result := 1;
  end;
end;

procedure TControlBarCep.WMTIMER(var Message: TWMTIMER);
begin
  if (Message.TimerID = IDEventTimer) and (fBands <> nil) and (Bands.Count > 0) then
  begin
    UpdateBandsProperties;
  end else
    inherited;
end;

procedure TControlBarCep.SetGradientStartColor(const Value: TColor);
begin
  if FGradientStartColor <> Value then
  begin
    FGradientStartColor := Value;
    RepaintAllocated;
  end;
end;

procedure TControlBarCep.SetParent(AParent: TWinControl);
begin
  inherited;
  if (Parent <> AParent) and (AParent <> nil) then
  begin
    Bands.DoAligned;
  end;
end;

procedure TControlBarCep.SetPushIndex(const Value: integer);
begin
  if fPushIndex <> Value then
  begin
    fPushIndex := Value;
    Invalidate;
  end;
end;

procedure TControlBarCep.SetRowSize(const Value: integer);
begin
  if fRowSize <> Value then
  begin
    fRowSize := value;
    if fBands <> nil then
    begin
      fBands.BeginUpdate;
      try
        if AutoSize then
        begin
          fAutoHeight := 0;
          fAutoWidth := 0;
        end;
        fBands.RowSize := fRowSize;
        fRowSize := fBands.RowSize;
      finally
        fBands.EndUpdate;
        Realign;
        RepaintAllocated;
      end;
    end;
  end;
end;

procedure TControlBarCep.KillTimer;
begin
  if (fTimer <> 0) and HandleAllocated then
  begin
    if not Windows.KillTimer(Handle, IDEventTimer) then
      RaiseLastOsError
    else
      fTimer := 0;
  end;
end;

procedure TControlBarCep.SetTimer;
begin
  if (fUpdateInterval > 0) and HandleAllocated then
  begin
    fTimer := Windows.SetTimer(Handle, IDEventTimer, fUpdateInterval, nil);
    if fTimer = 0 then
      RaiseLastOsError;
  end;
end;

procedure TControlBarCep.SetUpdateInterval(const Value: integer);
begin
  if fUpdateInterval <> Value then
  begin
    KillTimer;
    fUpdateInterval := Value;
    SetTimer;
  end;
end;


initialization
  Screen.Cursors[CrHandMoved] := LoadCursorEx('CRHANDMOVED');
  Screen.Cursors[CrHandMoveable] := LoadCursorEx('CRHANDMOVEABLE');
  Screen.Cursors[CrHand] := LoadCursorEx('CRHAND');

end.

