unit FormImageListCep;
(*
 * Module:            TImageListCep
 * Version:    004.00 (08.04.2011)
 * Author:      
 * Comments:    y     .
 *             http://roschinspb.narod.ru
 *             http://www.delphikingdom.com/asp/users.asp?ID=1271
 *
 * Copyright:   2011 .
 *)
interface

{$I Directives.inc}

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ImgList,
  ImageListCep,
  ActnList,
  Grids,
  SysConst,
  ExtDlgs,
  StdCtrls,
  ExtCtrls,
  InternalTimer,
  Mask,
  jpeg { , PNGIMAGE };

resourcestring
  StrSDxdd = '%s (%dx%d) [%d]';
  StrAOwnerError = 'AOwner   TFormDlgSIL';
  ResLoadError = ' %d    "%s"' + #13#10 + '%s';
  ErrorFormat = ' "%s"  ';

type
  TTypeAdd = (taScale, taCenter, taDiv);
  {$IFNDEF DELPHI_8_UP}
  _STARTUPINFO = _STARTUPINFOA;
  {$ENDIF}

  TFormOpenResource = class(TCustomForm)
  private
    fHotIndex: integer;
    fSelIndexes: array of integer;
    fPaintBox: TControl;
    fFileName: string;
    fResourceName: string;
    fhInstance: integer;
    fIcons: TStringList;
    fImageWidth: integer;
    fImageHeight: integer;
    procedure SetFileName(const Value: string);
    procedure FreeHinstance;
    procedure UpdateHinstance;
    function NameByIndex(Index: integer): string;
    function IsSelectedIndex(Index: integer): boolean;
    procedure SelectIndex(Index: integer);
    procedure UnSelectIndex(Index: integer);
    procedure ClickOk(Sender: TObject);
    procedure ClickCancel(Sender: TObject);
  protected
  published
    constructor Create(AOwner: TComponent; AImageWidth: integer = 32; AImageHeight: integer = 32); reintroduce;
    property FileName: string read fFileName write SetFileName;
    property ResourceName: string read fResourceName;
    property ImageWidth: integer read fImageWidth;
    property ImageHeight: integer read fImageHeight;
    destructor Destroy; override;
  end;

  TFormProp = class(TCustomForm)
  private
    fChild: TPersistent;
    feWidth: TMaskEdit;
    feHeight: TMaskEdit;
    feCount: TMaskEdit;
    {$IFDEF VER130}{$ELSE}
    fColorBox: TColorBox;
    {$ENDIF}
    fResourceBox: TComboBox;
    fEditFileName: TMaskEdit;
    fButtonBrowse: TButton;
    fDLGopen: TOpenDialog;
    fCheckAuto: TCheckBox;
    fCheckDOM: TCheckBox;
    procedure ClickOk(Sender: TObject);
    procedure ClickBrowse(Sender: TObject);
    procedure UpdateResourceNames;
    procedure ClickAuto(Sender: TObject);
    procedure UpdateEnableSize;
    procedure ClickDom(Sender: TObject);
  public
    constructor Create(AOwner: TComponent; AChild: TPersistent); reintroduce;
    procedure DoShow; override;
    property Child: TPersistent read fChild;
  end;

  TOpenPictureDialogCep = class(TOpenPictureDialog)
  private
    {$IFDEF VER130}
    {$ELSE}
    FSavedFilename: string;
    {$ENDIF}
  protected
    procedure DoSelectionChange; override;
  private

  end;

  TFormDlgSIL = class(TForm)
    ButtonAdd: TButton;
    ActionList1: TActionList;
    ActionAdd: TAction;
    ActionInsert: TAction;
    ButtonInsert: TButton;
    ActionDel: TAction;
    ButtonDelete: TButton;
    GroupTypeAdd: TRadioGroup;
    GroupSize: TGroupBox;
    Label1: TLabel;
    EHeight: TMaskEdit;
    eWidth: TMaskEdit;
    CDefaultSize: TCheckBox;
    ActionApply: TAction;
    ButtonApply: TButton;
    ButtonCancel: TButton;
    ActionClose: TAction;
    ActionOk: TAction;
    ButtonOk: TButton;
    ActionMoveNext: TAction;
    ActionMovePrior: TAction;
    ButtonProps: TButton;
    ActionAddStandart: TAction;
    ActionDelResource: TAction;
    ActionPropResource: TAction;
    ActionProps: TAction;
    ActionExport: TAction;
    ButtonExport: TButton;
    SaveDialog1: TSaveDialog;
    ActionExportAll: TAction;
    ActionAddResource: TAction;
    procedure InternalImageListChange(Sender: TObject);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState; WheelDelta: integer; MousePos: TPoint;
      var Handled: boolean);
    procedure ActionAddExecute(Sender: TObject);
    procedure ActionInsertExecute(Sender: TObject);
    procedure ActionDelUpdate(Sender: TObject);
    procedure ActionDelExecute(Sender: TObject);
    procedure MEKeyPress(Sender: TObject; var Key: Char);
    procedure EChange(Sender: TObject);
    procedure CDefaultSizeClick(Sender: TObject);
    procedure GroupTypeAddClick(Sender: TObject);
    procedure ActionPriorExecute(Sender: TObject);
    procedure ActionNextExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ActionApplyExecute(Sender: TObject);
    procedure ActionCloseExecute(Sender: TObject);
    procedure ActionOkExecute(Sender: TObject);
    procedure ActionMoveNextExecute(Sender: TObject);
    procedure ActionMovePriorExecute(Sender: TObject);
    procedure ActionAddStandartExecute(Sender: TObject);
    procedure ActionAddBBResourceExecute(Sender: TObject);
    procedure ActionAddStandartUpdate(Sender: TObject);
    procedure ActionDelResourceExecute(Sender: TObject);
    procedure ActionPropResourceExecute(Sender: TObject);
    procedure ActionPropsExecute(Sender: TObject);
    procedure ActionExportExecute(Sender: TObject);
    procedure ActionExportUpdate(Sender: TObject);
    procedure ActionExportAllExecute(Sender: TObject);
    procedure ActionAddResourceExecute(Sender: TObject);
  private
    { Private declarations }
    fItemIndex: integer;
    fAddedWidth: integer;
    fAddedHeight: integer;
    fAddedDefaultSize: boolean;
    fTypeAdd: TTypeAdd;
    fInternalImageList: TImageListCep;
    fImageListCep: TImageListCep;
    fGrid: TCustomGrid;
    fItemDel: TObject;
    fItemProp: TObject;
    fOpenPictureDialogCep: TOpenPictureDialogCep;
    fModified: boolean;
    fTimerUpdateGrid: TInternalTimer;
    procedure OpenFile(FileName: string; Index: integer; Image: TImage = nil);
    procedure SetItemIndex(const Value: integer);
    procedure SetAddedHeight(const Value: integer);
    procedure SetAddedWidth(const Value: integer);
    procedure SetAddedDefaultSize(const Value: boolean);
    procedure SetTypeAdd(const Value: TTypeAdd);
    procedure UpdateESize;
    procedure SetInternalImageList(const Value: TImageListCep);
    procedure SetImageListCep(const Value: TImageListCep);
    procedure CreatePopupMenuGrid(const SelResource: integer);
    procedure PopupUpdate(Sender: TObject);
    function CreateMenuItem(Action: TAction): TObject;
    procedure UpdateGrid;
    procedure UpdateCaption;
    procedure SaveToRes(B: TBitmap);
    procedure DoExport(All: boolean);
    procedure DrawPreview(ImgList: TImageListCep; Image: TImage);
    procedure UpdateGridByTimer(Sender: TObject);
  protected
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    //        
    //         False
    function LoadFiles(Ext: string; //  
      Instance: hinst; //   
      FileNames: string; //  ,   ( Instance<>0)
      Width, Height: integer; //   
      var Bitmap: TBitmap): boolean; virtual;
    procedure DoShow; override;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property Modified: boolean read fModified;
    property ItemIndex: integer read fItemIndex write SetItemIndex;
    property AddedWidth: integer read fAddedWidth write SetAddedWidth;
    property AddedHeight: integer read fAddedHeight write SetAddedHeight;
    property AddedDefaultSize: boolean read fAddedDefaultSize write SetAddedDefaultSize;
    property TypeAdd: TTypeAdd read fTypeAdd write SetTypeAdd;
    property InternalImageList: TImageListCep read fInternalImageList;
    property ImageListCep: TImageListCep read fImageListCep write SetImageListCep;
    property OpenPictureDialogCep: TOpenPictureDialogCep read fOpenPictureDialogCep;
  end;

var
  FormDlgSIL: TFormDlgSIL;

const
  Margin = 8;

implementation

uses ShellAPI,
  Menus,
  {$IFDEF VER130}{$ELSE}GraphUtil,{$ENDIF}GraphUtilEx;

resourcestring
  StrDel = ' ';
  ErrAChildType = 'AChild   TResourceName,  TCustomImg';
  StrProps = ' ';
  StrWidth = ' :';
  StrHeight = ' :';
  StrCount = ':';
  StrFileName = ' :';
  StrResourceName = ' :';
  StrTransparentColor = ' :';
  StrCancel = '';
  StrBrowse = '';
  StrOk = 'Ok';
  StrDOM = '  ';
  StrAuto = '';
  StrFileRes = '  ';
  StrExeDllexe = '   (*.exe; *.dll)|*.exe;*.dll|Bce(*.*)|*.*';
  {$R *.dfm}

type
  TImgGrid = class(TCustomGrid)
  private
    fForm: TFormDlgSIL;
    fTh: integer;
    fTw: integer;
    fMovedCol: integer;
    fNewCol: integer;
    fDragImageList: TDragImageList;
    fClickedRow: integer;
    procedure DrawDropPos(ARect: TRect; ACol: integer; ARow: integer);
    procedure WMDROPFILES(var Message: TWMDROPFILES);
      message WM_DROPFILES;
    procedure EventLeft(Sender: TObject);
    procedure EventRight(Sender: TObject);
  protected
    fTimer: TInternalTimer;
    function GetTimer(Event: TNotifyEvent): TInternalTimer;
    procedure DrawCell(ACol, ARow: Longint; ARect: TRect; AState: TGridDrawState); override;
    function DoMouseWheel(Shift: TShiftState; WheelDelta: integer; MousePos: TPoint): boolean; override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: integer); override;
    procedure DragOver(Source: TObject; X, Y: integer; State: TDragState; var Accept: boolean); override;
    procedure DoEndDrag(Target: TObject; X, Y: integer); override;
    procedure DoStartDrag(var DragObject: TDragObject); override;

    function GetDragImages: TDragImageList; override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure CreateParams(var Params: TCreateParams); override;
  public
    function SelectCell(ACol, ARow: Longint): boolean; override;
    property ClickedRow: integer read fClickedRow;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure UpdateGrid;
  end;

constructor TFormDlgSIL.Create(AOwner: TComponent);
begin
  inherited;
  fOpenPictureDialogCep := TOpenPictureDialogCep.Create(self);
  fOpenPictureDialogCep.Options := [ofHideReadOnly, ofAllowMultiSelect, ofEnableSizing];
  fOpenPictureDialogCep.Filter := GraphicFilter(TGraphic) + '|' + StrExeDllexe;
  fGrid := TImgGrid.Create(self);
  fInternalImageList := TImageListCep.Create(self);
  fInternalImageList.onChange := InternalImageListChange;
  AddedWidth := 32;
  AddedHeight := 32;
  AddedDefaultSize := true;
  TypeAdd := taDiv;
  KeyPreview := true;
  CreatePopupMenuGrid(-1);
  UpdateCaption;
end;

destructor TFormDlgSIL.Destroy;
begin
  inherited;
end;

procedure TFormDlgSIL.DrawPreview(ImgList: TImageListCep; Image: TImage);
var
  Dx, Dy, X, Y, i: integer;
begin
  if (Image <> nil) and (ImgList <> nil) then
  begin
    Image.Transparent := false;
    Image.Stretch := false;
    with Image.Picture.Bitmap do
    begin
      Width := Image.Width;
      Height := Image.Height;
      Canvas.Brush.Color := self.Color;
      Canvas.FillRect(Rect(0, 0, Width, Height));
      Y := Height div (ImgList.Height);
      if Y < 1 then
        Y := 1;
      Dy := (Height - (Y * ImgList.Height)) div (Y + 1);
      X := Width div (ImgList.Width);
      if X < 1 then
        X := 1;
      Dx := (Width - (X * ImgList.Width)) div (X + 1);

      X := Dx;
      Y := Dy;
      Canvas.Brush.Style := bsClear;
      for i := 0 to ImgList.Count - 1 do
      begin
        Canvas.Pen.Color := clBtnShadow;
        Canvas.MoveTo(X, Y + ImgList.Height);
        Canvas.LineTo(X + ImgList.Width, Y + ImgList.Height);
        Canvas.LineTo(X + ImgList.Width, Y - 1);
        Canvas.Pen.Color := clBtnHighlight;
        Canvas.MoveTo(X + ImgList.Width - 1, Y - 1);
        Canvas.LineTo(X - 1, Y - 1);
        Canvas.LineTo(X - 1, Y + ImgList.Height);
        ImgList.Draw(Canvas, X, Y, i, true);
        if ((X + 2 * (ImgList.Width + Dx)) > Width) and (X > Dx) then
        begin
          X := Dx;
          inc(Y, ImgList.Height + Dy);
        end
        else
          inc(X, ImgList.Width + Dx);
        if Y + Dy > Height then
          Break;
      end;
    end;
  end;
end;

procedure TFormDlgSIL.DoExport(All: boolean);
var
  B: TBitmap;
  FileExt: string;
  procedure UpdateBitmap(Img: TCustomImg);
  var
    i: integer;
  begin
    with Img do
    begin
      B.Width := Count * Width;
      B.Height := Height;
      if (BlendColor = clNone) or (BlendColor = clDefault) then
        B.Canvas.Brush.Color := clFuchsia
      else
        B.Canvas.Brush.Color := BlendColor;
      B.Canvas.FillRect(Rect(0, 0, B.Width, B.Height));
      for i := 0 to Count - 1 do
        Draw(B.Canvas, i * Width, 0, i);
    end;
  end;

begin
  B := TBitmap.Create;
  try
    B.PixelFormat := pf32Bit;
    if All then
      UpdateBitmap(InternalImageList)
    else
      UpdateBitmap(InternalImageList.CustomImg);
    FileExt := ExtractFileExt(SaveDialog1.FileName);
    B.PixelFormat := pf24Bit;
    if UpperCase(FileExt) = '.RES' then
      SaveToRes(B)
    else
      B.SaveToFile(SaveDialog1.FileName);
  finally
    FreeAndNil(B);
  end;
end;

procedure TFormDlgSIL.DoShow;
begin
  fModified := false;
  inherited;
end;

procedure TFormDlgSIL.SaveToRes(B: TBitmap);
var
  STARTUPINFO: _STARTUPINFO;
  PROCESS: _PROCESS_INFORMATION;
  A: array[0..255] of Char;
  Path, FileName, TmpFileName, RCFileName: string;
  List: TStringList;
begin
  List := nil;
  FileName := SaveDialog1.FileName;
  RCFileName := ChangeFileExt(FileName, '.RC');
  Path := ExtractFilePath(FileName);
  FileName := ExtractFileName(FileName);
  GetTempFileName(PChar(Path), 'Cep', 0, @A);
  TmpFileName := string(PChar(@A));
  B.SaveToFile(TmpFileName);
  try
    List := TStringList.Create;
    List.Text := UpperCase(ChangeFileExt(FileName, '')) + ' BITMAP ' + AnsiQuotedStr(TmpFileName, '"');
    List.SaveToFile(RCFileName);
    try
      List.Clear;
      ZeroMemory(@STARTUPINFO, SizeOf(STARTUPINFO));
      STARTUPINFO.cb := SizeOf(STARTUPINFO);
      STARTUPINFO.dwFlags := STARTF_USESHOWWINDOW;
      STARTUPINFO.wShowWindow := SW_HIDE;
      ZeroMemory(@PROCESS, SizeOf(PROCESS));
      if CreateProcess(nil, PChar('BRCC32.EXE ' + AnsiQuotedStr(RCFileName, '"')), nil, nil, true, CREATE_NEW_CONSOLE,
        nil, nil, STARTUPINFO, PROCESS) then
      begin
        WaitForSingleObject(PROCESS.hProcess, 5000);
        CloseHandle(PROCESS.hProcess);
        CloseHandle(PROCESS.hThread);
      end
      else
        RaiseLastOsError;
    finally
      DeleteFile(RCFileName);
    end;
  finally
    List.Free;
    DeleteFile(TmpFileName);
  end;
end;

procedure TFormDlgSIL.UpdateCaption;
begin
  if fImageListCep <> nil then
  begin
    if fImageListCep.Name = '' then
      Caption := fImageListCep.ClassType.ClassName
    else
      Caption := fImageListCep.Name;
    if fImageListCep.DirName <> '' then
    begin
      OpenPictureDialogCep.InitialDir := fImageListCep.DirName;
    end;
  end
  else
    Caption := '';
end;

function TFormDlgSIL.CreateMenuItem(Action: TAction): TObject;
var
  Item: TMenuItem;
begin
  Item := TMenuItem.Create(fGrid);
  try
    Item.Action := Action;
    TImgGrid(fGrid).PopupMenu.Items.Add(Item);
    result := Item;
  except
    FreeAndNil(Item);
    raise;
  end;
end;

procedure TFormDlgSIL.CreatePopupMenuGrid(const SelResource: integer);
var
  Item: TMenuItem;
begin
  if TImgGrid(fGrid).PopupMenu = nil then
  begin
    TImgGrid(fGrid).PopupMenu := TPopupMenu.Create(fGrid);
    try
      TImgGrid(fGrid).PopupMenu.OnPopup := PopupUpdate;
      fItemProp := CreateMenuItem(ActionPropResource);
      CreateMenuItem(ActionAddStandart);
      CreateMenuItem(ActionAddResource);
      Item := TMenuItem.Create(fGrid);
      Item.Caption := '-';
      TImgGrid(fGrid).PopupMenu.Items.Add(Item);
      fItemDel := CreateMenuItem(ActionDelResource);
    except
      TImgGrid(fGrid).PopupMenu.Free;
      TImgGrid(fGrid).PopupMenu := nil;
      raise;
    end;
  end;
  with InternalImageList do
    if (SelResource < 0) or (SelResource > ResourceNames.Count) then
    begin
      ActionDelResource.Caption := StrDel;
      ActionDelResource.Enabled := false;
      ActionDelResource.Tag := -1;
      ActionPropResource.Caption := StrProps;
      ActionPropResource.Enabled := false;
      ActionPropResource.Tag := -1;
    end
    else
    begin
      ActionDelResource.Tag := SelResource;
      ActionPropResource.Tag := SelResource;
      ActionPropResource.Enabled := true;
      if SelResource >= ResourceNames.Count then
      begin
        ActionDelResource.Caption := StrDel + CustomImg.Name + '...';
        ActionDelResource.Enabled := CustomImg.Count > 0;
        ActionPropResource.Caption := StrProps + CustomImg.Name + '...';
      end
      else
      begin
        ActionDelResource.Caption := StrDel + ResourceNames.Items[SelResource].Name + '...';
        ActionDelResource.Enabled := true;
        ActionPropResource.Caption := StrProps + ResourceNames.Items[SelResource].Name + '...';
      end;
    end;

end;

procedure TFormDlgSIL.PopupUpdate(Sender: TObject);
begin
  CreatePopupMenuGrid(TImgGrid(fGrid).ClickedRow);
end;

procedure TFormDlgSIL.ActionPriorExecute(Sender: TObject);
begin
  if ItemIndex > 0 then
    ItemIndex := ItemIndex - 1;
end;

procedure TFormDlgSIL.ActionPropResourceExecute(Sender: TObject);
var
  Obj: TPersistent;
  F: TFormProp;
  Pt: TPoint;
begin
  Obj := nil;
  if Sender is TAction then
    with InternalImageList do
    begin
      if TAction(Sender).Tag >= ResourceNames.Count then
        Obj := InternalImageList.CustomImg
      else if TAction(Sender).Tag >= 0 then
        Obj := InternalImageList.ResourceNames.Items[TAction(Sender).Tag];
    end;
  if Obj <> nil then
  begin
    F := TFormProp.Create(self, Obj);
    try
      Pt := Mouse.CursorPos;
      Dec(Pt.X, 32);
      Dec(Pt.Y, 16);
      if Pt.X < 0 then
        Pt.X := 0;
      if Pt.Y < 0 then
        Pt.Y := 0;

      F.SetBounds(Pt.X, Pt.Y, F.Width, F.Height);
      F.ShowModal;
    finally
      FreeAndNil(F);
    end;
  end;
end;

procedure TFormDlgSIL.ActionPropsExecute(Sender: TObject);
var
  F: TFormProp;
  Pt: TPoint;
begin
  F := TFormProp.Create(self, self.InternalImageList);
  try
    Pt := Point(0, ButtonProps.Height);
    Pt := ButtonProps.ClientToScreen(Pt);
    F.Left := Pt.X;
    F.Top := Pt.Y;
    if ImageListCep <> nil then
      F.Caption := ImageListCep.Name;
    F.ShowModal;
    // UpdateGrid;
  finally
    FreeAndNil(F);
  end;
end;

procedure TFormDlgSIL.ActionAddBBResourceExecute(Sender: TObject);
begin
  Repaint;
end;

procedure TFormDlgSIL.ActionAddStandartExecute(Sender: TObject);
begin
  InternalImageList.ResourceNames.AddDefault;
end;

procedure TFormDlgSIL.ActionAddStandartUpdate(Sender: TObject);
begin
  if Sender is TAction then
    with InternalImageList.ResourceNames do
    begin
      TAction(Sender).Enabled := FindItemByName(StandartResourceName) < 0;
    end;
end;

procedure TFormDlgSIL.ActionApplyExecute(Sender: TObject);
begin
  if ImageListCep <> nil then
  begin
    ImageListCep.Assign(InternalImageList);
    fImageListCep.DirName := OpenPictureDialogCep.InitialDir;
    fModified := true;
  end;
end;

procedure TFormDlgSIL.ActionCloseExecute(Sender: TObject);
begin
  Close;
end;

procedure TFormDlgSIL.ActionAddExecute(Sender: TObject);
begin
  if OpenPictureDialogCep.Execute then
  begin
    OpenPictureDialogCep.InitialDir := ExtractFilePath(OpenPictureDialogCep.FileName);
    OpenFile('', InternalImageList.CustomImg.Count);
  end;
end;

procedure TFormDlgSIL.ActionAddResourceExecute(Sender: TObject);
var
  Obj: TPersistent;
  F: TFormProp;
  Pt: TPoint;
begin
  Obj := InternalImageList.ResourceNames.Add;
  if Obj <> nil then
  begin
    F := TFormProp.Create(self, Obj);
    try
      Pt := Mouse.CursorPos;
      Dec(Pt.X, 32);
      Dec(Pt.Y, 16);
      if Pt.X < 0 then
        Pt.X := 0;
      if Pt.Y < 0 then
        Pt.Y := 0;

      F.SetBounds(Pt.X, Pt.Y, F.Width, F.Height);
      if F.ShowModal = idCancel then
        InternalImageList.ResourceNames.Delete(InternalImageList.ResourceNames.Count - 1);
    finally
      FreeAndNil(F);
    end;
  end;
end;

procedure TFormDlgSIL.ActionDelExecute(Sender: TObject);
var
  N: integer;
begin
  if Sender is TAction then
  begin
    N := InternalImageList.CustomImg.Count;
    if (N > 0) and (ItemIndex >= 0) and (ItemIndex < N) then
    begin
      InternalImageList.CustomImg.Delete(ItemIndex);
      Dec(N);
      if (ItemIndex >= N) and (N > 0) then
        ItemIndex := N - 1;
    end;
  end;
end;

procedure TFormDlgSIL.ActionDelResourceExecute(Sender: TObject);
begin
  if Sender is TAction then
    with InternalImageList do
    begin
      if TAction(Sender).Tag >= ResourceNames.Count then
      begin
        InternalImageList.CustomImg.Clear;
        ItemIndex := 0;
      end
      else if TAction(Sender).Tag >= 0 then
        InternalImageList.ResourceNames.Delete(TAction(Sender).Tag);
    end;
end;

procedure TFormDlgSIL.ActionDelUpdate(Sender: TObject);
var
  N: integer;
begin
  if Sender is TAction then
  begin
    N := InternalImageList.CustomImg.Count;
    TAction(Sender).Enabled := (N > 0) and (ItemIndex >= 0) and (ItemIndex < N);
  end;
end;

procedure TFormDlgSIL.ActionExportAllExecute(Sender: TObject);
begin
  if (InternalImageList.Count > 0) and (SaveDialog1.Execute) then
    DoExport(true);
end;

procedure TFormDlgSIL.ActionExportExecute(Sender: TObject);
begin
  if (InternalImageList.CustomImg.Count > 0) and (SaveDialog1.Execute) then
    DoExport(false);
end;

procedure TFormDlgSIL.ActionExportUpdate(Sender: TObject);
begin
  if Sender is TAction then
    TAction(Sender).Enabled := InternalImageList.CustomImg.Count > 0;
end;

procedure TFormDlgSIL.ActionInsertExecute(Sender: TObject);
begin
  if OpenPictureDialogCep.Execute then
  begin
    OpenPictureDialogCep.InitialDir := ExtractFilePath(OpenPictureDialogCep.FileName);
    OpenFile('', ItemIndex);
  end;
end;

procedure TFormDlgSIL.ActionMoveNextExecute(Sender: TObject);
begin
  if ItemIndex < InternalImageList.CustomImg.Count - 1 then
  begin
    MoveIMG(InternalImageList.CustomImg, ItemIndex, ItemIndex + 1);
    ItemIndex := ItemIndex + 1;
  end;
end;

procedure TFormDlgSIL.ActionMovePriorExecute(Sender: TObject);
begin
  if (ItemIndex > 0) and (ItemIndex < InternalImageList.CustomImg.Count) then
  begin
    MoveIMG(InternalImageList.CustomImg, ItemIndex, ItemIndex - 1);
    ItemIndex := ItemIndex - 1;
  end;
end;

procedure TFormDlgSIL.ActionNextExecute(Sender: TObject);
begin
  if ItemIndex < InternalImageList.CustomImg.Count then
    ItemIndex := ItemIndex + 1;
end;

procedure TFormDlgSIL.ActionOkExecute(Sender: TObject);
begin
  ActionApply.Execute;
  Close;
end;

//        
//  .
//    ,   False

function TFormDlgSIL.LoadFiles(Ext: string; //   (ICO, BMP, DLL
  Instance: hinst; //   
  FileNames: string; //  ,   ( ';')
  Width, Height: integer; //   
  var Bitmap: TBitmap): boolean; // ,    (. . NIL)
begin
  result := not ((pos(Ext, 'EXE;DLL;BMP;ICO') = 0) and ((Bitmap = nil) or (Bitmap.Empty)));
end;

//      ,  
//  

procedure TFormDlgSIL.OpenFile(FileName: string; Index: integer; Image: TImage = nil);
var
  W, H, i, J, K, N: integer;
  S, GetFileName, IconsNames: string;
  Bmp: TBitmap;
  R: TRect;
  F: TFormOpenResource;
  ImgList: TImageListCep;
  Pic: TPicture;
  //   
  procedure LoadIcon(Ext: string; Instance: hinst; Name: string);
  var
    HI: HICON;
    PIconName: Pointer;
    S, GetName: string;
    Flag: Cardinal;
    i, J: integer;
  begin
    //       ';'
    J := 0;
    repeat
      i := pos(';', Name);
      if i = 0 then
      begin
        GetName := Name;
        Name := '';
      end
      else
      begin
        GetName := Copy(Name, 1, i - 1);
        Delete(Name, 1, i);
      end;

      HI := 0;
      Bmp := nil;
      try
        Flag := LR_LOADMAP3DCOLORS;
        if (Instance <> 0) and (GetName <> '') then
        begin
          if (GetName[1] = '#') then
          begin
            S := Copy(GetName, 2, Length(GetName));
            PIconName := MAKEINTRESOURCE(StrToInt(S));
          end
          else
            PIconName := PChar(GetName);
        end
        else
        begin
          PIconName := PChar(GetName);
          Flag := Flag or LR_LOADFROMFILE;
        end;
        HI := LoadImage(Instance, PIconName, IMAGE_ICON, W, H, Flag);
        Bmp := TBitmap.Create;
        Bmp.PixelFormat := pf32Bit;
        Bmp.Canvas.Brush.Color := ImgList.CustomImg.BkColor;
        Bmp.Width := ImgList.CustomImg.Width;
        Bmp.Height := ImgList.CustomImg.Height;
        if (Bmp.Canvas.Brush.Color = clDefault) or (Bmp.Canvas.Brush.Color = clNone) then
          Bmp.Canvas.Brush.Color := clBtnFace;
        Bmp.TransparentColor := Bmp.Canvas.Brush.Color;
        Bmp.TransparentMode := tmFixed;
        Bmp.Transparent := true;
        Bmp.Canvas.FillRect(Rect(0, 0, Bmp.Width, Bmp.Height));
        DrawIconEx(Bmp.Canvas.Handle, 0, 0, HI, Bmp.Width, Bmp.Height, 0, Bmp.Canvas.Brush.Handle, DI_NORMAL);
        if (not LoadFiles(Ext, Instance, GetName, W, H, Bmp)) and (Image = nil) then
          raise EInvalidGraphic.CreateFmt(ErrorFormat, [Ext]); ;
        if Bmp <> nil then
        begin
          ImgList.CustomImg.InsertBitmap(Index + J, Bmp);
          inc(J);
        end;
      finally
        Bmp.Free;
        DestroyIcon(HI);
      end;
    until Name = '';
  end;
  //  
  procedure LoadBmp(var Bmp: TBitmap);
  var
    TAdd: TTypeAdd;
  begin
    if (Bmp <> nil) then
    begin
      if not Bmp.Empty then
      begin
        TAdd := TypeAdd;
        //     
        if Image <> nil then
        begin
          if Bmp.Width * Bmp.Height > Image.Width * Image.Height then
          begin
            if Bmp.Width > Image.Width then
              Bmp.Width := ImgList.Width * ((Image.Width) div (ImgList.Width));
            if Bmp.Height > Image.Height then
              Bmp.Height := ImgList.Height * ((Image.Height) div (ImgList.Height));
          end;
        end;
        Bmp.PixelFormat := pf32Bit;
        Bmp.Transparent := true;
        case TAdd of
          taScale:
            ImgList.CustomImg.InsertBitmap(Index + J, Bmp);
          taCenter:
            begin
              R.Left := (Bmp.Width - W) div (2);
              R.Top := (Bmp.Height - H) div (2);
              R.Right := R.Left + W;
              R.Bottom := R.Top + H;
              ImgList.CustomImg.InsertBitmap(Index + J, Bmp, R);
            end;
          taDiv:
            begin
              ImgList.CustomImg.InsertBitmaps(Index + J, Bmp, W, H);
            end;
        end;
        inc(J);
      end;
    end;
  end;

begin
  if Image <> nil then //     ,
  begin //    
    ImgList := TImageListCep.Create(nil);
    Index := 0;
    with ImgList do
    begin
      Width := InternalImageList.CustomImg.Width;
      Height := InternalImageList.CustomImg.Height;
      BkColor := InternalImageList.BkColor;
      BlendColor := InternalImageList.BlendColor;
      with CustomImg do
      begin
        Width := InternalImageList.CustomImg.Width;
        Height := InternalImageList.CustomImg.Height;
        BkColor := InternalImageList.CustomImg.BkColor;
        BlendColor := InternalImageList.CustomImg.BlendColor;
      end;
    end;
  end
  else
    ImgList := InternalImageList;
  try
    J := 0;
    //    
    if FileName = '' then
    begin
      for i := 0 to OpenPictureDialogCep.Files.Count - 1 do
        if FileName = '' then
          FileName := OpenPictureDialogCep.Files[i]
        else
          FileName := FileName + ';' + OpenPictureDialogCep.Files[i];
    end;
    OpenPictureDialogCep.InitialDir := ExtractFilePath(FileName);
    //    
    if AddedDefaultSize then
    begin
      W := ImgList.CustomImg.Width;
      H := ImgList.CustomImg.Height;
    end
    else
    begin
      W := AddedWidth;
      H := AddedHeight;
    end;
    //       ';'
    repeat
      //     
      i := pos(';', FileName);
      if i = 0 then
      begin
        GetFileName := FileName;
        FileName := '';
      end
      else
      begin
        GetFileName := Copy(FileName, 1, i - 1);
        Delete(FileName, 1, i);
      end;
      //   
      S := ExtractFileExt(UpperCase(GetFileName));
      while (Length(S) > 0) and (S[1] = '.') do
        Delete(S, 1, 1);
      //      
      if S = 'ICO' then //    
      begin
        LoadIcon(S, 0, GetFileName);
      end
      else if (S = 'DLL') or (S = 'EXE') then //  DLL  EXE  
      begin //     
        F := TFormOpenResource.Create(self, W, H);
        try
          try
            F.FileName := GetFileName;
          except
            if Image <> nil then
              Image.Visible := false //      
            else
              raise;
          end;
          if Image <> nil then
          begin
            //      
            IconsNames := '';
            if F.fIcons <> nil then
              N := F.fIcons.Count - 1
            else
              N := -1;
            if N > 39 then
              N := 39; //    40,  
            for K := 0 to N do
            begin
              if IconsNames = '' then
                IconsNames := F.fIcons[K]
              else
                IconsNames := IconsNames + ';' + F.fIcons[K];
            end;
            LoadIcon(S, F.fhInstance, IconsNames);
          end
          else if F.ShowModal = IdOk then
          begin
            //    
            LoadIcon(S, F.fhInstance, F.ResourceName);
          end;
        finally
          FreeAndNil(F);
        end;
      end
      else if S = 'BMP' then
      begin
        Bmp := TBitmap.Create;
        try
          Bmp.LoadFromFile(GetFileName);
          if (not LoadFiles(S, 0, GetFileName, W, H, Bmp)) and (Image = nil) then
            raise EInvalidGraphic.CreateFmt(ErrorFormat, [S]); ;
          LoadBmp(Bmp);
        finally
          FreeAndNil(Bmp);
        end;
      end
      else
      begin //    
        Bmp := TBitmap.Create;
        try
          //      
          try
            Pic := TPicture.Create;
            try
              Bmp.PixelFormat := pf32Bit;
              Bmp.Canvas.Brush.Color := ImgList.CustomImg.BkColor;
              if (Bmp.Canvas.Brush.Color = clDefault) or (Bmp.Canvas.Brush.Color = clNone) then
                Bmp.Canvas.Brush.Color := clBtnFace;
              Bmp.TransparentColor := Bmp.Canvas.Brush.Color;
              Bmp.TransparentMode := tmFixed;
              Bmp.Transparent := true;
              Bmp.Canvas.FillRect(Rect(0, 0, Bmp.Width, Bmp.Height));
              // TPicture.LoadFromFile    
              //  .     
              // *.jpg    JPEG    ,  
              //    . .  RegisterFileFormat
              Pic.LoadFromFile(GetFileName);
              //     Bmp
              Bmp.Width := Pic.Graphic.Width;
              Bmp.Height := Pic.Graphic.Height;
              Bmp.Canvas.Draw(0, 0, Pic.Graphic);
            finally
              FreeAndNil(Pic);
            end;
          except
            //  ,    
            //   ,       
            // LoadFiles
            FreeAndNil(Bmp);
          end;
          if (not LoadFiles(S, 0, GetFileName, W, H, Bmp)) and (Image = nil) then
            raise EInvalidGraphic.CreateFmt(ErrorFormat, [S]); ;
          LoadBmp(Bmp);
        finally
          FreeAndNil(Bmp);
        end;
      end;
      if Image <> nil then
        Break; //       
    until FileName = '';
  finally
    try
      if Image <> nil then
      begin
        //     ,    
        //  
        ImgList.UpdateImages;
        DrawPreview(ImgList, Image);
      end;
    finally
      if ImgList <> InternalImageList then
        FreeAndNil(ImgList);
    end;
  end;
end;

procedure TFormDlgSIL.FormMouseWheel(Sender: TObject; Shift: TShiftState; WheelDelta: integer; MousePos: TPoint;
  var Handled: boolean);
var
  D, i: integer;
begin
  D := 0;
  if WheelDelta > 0 then
    D := -1;
  if WheelDelta < 0 then
    D := 1;
  if ssShift in Shift then
  begin
    if (D <> 0) and (InternalImageList.CustomImg.Count > 1) then
    begin
      i := ItemIndex;
      inc(i, D);
      if i < 0 then
        i := 0
      else if i >= InternalImageList.CustomImg.Count then
        i := InternalImageList.CustomImg.Count - 1;
      if i <> ItemIndex then
      begin
        if ssCtrl in Shift then
        begin
          MoveIMG(InternalImageList.CustomImg, ItemIndex, i);
        end;
        ItemIndex := i;
      end;
    end;
    Handled := true;
  end
  else
  begin
    Handled := true;
    i := TImgGrid(fGrid).LeftCol + D;
    if (i >= TImgGrid(fGrid).FixedCols) and (i + TImgGrid(fGrid).VisibleColCount <= TImgGrid(fGrid).ColCount) then
    begin
      TImgGrid(fGrid).LeftCol := i;
      fGrid.Repaint;
    end;
  end;
end;

procedure TFormDlgSIL.UpdateGrid;
begin
  if (fGrid <> nil) and (not (csDestroying in ComponentState)) then
  begin
    TImgGrid(fGrid).UpdateGrid;
  end;
end;

procedure TFormDlgSIL.FormShow(Sender: TObject);
begin
  ButtonAdd.Top := ClientHeight - ButtonAdd.Height;
  ButtonInsert.Top := ClientHeight - ButtonInsert.Height;
  ButtonDelete.Top := ClientHeight - ButtonDelete.Height;
  ButtonProps.Top := ClientHeight - ButtonProps.Height;
  ButtonExport.Top := ClientHeight - ButtonExport.Height;
  fGrid.Height := ButtonAdd.Top - fGrid.Top - 8;
  ButtonOk.Left := ClientWidth - ButtonOk.Width - ButtonOk.Top;
  ButtonCancel.Left := ButtonOk.Left;
  ButtonApply.Left := ButtonOk.Left;
  GroupSize.Width := ButtonOk.Left - GroupSize.Left - 8;
  UpdateGrid;
end;

procedure TFormDlgSIL.UpdateGridByTimer(Sender: TObject);
begin
  UpdateGrid;
end;

procedure TFormDlgSIL.InternalImageListChange(Sender: TObject);
begin
  if (fGrid <> nil) and (not (csDestroying in ComponentState)) then
  begin
    if fTimerUpdateGrid = nil then
      fTimerUpdateGrid := TInternalTimer.Create(self);
    fTimerUpdateGrid.ExecuteDelay(40, UpdateGridByTimer);
  end;
  //UpdateGrid;
end;

procedure TFormDlgSIL.MEKeyPress(Sender: TObject; var Key: Char);
begin
  if (Key = #13) and (Sender is TWinControl) then
  begin
    SelectNext(TWinControl(Sender), true, true);
    Key := #0;
  end;
  {$IFDEF DELPHI_2009_UP}
  if not CharInSet(Key, ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', #8]) then
    {$ELSE}
  if not (Key in ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', #8]) then
    {$ENDIF}
    Key := #0;
end;

procedure TFormDlgSIL.Notification(AComponent: TComponent; Operation: TOperation);
begin
  inherited;
  if csDestroying in ComponentState then
    Exit;
  if (AComponent = fInternalImageList) and (Operation = opRemove) then
  begin
    fInternalImageList := nil;
    SetInternalImageList(nil);
  end;
end;

procedure TFormDlgSIL.EChange(Sender: TObject);
var
  i: integer;
begin
  if TMaskEdit(Sender).Text = '' then
    TMaskEdit(Sender).Text := '32';
  if Sender is TMaskEdit then
  begin
    i := StrToInt(TMaskEdit(Sender).Text);
    if Sender = EHeight then
      AddedHeight := i;
    if Sender = eWidth then
      AddedWidth := i;
  end;
end;

procedure TFormDlgSIL.UpdateESize;
begin
  if (fAddedDefaultSize) or (fTypeAdd = taScale) then
  begin
    EHeight.Enabled := false;
    eWidth.Enabled := false;
    EHeight.ParentColor := true;
    eWidth.ParentColor := true;
  end
  else
  begin
    EHeight.Enabled := true;
    eWidth.Enabled := true;
    EHeight.Color := clWindow;
    eWidth.Color := clWindow;
  end;
end;

procedure TFormDlgSIL.SetAddedDefaultSize(const Value: boolean);
begin
  if fAddedDefaultSize <> Value then
  begin
    fAddedDefaultSize := Value;
    CDefaultSize.Checked := fAddedDefaultSize;
    UpdateESize;
  end;
end;

procedure TFormDlgSIL.SetAddedHeight(const Value: integer);
begin
  if fAddedHeight <> Value then
  begin
    fAddedHeight := Value;
    if fAddedHeight <= 1 then
      fAddedHeight := 1;
    // if fAddedHeight>128 then fAddedHeight := 128;
    EHeight.Text := inttostr(fAddedHeight);
  end;
end;

procedure TFormDlgSIL.SetAddedWidth(const Value: integer);
begin
  if fAddedWidth <> Value then
  begin
    fAddedWidth := Value;
    if fAddedWidth < 1 then
      fAddedWidth := 1;
    // if fAddedWidth>128 then fAddedWidth := 128;
    eWidth.Text := inttostr(fAddedWidth);
  end;
end;

procedure TFormDlgSIL.SetItemIndex(const Value: integer);
begin
  if fItemIndex <> Value then
  begin
    fItemIndex := Value;
    UpdateGrid;
  end;
end;

procedure TFormDlgSIL.SetImageListCep(const Value: TImageListCep);
begin
  if fImageListCep <> nil then
    fImageListCep.RemoveFreeNotification(self);
  fImageListCep := Value;
  if fImageListCep <> nil then
    fImageListCep.FreeNotification(self);
  SetInternalImageList(fImageListCep);
  UpdateCaption;
end;

procedure TFormDlgSIL.SetInternalImageList(const Value: TImageListCep);
begin
  fInternalImageList.Assign(Value);
end;

procedure TFormDlgSIL.SetTypeAdd(const Value: TTypeAdd);
begin
  if fTypeAdd <> Value then
  begin
    fTypeAdd := Value;
    GroupTypeAdd.ItemIndex := integer(fTypeAdd);
    if fTypeAdd = taScale then
    begin
      Label1.Enabled := false;
      CDefaultSize.Enabled := false;
    end
    else
    begin
      Label1.Enabled := true;
      CDefaultSize.Enabled := true;
    end;
    UpdateESize;
  end;
end;

procedure TFormDlgSIL.GroupTypeAddClick(Sender: TObject);
begin
  TypeAdd := TTypeAdd(GroupTypeAdd.ItemIndex);
end;

procedure TFormDlgSIL.CDefaultSizeClick(Sender: TObject);
begin
  AddedDefaultSize := CDefaultSize.Checked;
end;

{ TImgGrid }

constructor TImgGrid.Create(AOwner: TComponent);
var
  Y: integer;
begin
  inherited;
  DragCursor := 0;
  fNewCol := -1;
  if AOwner is TFormDlgSIL then
  begin
    fForm := TFormDlgSIL(AOwner);
    ParentColor := true;
    Options := [goFixedVertLine, goFixedHorzLine, goHorzLine, goDrawFocusSelected, goThumbTracking];
    RowCount := 1;
    DefaultDrawing := false;
    FixedRows := 0;
    Parent := fForm;
    Anchors := [akLeft, akTop, akRight, akBottom];
    Y := fForm.GroupSize.Top + fForm.GroupSize.Height + fForm.BorderWidth;
    SetBounds(0, Y, fForm.ClientWidth, fForm.ButtonAdd.Top - (Y + 2 * fForm.BorderWidth));
    ParentColor := true;
  end
  else
    raise Exception.Create(StrAOwnerError);
end;

destructor TImgGrid.Destroy;
begin
  FreeAndNil(fDragImageList);
  inherited;
end;

function TImgGrid.GetTimer(Event: TNotifyEvent): TInternalTimer;
begin
  if fTimer = nil then
    fTimer := TInternalTimer.Create(self);
  result := fTimer;
  if @Event = nil then
    fTimer.Stop
  else
    fTimer.ExecuteInterval(100, Event);
end;

procedure TImgGrid.EventLeft(Sender: TObject);
begin
  if LeftCol > FixedCols then
  begin
    LeftCol := LeftCol - 1;
    if (fMovedCol <> -1) and (fNewCol <> -1) then
      Dec(fNewCol);
    InvalidateRect(Handle, nil, true);
  end
  else
    GetTimer(nil);
end;

procedure TImgGrid.EventRight(Sender: TObject);
begin
  if LeftCol + VisibleColCount < ColCount then
  begin
    LeftCol := LeftCol + 1;
    if (fMovedCol <> -1) and (fNewCol <> -1) then
      inc(fNewCol);
    InvalidateRect(Handle, nil, true);
  end
  else
    GetTimer(nil);
end;

//          

function TImgGrid.DoMouseWheel(Shift: TShiftState; WheelDelta: integer; MousePos: TPoint): boolean;
begin
  fForm.DoMouseWheel(Shift, WheelDelta, MousePos);
  result := true;
end;

procedure TImgGrid.KeyDown(var Key: Word; Shift: TShiftState);
begin
  case Key of
    VK_END:
      begin
        fForm.ItemIndex := fForm.InternalImageList.CustomImg.Count - 1;
        Key := 0;
      end;
    VK_RIGHT:
      begin
        if ssCtrl in Shift then
        begin
          fForm.ActionMoveNext.Execute;
          Key := 0;
        end;
      end;
    VK_LEFT:
      begin
        if ssCtrl in Shift then
        begin
          fForm.ActionMovePrior.Execute;
          Key := 0;
        end;
      end;
  end;
  inherited;
end;

//        

procedure TImgGrid.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: integer);
var
  R: TRect;
  Pt: TPoint;
  C: TGridCoord;
begin
  if Button = mbRight then
  begin
    C := MouseCoord(X, Y);
    fClickedRow := C.Y - FixedRows;
  end
  else
    fClickedRow := -1;
  Pt := Point(X, Y);
  R := CellRect(Col, Row);
  if (Focused) and (Button = mbLeft) and PtInRect(R, Pt) and
    (Col - FixedCols < fForm.InternalImageList.CustomImg.Count) then
  begin
    fMovedCol := Col;
    BeginDrag(true);
  end
  else
    inherited;
end;

procedure TImgGrid.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: integer);
var
  Col: integer;
begin
  inherited;
  if (Button = mbLeft) and (fNewCol <> -1) then
  begin
    Col := fNewCol;
    fNewCol := -1;
    InvalidateCell(Col, RowCount - 1);
    InvalidateCell(Col - 1, RowCount - 1);
    FreeAndNil(fDragImageList);
  end;
end;

function TImgGrid.GetDragImages: TDragImageList;
begin
  {$IFDEF VER130}
  {$ELSE}
  if fDragImageList = nil then
    with fForm.InternalImageList do
    begin
      fDragImageList := TDragImageList.Create(nil);
      fDragImageList.Width := CustomImg.Width;
      fDragImageList.Height := CustomImg.Height;
      fDragImageList.AddImage(CustomImg, fMovedCol - FixedCols);
      {$IFDEF VER140}
      {$ELSE}
      {$IFDEF VER150}
      {$ELSE}
      fDragImageList.DragHotspot := Point((Width * 2) div (3), (Height * 2) div (3));
      {$ENDIF}
      {$ENDIF}
    end;
  {$ENDIF}
  result := fDragImageList;
end;

procedure TImgGrid.DoStartDrag(var DragObject: TDragObject);
{$IFDEF VER130}
var
  Dr: TDragControlObject;
  {$ELSE}
var
  Dr: TDragControlObjectEx;
  {$ENDIF}
begin
  inherited;
  {$IFDEF VER130}
  Dr := TDragControlObject.Create(self);
  {$ELSE}
  Dr := TDragControlObjectEx.Create(self);
  {$IFDEF VER140}
  {$ELSE}
  {$IFDEF VER150}
  {$ELSE}
  Dr.AlwaysShowDragImages := true;
  {$ENDIF}
  {$ENDIF}
  {$ENDIF}
  DragObject := Dr;
end;

procedure TImgGrid.DoEndDrag(Target: TObject; X, Y: integer);
var
  Col: integer;
begin
  inherited;
  if (fNewCol <> -1) then
  begin
    Col := fNewCol;
    fNewCol := -1;
    if fMovedCol <> -1 then
    begin
      if Col > fMovedCol then
        Dec(Col);
      MoveIMG(fForm.InternalImageList.CustomImg,
              fMovedCol - FixedCols,
              Col - FixedCols);
      fForm.ItemIndex := Col - FixedCols;
    end;
    InvalidateCell(Col, RowCount - 1);
    InvalidateCell(Col - 1, RowCount - 1);
    fMovedCol := -1;
  end;
  FreeAndNil(fDragImageList);
  GetTimer(nil);
  fMovedCol := -1;
end;

procedure TImgGrid.DragOver(Source: TObject; X, Y: integer; State: TDragState; var Accept: boolean);
var
  C: TGridCoord;
  R: TRect;
  Pt: TPoint;
  NewCol, LeftX: integer;
begin
  inherited;
  NewCol := -1;
  C := MouseCoord(X, Y);
  Accept := C.Y = RowCount - 1;
  if Accept then
  begin
    Pt := Point(X, Y);
    R := CellRect(C.X, C.Y);
    NewCol := C.X;
    if X - R.Left > (R.Right - R.Left) div (2) then
      inc(NewCol);
    Accept := (NewCol <> fMovedCol) and (NewCol - 1 <> fMovedCol) and ((NewCol - FixedCols) >= 0) and
      ((NewCol - FixedCols) <= fForm.InternalImageList.CustomImg.Count);
  end;
  if not Accept then
    NewCol := -1;
  if FixedCols > 0 then
    LeftX := CellRect(FixedCols - 1, 0).Right + 4
  else
    LeftX := 4;
  if Accept and ((X >= ClientWidth - 4) or (X <= LeftX)) then
  begin
    if X <= LeftX then
      GetTimer(EventLeft)
    else
      GetTimer(EventRight);
  end
  else
    GetTimer(nil);
  if fNewCol <> NewCol then
  begin
    InvalidateCell(fNewCol, RowCount - 1);
    InvalidateCell(fNewCol - 1, RowCount - 1);
    fNewCol := NewCol;
    InvalidateCell(fNewCol - 1, RowCount - 1);
    InvalidateCell(fNewCol, RowCount - 1);
  end;
end;

//      

procedure TImgGrid.DrawDropPos(ARect: TRect; ACol: integer; ARow: integer);
begin
  if ARow = RowCount - 1 then
  begin
    Canvas.Pen.Width := 2;
    if ACol = fNewCol then
    begin
      Canvas.MoveTo(ARect.Left - 2, ARect.Top + 2);
      Canvas.LineTo(ARect.Left + 1, ARect.Top + 2);
      Canvas.MoveTo(ARect.Left - 1, ARect.Top + 2);
      Canvas.LineTo(ARect.Left - 1, ARect.Bottom - 2);
      Canvas.MoveTo(ARect.Left - 2, ARect.Bottom - 2);
      Canvas.LineTo(ARect.Left + 1, ARect.Bottom - 2);
    end;
    if ACol = fNewCol - 1 then
    begin
      Canvas.MoveTo(ARect.Right + 2, ARect.Top + 2);
      Canvas.LineTo(ARect.Right - 3, ARect.Top + 2);
      Canvas.MoveTo(ARect.Right, ARect.Top + 2);
      Canvas.LineTo(ARect.Right, ARect.Bottom - 2);
      Canvas.MoveTo(ARect.Right + 2, ARect.Bottom - 2);
      Canvas.LineTo(ARect.Right - 3, ARect.Bottom - 2);
    end;
  end;
end;

procedure DrawText(DC: HDC; R: TRect; S: string; Flags: Cardinal);
var
  RR: TRect;
  X, Y: integer;
begin
  RR := Rect(0, 0, Abs(R.Right - R.Left), 2000);
  Windows.DrawText(DC, PChar(S), Length(S), RR,
    (Flags and (DT_END_ELLIPSIS or DT_PATH_ELLIPSIS or DT_WORDBREAK or DT_SINGLELINE)) or DT_CALCRECT);
  Y := 0;
  X := 0;
  if (Flags and DT_VCENTER) = DT_VCENTER then
  begin
    Y := (R.Bottom - R.Top - RR.Bottom) div (2);
    if Y < -1 then
      Y := -1;
  end;
  if (Flags and DT_CENTER) = DT_CENTER then
  begin
    X := (R.Right - R.Left - RR.Right) div (2);
    if X < -1 then
      X := -1;
  end;
  inc(R.Left, X);
  inc(R.Top, Y);
  Windows.DrawText(DC, PChar(S), Length(S), R, Flags and (not (DT_VCENTER or DT_CENTER)));
end;

procedure TImgGrid.DrawCell(ACol, ARow: integer; ARect: TRect; AState: TGridDrawState);
var
  R: TRect;
  I1, I2, i: integer;
  S: string;
  NeedImg: boolean;
begin
  Canvas.Pen.Width := 1;
  Canvas.Font := Font;
  Canvas.Brush.Color := Color;
  Canvas.Font.Color := Font.Color;
  Canvas.Brush.Style := bsSolid;
  if (gdSelected in AState) then
  begin
    Canvas.Brush.Color := clHighlight;
    Canvas.Font.Color := clHighlightText;
  end;
  Canvas.FillRect(ARect);
  Canvas.Brush.Style := bsClear;
  I1 := ACol - FixedCols; //   
  I2 := ARow - FixedRows;
  with fForm.InternalImageList do
  begin
    NeedImg := ((I2 = ResourceNames.Count) and (I1 < CustomImg.Count)) or
      ((I2 < ResourceNames.Count) and (I2 >= 0) and (I1 < ResourceNames.Items[I2].GliphCount));
    if NeedImg then
      for i := 0 to ARow - FixedRows - 1 do
        inc(I1, ResourceNames.Items[i].GliphCount);
    I2 := 0;
    for i := 0 to ResourceNames.Count - 1 do
    begin
      if I2 + ResourceNames.Items[i].GliphCount >= ACol then
        Break;
      inc(I2, ResourceNames.Items[i].GliphCount);
    end;
    R := ARect;
    if (ARow >= FixedRows) and (ACol >= FixedCols) then
    begin
      if Focused and (gdSelected in AState) then
      begin
        Canvas.Brush.Color := Color;
        Canvas.DrawFocusRect(R);
        Canvas.Brush.Style := bsClear;
      end;
      if NeedImg then
        Draw(Canvas, (ARect.Right + ARect.Left - Width) div (2), ARect.Top + (Margin) div (2), I1, true);
    end;
  end;
  R := ARect;
  if ARow >= FixedRows then
  begin
    R.Top := R.Bottom - fTh - (Margin) div (2) + 1;
    R.Bottom := R.Top + fTh;
    if NeedImg then
      S := inttostr(I1)
    else
      S := '-';
  end
  else
  begin
    R.Top := R.Top - 1;
    R.Bottom := R.Top + fTh;
    S := inttostr(I1)
  end;
  if ACol >= FixedCols then
  begin
    if I1 >= 0 then
      DrawText(Canvas.Handle, R, S, DT_CENTER or DT_VCENTER);
  end
  else
  begin
    Canvas.Font.Name := 'Small Fonts';
    Canvas.Font.Size := 5;
    S := '';
    i := ARow - FixedRows;
    if (i >= 0) then
      if (i < fForm.InternalImageList.ResourceNames.Count) then
        S := fForm.InternalImageList.ResourceNames.Items[i].DisplayName
      else
        S := Format(StrSDxdd, [fForm.InternalImageList.CustomImg.Name, fForm.InternalImageList.CustomImg.Width,
          fForm.InternalImageList.CustomImg.Height, fForm.InternalImageList.CustomImg.Count]);
    R := ARect;
    InflateRect(R, -1, -2);
    DrawText(Canvas.Handle, R, S, DT_WORDBREAK);
  end;
  Canvas.Pen.Color := clBtnShadow;
  R := ARect;
  InflateRect(R, 1, 1);
  Canvas.Rectangle(R);
  Canvas.Font.Color := Font.Color;
  DrawDropPos(ARect, ACol, ARow);
end;

function TImgGrid.SelectCell(ACol, ARow: integer): boolean;
begin
  result := (ARow = RowCount - 1) and ((ACol - FixedCols) <= fForm.InternalImageList.CustomImg.Count);
  if result then
    fForm.ItemIndex := ACol - FixedCols;
end;

procedure TImgGrid.UpdateGrid;
var
  X, i: integer;
begin
  if (fForm.InternalImageList <> nil) and (fForm.InternalImageList.CountUpdating = 0) then
  begin
    X := 0;
    for i := 0 to fForm.InternalImageList.ResourceNames.Count - 1 do
      if X < fForm.InternalImageList.ResourceNames.Items[i].GliphCount then
        X := fForm.InternalImageList.ResourceNames.Items[i].GliphCount;
    if X < fForm.InternalImageList.CustomImg.Count then
      X := fForm.InternalImageList.CustomImg.Count;
    if X > 0 then
    begin
      ColCount := X + 1;
      FixedCols := 1;
    end
    else
    begin
      FixedCols := 0;
      ColCount := 1;
    end;
    RowCount := fForm.InternalImageList.ResourceNames.Count + 2;
    FixedRows := 1;
    Canvas.Font := Font;
    fTw := fForm.InternalImageList.Width + Margin;
    fTh := Canvas.TextWidth('000') + Margin;
    if fTw < fTh then
      fTw := fTh;
    if fTw < 24 then
      fTw := 24;
    fTh := Canvas.TextHeight('Wp');
    DefaultColWidth := fTw;
    DefaultRowHeight := fTh + Margin + fForm.InternalImageList.Height;
    RowHeights[0] := fTh;
    ColWidths[0] := Canvas.TextWidth(fForm.InternalImageList.CustomImg.Name) + 4;
    Row := RowCount - 1;
    X := fForm.ItemIndex + FixedCols;
    if X >= ColCount then
      X := 0;
    if X < 0 then
      X := 0;
    Col := X;
  end;
end;

//    Explorer

procedure TImgGrid.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.ExStyle := Params.ExStyle or WS_EX_ACCEPTFILES;
end;

procedure TImgGrid.WMDROPFILES(var Message: TWMDROPFILES);
var
  FileName: array[0..MAX_PATH] of Char;
  i, InsertIndex: integer;
  List: TStringList;
  S, Ex: string;
  Pt: TPoint;
  C: TGridCoord;
begin
  List := nil;
  try
    List := TStringList.Create;
    i := 0;
    while (DragQueryFile(Message.Drop, i, FileName, MAX_PATH) > 0) do
    begin
      S := string(FileName);
      Ex := UpperCase(ExtractFileExt(S));
      // if (Ex='.BMP') or (Ex='.ICO') then
      // begin
      List.Add(S);
      // end;
      inc(i);
    end;
    if List.Count > 0 then
    begin
      DragQueryPoint(Message.Drop, Pt);
      C := MouseCoord(Pt.X, Pt.Y);
      if (C.Y = RowCount - 1) or (C.Y = -1) then
      begin
        if (C.X - FixedCols >= fForm.InternalImageList.Count) or (C.X = -1) then
          InsertIndex := fForm.InternalImageList.Count
        else
          InsertIndex := C.X - FixedCols;
        for i := 0 to List.Count - 1 do
        try
          fForm.OpenFile(List[i], InsertIndex);
          inc(InsertIndex);
        except
          Continue
        end;
      end;
    end;
    Message.result := 0;
  finally
    FreeAndNil(List);
    DragFinish(Message.Drop);
  end;
end;

{ TFormProp }

procedure TFormProp.ClickBrowse(Sender: TObject);
var
  S: string;
begin
  if fDLGopen = nil then
  begin
    fDLGopen := TOpenDialog.Create(self);
    fDLGopen.Filter := '*.exe; *.dll|*.exe;*.dll' + #13#10 + '*.*|*.*';
    fDLGopen.Title := StrFileRes;
  end;
  S := ExtractFilePath(trim(fEditFileName.Text));
  {$IFDEF VER130}
  {$ELSE}
  if DirectoryExists(S) then
    fDLGopen.InitialDir := S;
  {$ENDIF}
  if {$IFDEF VER130}
  fDLGopen.Execute
    {$ELSE}
  {$IFDEF VER140}
  fDLGopen.Execute
    {$ELSE}
  {$IFDEF VER150}
  fDLGopen.Execute
    {$ELSE}
  fDLGopen.Execute(Handle)
    {$ENDIF}
  {$ENDIF}
  {$ENDIF} then
  begin
    fEditFileName.Text := fDLGopen.FileName;
    TResourceName(Child).FileName := trim(fEditFileName.Text);
    UpdateResourceNames;
  end;
end;

procedure TFormProp.ClickOk(Sender: TObject);
type
  TCustInt = 1..128;
var
  W, H, N: TCustInt;
  function EditToInt(Edit: TMaskEdit): TCustInt;
  var
    i: integer;
  begin
    try
      i := StrToInt(Edit.Text);
      if (i < Low(result)) or (i > High(result)) then
        raise ERangeError.Create(SRangeError);
      result := i;
    except
      Edit.SetFocus;
      raise;
    end;
  end;

begin
  W := EditToInt(feWidth);
  H := EditToInt(feHeight);
  if Child is TCustomImg then
  begin
    TCustomImg(Child).BeginUpdate;
    try
      TCustomImg(Child).Width := W;
      TCustomImg(Child).Height := H;
    finally
      TCustomImg(Child).EndUpdate;
    end;
  end;
  if Child is TResourceName then
  begin
    N := EditToInt(feCount);
    TResourceName(Child).Collection.BeginUpdate;
    try
      TResourceName(Child).AutoSize := fCheckAuto.Checked;
      if not TResourceName(Child).AutoSize then
      begin
        TResourceName(Child).Width := W;
        TResourceName(Child).Height := H;
      end;
      TResourceName(Child).GliphCount := N;
      {$IFDEF VER130}{$ELSE}
      TResourceName(Child).TransparentColor := fColorBox.Selected;
      {$ENDIF}
      TResourceName(Child).FileNameDOM := fCheckDOM.Checked;
      TResourceName(Child).FileName := trim(fEditFileName.Text);
      TResourceName(Child).Name := fResourceBox.Text;
    finally
      TResourceName(Child).Collection.EndUpdate;
    end;
  end;
  Close;
  ModalResult := IdOk;
end;

procedure TFormProp.ClickAuto(Sender: TObject);
begin
  UpdateEnableSize;
end;

procedure TFormProp.ClickDom(Sender: TObject);
begin
  UpdateResourceNames;
end;

constructor TFormProp.Create(AOwner: TComponent; AChild: TPersistent);
var
  Y, X: integer;
begin
  if not ((AChild is TResourceName) or (AChild is TCustomImg)) then
    raise Exception.Create(ErrAChildType);
  inherited CreateNew(AOwner);
  BorderStyle := bsToolWindow;
  BorderWidth := 4;
  Position := poDesigned;
  fChild := AChild;
  if Child is TResourceName then
    if TResourceName(fChild).Name <> '' then
      Caption := TResourceName(fChild).Name
    else
      Caption := Child.ClassType.ClassName
  else if TCustomImg(fChild).Name <> '' then
    Caption := TCustomImg(fChild).Name;
  AutoSize := false;
  Y := 2 * BorderWidth;
  with TLabel.Create(self) do
  begin
    Caption := StrWidth;
    Top := Y;
    X := Left + Width + BorderWidth;
    feWidth := TMaskEdit.Create(self);
    with feWidth do
    begin
      Top := Y - 3;
      Left := X;
      Width := 32;
      if AOwner is TFormDlgSIL then
        OnKeyPress := TFormDlgSIL(AOwner).MEKeyPress;
      inc(Y, Height + BorderWidth);
    end;
  end;
  with TLabel.Create(self) do
  begin
    Caption := StrHeight;
    Top := Y;
    feHeight := TMaskEdit.Create(self);
    with feHeight do
    begin
      Top := Y - 3;
      Left := X;
      Width := 32;
      if AOwner is TFormDlgSIL then
        OnKeyPress := TFormDlgSIL(AOwner).MEKeyPress;
      inc(Y, Height + BorderWidth);
    end;
  end;
  if Child is TResourceName then
  begin
    fCheckAuto := TCheckBox.Create(self);
    with fCheckAuto do
    begin
      Caption := StrAuto;
      Top := Y;
      Checked := TResourceName(Child).AutoSize;
      inc(Y, Height + BorderWidth);
      OnClick := ClickAuto;
    end;
    with TLabel.Create(self) do
    begin
      Caption := StrCount;
      Top := Y;
      feCount := TMaskEdit.Create(self);
      with feCount do
      begin
        Top := Y - 3;
        Left := X;
        Width := 32;
        if AOwner is TFormDlgSIL then
          OnKeyPress := TFormDlgSIL(AOwner).MEKeyPress;
        inc(Y, Height + BorderWidth);
      end;
    end;

    with TLabel.Create(self) do
    begin
      Caption := StrFileName;
      Top := Y;
      inc(Y, Height + BorderWidth);
      fEditFileName := TMaskEdit.Create(self);
      with fEditFileName do
      begin
        Top := Y;
        Width := X + 32;
        Text := TResourceName(Child).FileName;
        inc(Y, Height + BorderWidth);
      end;
      fCheckDOM := TCheckBox.Create(self);
      with fCheckDOM do
      begin
        Caption := StrDOM;
        Top := Y;
        Width := X + 32;
        Checked := TResourceName(Child).FileNameDOM;
        inc(Y, Height + BorderWidth);
        OnClick := ClickDom;
      end;
    end;

    with TLabel.Create(self) do
    begin
      Caption := StrResourceName;
      Top := Y;
      inc(Y, Height + BorderWidth);
      fResourceBox := TComboBox.Create(self);
      with fResourceBox do
      begin
        Top := Y;
        Width := X + 32;
        inc(Y, Height);
      end;
    end;

    {$IFDEF VER130}{$ELSE}
    with TLabel.Create(self) do
    begin
      Caption := StrTransparentColor;
      Top := Y;
      inc(Y, Height + BorderWidth);
      fColorBox := TColorBox.Create(self);
      with fColorBox do
      begin
        Top := Y;
        Width := X + 32;
        Selected := TResourceName(Child).TransparentColor;
        inc(Y, Height);
      end;
    end;
    {$ENDIF}
  end;
  with TBevel.Create(self) do
    SetBounds(-BorderWidth, 0, X + 32 + 2 * BorderWidth, Y);
  X := X + 32 + 3 * BorderWidth;
  Y := 0;
  with TButton.Create(self) do
  begin
    Top := Y;
    Left := X;
    Caption := StrOk;
    OnClick := ClickOk;
    Default := true;
    Y := Y + Height + BorderWidth;
  end;
  with TButton.Create(self) do
  begin
    Top := Y;
    Left := X;
    Caption := StrCancel;
    ModalResult := idCancel;
    Cancel := true;
    Y := Y + Height + BorderWidth;
  end;
  if Child is TCustomImg then
  begin
    feWidth.Text := inttostr(TCustomImg(Child).Width);
    feHeight.Text := inttostr(TCustomImg(Child).Height);
  end;
  if Child is TResourceName then
  begin
    feWidth.Text := inttostr(TResourceName(Child).Width);
    feHeight.Text := inttostr(TResourceName(Child).Height);
    feCount.Text := inttostr(TResourceName(Child).GliphCount);
    fButtonBrowse := TButton.Create(self);
    with fButtonBrowse do
    begin
      Top := Y;
      Left := X;
      Caption := StrBrowse;
      OnClick := ClickBrowse;
    end;
  end;
end;

procedure TFormProp.DoShow;
var
  i: integer;
begin
  for i := 0 to ComponentCount - 1 do
    if Components[i] is TButton then
      TControl(Components[i]).Parent := self;
  for i := 0 to ComponentCount - 1 do
  begin
    if Components[i] is TControl then
      TControl(Components[i]).Parent := self;
    {$IFDEF VER130}{$ELSE}
    if Components[i] is TColorBox then
      TColorBox(Components[i]).Style := [cbStandardColors, cbExtendedColors, cbSystemColors, cbIncludeNone,
        cbIncludeDefault, cbCustomColor
        {$IFDEF VER140}{$ELSE}
      {$IFDEF VER150}{$ELSE}
      , cbCustomColors
        {$ENDIF}
      {$ENDIF}];
    {$ENDIF}
  end;
  AutoSize := true;
  if Top + Height > Screen.Height then
    Top := Top - Height;
  if Left + Width > Screen.Width then
    Left := Screen.Width - Width;
  UpdateResourceNames;
  inherited;
  feWidth.SetFocus;
  UpdateEnableSize;
  if (Child is TResourceName) and (fResourceBox <> nil) then
    fButtonBrowse.SetFocus;
end;

procedure TFormProp.UpdateEnableSize;
begin
  if (Child is TResourceName) and (fResourceBox <> nil) then
  begin
    fButtonBrowse.SetFocus;
    feWidth.Enabled := not fCheckAuto.Checked;
    feHeight.Enabled := not fCheckAuto.Checked;
    if feWidth.Enabled then
    begin
      feWidth.Color := clWindow;
      feHeight.Color := clWindow;
    end
    else
    begin
      feWidth.ParentColor := true;
      feHeight.ParentColor := true;
    end;
  end;
end;

procedure TFormProp.UpdateResourceNames;
var
  L: TStringList;
  S: string;
begin
  if (Child is TResourceName) and (fResourceBox <> nil) then
  begin
    L := TStringList.Create;
    S := fResourceBox.Text;
    try
      TResourceName(Child).FileNameDOM := fCheckDOM.Checked;
      TResourceName(Child).EnumResources(L);
      fResourceBox.Items.Clear;
      fResourceBox.Items.AddStrings(L);
    finally
      FreeAndNil(L);
      fResourceBox.Text := S;
    end;
    fResourceBox.Text := TResourceName(Child).Name;
  end;
end;

{ TFormOpenResource }

type
  TPaitBoxCep = class(TImage)
  private
    fColCount: integer;
    fResizing: boolean;
    procedure CMMouseLeave(var Message: TMessage);
      message CM_MOUSELEAVE;
    procedure ChangeMousePos(X, Y: integer);
    function IndexByPos(X, Y: integer): integer;
    function GetForm: TFormOpenResource;
    function GetIconRect(Index: integer): TRect;
    function GetColCount: integer;
  protected
    procedure Click; override;
    procedure MouseMove(Shift: TShiftState; X, Y: integer); override;
  public
    procedure PaintRect(ARect: TRect; Clear: boolean = false);
    property Form: TFormOpenResource read GetForm;
    procedure Resize; override;
    constructor Create(AOwner: TComponent); override;
  end;

  TPaintPanel = class(TScrollingWinControl)
  public
    constructor Create(AOwner: TComponent); override;
  end;

  { TTmpPaintPanel }

constructor TPaintPanel.Create(AOwner: TComponent);
begin
  inherited;
  Align := alClient;
  VertScrollBar.Tracking := true;
  VertScrollBar.Visible := true;
  HorzScrollBar.Visible := false;
  Autoscroll := true;
  BevelKind := bkTile;
  BevelInner := bvLowered;
  if AOwner is TFormOpenResource then
    Parent := TFormOpenResource(AOwner);
end;

function TPaitBoxCep.GetColCount: integer;
begin
  result := Form.ImageWidth + 8;
  result := (ClientWidth + 8) div (result);
  if result < 1 then
    result := 1;
end;

function TPaitBoxCep.IndexByPos(X, Y: integer): integer;
var
  R, CC, C: integer;
begin
  result := -1;
  if (X <= -10) or (Y <= -10) then
    Exit;
  R := Form.ImageWidth + 8;
  CC := GetColCount;
  if CC * R <= X then
    Exit
  else
    C := (X) div (R);
  R := (Y) div (Form.ImageHeight + 8);
  result := R * CC + C;
end;

procedure TPaitBoxCep.ChangeMousePos(X, Y: integer);
var
  i, OldHotIndex: integer;
begin
  i := IndexByPos(X, Y);
  if i <> Form.fHotIndex then
  begin
    OldHotIndex := Form.fHotIndex;
    Form.fHotIndex := i;
    PaintRect(GetIconRect(OldHotIndex));
    Form.fFileName := Form.NameByIndex(i);
    Application.CancelHint;
    Hint := Form.fFileName;
    PaintRect(GetIconRect(Form.fHotIndex));
  end;
end;

function TPaitBoxCep.GetIconRect(Index: integer): TRect;
var
  X: integer;
  Y: integer;
  i: integer;
begin
  X := 4;
  Y := 4;
  FillChar(result, SizeOf(result), 0);
  if Index >= 0 then
  begin
    for i := 0 to Index - 1 do
    begin
      inc(X, Form.ImageWidth + 8);
      if X > ClientWidth - Form.ImageWidth + 4 then
      begin
        X := 4;
        inc(Y, Form.ImageHeight + 8);
      end;
    end;
    result := Rect(X - 4, Y - 4, X + Form.ImageWidth + 4, Y + Form.ImageHeight + 4);
  end;
end;

procedure TPaitBoxCep.CMMouseLeave(var Message: TMessage);
begin
  ChangeMousePos(-10, -10);
  inherited;
end;

constructor TPaitBoxCep.Create(AOwner: TComponent);
begin
  inherited;
  fColCount := -1;
end;

function TPaitBoxCep.GetForm: TFormOpenResource;
begin
  if Owner is TFormOpenResource then
    result := TFormOpenResource(Owner)
  else
    result := nil;

end;

procedure TPaitBoxCep.MouseMove(Shift: TShiftState; X, Y: integer);
begin
  inherited;
  ChangeMousePos(X, Y);
end;

procedure TPaitBoxCep.Click;
begin
  inherited;
  if Form.fHotIndex >= 0 then
  begin
    if Form.IsSelectedIndex(Form.fHotIndex) then
      Form.UnSelectIndex(Form.fHotIndex)
    else
      Form.SelectIndex(Form.fHotIndex);
    PaintRect(GetIconRect(Form.fHotIndex));
  end;
end;

procedure TPaitBoxCep.PaintRect(ARect: TRect; Clear: boolean = false);
var
  X: integer;
  Y: integer;
  i: integer;
  HI: integer;
  R, RR: TRect;
  Flag: Cardinal;
  Sel: boolean;
begin
  if (ARect.Right <= ARect.Left) or (ARect.Bottom <= ARect.Top) then
    Exit;
  with Picture.Bitmap do
    for i := 0 to Form.fIcons.Count - 1 do
    begin
      R := GetIconRect(i);
      if Windows.IntersectRect(RR, R, ARect) then
      begin
        X := Form.ImageWidth + 8;
        Width := ((self.Width + X - 1) div (X)) * X;
        Height := self.Height;
        Canvas.Brush.Color := Color;
        if Clear then
          Canvas.FillRect(Rect(0, 0, Width, Height))
        else
          Canvas.FillRect(R);
        X := R.Left;
        Y := R.Top;
        HI := integer(Form.fIcons.Objects[i]);
        Flag := DI_NORMAL;
        Sel := Form.IsSelectedIndex(i);
        if (i = Form.fHotIndex) then
          if Sel then
            Canvas.Brush.Color := GetHighLightColor(clHighlight)
          else
            Canvas.Brush.Color := {$IFDEF VER130}clAqua{$ELSE}clSkyBlue{$ENDIF}
        else if Sel then
          Canvas.Brush.Color := clHighlight
        else
          Canvas.Brush.Color := Color;
        Canvas.Brush.Style := bsSolid;
        if i = Form.fHotIndex then
        begin
          Canvas.Pen.Color := Font.Color;
        end
        else
        begin
          if Sel then
            Canvas.Pen.Color := clBtnShadow
          else
            Canvas.Pen.Color := Color;
        end;
        Canvas.Pen.Style := psSolid;
        Canvas.Rectangle(X + 2, Y + 2, X + Form.ImageWidth + 6, Y + Form.ImageHeight + 6);
        if (HI <> 0) and (HI <> -1) then
        begin
          DrawIconEx(Canvas.Handle, X + 4, Y + 4, HI, Form.ImageWidth, Form.ImageHeight, 0, Canvas.Brush.Handle, Flag);
          Windows.ExcludeClipRect(Canvas.Handle, X + 4, Y + 4, X + 4 + Form.ImageWidth, Y + 4 + Form.ImageHeight)
        end;
      end;
    end;
end;

procedure TPaitBoxCep.Resize;
var
  R: TRect;
  CC, OldH: integer;
begin
  OldH := Height;
  inherited;
  if fResizing then
    Exit;
  fResizing := true;
  try
    if (Form.fIcons <> nil) and (Form.fIcons.Count > 0) then
    begin
      R := GetIconRect(Form.fIcons.Count - 1);
      if R.Bottom <> Height then
        Height := R.Bottom
    end
    else
      Height := 0;
    CC := GetColCount;
    if (fColCount <> CC) or (Height <> OldH) then
    begin
      PaintRect(ClientRect, true);
      fColCount := CC;
      Paint;
    end;
  finally
    fResizing := false;
  end;
end;

constructor TFormOpenResource.Create(AOwner: TComponent; AImageWidth: integer = 32; AImageHeight: integer = 32);
var
  Panel: TPanel;
  PaintPanel: TPaintPanel;
begin
  inherited CreateNew(AOwner);
  Width := 394;
  fHotIndex := -1;
  BorderStyle := bsSizeToolWin;
  Position := poScreenCenter;
  VertScrollBar.Visible := true;
  fImageWidth := AImageWidth;
  fImageHeight := AImageHeight;
  ShowHint := true;
  Panel := TPanel.Create(self);
  with Panel do
  begin
    Height := 32;
    Align := alBottom;
    Parent := self;
    BevelOuter := bvNone;
    BorderStyle := bsNone;
    with TButton.Create(Panel) do
    begin
      Caption := StrOk;
      Default := true;
      OnClick := ClickOk;
      Anchors := [akTop, akRight, akBottom];
      SetBounds(Panel.Width - (64 + 8) * 2, 4, 64, Height);
      Parent := Panel;
    end;
    with TButton.Create(Panel) do
    begin
      Caption := StrCancel;
      Cancel := true;
      OnClick := ClickCancel;
      Anchors := [akTop, akRight, akBottom];
      SetBounds(Panel.Width - (64 + 8), 4, 64, Height);
      Parent := Panel;
    end;
  end;
  PaintPanel := TPaintPanel.Create(self);
  fPaintBox := TPaitBoxCep.Create(self);
  with fPaintBox do
  begin
    Width := PaintPanel.ClientWidth;
    Color := self.Color;
    Align := alTop;
    Parent := PaintPanel;
  end;
end;

destructor TFormOpenResource.Destroy;
begin
  FreeHinstance;
  inherited;
end;

function TFormOpenResource.NameByIndex(Index: integer): string;
begin
  result := '';
  if (Index >= 0) and (fIcons <> nil) and (Index < fIcons.Count) then
  begin
    result := fIcons[Index];
  end;
end;

function TFormOpenResource.IsSelectedIndex(Index: integer): boolean;
var
  i: integer;
begin
  result := false;
  for i := 0 to Length(fSelIndexes) - 1 do
    if fSelIndexes[i] = Index then
    begin
      result := true;
      Break;
    end;
end;

function EnumResNameProc(Module: hModule; lpszType: PChar; lpszName: PChar; lParam: Pointer): BOOL; stdcall;
var
  List: TStringList;
begin
  if (lParam <> nil) and (TObject(lParam) is TStringList) then
  begin
    List := TStringList(lParam);
    if integer(lpszName) > High(Word) then
      List.Add(lpszName)
    else
    begin
      List.Add('#' + inttostr(integer(lpszName)));
    end;
  end;
  result := true;
end;

procedure TFormOpenResource.UpdateHinstance;
var
  Error, i, HI, N: integer;
  S: string;
  PIconName: PChar;
  procedure RaiseError;
  begin
    Error := GetLastError;
    if (Error <> ERROR_RESOURCE_TYPE_NOT_FOUND) and (Error <> NO_ERROR) then
    begin
      {$IFDEF VER130}
      raise EWin32Error.CreateResFmt(@SWin32Error, [Error, SysErrorMessage(Error)])
      {$ELSE}
      raise EOSError.CreateResFmt(@SOSError, [Error, SysErrorMessage(Error)])
      {$ENDIF};
    end;
  end;

begin
  FreeHinstance;
  if trim(fFileName) = '' then
    Exit;
  fhInstance := LoadLibraryEx(PChar(fFileName), 0, LOAD_LIBRARY_AS_DATAFILE);
  if fhInstance = 0 then
    RaiseLastOsError;
  try
    fIcons := TStringList.Create;
    if not EnumResourceNames(fhInstance, RT_CURSOR, @EnumResNameProc, integer(fIcons)) then
      RaiseError;
    if not EnumResourceNames(fhInstance, RT_ICON, @EnumResNameProc, integer(fIcons)) then
      RaiseError;
    i := 0;
    while i < fIcons.Count do
    begin
      if (fIcons[i] <> '') and (fIcons[i][1] = '#') then
      begin
        S := Copy(fIcons[i], 2, Length(fIcons[i]));
        N := StrToInt(S);
        PIconName := MAKEINTRESOURCE(N);
      end
      else
        PIconName := PChar(fIcons[i]);
      HI := LoadImage(fhInstance, PIconName, IMAGE_ICON, ImageWidth, ImageHeight, LR_LOADMAP3DCOLORS);
      if HI <> 0 then
      begin
        fIcons.Objects[i] := TObject(HI);
        inc(i);
      end
      else
        fIcons.Delete(i);
    end;
    TPaitBoxCep(fPaintBox).Resize;
  except
    FreeHinstance;
    raise;
  end;
end;

procedure TFormOpenResource.FreeHinstance;
var
  i: integer;
begin
  if fIcons <> nil then
    for i := 0 to fIcons.Count - 1 do
      if (integer(fIcons.Objects[i]) <> 0) and (integer(fIcons.Objects[i]) <> -1) then
      begin
        // if not DestroyIcon(Integer(fIcons.Objects[i])) then raiseLastOsError;
        DestroyIcon(integer(fIcons.Objects[i]));
        fIcons.Objects[i] := nil;
      end;
  FreeAndNil(fIcons);
  if fhInstance <> 0 then
  begin
    if not FreeLibrary(fhInstance) then
      RaiseLastOsError;
    fhInstance := 0;
  end;
  TPaitBoxCep(fPaintBox).Resize;
end;

procedure TFormOpenResource.SelectIndex(Index: integer);
var
  i: integer;
begin
  for i := 0 to Length(fSelIndexes) - 1 do
    if fSelIndexes[i] = Index then
      Exit;
  SetLength(fSelIndexes, Length(fSelIndexes) + 1);
  fSelIndexes[Length(fSelIndexes) - 1] := Index;
end;

procedure TFormOpenResource.UnSelectIndex(Index: integer);
var
  i: integer;
begin
  for i := 0 to Length(fSelIndexes) - 1 do
    if fSelIndexes[i] = Index then
    begin
      Move(fSelIndexes[i + 1], fSelIndexes[i], SizeOf(fSelIndexes[i]) * Length(fSelIndexes) - i - 1);
      SetLength(fSelIndexes, Length(fSelIndexes) - 1);
      Break;
    end;
end;

procedure TFormOpenResource.ClickCancel(Sender: TObject);
begin
  fResourceName := '';
  Close;
  ModalResult := idCancel;
end;

procedure TFormOpenResource.ClickOk(Sender: TObject);
var
  i: integer;
begin
  fResourceName := '';
  if fIcons <> nil then
    for i := 0 to fIcons.Count - 1 do
      if IsSelectedIndex(i) then
        if fResourceName = '' then
          fResourceName := fIcons[i]
        else
          fResourceName := fResourceName + ';' + fIcons[i];
  Close;
  if fResourceName <> '' then
    ModalResult := IdOk;
end;

procedure TFormOpenResource.SetFileName(const Value: string);
var
  OldFileName: string;
begin
  if trim(fFileName) <> trim(Value) then
  begin
    OldFileName := fFileName;
    fFileName := Value;
    try
      UpdateHinstance;
    except
      fFileName := OldFileName;
      raise;
    end;
    Realign;
    Caption := trim(fFileName);
    Invalidate;
  end;
end;

{ TOpenPictureDialogCep }

procedure TOpenPictureDialogCep.DoSelectionChange;
{$IFDEF VER130}
{$ELSE}
var
  ValidPicture: boolean;
  FullName: string;
  i: integer;
  FDlgSIL: TFormDlgSIL;
  function ValidFile(const FileName: string): boolean;
  begin
    result := (trim(FileName) <> '') and (UpperCase(ExtractFileExt(FileName)) <> '.LNK') and
      (GetFileAttributes(PChar(FileName)) <> $FFFFFFFF) and (FileExists(FileName));
  end;
  {$ENDIF}

begin
  {$IFDEF VER130}
  inherited; //  Delphi 5 !
  {$ELSE}
  FullName := '';
  i := pos('"', FileName);
  if i > 0 then
  begin
    FullName := Copy(FileName, 1, i - 1);
    inc(i);
    while (i <= Length(FileName)) and (FileName[i] <> '"') do
    begin
      FullName := FullName + FileName[i];
      inc(i);
    end;
  end
  else
    FullName := FileName;

  if (Owner is TFormDlgSIL) then
  begin
    ValidPicture := ValidFile(FullName);
    if (FullName <> FSavedFilename) and (ValidPicture) then
    begin
      FDlgSIL := TFormDlgSIL(Owner);
      FSavedFilename := FullName;
      FDlgSIL.OpenFile(FullName, 0, ImageCtrl);
    end;
    PictureLabel.Caption := ExtractFileName(FullName);
    ImageCtrl.Visible := ValidPicture;
  end
  else
    inherited;
  {$ENDIF}
end;

end.

