unit ImageListCep;
//      
//   TImageListCep
// y     .
//       
//  roschinspb@mail.ru
//http://www.delphikingdom.com/asp/users.asp?ID=1271
//http://www.roschinspb.boom.ru
interface
{$I Directives.inc}
uses
  windows, SysUtils, SysConst, Classes, ImgList, Controls, Forms, Graphics, CepUtils,
  {$IFDEF VER130}Commctrl, Consts, {$ELSE}GraphUtil, {$ENDIF}GraphUtilEx,
  Math, InternalTimer;

const StandartResourceName = 'STANDARTBTN';

resourcestring
  StrNoFile = '   "%s"';
  StrNoRes = '   "%s"' + #13#10 + '%s';
type
  TImageListCep = class;

  //       
  TResourceName = class(TCollectionItem)
  private
    fName: string;
    fWidth: Byte;
    fHeight: Byte;
    fGliphCount: Word;
    fTransparentColor: TColor;
    fAutoSize: boolean;
    fFileName: string;
    fhInstance: THandle;
    fFileNameDOM: boolean;
    procedure SetHeight(const Value: Byte);
    procedure SetName(const Value: string);
    procedure SetWidth(const Value: Byte);
    procedure SetGliphCount(const Value: Word);
    procedure SetTransparentColor(const Value: TColor);
    procedure SetAutoSize(const Value: boolean);
    procedure SetFileName(const Value: string);
    procedure FreeHinstance(RaisedError: Boolean);
    function UpdatehInstance(RaisedError: Boolean): boolean;
    procedure SetFileNameODM(const Value: boolean);
  protected
    function GetDisplayName: string; override;
    procedure SetDisplayName(const Value: string); override;
    class function LoadOtherResource(const hInst: THandle; const RName: string;
      lpType: PChar; var Bmp: TGraphic): THandle;
  public
    procedure Assign(Source: TPersistent); override;
    procedure LoadFromStream(S: TStream);
    procedure SaveToStream(S: TStream);
    //   (. AutoSize)
    function GetResourceName: string;
    //    (. GetResourceName, FileName, FileNameDOM)
    function LoadFromResourceName(var Bmp: TGraphic; RaisedError: boolean = false): boolean;
    //     
    procedure EnumResources(List: TStringList);
  published
    constructor Create(Collection: TCollection); override;
    destructor Destroy; override;
    property Name: string read fName write SetName; // 
    property Width: Byte read fWidth write SetWidth default 24; //  ( )
    property Height: Byte read fHeight write SetHeight default 24; // 
    // AutoSize=true,   GetResourceName
    //   NAME_ss (ss - )    
    //     Width  Height
    property AutoSize: boolean read fAutoSize write SetAutoSize default true;
    //   
    property GliphCount: Word read fGliphCount write SetGliphCount default 8;
    //,     
    property TransparentColor: TColor read fTransparentColor
      write SetTransparentColor default clFuchsia;
    //     .
    // '',   
    property FileName: string read fFileName write SetFileName;
    // FileNameDOM=true,  FileName    DesignTime,
    //     . . FileName .
    property FileNameDOM: boolean read fFileNameDOM write SetFileNameODM default true;
  end;

  // 
  TResourceNames = class(TOwnedCollection)
  private
    function GetItem(Index: Integer): TResourceName;
    procedure SetItem(Index: Integer; const Value: TResourceName);
    function GetImageList: TImageListCep;
  protected
    procedure Update(Item: TCollectionItem); override; //   
  public
    procedure Assign(Source: TPersistent); override;
    procedure BeginUpdate; override;
    procedure EndUpdate; override;
    function AddDefault: TResourceName; //    StandartBtn
    property Items[Index: Integer]: TResourceName read GetItem write SetItem;
    function FindItemByName(Name: string): integer; //    c  &
  published
    property ImageListCep: TImageListCep read GetImageList;
  end;

  // TDragImageList   
  TCustomImg = class(TDragImageList)
  private
    fSourceBitmap: TBitmap;
    fDestBitmap: TBitmap;
    fTMPBitmap: TBitmap;
    fCountUpdating: integer;
    fTimer: TInternalTimer;
    function GetTimer: TInternalTimer;
    procedure CreateBitmapFromGraphics(const Graphics: TGraphic; var Bitmap: TBitmap);
    procedure FreeBitmapFromGraphics(const Graphics: TGraphic;
      var Bitmap: TBitmap);
  protected
    procedure DoChanged(Sender: TObject); virtual;
    procedure Change; override;
  public
    procedure LoadFromStream(S: TStream);
    procedure SaveToStream(S: TStream);
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    //    (ARect).  Index=Count, 
    //  .    .
    procedure InsertBitmap(Index: integer; Graphic: TGraphic; ARect: TRect); overload;
    procedure InsertBitmap(Index: integer; Graphic: TGraphic); overload;
    //  . Bitmap  
    //  
    function InsertBitmaps(Index: integer; Graphics: TGraphic;
      Width, Height: integer; Count: integer = 0): Word;
    procedure BeginUpdate;
    procedure EndUpdate;
    property CountUpdating: integer read fCountUpdating;
    property Timer: TInternalTimer read GetTimer;
  published
    property BlendColor;
    property BkColor;
    property Height;
    property Masked;
    property Width;
  end;

  //    
  TImageListCep = class(TCustomImg)
  private
    fInChange: boolean;
    fCustomImg: TCustomImg;
    fResourceNames: TResourceNames;
    fDirName: string;
    procedure SetResourceNames(const Value: TResourceNames);
    procedure ReaderProc(Reader: TReader);
    procedure WriterProc(Writer: TWriter);
    {$IFDEF VER130}
    procedure ReadLeft(Reader: TReader);
    procedure ReadTop(Reader: TReader);
    procedure WriteLeft(Writer: TWriter);
    procedure WriteTop(Writer: TWriter);
    procedure ReadCustomImgWidth(Reader: TReader);
    procedure WriteCustomImgWidth(Writer: TWriter);
    procedure ReadCustomImgHeight(Reader: TReader);
    procedure WriteCustomImgHeight(Writer: TWriter);
    procedure ReadCustomImgBitmap(Stream: TStream);
    procedure WriteCustomImgBitmap(Stream: TStream);
    {$ENDIF}
  protected
    procedure DefineProperties(Filer: TFiler); override;
    {$IFDEF VER130}
    procedure ReadData(Stream: TStream);
    procedure WriteData(Stream: TStream);
    {$ELSE}
    procedure ReadData(Stream: TStream); override;
    procedure WriteData(Stream: TStream); override;
    {$ENDIF}
    procedure DoChanged(Sender: TObject); override;
    procedure Loaded; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    //   ,  
    //    ResourceNames  CustomImg
    function UpdateImages(Need: boolean = false): boolean; dynamic;
    // ,       
    property DirName: string read fDirName write fDirName;
  published
    //       
    property ResourceNames: TResourceNames read fResourceNames write SetResourceNames;
    //  ,   
    property CustomImg: TCustomImg read fCustomImg;
    property onChange;
    {$IFDEF DELPHI_2010_UP} property ColorDepth default cd32Bit; {$ENDIF}
  end;

var DesignTime: boolean;

function ResourceNameToSize(Name: string; var Size: integer): string;
/// <summary>    Delphi XE </summary>
procedure MoveIMG(const IMG: TCustomImageList; const CurIndex, NewIndex: Integer);
procedure Register;

implementation

{$R StandartBtn_32.RES}
{$R StandartBtn_24.RES}
{$R StandartBtn_16.RES}
{$R CepExperts.RES}


procedure Register;
begin
  RegisterComponents('Cep', [TImageListCep]);
end;

type
  TCustomImageListEx = class(TCustomImageList)

  end;

procedure MoveIMG(const IMG: TCustomImageList; const CurIndex, NewIndex: Integer);
begin
  if (IMG <> nil) and (CurIndex <> NewIndex) then
  begin
    IMG.Move(CurIndex, NewIndex);
    {$IFDEF DELPHI_2011_UP}
    if (IMG <> nil) then
      TCustomImageListEx(IMG).Change;
    {$ENDIF}
  end;
end;

{ TStandartImageList }

procedure TImageListCep.Assign(Source: TPersistent);
begin
  BeginUpdate;
  try
    if Source = nil then
    begin
      ResourceNames.Assign(nil);
      CustomImg.Clear;
    end
    else
    begin
      if (Source is TImageListCep) then
      begin
        Clear;
        Width := TCustomImg(Source).Width;
        Height := TCustomImg(Source).Width;
        BkColor := TCustomImg(Source).BkColor;
        BlendColor := TCustomImg(Source).BlendColor;
        ResourceNames.Assign(TImageListCep(Source).ResourceNames);
        CustomImg.Assign(TImageListCep(Source).CustomImg);
      end
      else if (Source is TCustomImageList) then
      begin
        ResourceNames.Assign(nil);
        CustomImg.Assign(TCustomImageList(Source));
      end
      else
        inherited;
    end;
  finally
    EndUpdate;
    inherited Change;
  end;
end;

constructor TImageListCep.Create(AOwner: TComponent);
begin
  inherited;
  {$IFDEF DELPHI_2010_UP} ColorDepth := cd32Bit; {$ENDIF}
  fCustomImg := TCustomImg.Create(self);
  fCustomImg.Name := 'CustomImg';
  {$IFDEF VER130}
  {$ELSE}
  fCustomImg.SetSubComponent(True);
  {$ENDIF}
  fResourceNames := TResourceNames.Create(self, TResourceName);
  UpdateImages;
end;

procedure TImageListCep.Loaded;
begin
  inherited;
  inherited Change;
end;

type TTmpControl = class(TControl);

function GetDefBkColor(ImageList: TCustomImageList): TColor;
begin
  result := GetShadowColor(clBtnFace);
  if ImageList <> nil then
    with ImageList do
    begin
      result := BkColor;
      if ((result = clNone) or (result = clDefault)) and
        (Owner is TControl) and
        (TTmpControl(Owner).Color <> clNone) and
        (TTmpControl(Owner).Color <> clDefault) then
        result := ColorToRGB(TTmpControl(Owner).Color);
      if ((result = clNone) or (result = clDefault)) and
        (Owner is TCustomImg) and
        (TCustomImg(Owner).BkColor <> clNone) and
        (TCustomImg(Owner).BkColor <> clDefault) then
        result := ColorToRGB(TCustomImg(Owner).BkColor);
      if ((result = clNone) or (result = clDefault)) then
        result := GetShadowColor(clBtnFace);
    end;
  result := ColorToRGB(result);
end;

procedure UpdateTransparentBitmap(var Bitmap: TBitmap; Color: TColor);
begin
  if Color = clNone then
    Bitmap.Transparent := false
  else
  begin
    Bitmap.Transparent := true;
    if Color = clDefault then
      Bitmap.TransparentMode := tmAuto
    else
    begin
      Bitmap.TransparentMode := tmFixed;
      Bitmap.TransparentColor := Color;
    end;
  end;
end;

procedure TImageListCep.DefineProperties(Filer: TFiler);
{$IFDEF VER130}
var
  Ancestor: TComponent;
  Info: Longint;
  {$ENDIF}
begin
  {$IFDEF VER130}
  Info := 0;
  Ancestor := TComponent(Filer.Ancestor);
  if Ancestor <> nil then Info := Ancestor.DesignInfo;

  Filer.DefineProperty(fCustomImg.Name + '.Width',
    ReadCustomImgWidth,
    WriteCustomImgWidth,
    fCustomImg.Width <> 16);
  Filer.DefineProperty(fCustomImg.Name + '.Height',
    ReadCustomImgHeight,
    WriteCustomImgHeight,
    fCustomImg.Height <> 16);
  Filer.DefineBinaryProperty(fCustomImg.Name + '.Bitmap',
    ReadCustomImgBitmap,
    WriteCustomImgBitmap,
    fCustomImg.Count > 0);

  Filer.DefineBinaryProperty('Bitmap', ReadData, WriteData, true);
  Filer.DefineProperty('Left', ReadLeft, WriteLeft,
    LongRec(DesignInfo).Lo <> LongRec(Info).Lo);
  Filer.DefineProperty('Top', ReadTop, WriteTop,
    LongRec(DesignInfo).Hi <> LongRec(Info).Hi);
  {$ELSE}
  inherited;
  {$ENDIF}
  Filer.DefineProperty('DirName', ReaderProc, WriterProc, DirName <> '');
end;

destructor TImageListCep.Destroy;
begin
  FreeAndNil(fResourceNames);
  inherited;
end;

procedure TImageListCep.DoChanged(Sender: TObject);
begin
  UpdateImages;
  inherited;
end;

procedure TImageListCep.ReaderProc(Reader: TReader);
begin
  try
    fDirName := Reader.ReadString;
  except
    fDirName := '';
  end;
end;

procedure TImageListCep.WriterProc(Writer: TWriter);
begin
  Writer.WriteString(fDirName);
end;

//     5 
{$IFDEF VER130}

procedure TImageListCep.ReadCustomImgWidth(Reader: TReader);
begin
  fCustomImg.Width := Reader.ReadInteger;
end;

procedure TImageListCep.WriteCustomImgWidth(Writer: TWriter);
begin
  Writer.WriteInteger(fCustomImg.Width);
end;

procedure TImageListCep.ReadCustomImgHeight(Reader: TReader);
begin
  fCustomImg.Height := Reader.ReadInteger;
end;

procedure TImageListCep.WriteCustomImgHeight(Writer: TWriter);
begin
  Writer.WriteInteger(fCustomImg.Height);
end;

procedure TImageListCep.ReadCustomImgBitmap(Stream: TStream);
var
  SA: TStreamAdapter;
begin
  with fCustomImg do
  begin
    SA := TStreamAdapter.Create(Stream);
    try
      Handle := ImageList_Read(SA);
      if Handle = 0 then
        raise EReadError.CreateRes(@SImageReadFail);
    finally
      SA.Free;
    end;
  end;
end;

procedure TImageListCep.WriteCustomImgBitmap(Stream: TStream);
var
  SA: TStreamAdapter;
begin
  with fCustomImg do
  begin
    SA := TStreamAdapter.Create(Stream);
    try
      if not ImageList_Write(Handle, SA) then
        raise EWriteError.CreateRes(@SImageWriteFail);
    finally
      SA.Free;
    end;
  end;
end;

procedure TImageListCep.ReadLeft(Reader: TReader);
var FDesignInfo: Longint;
begin
  FDesignInfo := DesignInfo;
  LongRec(FDesignInfo).Lo := Reader.ReadInteger;
  DesignInfo := FDesignInfo;
end;

procedure TImageListCep.ReadTop(Reader: TReader);
var FDesignInfo: Longint;
begin
  FDesignInfo := DesignInfo;
  LongRec(FDesignInfo).Hi := Reader.ReadInteger;
  DesignInfo := FDesignInfo;
end;

procedure TImageListCep.WriteLeft(Writer: TWriter);
var FDesignInfo: Longint;
begin
  FDesignInfo := DesignInfo;
  Writer.WriteInteger(LongRec(FDesignInfo).Lo);
end;

procedure TImageListCep.WriteTop(Writer: TWriter);
var FDesignInfo: Longint;
begin
  FDesignInfo := DesignInfo;
  Writer.WriteInteger(LongRec(FDesignInfo).Hi);
end;
{$ENDIF}

procedure TImageListCep.ReadData(Stream: TStream);
begin
  //inherited;
end;

procedure TImageListCep.WriteData(Stream: TStream);
begin
  //inherited;
end;

procedure TImageListCep.SetResourceNames(const Value: TResourceNames);
begin
  if Value = nil then
    fResourceNames.Clear
  else
    fResourceNames.Assign(Value);
end;

function TImageListCep.UpdateImages(Need: boolean = false): boolean;
var K, I, ImgCount: integer;
  ResBmp: TGraphic;
begin
  result := false;
  if (not Need) and ((CountUpdating > 0) or (fInChange)) then Exit;
  fInChange := true;
  try
    if ((Need) or (([csUpdating, csDestroying, csLoading] * ComponentState) = [])) and
      (Width > 0) and (Height > 0) then
    begin
      ImgCount := 0;
      for i := 0 to ResourceNames.Count - 1 do
        inc(ImgCount, ResourceNames.Items[i].GliphCount);
      if (fCustomImg <> nil) then inc(ImgCount, fCustomImg.Count);
      if ImgCount > 0 then
      begin
        BeginUpdate;
        ResBmp := nil;
        try
          Clear;
          for I := 0 to ResourceNames.Count - 1 do
          try
            ResBmp := nil;
            if ResourceNames.Items[i].Name <> '' then
            begin
              if ResourceNames.Items[i].LoadFromResourceName(ResBmp) then
              begin
                if ResBmp is TBitmap then
                begin
                  TBitmap(ResBmp).PixelFormat := pf32Bit;
                  TBitmap(ResBmp).TransparentColor := ResourceNames.Items[i].TransparentColor;
                  UpdateTransparentBitmap(TBitmap(ResBmp), ResourceNames.Items[i].TransparentColor);
                end;
              end;
            end;
            if ResBmp <> nil then
            begin
              InsertBitmaps(Count,
                ResBmp,
                ResourceNames.Items[i].Width,
                ResourceNames.Items[i].Height,
                ResourceNames.Items[i].GliphCount);
            end
            else
            begin
              ResBmp := TBitmap.Create;
              with TBitmap(ResBmp) do
              begin
                PixelFormat := pf32Bit;
                TransparentColor := clBtnFace;
                Canvas.Brush.Color := clBtnFace;
                Width := (ResourceNames.Items[i].Width * 3) div (2);
                Height := (ResourceNames.Items[i].Height * 3) div (2);
                for K := 0 to ResourceNames.Items[i].GliphCount - 1 do
                begin
                  Canvas.FillRect(Rect(0, 0, ResBmp.Width, ResBmp.Height));
                  Canvas.Font.Name := 'Small Fonts';
                  Canvas.Font.Color := clWindowText;
                  Canvas.Font.Size := 7;
                  Canvas.TextOut(0, 0, Format('%d', [K]));
                  Canvas.TextOut(0, 8, ResourceNames.Items[i].Name);
                  InsertBitmap(Count, TBitmap(ResBmp));
                end;
              end;
            end;
          finally
            FreeAndNil(ResBmp);
          end;
          if (fCustomImg <> nil) and (fCustomImg.Count > 0) then
          begin
            ResBmp := TBitmap.Create;
            try
              with TBitmap(ResBmp) do
              begin
                PixelFormat := pf32Bit;
                Transparent := false;
                Width := fCustomImg.Width;
                Height := fCustomImg.Height;
                Canvas.Brush.Color := GetDefBkColor(self);
                for K := 0 to fCustomImg.Count - 1 do
                begin
                  Canvas.FillRect(Rect(0, 0, Width, Height));
                  fCustomImg.Draw(Canvas, 0, 0, K, true);
                  InsertBitmap(Count, TBitmap(ResBmp));
                end;
              end;
            finally
              FreeAndNil(ResBmp);
            end;
          end;
        finally
          FreeAndNil(ResBmp);
          EndUpdate;
        end;
        result := true;
      end
      else
      begin
        if Count > 0 then
        begin
          Clear;
          result := true;
        end;
      end;
    end;
  finally
    fInChange := false;
    if Timer <> nil then Timer.Stop;
  end;
end;

{ TResourceName }

procedure TResourceName.Assign(Source: TPersistent);
var Name: string;
  Width, Height, GliphCount: integer;
  TransparentColor: TColor;
  FileName: string;
  AutoSize, FileNameDOM: boolean;
begin
  if Source = nil then
  begin
    fName := '';
    fFileName := '';
  end
  else if Source is TResourceName then
  begin
    Name := trim(UpperCase(TResourceName(Source).Name));
    Width := TResourceName(Source).Width;
    Height := TResourceName(Source).Height;
    GliphCount := TResourceName(Source).GliphCount;
    FileName := TResourceName(Source).FileName;
    TransparentColor := TResourceName(Source).TransparentColor;
    AutoSize := TResourceName(Source).AutoSize;
    FileNameDOM := TResourceName(Source).FileNameDOM;
    if (fName <> Name) or
      (fWidth <> Width) or
      (fHeight <> Height) or
      (fGliphCount <> GliphCount) or
      (fFileName <> FileName) or
      (fTransparentColor <> TransparentColor) or
      (fAutoSize <> AutoSize) or
      (fFileNameDOM <> FileNameDOM) then
    begin
      fName := Name;
      fWidth := Width;
      fHeight := Height;
      fGliphCount := GliphCount;
      fFileName := FileName;
      fTransparentColor := TransparentColor;
      fAutoSize := AutoSize;
      fFileNameDOM := FileNameDOM;
      Changed(false);
    end;
  end
  else
    inherited;
end;

constructor TResourceName.Create(Collection: TCollection);
begin
  inherited;
  fFileNameDOM := true;
  fWidth := 24;
  fHeight := 24;
  fGliphCount := 8;
  fTransparentColor := clFuchsia;
  fAutoSize := true;
  if (Collection is TResourceNames) and
    (TResourceNames(Collection).ImageListCep <> nil) then
  begin
    if fWidth <= 0 then
      fWidth := TResourceNames(Collection).ImageListCep.Width;
    if fHeight <= 0 then
      fHeight := TResourceNames(Collection).ImageListCep.Height;
  end;
end;

destructor TResourceName.Destroy;
begin
  FreeHinstance(false);
  inherited;
end;

function EnumResNameProc(Module: hModule;
  lpszType: PChar;
  lpszName: PChar;
  lParam: Pointer): BOOL; stdcall;
var List: TStringList;
    {$IFDEF DELPHI_2010_UP}
    Bit: TGraphic;
    {$ENDIF}
begin
  if (lParam <> nil) and (TObject(LParam) is TStringList) then
  begin
    List := TStringList(lParam);
    if lpszType = RT_BITMAP then
    begin
      List.Add(lpszName);
    end
    else
    begin
      {$IFDEF DELPHI_2010_UP}
      Bit := nil;
      try
        if TResourceName.LoadOtherResource(Module, lpszName, lpszType, Bit) <> 0 then
          List.Add(lpszName);
      finally
        Bit.Free;
      end;
      {$ENDIF}
    end;
  end;
  result := true;
end;

procedure TResourceName.EnumResources(List: TStringList);
var L: TStringList;
  i: integer;
  hInst: THandle;
begin
  if List = nil then Exit;
  L := nil;
  try
    if List <> nil then
    begin
      UpdatehInstance(true);
      L := TStringList.Create;
      if fhInstance = 0 then
        hInst := hInstance
      else
        hInst := fhInstance;
      EnumResourceNames(hInst, RT_BITMAP, @EnumResNameProc, Longint(L));
      EnumResourceNames(hInst, RT_RCDATA, @EnumResNameProc, Longint(L));
      List.BeginUpdate;
      try
        for i := 0 to L.Count - 1 do
          if List.IndexOf(L[i]) = -1 then List.Add(L[I]);
      finally
        List.EndUpdate;
      end;
    end;
  finally
    FreeAndNil(L);
    FreeHinstance(true);
  end;
end;

function TResourceName.UpdatehInstance(RaisedError: Boolean): boolean;
var Designing: boolean;
begin
  Designing := DesignTime or
    ((Collection is TResourceNames) and
    (TResourceNames(Collection).ImageListCep <> nil) and
    (csDesigning in TResourceNames(Collection).ImageListCep.ComponentState));

  result := false;
  if (FileName <> '') and
    ((not fFileNameDOM) or
    (fFileNameDOM and Designing)) then
  begin
    if (fhInstance = 0) then
    begin
      if FileExists(fFileName) then
      begin
        fhInstance := LoadLibraryEx(PChar(fFileName), 0, LOAD_LIBRARY_AS_DATAFILE);
        if fhInstance = 0 then
          if RaisedError then
            RaiseLastOSError
          else
            Exit;
        result := true;
      end
      else
      begin
        if RaisedError then
          {$IFDEF VER130}
          EWin32Error.CreateFmt(StrNoFile, [fFileName])
            {$ELSE}
          EOSError.CreateFmt(StrNoFile, [fFileName])
            {$ENDIF}
        else
          Exit;
      end;
    end
    else
      result := true;
  end
  else
  begin
    FreeHinstance(RaisedError);
    result := true;
  end;
end;

procedure TResourceName.FreeHinstance(RaisedError: Boolean);
begin
  if fhInstance <> 0 then
  begin
    if not FreeLibrary(fhInstance) then
      if RaisedError then
        RaiseLastOSError;
    fhInstance := 0;
  end;
end;

function TResourceName.GetDisplayName: string;
begin
  result := Name;
  if result = '' then
    result := inherited GetDisplayName;
  if result <> '' then result := result + ' ';
  result := result + Format('(%dx%d)[%d]', [Width, Height, GliphCount]);
end;

class function TResourceName.LoadOtherResource(const hInst: THandle; const RName: string; lpType: PChar; var Bmp: TGraphic): THandle;
{$IFDEF DELPHI_2010_UP}
var
  Stream: TResourceStream;
  Img: TWICImage;
{$ENDIF}
begin
  {$IFDEF DELPHI_2010_UP}
  if Bmp <> nil then raise EArgumentException.Create(SVarInvalid);
  Result := windows.FindResource(hInst, PChar(RName), lpType);
  if Result <> 0 then
  begin
    Stream := TResourceStream.Create(hInst, RName, lpType);
    try
      Img := TWICImage.Create;
      try
        Img.LoadFromStream(Stream);
        Bmp := Img;
        //Bmp.Assign(Img);
      except
        Bmp := nil;
        Img.Free;
      end;
    finally
      FreeAndNil(Stream);
    end;
  end;
  {$ELSE}
  Result := 0;
  {$ENDIF}
end;

type
  TResourceNameWrapper = class(TComponent)
  private
    fResourceName: TResourceName;
  published
    property ResourceName: TResourceName read fResourceName write fResourceName;
  end;

function TResourceName.LoadFromResourceName(var Bmp: TGraphic;
  RaisedError: boolean): boolean;
var RName: String;
    hInst: THandle;
    hRes: THandle;
begin
  FreeAndNil(Bmp);
  RName := GetResourceName;
  result := UpdatehInstance(RaisedError);
  if not result then Exit;
  try
    try
      if fhInstance = 0 then
        hInst := FindResourceHInstance(hInstance)
      else
        hInst := fhInstance;

      hRes := windows.FindResource(hInst, PChar(RName), RT_BITMAP);
      if hRes <> 0 then
      begin
        Bmp := TBitmap.Create;
        TBitmap(Bmp).PixelFormat := pf32Bit;
        TBitmap(Bmp).LoadFromResourceName(hInst, RName);
      end
      else
      begin
        hRes := LoadOtherResource(hInst, RName, RT_RCDATA, Bmp);
        if hRes = 0 then
          hRes := LoadOtherResource(hInst, RName, RT_ICON, Bmp);
      end;
      if (hRes = 0) then
        raiseLastOsError;

      result := true;
    finally
      FreeHinstance(RaisedError);
    end;
  except
    on E: Exception do
    begin
      result := False;
      FreeAndNil(Bmp);
      if RaisedError then
      begin
        E.Message := Format(StrNoRes, [RName, E.Message]);
        raise E;
      end;
    end;
  end;
end;

procedure TResourceName.LoadFromStream(S: TStream);
var
  Wrapper: TResourceNameWrapper;
begin
  Wrapper := TResourceNameWrapper.Create(nil);
  try
    Wrapper.ResourceName := TResourceName.Create(nil {GetOwner});
    S.ReadComponent(Wrapper);
    Assign(Wrapper.ResourceName);
  finally
    Wrapper.ResourceName.Free;
    Wrapper.Free;
  end;
end;

function ResourceNameToSize(Name: string; var Size: integer): string;
var S: string;
  i, Code: integer;
begin
  S := Trim(Name);
  result := S;
  I := 0;
  Size := 0;
  while (I < Length(S)) and (I < 3) and
    (S[Length(S) - I] >= '0') and (S[Length(S) - I] <= '9') do
    inc(I);
  if (I < Length(S)) and (S[Length(S) - I] = '_') then
  begin
    S := Copy(S, Length(S) - I + 1, I);
    if S <> '' then Val(S, Size, Code);
    if Code <> 0 then Size := -1;
    result := Copy(result, 1, Length(result) - I - 1);
  end;
end;

function TResourceName.GetResourceName: string;
var S, SS: string;
  i, Size, MinSize, OwnerSize: integer;
  List: TStringList;
  Sizes: array of integer;
begin
  result := Name;
  if (result <> '') and (AutoSize) then
  begin
    List := nil;
    S := ResourceNameToSize(Name, Size);
    OwnerSize := TResourceNames(Collection).ImageListCep.Height;
    if (S <> '') and (OwnerSize > 0) then
    try
      List := TStringList.Create;
      EnumResources(List);
      for I := 0 to List.Count - 1 do
      begin
        SS := ResourceNameToSize(List[I], Size);
        if (SS = S) then
        begin
          SetLength(Sizes, Length(Sizes) + 1);
          Sizes[High(Sizes)] := Size;
        end;
      end;
      result := S;
      MinSize := MaxInt;
      for I := 0 to Length(Sizes) - 1 do
        if (Sizes[i] >= OwnerSize) and (Sizes[i] < MinSize) then
          MinSize := Sizes[I];
      if MinSize = MaxInt then
      begin
        MinSize := 0;
        for I := 0 to Length(Sizes) - 1 do
          if Sizes[i] > MinSize then
            MinSize := Sizes[I];
      end;
      if MinSize <> 0 then
      begin
        result := S + '_' + inttostr(MinSize);
        if fAutoSize then
        begin
          fWidth := MinSize;
          fHeight := MinSize;
        end;
      end;
    finally
      FreeAndNil(List);
    end;
  end;
end;

procedure TResourceName.SaveToStream(S: TStream);
var
  Wrapper: TResourceNameWrapper;
begin
  Wrapper := TResourceNameWrapper.Create(nil);
  try
    Wrapper.ResourceName := Self;
    S.WriteComponent(Wrapper);
  finally
    Wrapper.Free;
  end;
end;

procedure TResourceName.SetAutoSize(const Value: boolean);
begin
  if fAutoSize <> Value then
  begin
    fAutoSize := Value;
    GetResourceName;
    Changed(false);
  end;
end;

procedure TResourceName.SetDisplayName(const Value: string);
begin
  inherited SetDisplayName(Value);
end;

procedure TResourceName.SetFileName(const Value: string);
begin
  if fFileName <> Value then
  begin
    fFileName := Value;
    FreeHinstance(true);
    Changed(false);
  end;
end;

procedure TResourceName.SetFileNameODM(const Value: boolean);
begin
  if fFileNameDOM <> Value then
  begin
    fFileNameDOM := Value;
    FreeHinstance(true);
    Changed(true);
  end;
end;

procedure TResourceName.SetGliphCount(const Value: Word);
begin
  if fGliphCount <> Value then
  begin
    fGliphCount := Value;
    Changed(true);
  end;
end;

procedure TResourceName.SetHeight(const Value: Byte);
begin
  if (Value <> fHeight) and (Value > 0) then
  begin
    fHeight := Value;
    if (Collection is TResourceNames) and
      (TResourceNames(Collection).ImageListCep <> nil) then
    begin
      if fHeight <= 0 then
        fHeight := TResourceNames(Collection).ImageListCep.Height;
    end;
    Changed(false);
  end;
end;

procedure TResourceName.SetName(const Value: string);
var V: string;
begin
  V := trim(UpperCase(Value));
  if V <> fName then
  begin
    fName := V;
    Changed(false);
  end;
end;

procedure TResourceName.SetTransparentColor(const Value: TColor);
begin
  if fTransparentColor <> Value then
  begin
    fTransparentColor := Value;
    Changed(false);
  end;
end;

procedure TResourceName.SetWidth(const Value: Byte);
begin
  if (Value <> fWidth) and (Value > 0) then
  begin
    fWidth := Value;
    if (Collection is TResourceNames) and
      (TResourceNames(Collection).ImageListCep <> nil) then
    begin
      if fWidth <= 0 then
        fWidth := TResourceNames(Collection).ImageListCep.Width;
    end;
    Changed(false);
  end;
end;

{ TResourceNames }

function TResourceNames.AddDefault: TResourceName;
var i: integer;
begin
  result := nil;
  for i := 0 to Count - 1 do
    if Items[i].Name = StandartResourceName then
    begin
      result := Items[i];
      break;
    end;
  if result = nil then
  begin
    result := TResourceName(Add);
    result.Name := StandartResourceName;
    result.GliphCount := 36;
  end;
end;

procedure TResourceNames.Assign(Source: TPersistent);
begin
  if Source = nil then
    Clear
  else
    inherited;
end;

procedure TResourceNames.BeginUpdate;
begin
  inherited;

end;

procedure TResourceNames.EndUpdate;
begin
  inherited;
end;

function TResourceNames.FindItemByName(Name: string): integer;
var S: string;
  i: integer;
  C: Char;
begin
  result := -1;
  S := '';
  i := 1;
  while i <= Length(Name) do
  begin
    C := UpCase(Name[i]);
    if (C = '&') and (i < Length(Name)) and (Name[i + 1] = '&') then inc(I);
    if (C < #128) and (C >= '!') then S := S + C;
    inc(I);
  end;
  for I := 0 to Count - 1 do
    if Items[i].Name = S then
    begin
      result := i;
      exit;
    end;
end;

function TResourceNames.GetItem(Index: Integer): TResourceName;
begin
  result := TResourceName(inherited GetItem(Index));
end;

function TResourceNames.GetImageList: TImageListCep;
begin
  if GetOwner is TImageListCep then
    result := TImageListCep(GetOwner)
  else
    result := nil;
end;

procedure TResourceNames.SetItem(Index: Integer; const Value: TResourceName);
begin
  inherited SetItem(Index, Value);
end;

procedure TResourceNames.Update(Item: TCollectionItem);
begin
  if (ImageListCep <> nil) and (UpdateCount = 0) then
  begin
    ImageListCep.Change;
  end;
end;

{ TCustomImg }

procedure TCustomImg.Assign(Source: TPersistent);
begin
  if Source = nil then
  begin
    BeginUpdate;
    try
      Clear;
      BlendColor := clNone;
      BkColor := clNone;
      Masked := true;
      Tag := 0;
      Width := 16;
      Height := 16;
    finally
      EndUpdate;
    end;
  end
  else
  begin
    BeginUpdate;
    try
      if Source is TCustomImg then
      begin
        Clear;
        Width := TCustomImg(Source).Width;
        Height := TCustomImg(Source).Width;
        BkColor := TCustomImg(Source).BkColor;
        BlendColor := TCustomImg(Source).BlendColor;
        if TCustomImg(Source).Count > 0 then
        begin
          AddImages(TCustomImg(Source));
        end;
      end
      else
        inherited Assign(Source);
    finally
      EndUpdate;
    end;
  end;
end;

type
  TCustomImgWrapper = class(TComponent)
  private
    fCustomImg: TCustomImg;
  published
    property CustomImg: TCustomImg read fCustomImg write fCustomImg;
  end;

procedure TCustomImg.LoadFromStream(S: TStream);
var
  Wrapper: TCustomImgWrapper;
begin
  Wrapper := TCustomImgWrapper.Create(nil);
  try
    Wrapper.CustomImg := TCustomImg.Create(nil {GetOwner});
    S.ReadComponent(Wrapper);
    Assign(Wrapper.CustomImg);
  finally
    Wrapper.CustomImg.Free;
    Wrapper.Free;
  end;
end;

procedure TCustomImg.SaveToStream(S: TStream);
var
  Wrapper: TCustomImgWrapper;
begin
  Wrapper := TCustomImgWrapper.Create(nil);
  try
    Wrapper.CustomImg := Self;
    S.WriteComponent(Wrapper);
  finally
    Wrapper.Free;
  end;
end;

procedure TCustomImg.InsertBitmap(Index: integer; Graphic: TGraphic; ARect: TRect);
var NeedSourceBitmap, NeedDestBitmap, NeedTMPBitmap: boolean;
  Scale1: Double;
  X, Y: integer;
  TransparentColor: TColor;
  procedure InsertBmp(Bitmap: TBitmap);
  var X, Y: integer;
  begin
    if (Bitmap.Width <> Width) or (Bitmap.Height <> Height) then
    begin
      if fTMPBitmap = nil then
      begin
        fTMPBitmap := TBitmap.Create;
      end;
      fTMPBitmap.Width := Width;
      fTMPBitmap.Height := Height;
      fTMPBitmap.Canvas.Brush.Color := TransparentColor;
      fTMPBitmap.Canvas.FillRect(Rect(0, 0, Width, Height));
      X := (Width - Bitmap.Width) div (2);
      Y := (Height - Bitmap.Height) div (2);
      BitBlt(fTMPBitmap.Canvas.Handle, X, Y, Bitmap.Width, Bitmap.Height,
        Bitmap.Canvas.Handle, 0, 0, SRCCOPY);
      Bitmap := fTMPBitmap;
    end;
    if Index >= Count then
      AddMasked(Bitmap, TransparentColor {clFuchsia})
    else
      InsertMasked(Index, Bitmap, TransparentColor {clFuchsia});
  end;
begin
  NeedSourceBitmap := fSourceBitmap = nil;
  NeedDestBitmap := fDestBitmap = nil;
  NeedTMPBitmap := fTMPBitmap = nil;
  if Graphic <> nil then
  try
    if NeedSourceBitmap then fSourceBitmap := TBitmap.Create;
    fSourceBitmap.PixelFormat := pf32Bit;
    fSourceBitmap.Transparent := false;
    fSourceBitmap.Width := Abs(ARect.Right - ARect.Left);
    fSourceBitmap.Height := Abs(ARect.Bottom - ARect.Top);
    X := ARect.Left;
    if X > ARect.Right then X := ARect.Right;
    Y := ARect.Top;
    if Y > ARect.Bottom then Y := ARect.Bottom;
    Scale1 := Scale(Width, Height, fSourceBitmap.Width, fSourceBitmap.Height);
    if Scale1 <> 0 then
    begin
     //    BkColor
      TransparentColor := GetDefBkColor(self);
      fSourceBitmap.Canvas.Brush.Color := TransparentColor;
      fSourceBitmap.Canvas.FillRect(Rect(0, 0, fSourceBitmap.Width, fSourceBitmap.Height));
      if (fSourceBitmap.Width = Graphic.Width) and
         (fSourceBitmap.Height = Graphic.Height) and
         (X = 0) and (Y = 0) and (Scale1 = 1) then
        fSourceBitmap.Assign(Graphic)
      else
        fSourceBitmap.Canvas.Draw(-X, -Y, Graphic);
      if Scale1 <> 1 then
      begin
        if NeedDestBitmap then fDestBitmap := TBitmap.Create;
        fDestBitmap.PixelFormat := pf32Bit;
        fDestBitmap.Transparent := false;
        ScaleImage(fSourceBitmap, fDestBitmap, Scale1);
        InsertBmp(fDestBitmap);
      end
      else
      begin
        InsertBmp(fSourceBitmap);
      end;
    end;
  finally
    if NeedDestBitmap then FreeAndNil(fDestBitmap);
    if NeedSourceBitmap then FreeAndNil(fSourceBitmap);
    if NeedTMPBitmap then FreeAndNil(fTMPBitmap);
  end;
end;

procedure TCustomImg.BeginUpdate;
begin
  inc(fCountUpdating);
  if fCountUpdating = 1 then
  begin
    Updating;
    if fSourceBitmap = nil then
    begin
      fSourceBitmap := TBitmap.Create;
      fSourceBitmap.PixelFormat := pf32Bit;
    end;
    if fDestBitmap = nil then
    begin
      fDestBitmap := TBitmap.Create;
      fDestBitmap.PixelFormat := pf32Bit;
    end;
  end;
end;

procedure TCustomImg.EndUpdate;
begin
  if fCountUpdating > 0 then
  begin
    Dec(fCountUpdating);
    if fCountUpdating = 0 then
    begin
      Updated;
      FreeAndNil(fSourceBitmap);
      FreeAndNil(fDestBitmap);
      FreeAndNil(fTMPBitmap);
      Change;
    end;
  end
  else
    fCountUpdating := 0;
end;

function TCustomImg.GetTimer: TInternalTimer;
begin
  if (not (csDestroying in ComponentState)) and
    (fTimer = nil) then
    fTimer := TInternalTimer.Create(nil);
  result := fTimer;
end;

procedure TCustomImg.DoChanged(Sender: TObject);
begin
  if Owner is TImageListCep then
    with TImageListCep(Owner) do
    begin
      if ([csUpdating, csLoading, csDestroying] * ComponentState = []) and
        (CountUpdating = 0) then
        Change;
    end;
  if ([csUpdating, csLoading, csDestroying] * ComponentState = []) and
    (CountUpdating = 0) then
    inherited Change;
end;

procedure TCustomImg.Change;
begin
  if Timer <> nil then Timer.ExecuteDelay(40, self.DoChanged);
end;

destructor TCustomImg.Destroy;
begin
  FreeAndNil(fSourceBitmap);
  FreeAndNil(fDestBitmap);
  FreeAndNil(fTMPBitmap);
  FreeAndNil(fTimer);
  inherited;
end;

procedure TCustomImg.InsertBitmap(Index: integer; Graphic: TGraphic);
begin
  InsertBitmap(Index, Graphic, Rect(0, 0, Graphic.Width, Graphic.Height));
end;

procedure TCustomImg.CreateBitmapFromGraphics(const Graphics: TGraphic; var Bitmap: TBitmap);
begin
  if Graphics is TBitmap then
    Bitmap := TBitmap(Graphics)
  else
  begin
    Bitmap := TBitmap.Create;
    try
      Bitmap.PixelFormat := pf32Bit;
      Bitmap.Assign(Graphics);
    except
      FreeAndNil(Bitmap);
      raise;
    end;
  end;
end;

procedure TCustomImg.FreeBitmapFromGraphics(const Graphics: TGraphic; var Bitmap: TBitmap);
begin
  if Graphics is TBitmap then
    Bitmap := nil
  else
    FreeAndNil(Bitmap);
end;

function TCustomImg.InsertBitmaps(Index: integer; Graphics: TGraphic;
  Width, Height: integer; Count: integer): Word;
var X, Y, N, i, RowCount, ColCount: integer;
  R: TRect;
  EmptyBitmap, Bitmap: TBitmap;
begin
  result := 0;
  if (Graphics <> nil) and (Width > 0) and (Height > 0) then
  begin
    BeginUpdate;
    try
      CreateBitmapFromGraphics(Graphics, Bitmap);
      try
        if Count < 0 then
        begin
          InsertBitmap(Index, Bitmap);
          result := 1;
        end
        else
        begin
          ColCount := (Bitmap.Width + Width - 1) div (Width);
          RowCount := (Bitmap.Height + Height - 1) div (Height);
          N := RowCount * ColCount;
          if (Count > 0) and (N > Count) then N := Count;
          for Y := 0 to RowCount - 1 do
            for X := 0 to ColCount - 1 do
            begin
              if result >= N then break;
              R := Rect(X * Width, Y * Height, (X + 1) * Width, (Y + 1) * Height);
              InsertBitmap(Index + Result, Bitmap, R);
              inc(result);
            end;
          N := Count - result;
          if N > 0 then
          begin
            EmptyBitmap := TBitmap.Create;
            try
              EmptyBitmap.PixelFormat := pf32Bit;
              R := Rect(0, 0, N * self.Width, self.Height);
              EmptyBitmap.Width := R.Right;
              EmptyBitmap.Height := R.Bottom;
              with EmptyBitmap.Canvas do
              begin
                Brush.Color := clFuchsia;
                for i := 0 to N - 1 do
                begin
                  R := Rect(i * self.Width, 0, (i + 1) * self.Width, self.Height);
                  Rectangle(R);
                  MoveTo(R.Left, R.Top);
                  LineTo(R.Right, R.Bottom);
                  MoveTo(R.Right - 1, R.Top);
                  LineTo(R.Left, R.Bottom - 1);
                end;
              end;
              if Index + result >= self.Count then
                AddMasked(EmptyBitmap, clFuchsia)
              else
                InsertMasked(Index + result, EmptyBitmap, clFuchsia);
              inc(result, N);
            finally
              FreeAndNil(EmptyBitmap);
            end;
          end;
        end;
      finally
        FreeBitmapFromGraphics(Graphics, Bitmap);
      end;
    finally
      EndUpdate;
    end;
  end;
end;

initialization
  DesignTime := false;
end.

