unit InternalTimer;
(*
 * Module:           
 *              ,    .
 * Version:    1.5 (31.01.2007)
 * Author:      
 * Comments:         .
 *                    
 *              : roschinspb@mail.ru
 *             http://www.delphikingdom.com/asp/users.asp?ID=1271
 *             http://www.roschinspb.boom.ru
 *
 * Copyright:   2006, 2007 .
 *)
interface
uses Windows,Messages,SysUtils,Classes;

type
  //        
  TInternalTimer=class (TComponent)
  private
    fInstanceProc:pointer;
    fHandle:THandle;
    fEvent:TNotifyEvent;
    fOne:boolean;
    fFirst:boolean;
    fExecuted:boolean;
    procedure TimerProc(var M: TMessage);
  protected
    procedure DoEvent; virtual;
  public
    destructor Destroy; override;
    procedure ExecuteDelay(const Delay:integer; const Event:TNotifyEvent);
    procedure ExecuteInterval(const Interval:integer; const Event:TNotifyEvent);
    function Stop:boolean;                // .     ,   True
    property First:boolean read fFirst;   // ,   ,      
    property Handle:THandle read fHandle;
    property One:boolean read fOne;       //    ,      
  end;

implementation
{$IFDEF VER130}
uses Forms, GraphUtilEx;
{$ENDIF}

{ TInternalTimer }

destructor TInternalTimer.Destroy;
begin
  Stop;
  inherited;
end;

procedure TInternalTimer.ExecuteDelay(const Delay: integer; const Event: TNotifyEvent);
begin
  Stop;
  fExecuted:=false;
  If (Delay>0) then begin
   fOne:=true;
   fEvent:=Event;
   fInstanceProc:=MakeObjectInstance(TimerProc);
   fFirst:=true;
   fHandle:=SetTimer(0,Cardinal(Self),Delay,fInstanceProc);
  end else begin
   fOne:=false;
   fEvent:=nil;
   fFirst:=false;
  end;
end;

procedure TInternalTimer.ExecuteInterval(const Interval: integer; const Event: TNotifyEvent);
begin
  Stop;
  fExecuted:=false;
  fOne:=false;
  If (Interval>0) then begin
   fEvent:=Event;
   fInstanceProc:=MakeObjectInstance(TimerProc);
   fFirst:=true;
   fHandle:=SetTimer(0,Cardinal(Self),Interval,fInstanceProc);
  end else begin
   fEvent:=nil;
   fFirst:=false;
  end;
end;

function TInternalTimer.Stop: boolean;
begin
  result:=false;
  If self=nil then exit;
  result:=fExecuted;
  if fHandle<>0 then begin
   if Windows.KillTimer(0,fHandle) then fHandle:=0
                                   else RaiseLastOSError;
  end;
  if fInstanceProc<>nil then begin
   FreeObjectInstance(fInstanceProc);
   fInstanceProc:=nil;
  end;
end;

procedure TInternalTimer.TimerProc(var M: TMessage);
begin
  If fOne then Stop;
  try
    try
      DoEvent;
      If self<>nil then fExecuted:=true;
    except
      on E: EAbort do
      begin
        //    
      end;
    end;
  finally
   If self<>nil then fFirst:=false;
  end;
end;

procedure TInternalTimer.DoEvent;
begin
  If @fEvent<>nil then fEvent(self);
end;



initialization


end.
