unit NavigatorCep;
(*
 * Module:           TNavigatorCep
 * Version:    2.5 (02.12.2008)
 * Author:      
 * Comments:         .
 *                    
 *              : roschinspb@mail.ru
 *             http://www.delphikingdom.com/asp/users.asp?ID=1271
 *             http://www.roschinspb.narod.ru
 *
 * Copyright:   2008 .
 *
 * Version:    2.5 (02.12.2008)
 * Realized:    SmallImages,     SmallIcons.
 *                 ,   "" (Cancel)   
 *                    (Revert).
 *)
interface
uses
  SysUtils, Classes, Windows, Controls, ToolWin, ActnMan, Messages, Graphics, GraphUtil,
  ActnList, DBActns, DB, DBClient, ExtCtrls, ActnCtrls, Forms,
  ActnMenus, XPActnCtrls, CepStyleActnCtrls, BitOp, InternalTimer, ImgList,
  ImageListCep, CepStyleUtl;

resourcestring
  CapFirst = '|   ';
  CapPrior = '|   ';
  CapState = '%0:s  %1:s| %0:s  %1:s';
  CapNext = '|   ';
  CapLast = '|   ';
  CapInsert = '|  ';
  CapDelete = '| ';
  CapEdit = '|  ';
  CapPost = '|  ';
  CapCancel = '|  ';
  CapRefresh = '|   ';
  CapApply = '|   ';
  CapRevert = '|  ';
  CapUndo = '|    ';

  CapClose = ' ';
  CapEmpty = ' ';

type
  // 
  TDBCepButton = (dcbFirst, dcbPrior, dcbState, dcbNext, dcbLast,
    dcbInsert, dcbDelete, dcbEdit, dcbPost,
    dcbCancel, dcbRefresh, dcbApply,
    dcbRevert, dcbUndo);
  // 
  TDBCepButtons = set of TDBCepButton;
  //,        
  TDBCepEvent = procedure(Sender: TObject; Action: TAction; DataSet: TDataSet; Button: TDBCepButton; var Allowed: boolean) of object;

const
  //  
  Caps: array[TDBCepButton] of string =
  (CapFirst, CapPrior, CapState, CapNext, CapLast,
    CapInsert, CapDelete, CapEdit, CapPost,
    CapCancel, CapRefresh, CapApply,
    CapRevert, CapUndo);
  //   TNavigatorCep,    
  UMRecreate = WM_USER + 139;

  DefaulButtons = [dcbFirst, dcbPrior, dcbState, dcbNext, dcbLast,
    dcbInsert, dcbDelete, dcbEdit, dcbPost,
    dcbCancel, dcbRefresh, dcbApply];

  DefaultVisibleButtons = [dcbFirst, dcbPrior, dcbState, dcbNext, dcbLast];
type
  //     .
  //    ,      
  TDataSetActionCep = class(TDataSetAction)
  private
    fDBCepButton: TDBCepButton;
    fDataSet: TDataSet;
  public
    procedure ExecuteTarget(Target: TObject); override;
    procedure UpdateTarget(Target: TObject); override;
  protected
    procedure DoCallAction(ATarget: TObject; ABeforeAction: boolean);
  public
    property DataSource;
    property DataSet: TDataSet read fDataSet;
    property DBCepButton: TDBCepButton read fDBCepButton;
  end;
  //       
  //       - ,
  //   .
  // Enabled = true,    
  // Checked = true,    
  TDataSetStateAction = class(TDataSetActionCep)
  private
    fInternalTimer: TInternalTimer;
    fRecordCount: integer;
    fRecNo: integer;
    function GetInternalTimer: TInternalTimer;
    procedure DoTimer(Sender: TObject);
  protected
    procedure Change; override;
  public
    procedure UpdateTarget(Target: TObject); override;
    destructor Destroy; override;
  end;
  //   
  TCepNavButton = class(TCepStyleButton)
  private
    fInterval: integer;
    fInternalTimer: TInternalTimer;
    fAutoClick: boolean;
   // fRecurs: boolean;
  protected
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure DoTimer(Sender: TObject); virtual;
  public
    constructor Create(AOwner: TComponent); override;
    //   ,    
    //   
    property AutoClick: boolean read fAutoClick write fAutoClick;
    function DesignWndProc(var Message: TMessage): Boolean; override;
  end;
  //    .
  TCepStyleButtonState = class(TCepStyleButton)
  private
  protected
    procedure DrawGlyph(const Location: TPoint); override;
    procedure DrawLargeGlyph(Location: TPoint); override;
    procedure DrawBackground(var PaintRect: TRect); override;
    procedure DrawFrame(ARect: TRect; Down: Boolean); override;
    procedure CalcLayout; override;
    procedure DrawText(var ARect: TRect; var Flags: Cardinal; Text: string); override;
  public
    function DesignWndProc(var Message: TMessage): Boolean; override;
  end;
  //     ,   
  TCepNavAddRemoveItem = class(TCepStyleAddRemoveItem)
  protected
    procedure DrawGlyph(const Location: TPoint); override;
  end;
  //   ,       
  TCepNavCustomizePopup = class(TXPStyleCustomizePopup)
  private
    FARItem: TActionClientItem;
  protected
    procedure SetActionClient(const Value: TActionClient); override;
    function GetAddRemoveItemClass: TCustomAddRemoveItemClass; override;
    procedure GetSubMenuControlClass(Sender: TCustomActionBar; AnItem: TActionClient;
      var ControlClass: TCustomActionControlClass); override;
    function DoItemClicked(AnItem: TCustomActionControl): TActionClientItem; override;
  public
    procedure CloseMenu; override;
  end;
  // 
  TNavigatorCep = class(TCustomGradientActionToolBar)
  private
    fIntActionManager: TActionManager;
    fButtons: TDBCepButtons;
    fVisibleButtons: TDBCepButtons;
    fItemsCreated: boolean;
    fActions: array[TDBCepButton] of TAction;
    fARAction: TAction;
    fBeforeAction: TDBCepEvent;
    fUpdateAction: TDBCepEvent;
    fLastRefresh: DWORD;
    fWait: boolean;
    fNeedExecute: boolean;
    fAfterAction: TDBCepEvent;
    fNoPaint: DWORD;
    fItemsChanged: boolean;
    fMaxWidthState: integer;
    fTmpTimer: TInternalTimer;
    fSmallImages: boolean;
    procedure WMPAINT(var Message: TWMPAINT); message WM_PAINT;
    procedure RecreateActionManager;
    procedure RecreateItems;
    procedure SetButtons(const Value: TDBCepButtons);
    procedure SetVisibleButtons(const Value: TDBCepButtons);
    procedure ExecuteARItem(Sender: TObject);
    procedure UpdateARItem(Sender: TObject);
    function CreateButton(B: TDBCepButton): TActionClientItem;
    procedure UMRecreateItems(var Message: TMessage); message UMRecreate;
    function ActionClass(B: TDBCepButton): TContainedActionClass;
    procedure SetWait(const Value: boolean);
    procedure DoRecreateItems(Sender: TObject);
    procedure RecreateItemsDelay(Time: integer);
    function GetDataSource: TDataSource;
    procedure SetDataSource(const Value: TDataSource);
    procedure SetSmallImages(const Value: boolean);
  protected
    { Protected declarations }
    procedure SetParent(AParent: TWinControl); override;
    function GetPopupClass: TCustomActionBarClass; override;
    function GetControlClass(AnItem: TActionClientItem): TCustomActionControlClass; override;
    procedure DragOver(Source: TObject; X: Integer; Y: Integer; State: TDragState; var Accept: Boolean); override;
    function DoBeforeAction(Action: TAction; DataSet: TDataSet; Button: TDBCepButton): boolean; virtual;
    function DoUpdateAction(Action: TAction; DataSet: TDataSet; Button: TDBCepButton): boolean; virtual;
    procedure DoDropItem(Source: TActionItemDragObject; const X, Y: Integer); override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
  public
    { Public declarations }
    procedure SaveToStream(Stream: TStream);
    procedure LoadFromStream(Stream: TStream);
    procedure AfterConstruction; override;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property SmallIcons: boolean read fSmallImages write SetSmallImages;
    property Canvas;
  published
    { Published declarations }
    property VisibleButtons: TDBCepButtons read fVisibleButtons write SetVisibleButtons default DefaultVisibleButtons;
    property Buttons: TDBCepButtons read fButtons write SetButtons default DefaulButtons;
    property Wait: boolean read fWait write SetWait default false;
    property BeforeAction: TDBCepEvent read fBeforeAction write fBeforeAction;
    property AfterAction: TDBCepEvent read fAfterAction write fAfterAction;
    property DataSource: TDataSource read GetDataSource write SetDataSource;
    property SmallImages: boolean read fSmallImages write SetSmallImages default false;
    property onUpdateAction: TDBCepEvent read fUpdateAction write fUpdateAction;

    property Align default alTop;
    property AllowHiding default True;
    property Anchors;
    property AutoSize;
    property BiDiMode;
    property Caption;
    property Color default clBtnFace;
    property ColorMap;
    property Constraints;
    property Cursor;
    property DragCursor;
    property DragKind default dkDock;
    property DragMode;
    property EdgeBorders default [];
    property EdgeInner;
    property EdgeOuter default esNone;
    property Enabled;
    property Font;
    property HorzMargin;
    property HorzSeparator default True;
    property Orientation default boLeftToRight;
    property ParentBiDiMode;
    property ParentBackground default False;
    property ParentColor default False;
    property ParentFont;
    property ParentShowHint;
    property PersistentHotKeys default False;
    property PopupMenu;
    property ShowHint;
    property Spacing;
    property VertMargin;
    property Visible;
    property OnAlignInsertBefore;
    property OnAlignPosition;
    property OnControlCreated;
    property OnCanResize;
    property OnClick;
    property OnConstrainedResize;
    property OnContextPopup;
    property OnDockDrop;
    property OnDockOver;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnGetControlClass;
    property OnGetSiteInfo;
    property OnMouseActivate;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnPaint;
    property OnResize;
    property OnStartDock;
    property OnStartDrag;
    property OnUnDock;
  end;

procedure Register;

implementation

{$R 'DATASETIMAGES_24.RES'}
{$R 'DATASETIMAGES_16.RES'}
{$R 'Overlays_16.RES'}

procedure Register;
begin
  RegisterComponents('Cep', [TNavigatorCep]);
end;

type
  TDBCepActionManager = class(TActionManager)
  public
  end;
  TCustomClientDataSetEx = class(TCustomClientDataSet)
  end;


{$REGION ' '}
var _IntImages: TImageListCep;
  _IntImagesOverlay: TImageListCep;
  _IntOverlay: TRichImageList;

procedure CreateImageList(var Images: TImageListCep; Size, Count: integer; ResourceName: string);
  procedure AddResource;
  var N: integer;
  begin
    N := Images.ResourceNames.Count;
    Images.ResourceNames.Add;
    Images.ResourceNames.Items[N].AutoSize := true;
    Images.ResourceNames.Items[N].Name := Trim(UpperCase(ResourceName));
    Images.ResourceNames.Items[N].GliphCount := Count;
  end;
begin
  if Images = nil then
    Images := TImageListCep.Create(nil);
  Images.ResourceNames.BeginUpdate;
  try
    Images.Width := Size;
    Images.Height := Size;
    AddResource;
  finally
    Images.ResourceNames.EndUpdate;
  end;
  Images.UpdateImages;
end;

function IntImagesOverlay: TImageListCep;
begin
  CreateImageList(_IntImagesOverlay, 16, 4, 'Overlays');
  result := _IntImagesOverlay;
end;

function IntOverlay: TRichImageList;
begin
  if _IntOverlay = nil then
  begin
    _IntOverlay := TRichImageList.Create;
    _IntOverlay.Width := IntImagesOverlay.Width + 2;
    _IntOverlay.Height := IntImagesOverlay.Height + 2;
    _IntOverlay.ImageList := IntImagesOverlay;
    _IntOverlay.Border := CepXPBorder;
    _IntOverlay.BorderColor := $1FFFFFFF;
    _IntOverlay.Transparent := true;
    _IntOverlay.Adjusted := true;
    _IntOverlay.Hot := true;
  end;
  result := _IntOverlay;
end;
{$ENDREGION}


//      

function GetNavigatorCep(Action: TBasicAction): TNavigatorCep;
begin
  if (Action is TDataSetActionCep) and
    (TDataSetActionCep(Action).ActionList is TDBCepActionManager) and
    (TDBCepActionManager(TDataSetActionCep(Action).ActionList).Owner is TNavigatorCep) then
    result := TNavigatorCep(TDBCepActionManager(TDataSetActionCep(Action).ActionList).Owner)
  else
    result := nil;
end;


{ TDataSetActionCep }

procedure TDataSetActionCep.DoCallAction(ATarget: TObject;
  ABeforeAction: boolean);
var DBActionBar: TNavigatorCep;
  B: TDBCepButton;
begin
  if ATarget is TDataSource then
    fDataSet := TDataSource(ATarget).DataSet
  else
    fDataSet := nil;
  DBActionBar := GetNavigatorCep(self);
  if (DBActionBar <> nil) then
  begin
    for B := Low(DBActionBar.fActions) to High(DBActionBar.fActions) do
      if self = DBActionBar.fActions[B] then begin
        try
          fDBCepButton := B;
          if ABeforeAction then
            DBActionBar.DoBeforeAction(self, fDataSet, DBCepButton)
          else
            DBActionBar.DoUpdateAction(self, fDataSet, DBCepButton);
        except
          on E: EAbort do
          begin
            Exit;
          end;
          on E: Exception do raise;
        end;
        break;
      end;
  end;
end;

procedure TDataSetActionCep.ExecuteTarget(Target: TObject);
begin
  DoCallAction(Target, True);
end;

procedure TDataSetActionCep.UpdateTarget(Target: TObject);
begin
  DoCallAction(Target, False);
end;

{ TDataSetStateAction }

procedure TDataSetStateAction.Change;
begin
  inherited;
  if not Enabled then
  begin
    Caption := CapEmpty;
    Hint := CapEmpty;
    Checked := false;
  end;
  if Visible and Enabled and Checked then
    GetInternalTimer
  else
    FreeAndNil(fInternalTimer);
end;

destructor TDataSetStateAction.Destroy;
begin
  FreeAndNil(fInternalTimer);
  inherited;
end;

procedure TDataSetStateAction.DoTimer(Sender: TObject);
begin
  if (Visible) and (Checked) and (DataSet <> nil) and
    ((fRecordCount <> DataSet.RecordCount) or
    (fRecNo <> DataSet.RecNo)) then
    Update;
end;

function TDataSetStateAction.GetInternalTimer: TInternalTimer;
begin
  if fInternalTimer = nil then
  begin
    fInternalTimer := TInternalTimer.Create(nil);
    fInternalTimer.ExecuteInterval(40, DoTimer);
  end;
  result := fInternalTimer;
end;

procedure TDataSetStateAction.UpdateTarget(Target: TObject);
var S1, S2, H, C: string;
  DataSet: TDataSet;
  NoUpdating: boolean;
begin
  if Target is TDataSource then
    DataSet := TDataSource(Target).DataSet
  else
    DataSet := nil;
  if DataSet <> nil then
    with DataSet do
    begin
      NoUpdating := not (csUpdating in ComponentState);
      if NoUpdating then Updating;
      try
        Checked := Active;
        if Checked then
        begin
          fRecordCount := DataSet.RecordCount;
          fRecNo := DataSet.RecNo;
          if fRecNo >= 0 then S1 := inttostr(fRecNo)
          else S1 := '?';
          if fRecordCount >= 0 then S2 := inttostr(fRecordCount)
          else S2 := '?';
          H := Format(CapState, [S1, S2]);
          SeparateCaption(C, H);
          if {fDataSet.}State in [dsEdit, dsInsert] then
          begin
            C := StringReplace(C, ' ', #160, []);
          end;
          Caption := C;
          Hint := H;
        end
        else
        begin
          Caption := CapClose;
          Hint := CapClose;
        end;
        inherited;
      finally
        if NoUpdating then Updated;
      end;
    end else inherited;
end;

{ TCepNavButton }

constructor TCepNavButton.Create(AOwner: TComponent);
begin
  inherited;
  SetSubComponent(True);
  ControlStyle := ControlStyle
    - [csDesignInteractive, csDoubleClicks, csReflector]
    + [csNoDesignVisible];
  if (csDesigning in ComponentState) then
    ControlStyle := ControlStyle
      - [csCaptureMouse, csActionClient, csClickEvents]
      - [csNoStdEvents];
 // ComponentStyle := ComponentStyle ;
end;

type
  TWinControlEx = class(TWinControl)

  end;

function TCepNavButton.DesignWndProc(var Message: TMessage): Boolean;
begin
  Result := false;
  case Message.Msg of
    WM_NCHITTEST:
      begin
        Message.result := -1;
      end;
    WM_LBUTTONDBLCLK:
      begin
      //   
      end;
  else
    result := inherited DesignWndProc(Message);
  end;
end;

procedure TCepNavButton.DoTimer(Sender: TObject);
var Action: TDataSetActionCep;
begin
  Action := TDataSetActionCep(ActionClient.Action);
  if (Action <> nil) and (MouseInControl) and
    (Action.DataSet <> nil) and
    (Action.DataSet.Active) and
    (Action.Enabled) and (Action.Visible) then
  begin
    Action.Execute;
    if fInterval > 40 then
    begin
      fInternalTimer.Stop;
      fInterval := (fInterval * 2) div 3;
      fInternalTimer.ExecuteInterval(fInterval, DoTimer);
    end;
  end else
  begin
    fInternalTimer.Stop;
    inherited MouseUp(mbLeft, [], 0, 0);
  end;
end;

procedure TCepNavButton.MouseDown(Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
var DBActionBar: TNavigatorCep;
begin
  if csDesigning in ComponentState then Exit;
  inherited;
  if ActionClient <> nil then
  begin
    DBActionBar := GetNavigatorCep(ActionClient.Action);
    if (DBActionBar <> nil) then
    begin
      if (Action is TDataSetActionCep) and
        (TDataSetActionCep(Action).DBCepButton in [dcbPrior, dcbNext]) then
        AutoClick := true;
      if AutoClick then
      begin
        if fInternalTimer = nil then
        begin
          fInternalTimer := TInternalTimer.Create(self);
        end;
        fInterval := 500;
        fInternalTimer.ExecuteInterval(fInterval, DoTimer);
      end else
      begin
        FreeAndNil(fInternalTimer);
      end;
    end;
  end;
end;

procedure TCepNavButton.MouseUp(Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
var DBActionBar: TNavigatorCep;
  Need: boolean;
begin
  if csDesigning in ComponentState then Exit;
  if ActionClient <> nil then
  begin
    DBActionBar := GetNavigatorCep(ActionClient.Action);
    if (DBActionBar <> nil) then
    begin
      Need := (fInterval = 500) or (fInternalTimer = nil);
      DBActionBar.fNeedExecute := Need;
      try
        inherited;
      finally
        DBActionBar.fNeedExecute := true;
      end;
    end else inherited;
    FreeAndNil(fInternalTimer);
    fInterval := 0;
  end else inherited;
end;

{ TCepStyleButtonState }

procedure TCepStyleButtonState.CalcLayout;
var W: integer;
  DBActionBar: TNavigatorCep;
begin
  inherited;
  if ShowCaption and (ActionClient <> nil) then
  begin
    DBActionBar := GetNavigatorCep(ActionClient.Action);
    if DBActionBar <> nil then
    begin
      W := Width;
      W := ((W) div (8)) * 8;
      if W < DBActionBar.fMaxWidthState then
        Width := DBActionBar.fMaxWidthState
      else
        DBActionBar.fMaxWidthState := W;
    end;
  end;
end;

function TCepStyleButtonState.DesignWndProc(var Message: TMessage): Boolean;
begin
  case Message.Msg of
    WM_NCHITTEST:
      begin
        Message.result := -1;
        Result := true;
      end;
    WM_LBUTTONDBLCLK:
      begin
      //   
        Result := True;
      end;
  else
    result := inherited DesignWndProc(Message);
  end;
end;

procedure TCepStyleButtonState.DrawBackground(var PaintRect: TRect);
begin
  //inherited;   
end;

procedure TCepStyleButtonState.DrawFrame(ARect: TRect; Down: Boolean);
begin
  //inherited;   
end;

procedure TCepStyleButtonState.DrawGlyph(const Location: TPoint);
var Img: TRichImageList;
  Action: TDataSetStateAction;
  DBActionBar: TNavigatorCep;
begin
  Img := GetImg(ActionClient.ActionClients.SmallIcons);
  if (ActionClient.ShowGlyph) and (Img <> nil) and (Img.ImageList <> nil) and (Img.Index >= 0) and (Img.Index < Img.ImageList.Count) then
  begin
    DBActionBar := GetNavigatorCep(ActionClient.Action);
    if DBActionBar <> nil then
    begin
      Action := TDataSetStateAction(ActionClient.Action);
      IntOverlay.Enabled := Action.Enabled;
      if Action.Enabled then
      begin
        Img.Width := Img.ImageList.Width;
        Img.Height := Img.ImageList.Height;
        Img.Enabled := (Action.Checked);
        Img.Hot := false;
        Img.Pushed := False;
        Img.Checked := false;
        Img.BorderColor := $1FFFFFFF;
        Canvas.Draw(Location.X - 4, Location.Y + 2, Img);
        if not DBActionBar.Wait then
        begin
          if Action.fDataSet <> nil then
          begin
            case Action.fDataSet.State of
              dsEdit: IntOverlay.Index := 1;
              dsInsert: IntOverlay.Index := 0;
            else
              IntOverlay.Index := -1
            end;
          end else IntOverlay.Index := -1;
        end
        else
          IntOverlay.Index := 2;
      end else
      begin
        IntOverlay.Index := 3;
      end;
      Canvas.Draw(Location.X + Img.ImageList.Width - IntOverlay.Width + 2,
        Location.Y - 2,
        IntOverlay);
    end;
  end;
end;

procedure TCepStyleButtonState.DrawLargeGlyph(Location: TPoint);
begin
  DrawGlyph(Location);
end;

procedure TCepStyleButtonState.DrawText(var ARect: TRect; var Flags: Cardinal;
  Text: string);
begin
  while (Length(Text) > 0) and (Text[Length(Text)] = '.') do
    Delete(Text, Length(Text), 1);
  OffsetRect(ARect, -3, 0);
  if (Action is TAction) and (not TAction(Action).Checked) then
    inherited DrawShadowedText(ARect, Flags, Text, 0, 0)
  else
    inherited;
end;

{ TCepNavAddRemoveItem }

procedure TCepNavAddRemoveItem.DrawGlyph(const Location: TPoint);
var
  X, Y: integer;
  IsVisible, Need: boolean;
  B: TDBCepButton;
  DBActionBar: TNavigatorCep;
begin
  IsVisible := false;
  Need := false;
  DBActionBar := GetNavigatorCep(ActionClient.Action);
  if DBActionBar <> nil then
    for B := Low(DBActionBar.fActions) to High(DBActionBar.fActions) do
      if DBActionBar.fActions[B] = ActionClient.Action then
      begin
        IsVisible := (B in DBActionBar.VisibleButtons) and (B in DBActionBar.Buttons);
        Need := (B in DBActionBar.Buttons);
        break;
      end;
  // ,     ,   
  if Need then
  begin
    X := 3;
    Y := (ClientHeight - 11) div (2);
    Canvas.Brush.Color := Menu.ColorMap.SelectedColor;
    Canvas.Pen.Color := DBActionBar.ColorMap.BtnFrameColor;
    Canvas.Pen.Width := 1;
    Canvas.Rectangle(X, Y, X + 11, Y + 11);
    if IsVisible then
    begin
      Canvas.Pen.Color := Menu.ColorMap.FontColor;
      DrawCheck(Canvas, Point(X + 2, Y + 5), 2, false);
    end;
  end;
  DrawGliphControl(self, false, Location);
end;

{ TCepNavCustomizePopup }

procedure TCepNavCustomizePopup.CloseMenu;
begin
  if PopupStack <> nil then
  begin
    inherited CloseMenu;
    if Owner is TNavigatorCep then
    begin
      TNavigatorCep(Owner).fItemsChanged := true;
      TNavigatorCep(Owner).RecreateItemsDelay(50);
    end;
  end;
end;

function TCepNavCustomizePopup.DoItemClicked(
  AnItem: TCustomActionControl): TActionClientItem;
var ActionBar: TNavigatorCep;
  B: TDBCepButton;
begin
  if (AnItem is TCepNavAddRemoveItem) and (AnItem.ActionClient.Action is TAction) then
  begin
    if Owner is TNavigatorCep then
    begin
      ActionBar := TNavigatorCep(Owner);
      for B := Low(ActionBar.fActions) to High(ActionBar.fActions) do
        if ActionBar.fActions[B] = AnItem.ActionClient.Action then
        begin
          with ActionBar do
            if B in fVisibleButtons then
              fVisibleButtons := fVisibleButtons - [B]
            else
              fVisibleButtons := fVisibleButtons + [B];
          break;
        end;
      {ActionBar.Realign;
      with ActionBar do
        ActionBar.SetBounds(Left, Top, Width, Height); }
    end;
    Result := nil;
  end
  else
    result := inherited DoItemClicked(AnItem);
end;

function TCepNavCustomizePopup.GetAddRemoveItemClass: TCustomAddRemoveItemClass;
begin
  result := TCepNavAddRemoveItem;
end;

procedure TCepNavCustomizePopup.GetSubMenuControlClass(Sender: TCustomActionBar;
  AnItem: TActionClient; var ControlClass: TCustomActionControlClass);
begin
  ControlClass := GetAddRemoveItemClass;
end;

procedure TCepNavCustomizePopup.SetActionClient(const Value: TActionClient);
  procedure RecreateItems;
  var J: TDBCepButton;
    ClientItem: TActionClientItem;
    DBActionBar: TNavigatorCep;
  begin
    if not (csDestroying in ComponentState) and (Owner is TNavigatorCep) then
    begin
      with FARItem do
      begin
        DBActionBar := TNavigatorCep(Owner);
        Items.BeginUpdate;
        try
          Items.Clear;
          for J := Low(DBActionBar.fActions) to High(DBActionBar.fActions) do
            if (DBActionBar.fActions[J] <> nil) then
            begin
              ClientItem := Items.Add;
              if Parent <> nil then
              begin
                ClientItem.Action := DBActionBar.fActions[J];
              end;
            end;
        finally
          Items.EndUpdate;
        end;
      end;
    end;
  end;
begin
  if (Owner is TNavigatorCep) and (Value <> nil) then
  begin
    if FARItem = nil then
    begin
      FARItem := Value.Items.Add;
      FARItem.UsageCount := -1;
      FARItem.Action := TNavigatorCep(Owner).fARAction;
      RecreateItems;
    end;
  end;
  inherited;
end;

{ TNavigatorCep }

function TNavigatorCep.ActionClass(B: TDBCepButton): TContainedActionClass;
begin
  if B = dcbState then
    result := TDataSetStateAction
  else
    result := TDataSetActionCep;
end;

constructor TNavigatorCep.Create(AOwner: TComponent);
begin
  inherited;
  ControlStyle := ControlStyle + [csDesignInteractive] - [csAcceptsControls, csSetCaption];
  if csDesigning in ComponentState then
    ControlStyle := ControlStyle - [csReplicatable] - [csPannable];
  Designable := false;
  fNeedExecute := true;
  fButtons := DefaulButtons;
  fVisibleButtons := DefaultVisibleButtons;
  Align := alTop;
end;

procedure TNavigatorCep.AfterConstruction;
begin
  inherited;
  RecreateActionManager;
end;

destructor TNavigatorCep.Destroy;
begin

  inherited;
end;

function TNavigatorCep.DoBeforeAction(Action: TAction; DataSet: TDataSet;
  Button: TDBCepButton): boolean;
var Allowed: boolean;
  OldWait: boolean;
begin
  result := false;
  if not fNeedExecute then Exit;
  if (csDesigning in ComponentState) and
    (not (Button in [dcbFirst, dcbPrior, dcbNext, dcbLast])) then
    Exit;
  result := DoUpdateAction(Action, DataSet, Button);
  Allowed := true;
  OldWait := Wait;
  if Result then
  begin
    if (not (csDesigning in ComponentState)) and
      (Button <> dcbRefresh) and Assigned(BeforeAction) then
      BeforeAction(Self, Action, DataSet, Button, Allowed);
    if Allowed and (DataSet <> nil) then
    begin
      with DataSet do
        case Button of
          dcbFirst: First;
          dcbPrior: Prior;
          dcbNext: Next;
          dcbLast:
            begin
              Wait := True;
              try
                Last;
              finally
                Wait := OldWait;
              end;
            end;
          dcbInsert: Insert;
          dcbDelete: Delete;
          dcbEdit: Edit;
          dcbPost: Post;
          dcbCancel: begin
              if Active then
              begin
                if State in [dsEdit, dsInsert] then
                  Cancel
                else if (DataSet is TCustomClientDataSet) and (fActions[dcbRevert] <> nil) then
                begin
                  fActions[dcbRevert].Execute;
                end;
              end;
            end;
          dcbRefresh: begin
              if abs(fLastRefresh - GetTickCount) > 1000 then
              begin
                Wait := True;
                try
                  if Assigned(BeforeAction) then
                    BeforeAction(Self, Action, DataSet, Button, Allowed);
                  if Allowed then
                  begin
                    if Active then
                    begin
                      if (DataSet is TClientDataSet) and (TClientDataSet(DataSet).ProviderName = '') then
                        TClientDataSet(DataSet).EmptyDataSet
                      else
                        Refresh;
                    end else
                    begin
                      if (DataSet is TClientDataSet) and (TClientDataSet(DataSet).ProviderName = '') then
                        TClientDataSet(DataSet).CreateDataSet
                      else
                        Open;
                    end;
                  end;
                  if Assigned(AfterAction) then
                    AfterAction(Self, Action, DataSet, Button, Allowed);
                finally
                  fLastRefresh := GetTickCount;
                  Wait := OldWait;
                end;
              end;
            end;
          dcbApply, dcbRevert, dcbUndo:
            begin
              result := Active and (DataSet is TCustomClientDataSet);
              if result then
                with TCustomClientDataSetEx(DataSet) do
                  case Button of
                    dcbApply: ApplyUpdates(-1);
                    dcbRevert: RevertRecord;
                    dcbUndo: UndoLastChange(True);
                  end;
            end;
        end;
    end;
    if (not (csDesigning in ComponentState)) and
      (Button <> dcbRefresh) and Assigned(AfterAction) then
      AfterAction(Self, Action, DataSet, Button, Allowed);
  end;
end;

procedure TNavigatorCep.DoDropItem(Source: TActionItemDragObject; const X,
  Y: Integer);
begin
  //inherited;
end;

function TNavigatorCep.DoUpdateAction(Action: TAction; DataSet: TDataSet;
  Button: TDBCepButton): boolean;
var Allowed: boolean;
begin
  result := false;
  if (csDesigning in ComponentState) and
    (not (Button in [dcbFirst, dcbPrior, dcbNext, dcbLast, dcbState])) then
    Exit;
  result := (DataSet <> nil) and (Action <> nil);
  Allowed := true;
  if Result then
  begin
    if (not (csDesigning in ComponentState)) and Assigned(self.onUpdateAction) then
      onUpdateAction(Self, Action, DataSet, Button, Allowed);
    if Allowed then
    begin
      with DataSet do
        case Button of
          dcbState: result := true;
          dcbFirst, dcbPrior: result := Active and (not BOF);
          dcbNext, dcbLast: result := Active and (not EOF);
          dcbInsert, dcbDelete, dcbEdit, dcbPost: begin
              result := Active and CanModify;
              if result then
                case Button of
                  dcbInsert: result := State <> dsInsert;
                  dcbDelete: result := not IsEmpty;
                  dcbEdit: result := not (State in [dsEdit, dsInsert]);
                  dcbPost: result := (State in [dsEdit, dsInsert]);
                end;
              if result and (DataSet is TCustomClientDataSet) then
                result := not TCustomClientDataSetEx(DataSet).ReadOnly;
            end;
          dcbCancel: begin
              result := Active and CanModify and (State in [dsEdit, dsInsert]);
              if (not Result) and Active and (DataSet is TCustomClientDataSet) and (fActions[dcbRevert] <> nil) then
              begin
                fActions[dcbRevert].Update;
                result := fActions[dcbRevert].Enabled;
              //result := not (TCustomClientDataSetEx(DataSet).UpdateStatus = usUnmodified);
              end;
            end;
          dcbRefresh: result := true;
          dcbApply, dcbRevert, dcbUndo:
            begin
              result := Active and (DataSet is TCustomClientDataSet);
              if result then
                with TCustomClientDataSetEx(DataSet) do
                  case Button of
                    dcbApply: result := CanModify and (not ReadOnly) and (ChangeCount > 0);
                    dcbRevert: result := not (UpdateStatus = usUnmodified);
                    dcbUndo: result := ChangeCount > 0;
                  end;
            end;
        end;
      Action.Enabled := result;
    end
    else
      result := Action.Enabled;
  end else
  begin
    if (not (csDesigning in ComponentState)) and Assigned(self.onUpdateAction) then
    begin
      onUpdateAction(Self, Action, DataSet, Button, Allowed);
      result := Action.Enabled;
    end;
  end;
end;

procedure TNavigatorCep.DragOver(Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  //inherited;
  Accept := false;
end;

procedure TNavigatorCep.ExecuteARItem(Sender: TObject);
begin
  //Repaint;
end;

function TNavigatorCep.GetControlClass(
  AnItem: TActionClientItem): TCustomActionControlClass;
begin
  if (AnItem <> nil) and (AnItem.Action is TDataSetStateAction) then
  begin
    result := TCepStyleButtonState;
  end else
    result := TCepNavButton;
end;

function TNavigatorCep.GetDataSource: TDataSource;
var I: integer;
begin
  result := nil;
  for I := 0 to ControlCount - 1 do
    if (Controls[i].Action is TDataSetActionCep) and
      (TDataSetActionCep(Controls[i].Action).DataSource <> nil) then
    begin
      result := TDataSetActionCep(Controls[i].Action).DataSource;
    end;
end;

function TNavigatorCep.GetPopupClass: TCustomActionBarClass;
begin
  result := TCepNavCustomizePopup;
end;

procedure TNavigatorCep.SetDataSource(const Value: TDataSource);
var I: integer;
begin
  for I := 0 to ControlCount - 1 do
    if (Controls[i].Action is TDataSetActionCep) and
      (TDataSetActionCep(Controls[i].Action).DataSource <> Value) then
    begin
      TDataSetActionCep(Controls[i].Action).DataSource := Value;
    end;
end;

procedure TNavigatorCep.LoadFromStream(Stream: TStream);
var V, B, N: integer;
  I: TDBCepButton;
  But, Vis, OldBut, OldVis: TDBCepButtons;
  Large: Byte;
begin
  OldBut := Buttons;
  OldVis := VisibleButtons;
  try
    N := 0;
    But := [];
    Vis := [];
    inherited;
    Stream.ReadBuffer(B, SizeOf(B));
    Stream.ReadBuffer(V, SizeOf(V));
    Stream.ReadBuffer(Large, SizeOf(Large));
    if Large = 0 then
      SmallImages := true
    else
      SmallImages := false;
    for I := Low(TDBCepButton) to High(TDBCepButton) do
    begin
      if (B and (1 shl (N))) <> 0 then
        But := But + [I];
      if (V and (1 shl (N))) <> 0 then
        Vis := Vis + [I];
      inc(N);
    end;
  except
    But := OldBut;
    Vis := OldVis;
    raise;
  end;
end;

procedure TNavigatorCep.SaveToStream(Stream: TStream);
var V, B, N: integer;
  I: TDBCepButton;
  Large: byte;
begin
  inherited;
  V := 0;
  B := 0;
  N := 0;
  if SmallImages then
    Large := 0
  else
    Large := 1;
  for I := Low(TDBCepButton) to High(TDBCepButton) do
  begin
    if I in Buttons then
      B := B or (1 shl (N));
    if I in VisibleButtons then
      V := V or (1 shl (N));
    inc(N);
  end;
  Stream.WriteBuffer(B, SizeOf(B));
  Stream.WriteBuffer(V, SizeOf(V));
  Stream.WriteBuffer(Large, SizeOf(Large));
end;

procedure TNavigatorCep.MouseDown(Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
  if (csDesigning in ComponentState) then Exit;
  inherited;
end;

procedure TNavigatorCep.MouseUp(Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
  if (csDesigning in ComponentState) then Exit;
  inherited;
end;

type
  TActionClientsEx = class(TActionClients)

  end;

procedure TNavigatorCep.RecreateActionManager;
var j: TDBCepButton;
  i: integer;
  AMIsNull: boolean;
  NewActionBarItem: TActionBarItem;
  function CreateAction(ClassAction: TContainedActionClass; Caption: string; Index: TDBCepButton): TAction;
  var S: string;
    NewAction: TAction;
  begin
    result := nil;
    if (ClassAction <> nil) and (ClassAction.InheritsFrom(TAction)) then
    begin
      if (ClassAction.InheritsFrom(TDataSetAction) and (Index in fButtons)) or
        (not ClassAction.InheritsFrom(TDataSetAction)) then
      begin
        NewAction := TAction(ClassAction.Create(fIntActionManager));
        result := NewAction;
        SeparateCaption(S, Caption);
        if TDBCepButton(Index) = dcbState then
        begin
          result.Caption := CapEmpty;
          result.Hint := CapEmpty;
        end else
        begin
          result.Caption := S;
          result.Hint := Caption;
        end;
        result.ActionList := fIntActionManager;
        if result is TDataSetActionCep then
          result.ImageIndex := integer(Index);
      end;
    end;
  end;
begin
  AMIsNull := false;
  try
    if Items <> nil then Items.Clear;
    AMIsNull := fIntActionManager = nil;
    if AMIsNull then
    begin
      fIntActionManager := TDBCepActionManager.Create(self);
      fIntActionManager.Style := CepStyle;
      if _IntImages = nil then
      begin
        CreateImageList(_IntImages, 24, 16, 'DATASETIMAGES_24');
        CreateImageList(_IntImages, 16, 16, 'DATASETIMAGES_16');
      end;
      fIntActionManager.Images := _IntImages;
      fARAction := CreateAction(TAction, CapAR, Low(Caps));
      fARAction.OnExecute := ExecuteARItem;
      fARAction.OnUpdate := UpdateARItem;
    end else
    begin
      // ,    Buttons
      i := 0;
      while i < fIntActionManager.ActionCount do
        if (fIntActionManager.Actions[i] <> fARAction) then
        begin
          for J := Low(fActions) to High(fActions) do
            if (not (J in fButtons)) and
              (fActions[J] = fIntActionManager.Actions[i]) then
            begin
              fIntActionManager.Actions[i].Free;
              fActions[J] := nil;
              Dec(i);
              break;
            end;
          inc(i);
        end
        else inc(i);
    end;
    // ,    fButtons
    for J := Low(Caps) to High(Caps) do
      if (J in fButtons) and (fActions[J] = nil) then
      begin
        fActions[J] := CreateAction(ActionClass(J), Caps[J], J);
      end;
    fIntActionManager.ActionBars.Customizable := false;
    for I := 0 to fIntActionManager.ActionBars.Count - 1 do
      fIntActionManager.ActionBars[I].Items.SmallIcons := fSmallImages;

  finally
    if AMIsNull then
    begin
      NewActionBarItem := fIntActionManager.ActionBars.Add;
      NewActionBarItem.ActionBar := self;
      NewActionBarItem.Items.HideUnused := false;
      fIntActionManager.ActionBars[0].ChangesAllowed := [{caModify,caMove,caDelete}];
      AutoSize := false;
      AutoSizing := false;
    end;
  end;
end;

function TNavigatorCep.CreateButton(B: TDBCepButton): TActionClientItem;
begin
  result := nil;
  if (fActions[B] <> nil) and (B in fVisibleButtons) then
  begin
    result := Items.Add;
    if Parent <> nil then
    begin
      fItemsCreated := true;
      fActions[B].Visible := true;
      if fActions[B] is TDataSetStateAction then
      begin
        result.ShowCaption := true;
      end
      else begin
        result.ShowCaption := false;
      end;
      result.Action := fActions[B];
    end;
  end;
end;

procedure TNavigatorCep.RecreateItems;
var J: TDBCepButton;
  I: integer;
  Canvas: TCanvas;
  DC: HDC;
  DS: TDataSource;
  C, H: string;
begin
  if ([csDestroying, csUpdating] * ComponentState = []) and (fItemsChanged) and
    (Items <> nil) and (Parent <> nil) then
  begin
    fItemsChanged := false;
    Items.BeginUpdate;
    try
      DS := DataSource;
      DisableAlign;
      try
        if fMaxWidthState = 0 then
        begin
          DC := 0;
          Canvas := TCanvas.Create;
          try
            DC := GetDC(0);
            Canvas.Handle := DC;
            Canvas.Font := self.Font;
            C := CapState;
            SeparateCaption(C, H);
            fMaxWidthState := Canvas.TextWidth(Format(C, ['000', '000']));
            fMaxWidthState := ((fMaxWidthState + 40) div (8)) * 8;
          finally
            FreeAndNil(Canvas);
            if DC <> 0 then
            begin
              if releaseDC(0, DC) <> 1 then raiselastoserror;
            end;
          end;
        end;
        Items.HideUnused := false;
        Items.Customizable := false;
        if fItemsCreated then fNoPaint := GetTickCount;
        Items.Clear;
        for J := Low(fActions) to High(fActions) do
          if (fActions[J] <> nil) and (J in fVisibleButtons) then
          begin
            CreateButton(J);
          end;
        for I := 0 to ControlCount - 1 do
          if Controls[i].Action is TDataSetActionCep then
            Controls[i].Visible := TDataSetActionCep(Controls[i].Action).Visible;
      finally
        EnableAlign;
        DataSource := DS;
      end;
    finally
      Items.EndUpdate;
    end;
  end;
end;

procedure TNavigatorCep.SetButtons(const Value: TDBCepButtons);
begin
  if fButtons <> Value then
  begin
    fButtons := Value;
    fItemsChanged := true;
    RecreateActionManager;
    if csDesigning in ComponentState then
      RecreateItemsDelay(50)
    else
      RecreateItemsDelay(0);
  end;
end;

procedure TNavigatorCep.SetParent(AParent: TWinControl);
begin
  inherited;
  if (Parent <> nil) and (not fItemsCreated) then
  begin
    if fIntActionManager = nil then
      RecreateActionManager;
    fItemsChanged := true;
    if csDesigning in ComponentState then
      RecreateItemsDelay(50)
    else
      RecreateItemsDelay(0);
  end;
end;

procedure TNavigatorCep.SetSmallImages(const Value: boolean);
var I: integer;
begin
  if fSmallImages <> Value then
  begin
    fSmallImages := Value;
    fItemsChanged := True;
    for I := 0 to fIntActionManager.ActionBars.Count - 1 do
      fIntActionManager.ActionBars[I].Items.SmallIcons := Value;
    if (not (csUpdating in ComponentState)) and HandleAllocated then
    begin
      RecreateItems;
      self.AdjustSize;
    end;
  end;
end;

procedure TNavigatorCep.SetVisibleButtons(const Value: TDBCepButtons);
begin
  if fVisibleButtons <> Value then
  begin
    fVisibleButtons := Value;
    fItemsChanged := true;
    if csDesigning in ComponentState then
      RecreateItemsDelay(50)
    else
      RecreateItemsDelay(0);
  end;
end;

procedure TNavigatorCep.SetWait(const Value: boolean);
begin
  if fWait <> Value then
  begin
    fWait := Value;
    Repaint;
  end;
end;

//  

procedure TNavigatorCep.RecreateItemsDelay(Time: integer);
begin
  if Time = 0 then
    PostMessage(Handle, UMRecreate, 0, 0)
  else if Time > 0 then
  begin
    if fTmpTimer = nil then
      fTmpTimer := TInternalTimer.Create(self);
    fTmpTimer.ExecuteDelay(Time, DoRecreateItems);
  end else
    DoRecreateItems(self);
  if Time <= 0 then FreeAndNil(fTmpTimer);
end;

procedure TNavigatorCep.DoRecreateItems(Sender: TObject);
var i: integer;
begin
  RecreateItems;
  UpdateActionBars(fIntActionManager);
 // SetupDropDownBtn;
  if (csDesigning in ComponentState) and (fIntActionManager <> nil) then
    for I := 0 to fIntActionManager.ActionCount - 1 do
      fIntActionManager.Actions[i].Update;
end;

procedure TNavigatorCep.UMRecreateItems(var Message: TMessage);
begin
  DoRecreateItems(nil);
end;

procedure TNavigatorCep.UpdateARItem(Sender: TObject);
begin
  if Sender is TAction then
    TAction(Sender).Enabled := Buttons <> [];
end;

procedure TNavigatorCep.WMPAINT(var Message: TWMPAINT);
begin
  if (fNoPaint = 0) or (abs(GetTickCount - fNoPaint) > 50) then
  begin
    inherited;
    fNoPaint := 0;
  end;
end;


initialization
  _IntImages := nil;
  _IntImagesOverlay := nil;
  _IntOverlay := nil;
finalization
  FreeAndNil(_IntImages);
  FreeAndNil(_IntImagesOverlay);
  FreeAndNil(_IntOverlay);

end.

