unit EditImageListCep;
(*
 * Module:           TImageListCep
 * Version:    2.0 (27.11.2007)
 * Author:      
 * Comments:    y     .
 *                    
 *               roschinspb@mail.ru
 *             http://www.delphikingdom.com/asp/users.asp?ID=1271
 *
 * Copyright:   2007 .
 *
 * Version:    2.0
 *)
interface
{$I '..\Directives.Inc'}
uses SysUtils, Classes,
     {$IFDEF VER130}
     DsgnIntf,
     {$ELSE}
     DesignIntf,DesignEditors,VCLEditors,
     {$ENDIF}
     TypInfo, Controls,
     ActnList, FormImageListCep, ImageListCep, ActionTreeView, uEditActionTreeView;
resourcestring
  Verb0 = '';
type
  TImageListCepEditor = class (TComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer;  override;
  end;

  TActionTreeViewEditor = class (TComponentEditor)
  private
    fListNames: TStringList;
    fListImages: TStringList;
    procedure GetObjectName(const S: string);
    procedure GetImagesName(const S: string);
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer;  override;
  end;


procedure Register;

implementation
uses Windows;

procedure Register;
begin
  {$IFDEF DELPHI_2005_UP}
  ForceDemandLoadState(dlDisable);
  {$ENDIF}
  RegisterComponentEditor(TImageListCep, TImageListCepEditor);
  RegisterComponentEditor(TActionTreeView, TActionTreeViewEditor);
end;

{ TImageListCepEditor }

procedure TImageListCepEditor.ExecuteVerb(Index: Integer);
var F:TFormDlgSIL;
    DT:boolean;
begin
  inherited;
  if Component is TImageListCep then
  begin
    F:=TFormDlgSIL.Create(nil);
    try
      DT := ImageListCep.DesignTime;
      ImageListCep.DesignTime := True;
      try
        F.ImageListCep := TImageListCep(Component);
        F.ShowModal;
      finally
        ImageListCep.DesignTime := DT;
        if F.Modified then
          Designer.Modified;
      end;
    finally
      FreeAndNil(F);
    end;
  end;
end;

function TImageListCepEditor.GetVerb(Index: Integer): string;
begin
  if index=0 then
    result := Verb0
  else
    result := inttostr(Index);
end;

function TImageListCepEditor.GetVerbCount: Integer;
begin
  result := 1;
end;

{ TActionTreeViewEditor }

procedure TActionTreeViewEditor.ExecuteVerb(Index: Integer);
var I: integer;
begin
  inherited;
  if Component is TActionTreeView then
  begin
    if EditActionTreeView = nil then
      EditActionTreeView := TEditActionTreeView.Create(nil);
    try
      for I := 0 to EditActionTreeView.pTop.ComponentCount - 1 do
      begin
        if EditActionTreeView.pTop.Components[I] is TActionTreeView then
          TActionTreeView(EditActionTreeView.pTop.Components[I]).IsDesigning := True;
      end;
      fListNames := TStringList.Create;
      fListImages := TStringList.Create;
      try
        EditActionTreeView.EnableActionEdit := True;
        EditActionTreeView.Caption := Component.Name;
        EditActionTreeView.ActionTreeView := TActionTreeView(Component);
       // MessageBox(0, PChar(Inttostr(TypeData.)), nil, 0);
        Designer.GetComponentNames(GetTypeData(TypeInfo(TCustomAction)), GetObjectName);
        Designer.GetComponentNames(GetTypeData(TypeInfo(TDragImageList)), GetImagesName);
        try
          EditActionTreeView.AddSourceActions(fListNames);
          EditActionTreeView.AddImages(fListImages);
        except
          on E: Exception do
          begin
            MessageBox(0, PChar(E.Message), PChar(string(E.ClassName)), MB_ICONERROR);
          end;
        end;
        //EditActionTreeView.ListBox1.Items := fListNames;
      finally
        FreeAndNil(fListImages);
        FreeAndNil(fListNames);
        if EditActionTreeView.ShowModal = IdOk then
        begin
          TActionTreeView(Component).Assign(EditActionTreeView.ActionTreeView);
          Designer.Modified;
        end;
      end;
    finally
      FreeAndNil(EditActionTreeView);
    end;
  end;
end;

procedure TActionTreeViewEditor.GetObjectName(const S: string);
begin
  fListNames.AddObject(S, Designer.GetComponent(S));
end;

procedure TActionTreeViewEditor.GetImagesName(const S: string);
begin
  fListImages.AddObject(S, Designer.GetComponent(S));
end;

function TActionTreeViewEditor.GetVerb(Index: Integer): string;
begin
  if index=0 then
    result := Verb0
  else
    result := inttostr(Index);
end;

function TActionTreeViewEditor.GetVerbCount: Integer;
begin
  result := 1;
end;

end.
