{$IFDEF DELPHI_2005_UP}{$REGION '      . TSpeedButtonCep   Cep'}{$ENDIF}
///	<summary>      .  <b>TSpeedButtonCep</b>  
///	<b>Cep</b></summary>
/// <comments>   ,    EditorsCepEx.dpk</comments>
{$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
unit SpeedButtonCep;

(*
  * Module:            TSpeedButtonCep
  *                      Delphi
  *                 
  *             ControlsCepEx.dpk  EditorsCepEx.dpk.
  * Version:    2.8.0.0 (20.01.2010)
  * Author:      
  * Comments:         .
  *                    
  *              : roschinspb@mail.ru
  *             http://www.delphikingdom.com/asp/users.asp?ID=1271
  *             http://www.roschinspb.narod.ru
  *
  * Copyright:   2006 - 2010 .
  *
  * Version:    2.8.0.0 (20.01.2010)
  * Realized:     TCustomGliphs
  *
  * Version:    2.2 (21.09.2008)
  * Realized:     Delphi 2009.
  *
  * Version:    2.1 (18.09.2007)
  * Realized:      XP. .  ThemeEnabled.
*)
interface

{$I Directives.Inc}

uses
  Windows, Messages, SysUtils, Classes,
{$IFDEF DELPHI_6_UP}
  RTLConsts,
{$ELSE}
  Consts,
{$ENDIF}
  Controls, ImgList, Graphics,
{$IFDEF VER130}{$ELSE}GraphUtil, {$ENDIF}
  GraphUtilEx, CommCtrl, ActnList, ExtCtrls, Buttons, BitOp, InternalTimer;

resourcestring
  NoAssign = '   %s  %s';
  NoIndexImg = '   (%d)';
  NoAssignfList = '  fList';

type

  {$IFDEF DELPHI_2005_UP}{$REGION '   '}{$ENDIF}
  /// <summary>   </summary>
  /// <remarks>
  /// <para>CepBKImage -  </para>
  /// <para>CepBKNone -   </para>
  /// <para>CepBKLeftChevron -    </para>
  /// <para>CepBKRightChevron -    </para>
  /// <para>CepBKUpChevron -    </para>
  /// <para>CepBKDownChevron -    </para>
  /// <para>CepBKLeftArrow -   </para>
  /// <para>CepBKRightArrow -   </para>
  /// <para>CepBKUpArrow -   </para>
  /// <para>CepBKDownArrow -   </para>
  /// <para>CepBkCheck -  </para>
  /// <para>CepBkCheckShadow -   </para>
  /// <para>CepBKBulets -  </para>
  /// </remarks>
  /// <seealso cref="TSpeedButtonCep.ButtonKind"></seealso>
  {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
  TCepButtonKind = (CepBKImage, CepBKNone, CepBKLeftChevron, CepBKRightChevron,
    CepBKUpChevron, CepBKDownChevron, CepBKLeftArrow, CepBKRightArrow,
    CepBKUpArrow, CepBKDownArrow, CepBkCheck, CepBkCheckShadow, CepBKBulets);

  {$IFDEF DELPHI_2005_UP}{$REGION '      Invalidate.'}{$ENDIF}
  /// <summary>      Invalidate.</summary>
  /// <remarks>
  /// <para>imInvalidate -     ,    
  ///  .</para>
  /// <para>imRepaint -   </para>
  /// <para>imNone -    </para>
  /// </remarks>
  /// <seealso cref="TSpeedButtonCep.Invalidate"></seealso>
  /// <seealso cref="TSpeedButtonCep.InvalidateMode"></seealso>
  /// <seealso cref="InvalidateRect"></seealso>
  {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
  TInvalidateMode = (imInvalidate, imRepaint, imNone);

  {$IFDEF DELPHI_2005_UP}{$REGION ' '}{$ENDIF}
  /// <summary> </summary>
  /// <remarks>
  /// <para>cbsNormal -  </para>
  /// <para>cbsDropDown -     </para>
  /// <para>cbsDropRight -     </para>
  /// <para>cbsDrop -     </para>
  /// </remarks>
  /// <seealso cref="TSpeedButtonCep.Style"></seealso>
  {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
  TCepButtonStyle = (cbsNormal, cbsDropDown, cbsDropRight, cbsDrop);

  TCustomGliphs = class(TPersistent)
  private
    fOwner: TComponent;
    fOnChanged: TNotifyEvent;
  protected
    procedure Changed; virtual;
    function CheckImageIndex(I: integer): boolean; virtual;
    function GetHandle: THandle; virtual;
    function GetOwner: TPersistent; override;
  public
    constructor Create(AOwner: TComponent);
    procedure LoadFromStream(S: TStream); virtual;
    procedure SaveToStream(S: TStream); virtual;
    property Handle: THandle read GetHandle;
    property Owner: TComponent read fOwner;
    property OnChanged: TNotifyEvent read fOnChanged write fOnChanged;
  end;


  {$IFDEF DELPHI_2005_UP}{$REGION '    '}{$ENDIF}
  ///	<summary>    </summary>
  ///	<seealso cref="TSpeedButtonCep"></seealso>
  {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
  TGliphsClass = class of TCustomGliphs;

  {$IFDEF DELPHI_2005_UP}{$REGION '     '}{$ENDIF}
  ///	<summary>     </summary>
  {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
  TGliphs = class(TCustomGliphs)
  private
    fImageIndexNormal: TImageIndex;
    fImageIndexPush: TImageIndex;
    fImageIndexCheck: TImageIndex;
    fImageIndexNormalHot: TImageIndex;
    fImageIndexCheckHot: TImageIndex;
    fImageIndexDisable: TImageIndex;
    fImageIndexCheckDisable: TImageIndex;
    procedure SetImageIndexCheck(const Value: TImageIndex);
    procedure SetImageIndexCheckDisable(const Value: TImageIndex);
    procedure SetImageIndexCheckHot(const Value: TImageIndex);
    procedure SetImageIndexDisable(const Value: TImageIndex);
    procedure SetImageIndexNormal(const Value: TImageIndex);
    procedure SetImageIndexPush(const Value: TImageIndex);
    procedure SetIndexNormalHot(const Value: TImageIndex);
    procedure SetIndex(var OldValue: TImageIndex; NewValue: TImageIndex);
  protected
    procedure Changed; override;
  public
    constructor Create(AOwner: TControl);
    procedure Assign(Source: TPersistent); override;
  published
    property ImageIndexNormal: TImageIndex read fImageIndexNormal
      write SetImageIndexNormal default -1;
    property ImageIndexPush: TImageIndex read fImageIndexPush
      write SetImageIndexPush default -1;
    property ImageIndexCheck: TImageIndex read fImageIndexCheck
      write SetImageIndexCheck default -1;
    property ImageIndexNormalHot: TImageIndex read fImageIndexNormalHot
      write SetIndexNormalHot default -1;
    property ImageIndexCheckHot: TImageIndex read fImageIndexCheckHot
      write SetImageIndexCheckHot default -1;
    property ImageIndexDisable: TImageIndex read fImageIndexDisable
      write SetImageIndexDisable default -1;
    property ImageIndexCheckDisable: TImageIndex read fImageIndexCheckDisable
      write SetImageIndexCheckDisable default -1;
    property OnChanged;
  end;

  {$IFDEF DELPHI_2005_UP}{$REGION '  .'}{$ENDIF}
  /// <summary>  .</summary>
  {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
  TSpeedButtonCep = class(TGraphicControl)
  private
    fGliphs: TGliphs;
    fList: TRichImageList;
    FImageChangeLink: TChangeLink;
    fAutoCheck: boolean;
    fTimer: TTimer;
    fDefaultIndex: boolean;
    fClicks: TNotifyEvent;
    fIsClicks: boolean;
    fButtonKind: TCepButtonKind;
    fAutoHot: boolean;
    fHotChanged: TNotifyEvent;
    fCountUpdate: integer;
    fImageIndex: integer;
    fInvalidateMode: TInvalidateMode;
    fDropDown: TNotifyEvent;
    fStyle: TCepButtonStyle;
    fChildButton: TGraphicControl;
    {$IFDEF DELPHI_2005_UP}{$REGION '      . Note:    200  '}{$ENDIF}
    /// <summary>
    /// <para>      .</para>
    /// <note type="note">   200 </note>
    /// </summary>
    {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
    fTimerHot: TInternalTimer;
    fInvalidating: boolean;
    procedure HotProc(Sender: TObject);
    procedure AddToEdit(Control: TWinControl);
    procedure SbbFromEdit(Control: TWinControl);
    procedure SetImageList(const Value: TCustomImageList);
    procedure ImageListChange(Sender: TObject);
    procedure ListChange(Sender: TObject);
    procedure SetChecked(const Value: boolean);
    procedure CMColorChanged(var Message: TMessage); message CM_COLORCHANGED;
    procedure CMVISIBLECHANGED(var Message: TMessage);
      message CM_VISIBLECHANGED;
    procedure CMENABLEDCHANGED(var Message: TMessage);
      message CM_ENABLEDCHANGED;
    procedure WMLButtonUp(var Message: TWMLButtonUp); message WM_LButtonUp;
    procedure CMMouseEnter(var Message: TMessage); message CM_MouseEnter;
    procedure CMMouseLeave(var Message: TMessage); message CM_MouseLeave;
    procedure WMSETTEXT(var Message: TWMSETTEXT); message WM_SETTEXT;
    procedure WMGETTEXTLENGTH(var Message: TWMGETTEXTLENGTH);
      message WM_GETTEXTLENGTH;
    procedure WMGETTEXT(var Message: TWMGETTEXT); message WM_GETTEXT;
    procedure CMFontChanged(var Message: TMessage); message CM_FONTCHANGED;
    procedure SetBorder(const Value: TCepButtonBorder);
    procedure SetBtnFrameColor(const Value: TColor);
    procedure SetSelectedColor(const Value: TColor);
    procedure SetTransparent(const Value: boolean);
    procedure SetImageIndex(const Value: integer);
    procedure SetPushed(const Value: boolean);
    procedure StartTimer;
    procedure StopTimer;
    procedure onTimer(Sender: TObject);
    procedure SetHot(const Value: boolean);
    procedure SetGliphs(const Value: TGliphs);
    procedure SetBlend(const Value: byte);
    procedure SetButtonKind(const Value: TCepButtonKind);
    procedure SetAutoHot(const Value: boolean);
    function GetBorder: TCepButtonBorder;
    function GetPushed: boolean;
    function GetBlend: byte;
    function GetBtnFrameColor: TColor;
    function GetSelectedColor: TColor;
    function GetImageList: TCustomImageList;
    function GetTransparent: boolean;
    function GetImageIndex: integer;
    function GetHot: boolean;
    function GetChecked: boolean;
    function GetLayout: TButtonLayout;
    function GetSpacing: byte;
    procedure SetLayout(const Value: TButtonLayout);
    procedure SetSpacing(const Value: byte);
    procedure SetStyle(const Value: TCepButtonStyle);
    procedure ClickChild(Sender: TObject);
    procedure ChildHotChanged(Sender: TObject);
    procedure UpdateChildBlend;
    procedure DoResize;
    function GetThemeEnabled: boolean;
    procedure SetThemeEnabled(const Value: boolean);
  protected
    procedure Notification(AComponent: TComponent;
      Operation: TOperation); override;
    procedure WndProc(var Message: TMessage); override;
    procedure SetFocus; dynamic;
    procedure KillFocus; dynamic;
    {$IFDEF DELPHI_2005_UP}{$REGION '   '}{$ENDIF}
    /// <summary>    </summary>
    /// <param name="Canvas"> (),     </param>
    /// <param name="X">  </param>
    /// <param name="Y">  </param>
    /// <param name="Transparent"> true      </param>
    {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
    procedure PaintToCanvas(Canvas: TCanvas; X, Y: integer;
      Transparent: boolean);
    procedure Updated; override;
    procedure UpdateImageIndex;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: integer); override;
    procedure ActionChange(Sender: TObject; CheckDefaults: boolean); override;
    function GetActionLinkClass: TControlActionLinkClass; override;
    procedure HotChanged; dynamic;
    procedure DropDown; dynamic;
    function CreateChildButton(Style: TCepButtonStyle)
      : TGraphicControl; dynamic;
    {$IFDEF DELPHI_2005_UP}{$REGION '       '}{$ENDIF}
    ///	<summary>       </summary>
    {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
    procedure UpdateChildButton;
    procedure SetParent(AParent: TWinControl); override;
    procedure Loaded; override;
    procedure Resize; override;
    property List: TRichImageList read fList;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property ImageIndex: integer read GetImageIndex write SetImageIndex;
    {$IFDEF DELPHI_2005_UP}{$REGION '    True,   '}{$ENDIF}
    /// <summary>    True,   </summary>
    {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
    property Pushed: boolean read GetPushed write SetPushed;
    {$IFDEF DELPHI_2005_UP}{$REGION '    True,      '}{$ENDIF}
    /// <summary>    True,      </summary>
    {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
    property Hot: boolean read GetHot write SetHot;
    procedure Repaint; override;
    {$IFDEF DELPHI_2005_UP}{$REGION '     InvalidateMode,      ,   ...'}{$ENDIF}
    ///	<summary>     InvalidateMode,      , 
    ///	 ,     </summary>
    ///	<seealso cref="InvalidateMode"></seealso>
    ///	<seealso cref="TInvalidateMode"></seealso>
    {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
    procedure Invalidate; override;
    procedure Paint; override;
    procedure Clicks; dynamic;
    procedure Click; override;
    property AutoHot: boolean read fAutoHot write SetAutoHot;
    procedure BeginUpdate;
    procedure EndUpdate;

    {$IFDEF DELPHI_2005_UP}{$REGION '    ,     Invalidate'}{$ENDIF}
    ///	<summary>    ,     Invalidate</summary>
    ///	<seealso cref="TInvalidateMode"></seealso>
    {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
    property InvalidateMode: TInvalidateMode read fInvalidateMode
      write fInvalidateMode;
  published
    property Action;
    property Anchors;
    property Align;
    {$IFDEF DELPHI_2005_UP}{$REGION '   ,        Checked'}{$ENDIF}
    /// <summary>   ,        Checked</summary>
    /// <seealso cref="TSpeedButtonCep.Checked"></seealso>
    {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
    property AutoCheck: boolean read fAutoCheck write fAutoCheck default false;
    {$IFDEF DELPHI_2005_UP}{$REGION ' '}{$ENDIF}
    /// <summary> </summary>
    /// <seealso cref="TSpeedButtonCep.BtnFrameColor"></seealso>
    {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
    property Border: TCepButtonBorder read GetBorder write SetBorder
      default CepSingleBorder;
    {$IFDEF DELPHI_2005_UP}{$REGION ' . Note: 255 -  ; 0 -  ( ) '}{$ENDIF}
    /// <summary>
    /// <para> .</para>
    /// <para>255 -  ;</para>
    /// <para>0 -  ( )</para>
    /// </summary>
    {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
    property Blend: byte read GetBlend write SetBlend default 255;
    {$IFDEF DELPHI_2005_UP}{$REGION '    '}{$ENDIF}
    /// <summary>    </summary>
    /// <seealso cref="TCepButtonKind"></seealso>
    {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
    property ButtonKind: TCepButtonKind read fButtonKind write SetButtonKind
      default CepBKImage;
    {$IFDEF DELPHI_2005_UP}{$REGION '   '}{$ENDIF}
    /// <summary>   </summary>
    {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
    property Caption;
    {$IFDEF DELPHI_2005_UP}{$REGION '   True,     '}{$ENDIF}
    /// <summary>   True,     </summary>
    {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
    property Checked: boolean read GetChecked write SetChecked default false;
    {$IFDEF DELPHI_2005_UP}{$REGION ' '}{$ENDIF}
    /// <summary> </summary>
    /// <seealso cref="Transparent"></seealso>
    /// <seealso cref="ThemeEnabled"></seealso>
    {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
    property Color;
    {$IFDEF DELPHI_2005_UP}{$REGION ' '}{$ENDIF}
    /// <summary> </summary>
    /// <remarks>        CepXPBorder</remarks>
    /// <seealso cref="TSpeedButtonCep.Border"></seealso>
    {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
    property BtnFrameColor: TColor read GetBtnFrameColor write SetBtnFrameColor
      default $00C66931;
    {$IFDEF DELPHI_2005_UP}{$REGION '  / '}{$ENDIF}
    /// <summary>  / </summary>
    /// <seealso cref="Transparent"></seealso>
    /// <seealso cref="ThemeEnabled"></seealso>
    {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
    property SelectedColor: TColor read GetSelectedColor write SetSelectedColor
      default $00EFD3C6;
    property Constraints;
    property Enabled;
    property Font;
    {$IFDEF DELPHI_2005_UP}{$REGION '     '}{$ENDIF}
    /// <summary>     </summary>
    /// <seealso cref="ImageList"></seealso>
    {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
    property Gliphs: TGliphs read fGliphs write SetGliphs;
    {$IFDEF DELPHI_2005_UP}{$REGION ' .'}{$ENDIF}
    /// <summary> .</summary>
    /// <remarks>   ,  <c>ButtonKind = CepBKImage</c></remarks>
    /// <seealso cref="ButtonKind"></seealso>
    {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
    property ImageList: TCustomImageList read GetImageList write SetImageList;
    {$IFDEF DELPHI_2005_UP}{$REGION '   True,     '}{$ENDIF}
    /// <summary>   True,     </summary>
    (*/// <seealso cref="Color"></seealso>*)
    /// <seealso cref="ThemeEnabled"></seealso>
    {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
    property Transparent: boolean read GetTransparent write SetTransparent
      default false;
    {$IFDEF DELPHI_2005_UP}{$REGION '       '}{$ENDIF}
    /// <summary>       </summary>
    {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
    property Layout: TButtonLayout read GetLayout write SetLayout
      default blGlyphLeft;
    {$IFDEF DELPHI_2005_UP}{$REGION '    '}{$ENDIF}
    /// <summary>    </summary>
    {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
    property Spacing: byte read GetSpacing write SetSpacing default 4;
    {$IFDEF DELPHI_2005_UP}{$REGION '        .'}{$ENDIF}
    /// <summary>        .</summary>
    /// <seealso cref="TCepButtonStyle"></seealso>
    {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
    property Style: TCepButtonStyle read fStyle write SetStyle
      default cbsNormal;

    {$IFDEF DELPHI_2005_UP}{$REGION '   True,   CepSingleBorder, CepFlatBorder      Windows, ...'}{$ENDIF}
    ///	<summary>
    ///	  <para>   True,   CepSingleBorder, CepFlatBorder     
    ///	  Windows,     .</para>
    ///	  <note type="warning">  ,  Transparent, Color  SelectedColor </note>
    ///	</summary>
    ///	<remarks>        Delphi5,    XPManifest.</remarks>
    ///	<seealso cref="Transparent"></seealso>
    ///	<seealso cref="SelectedColor"></seealso>
    {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
    property ThemeEnabled: boolean read GetThemeEnabled write SetThemeEnabled
      default false;
    property ShowHint;
    property ParentShowHint;
    property ParentColor;
    property ParentFont;
    property PopupMenu;
    property Visible;
    property OnClick;
    {$IFDEF DELPHI_2005_UP}{$REGION '   ,  ,      '}{$ENDIF}
    /// <summary>   ,  ,      </summary>
    {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
    property onClicks: TNotifyEvent read fClicks write fClicks;
    property OnDblClick;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    {$IFDEF DELPHI_2005_UP}{$REGION '        ,     '}{$ENDIF}
    /// <summary>        ,     </summary>
    {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
    property onHotChanged: TNotifyEvent read fHotChanged write fHotChanged;
    {$IFDEF DELPHI_2005_UP}{$REGION '         .'}{$ENDIF}
    // <summary>         .</summary>
    // <seealso cref="Style"></seealso>
    {$IFDEF DELPHI_2005_UP}{$ENDREGION}{$ENDIF}
    property OnDropDown: TNotifyEvent read fDropDown write fDropDown;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Cep', [TSpeedButtonCep]);
end;

{ TCustomGliphs }

procedure TCustomGliphs.Changed;
begin
  if @fOnChanged <> nil then
    fOnChanged(self);
end;

function TCustomGliphs.CheckImageIndex(I: integer): boolean;
var
  HIMGLIST: THandle;
  C: integer;
begin
  result := True;
  HIMGLIST := Handle;
  if HIMGLIST <> 0 then
  begin
    C := ImageList_GetImageCount(HIMGLIST);
    result := (I = -1) or ((I >= 0) and (I < C));
  end;
end;

constructor TCustomGliphs.Create(AOwner: TComponent);
begin
  if AOwner = nil then
    raise EConvertError.CreateFmt(SAssignError, ['nil', 'Owner']);
  inherited Create;
  fOwner := AOwner;
end;

function TCustomGliphs.GetHandle: THandle;
begin
  result := 0;
  if (GetOwner is TControl) and ([csLoading, csDestroying, csUpdating] *
    TComponent(GetOwner).ComponentState = []) then
  begin
    result := TControl(GetOwner).Perform(TCM_GETIMAGELIST, 0, 0);
  end;
end;

function TCustomGliphs.GetOwner: TPersistent;
begin
  result := fOwner;
end;

//        
type
  TGliphsWrapper = class(TComponent)
  private
    fGliphs: TCustomGliphs;
  published
    property Gliphs: TCustomGliphs read fGliphs write fGliphs;
  end;

procedure TCustomGliphs.LoadFromStream(S: TStream);
var
  Wrapper: TGliphsWrapper;
begin
  Wrapper := TGliphsWrapper.Create(nil);
  try
    Wrapper.Gliphs := TGliphsClass(ClassType).Create(TComponent(GetOwner));
    S.ReadComponent(Wrapper);
    Assign(Wrapper.Gliphs);
  finally
    Wrapper.Gliphs.Free;
    Wrapper.Free;
  end;
end;

procedure TCustomGliphs.SaveToStream(S: TStream);
var
  Wrapper: TGliphsWrapper;
begin
  Wrapper := TGliphsWrapper.Create(nil);
  try
    Wrapper.Gliphs := self;
    S.WriteComponent(Wrapper);
  finally
    Wrapper.Free;
  end;
end;

{ TGliphs }
//        
//   

constructor TGliphs.Create(AOwner: TControl);
begin
  inherited Create(AOwner);
  fOwner := AOwner;
  fImageIndexNormal := -1;
  fImageIndexPush := -1;
  fImageIndexCheck := -1;
  fImageIndexNormalHot := -1;
  fImageIndexCheckHot := -1;
  fImageIndexDisable := -1;
  fImageIndexCheckDisable := -1;
end;

procedure TGliphs.Assign(Source: TPersistent);
var
  SourceName: string;
  isChange: boolean;
begin
  if Source = nil then
  begin
    isChange := (fImageIndexNormal <> -1) or (fImageIndexPush <> -1) or
      (fImageIndexCheck <> -1) or (fImageIndexNormalHot <> -1) or
      (fImageIndexCheckHot <> -1) or (fImageIndexDisable <> -1) or
      (fImageIndexCheckDisable <> -1);
    if isChange then
    begin
      fImageIndexNormal := -1;
      fImageIndexPush := -1;
      fImageIndexCheck := -1;
      fImageIndexNormalHot := -1;
      fImageIndexCheckHot := -1;
      fImageIndexDisable := -1;
      fImageIndexCheckDisable := -1;
      Changed;
    end;
  end
  else
  begin
    SourceName := Source.ClassType.ClassName;
    if not(Source is TGliphs) then
    begin
      raise EConvertError.CreateFmt(NoAssign,
        [SourceName, ClassType.ClassName]);
    end;
    isChange := (fImageIndexNormal <> TGliphs(Source).ImageIndexNormal) or
      (fImageIndexPush <> TGliphs(Source).ImageIndexPush) or
      (fImageIndexCheck <> TGliphs(Source).ImageIndexCheck) or
      (fImageIndexNormalHot <> TGliphs(Source).ImageIndexNormalHot) or
      (fImageIndexCheckHot <> TGliphs(Source).ImageIndexCheckHot) or
      (fImageIndexDisable <> TGliphs(Source).ImageIndexDisable) or
      (fImageIndexCheckDisable <> TGliphs(Source).ImageIndexCheckDisable);
    if isChange then
    begin
      fImageIndexNormal := TGliphs(Source).ImageIndexNormal;
      fImageIndexPush := TGliphs(Source).ImageIndexPush;
      fImageIndexCheck := TGliphs(Source).ImageIndexCheck;
      fImageIndexNormalHot := TGliphs(Source).ImageIndexNormalHot;
      fImageIndexCheckHot := TGliphs(Source).ImageIndexCheckHot;
      fImageIndexDisable := TGliphs(Source).ImageIndexDisable;
      fImageIndexCheckDisable := TGliphs(Source).ImageIndexCheckDisable;
      Changed;
    end;
  end;
end;

procedure TGliphs.Changed;
begin
  inherited;
  if (fOwner is TControl) and ([csDestroying, csUpdating] * TControl(fOwner)
    .ComponentState = []) then
  begin
    if fOwner is TSpeedButtonCep then
      TSpeedButtonCep(fOwner).UpdateImageIndex
    else
      TControl(fOwner).Invalidate;
  end;
end;

procedure TGliphs.SetIndex(var OldValue: TImageIndex; NewValue: TImageIndex);
begin
  if NewValue < -1 then
    NewValue := -1;
  if OldValue <> NewValue then
  begin
    // if not CheckImageIndex(NewValue) then raise EListError.CreateFMT(NoIndexImg, [NewValue]);
    OldValue := NewValue;
    Changed;
  end;
end;

procedure TGliphs.SetImageIndexCheckHot(const Value: TImageIndex);
begin
  SetIndex(fImageIndexCheckHot, Value);
end;

procedure TGliphs.SetIndexNormalHot(const Value: TImageIndex);
begin
  SetIndex(fImageIndexNormalHot, Value);
end;

procedure TGliphs.SetImageIndexCheckDisable(const Value: TImageIndex);
begin
  SetIndex(fImageIndexCheckDisable, Value);
end;

procedure TGliphs.SetImageIndexDisable(const Value: TImageIndex);
begin
  SetIndex(fImageIndexDisable, Value);
end;

procedure TGliphs.SetImageIndexPush(const Value: TImageIndex);
begin
  SetIndex(fImageIndexPush, Value);
end;

procedure TGliphs.SetImageIndexNormal(const Value: TImageIndex);
begin
  SetIndex(fImageIndexNormal, Value);
end;

procedure TGliphs.SetImageIndexCheck(const Value: TImageIndex);
begin
  SetIndex(fImageIndexCheck, Value);
end;

{ TSpeedButtonCep }

constructor TSpeedButtonCep.Create(AOwner: TComponent);
begin
  inherited;
  fList := TRichImageList.Create;
  fList.Border := CepSingleBorder;
  fList.Blend := 255;
  fList.BorderColor := $00C66931;
  fList.SelectedColor := $00EFD3C6;
  fList.BkColor := Color;
  fList.Index := -1;
  fList.Spacing := 2;
  fList.Enabled := Enabled;
  SetBounds(Left, Top, Left + 28, Top + 28);
  fList.OnChange := ListChange;

  AutoHot := True;
  fGliphs := TGliphs.Create(self);
  FImageChangeLink := TChangeLink.Create;
  FImageChangeLink.OnChange := ImageListChange;
end;

destructor TSpeedButtonCep.Destroy;
begin
  FreeAndNil(FImageChangeLink);
  FreeAndNil(fList);
  FreeAndNil(fTimer);
  FreeAndNil(fTimerHot);
  FreeAndNil(fGliphs);
  inherited;
end;

//  

function TSpeedButtonCep.GetImageList: TCustomImageList;
begin
  if fList <> nil then
    result := fList.ImageList
  else
    result := nil;
end;

procedure TSpeedButtonCep.SetImageList(const Value: TCustomImageList);
begin
  if fList = nil then
    raise Exception.Create(NoAssignfList);
  if ImageList <> nil then
    ImageList.UnRegisterChanges(FImageChangeLink);
  BeginUpdate;
  try
    fList.ImageList := Value;
    if ImageList <> nil then
    begin
      fList.ImageList.RegisterChanges(FImageChangeLink);
      fList.ImageList.FreeNotification(self);
      ClearHasButtonBitmap;
      UpdateImageIndex;
    end;
    Changed;
  finally
    EndUpdate;
  end;
end;

procedure TSpeedButtonCep.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if Operation = opRemove then
  begin
    if AComponent = ImageList then
    begin
      BeginUpdate;
      try
        ImageList := nil;
        ClearHasButtonBitmap;
        UpdateImageIndex;
        Changed;
      finally
        EndUpdate;
      end;
    end;
  end;
end;

procedure TSpeedButtonCep.ImageListChange(Sender: TObject);
begin
  if Sender = ImageList then
  begin
    ClearHasButtonBitmap;
    BeginUpdate;
    try
      UpdateImageIndex;
      Changed;
    finally
      EndUpdate;
    end;
  end;
end;

procedure TSpeedButtonCep.ListChange(Sender: TObject);
begin
  if Sender = fList then
  begin
    if not(csUpdating in ComponentState) then
    begin
      Invalidate;
      Changed;
    end;
  end;
end;

procedure TSpeedButtonCep.WndProc(var Message: TMessage);
begin
  inherited;
  case Message.Msg of
    TCM_GETIMAGELIST:
      begin
        if (ImageList = nil) then
          Message.result := 0
        else
          Message.result := ImageList.Handle;
      end;
    WM_SETFOCUS:
      SetFocus;
    WM_KILLFOCUS:
      KillFocus;
  end;
end;

procedure TSpeedButtonCep.SetFocus;
begin

end;

procedure TSpeedButtonCep.KillFocus;
begin

end;

//  

function TSpeedButtonCep.GetChecked: boolean;
begin
  result := fList.Checked;
end;

procedure TSpeedButtonCep.SetChecked(const Value: boolean);
begin
  if fList.Checked <> Value then
  begin
    fList.Checked := Value;
    UpdateImageIndex;
  end;
end;

type
  TTMPCont = class(TGraphicControl);

  //  

procedure TSpeedButtonCep.CMColorChanged(var Message: TMessage);
begin
  fList.BkColor := Color;
  if fChildButton <> nil then
    TTMPCont(fChildButton).Color := Color;
end;

//   

function TSpeedButtonCep.GetBtnFrameColor: TColor;
begin
  result := fList.BorderColor;
end;

procedure TSpeedButtonCep.SetBtnFrameColor(const Value: TColor);
begin
  fList.BorderColor := Value;
  if fChildButton is TSpeedButtonCep then
  begin
    if fStyle = cbsDrop then
      TSpeedButtonCep(fChildButton).BtnFrameColor := SelectedColor
    else
      TSpeedButtonCep(fChildButton).BtnFrameColor := fList.BorderColor;
  end;
end;

//   

function TSpeedButtonCep.GetSelectedColor: TColor;
begin
  result := fList.SelectedColor;
end;

procedure TSpeedButtonCep.SetSelectedColor(const Value: TColor);
begin
  fList.SelectedColor := Value;
  if fChildButton is TSpeedButtonCep then
  begin
    TSpeedButtonCep(fChildButton).SelectedColor := Value;
    if fStyle = cbsDrop then
      TSpeedButtonCep(fChildButton).BtnFrameColor := Value
    else
      TSpeedButtonCep(fChildButton).BtnFrameColor := fList.BorderColor;
  end;
end;

//    

function TSpeedButtonCep.GetBorder: TCepButtonBorder;
begin
  result := fList.Border;
end;

procedure TSpeedButtonCep.SetBorder(const Value: TCepButtonBorder);
begin
  fList.Border := Value;
  if fChildButton is TSpeedButtonCep then
    TSpeedButtonCep(fChildButton).Border := Value;
end;

function TSpeedButtonCep.GetThemeEnabled: boolean;
begin
  result := fList.ThemeEnabled;
end;

//     Transparent,    

function TSpeedButtonCep.GetTransparent: boolean;
begin
  result := fList.Transparent;
end;

procedure TSpeedButtonCep.SetThemeEnabled(const Value: boolean);
begin
  if fList.ThemeEnabled <> Value then
  begin
    fList.ThemeEnabled := Value;
    UpdateImageIndex;
    if fChildButton is TSpeedButtonCep then
      TSpeedButtonCep(fChildButton).ThemeEnabled := Value;
  end;
end;

procedure TSpeedButtonCep.SetTransparent(const Value: boolean);
begin
  if (Blend < 255) or (Value) then
    ControlStyle := ControlStyle - [csOpaque]
  else
    ControlStyle := ControlStyle + [csOpaque];
  fList.Transparent := Value;
end;

//   

function TSpeedButtonCep.GetImageIndex: integer;
begin
  result := fImageIndex;
end;

procedure TSpeedButtonCep.SetImageIndex(const Value: integer);
var
  V: integer;
begin
  V := Value;
  if (V < 0) or ((ImageList <> nil) and (V >= fList.ImageList.Count)) then
    V := -1;
  fImageIndex := V;
  if fButtonKind = CepBKImage then
  begin
    fList.Index := fImageIndex;
  end;
end;

//     

procedure TSpeedButtonCep.UpdateChildBlend;
begin
  if (fChildButton is TSpeedButtonCep) then
  begin
    if (TSpeedButtonCep(fChildButton).Hot) or
      (TSpeedButtonCep(fChildButton).Border <> CepXPBorder) or
      (fStyle <> cbsDrop) then
      TSpeedButtonCep(fChildButton).Blend := Blend
    else
      TSpeedButtonCep(fChildButton).Blend := (Blend) div (2);
  end;
end;

//  

function TSpeedButtonCep.GetBlend: byte;
begin
  result := fList.Blend;
end;

procedure TSpeedButtonCep.SetBlend(const Value: byte);
begin
  if (Value < 255) or (Transparent) then
    ControlStyle := ControlStyle - [csOpaque]
  else
    ControlStyle := ControlStyle + [csOpaque];
  fList.Blend := Value;
  UpdateChildBlend;
end;

//    

function TSpeedButtonCep.GetPushed: boolean;
begin
  result := fList.Pushed;
end;

procedure TSpeedButtonCep.SetPushed(const Value: boolean);
var
  R: TRect;
  Pt: TPoint;
  V: boolean;
  I: integer;
begin
  V := Value and Enabled and Visible;
  if Pushed <> V then
  begin
    BeginUpdate;
    try
      fList.Pushed := V;
      if AutoHot then
      begin
        for I := 0 to ComponentCount - 1 do
          if Components[I] is TSpeedButtonCep then
          begin
            TSpeedButtonCep(Components[I]).Pushed := Pushed;
          end;
        if (not V) then
        begin
          GetCursorPos(Pt);
          R := ClientRect;
          Pt := ScreenToClient(Pt);
          if PtInRect(R, Pt) then
          begin
            if fAutoCheck then
            begin
              Checked := not Checked;
              if Action is TCustomAction then
                TCustomAction(Action).Checked := Checked;
            end;
          end;
        end;
        if V then
          StartTimer
        else
          StopTimer;
      end
      else
        StopTimer;
      Changed;
      UpdateImageIndex;
    finally
      EndUpdate;
    end;
  end;
end;

//      OnClicks

procedure TSpeedButtonCep.onTimer(Sender: TObject);
var
  I: integer;
begin
  if (fTimer <> nil) then
    I := fTimer.Interval
  else
    Exit;
  if I = 199 then
    I := 200
  else
    I := (I) div (2);
  if I < 40 then
    I := 40;
  fTimer.Interval := I;
  Clicks;
end;

procedure TSpeedButtonCep.StartTimer;
begin
  fIsClicks := false;
  if fTimer = nil then
  begin
    fTimer := TTimer.Create(self);
    fTimer.Interval := 199;
    fTimer.Enabled := True;
    fTimer.onTimer := onTimer;
  end;
  fTimer.Enabled := True;
end;

procedure TSpeedButtonCep.StopTimer;
begin
  FreeAndNil(fTimer);
end;

//        

procedure TSpeedButtonCep.HotProc(Sender: TObject);
var
  P: TPoint;
begin
  if self <> nil then
  begin
    GetCursorPos(P);
    P := ScreenToClient(P);
    if PtInRect(Rect(0, 0, Width, Height), P) then
    begin
      Hot := True;
    end
    else if not(csUpdating in ComponentState) then
    begin
      BeginUpdate;
      try
        Hot := false;
        Pushed := false;
      finally
        EndUpdate;
      end;
    end;
  end;
end;

procedure TSpeedButtonCep.Updated;
var
  Need: boolean;
begin
  Need := csUpdating in ComponentState;
  inherited;
  if Need then
  begin
    Changed;
    Invalidate;
  end;
end;

procedure TSpeedButtonCep.BeginUpdate;
begin
  if fCountUpdate = 0 then
    Updating;
  inc(fCountUpdate);
end;

procedure TSpeedButtonCep.EndUpdate;
begin
  if fCountUpdate = 1 then
    Updated;
  dec(fCountUpdate);
end;

//    ,     

function TSpeedButtonCep.GetHot: boolean;
begin
  result := fList.Hot;
end;

procedure TSpeedButtonCep.SetHot(const Value: boolean);
var
  V: boolean;
  I: integer;
begin
  V := Value and Enabled and Visible;
  if fList.Hot <> V then
  begin
    fList.Hot := V;
    if AutoHot then
    begin
      for I := 0 to ComponentCount - 1 do
        if Components[I] is TSpeedButtonCep then
        begin
          TSpeedButtonCep(Components[I]).AutoHot := not Hot;
          TSpeedButtonCep(Components[I]).Hot := Hot;
        end;
    end;
    if (Owner is TSpeedButtonCep) and (AutoHot) then
    begin
      TSpeedButtonCep(Owner).AutoHot := not Hot;
      TSpeedButtonCep(Owner).Hot := Hot;
    end;
    if Hot and ((fTimerHot = nil) or (fTimerHot.Handle = 0)) and fAutoHot then
    begin
      if fTimerHot = nil then
        fTimerHot := TInternalTimer.Create(self);
      fTimerHot.ExecuteInterval(200, HotProc);
    end
    else
    begin
      if fTimerHot <> nil then
        fTimerHot.Stop;
    end;
    Changed;
    BeginUpdate;
    try
      UpdateImageIndex;
      if (not(csDesigning in ComponentState)) and
        ((Hot and (Enabled) and (Visible)) or (not Hot)) then
        HotChanged;
    finally
      EndUpdate;
    end;
  end;
end;

procedure TSpeedButtonCep.SetAutoHot(const Value: boolean);
begin
  if fAutoHot <> Value then
  begin
    fAutoHot := Value;
    if (not fAutoHot) and ((fTimerHot <> nil) and (fTimerHot.Handle <> 0)) then
    begin
      fTimerHot.Stop;
    end;
  end;
end;

//     

procedure TSpeedButtonCep.CMMouseEnter(var Message: TMessage);
begin
  if fAutoHot then
    Hot := True;
end;

//    

procedure TSpeedButtonCep.CMMouseLeave(var Message: TMessage);
begin
  if Enabled then
  begin
    BeginUpdate;
    try
      if fAutoHot then
        Hot := false;
      Pushed := false;
    finally
      EndUpdate;
    end;
  end
  else
  begin
    if fAutoHot then
      fList.Hot := false;
    Pushed := false;
  end;
end;

//  

procedure TSpeedButtonCep.Paint;
begin
  if Parent = nil then
    Exit;
  if Font <> nil then
    Canvas.Font := Font;
  Canvas.Draw(0, 0, fList);
  if (Border = CepNoBorder) and (csDesigning in ComponentState) then
  begin
    Canvas.Brush.Style := bsClear;
    Canvas.Pen.Style := psSolid;
    Canvas.Pen.Color := clGrayText;
    Canvas.Rectangle(0, 0, Width, Height);
  end;
end;

procedure TSpeedButtonCep.Repaint;
begin
  if not(csUpdating in ComponentState) then
    inherited;
end;

procedure TSpeedButtonCep.Invalidate;
var
  R: TRect;
begin
  if Parent = nil then
    Exit;
  if fInvalidateMode <> imNone then
  begin
    if fInvalidating then
      Exit;
    fInvalidating := True;
    try
      if not(csUpdating in ComponentState) then
      begin
        if fInvalidateMode = imInvalidate then
        begin
          if (Parent <> nil) and (Parent.HandleAllocated) then
          begin
            R := Rect(Left, Top, Left + Width, Top + Height);
            InvalidateRect(Parent.Handle, @R, True);
          end;
        end
        else
          inherited Repaint;
      end;
    finally
      fInvalidating := false;
    end;
  end;
end;

//     

procedure TSpeedButtonCep.PaintToCanvas(Canvas: TCanvas; X, Y: integer;
  Transparent: boolean);
begin
  fList.Transparent := Transparent;
  if Font <> nil then
    Canvas.Font := Font;
  Canvas.Draw(X, Y, fList);
end;

//   Enabled

procedure TSpeedButtonCep.CMENABLEDCHANGED(var Message: TMessage);
var
  Pt: TPoint;
  R: TRect;
begin
  inherited;
  BeginUpdate;
  try
    if not Enabled then
      Pushed := false;
    if not Enabled then
      Hot := false
    else
    begin
      GetCursorPos(Pt);
      R := Rect(0, 0, Width, Height);
      R.TopLeft := ClientToScreen(R.TopLeft);
      R.BottomRight := ClientToScreen(R.BottomRight);
      if PtInRect(R, Pt) then
        Perform(CM_MouseEnter, 0, 0);
    end;
    fList.Enabled := Enabled;
    UpdateImageIndex;
    if fChildButton <> nil then
      fChildButton.Enabled := Enabled;
  finally
    EndUpdate;
  end;
end;

//   Visible

procedure TSpeedButtonCep.CMVISIBLECHANGED(var Message: TMessage);
begin
  inherited;
  BeginUpdate;
  try
    if not Visible then
      Hot := false;
    if not Visible then
      Pushed := false;
    UpdateImageIndex;
    if fChildButton <> nil then
      fChildButton.Visible := Visible;
  finally
    EndUpdate;
  end;
end;

//        

procedure TSpeedButtonCep.UpdateImageIndex;
var
  I: integer;
  procedure updateDefault;
  begin
    if fDefaultIndex then
      fDefaultIndex := I >= 0;
  end;

begin
  if ButtonKind = CepBKImage then
  begin
    I := -1;
    fDefaultIndex := True;
    if fGliphs = nil then
      Exit;
    if Checked then
    begin
      if Pushed and Enabled then
      begin
        I := fGliphs.ImageIndexPush;
        updateDefault;
      end;
      if I = -1 then
      begin
        if Hot then
        begin
          I := fGliphs.ImageIndexCheckHot;
          updateDefault;
          if I = -1 then
            I := fGliphs.ImageIndexCheck;
          if I = -1 then
            I := fGliphs.ImageIndexNormalHot;
          if I = -1 then
            I := fGliphs.ImageIndexNormal;
        end
        else
        begin
          if Enabled then
          begin
            I := fGliphs.ImageIndexCheck;
            updateDefault;
            if I = -1 then
              I := fGliphs.ImageIndexCheckHot;
            if I = -1 then
              I := fGliphs.ImageIndexNormal;
            if I = -1 then
              I := fGliphs.ImageIndexNormalHot;
          end
          else
          begin
            I := fGliphs.ImageIndexCheckDisable;
            updateDefault;
            if I = -1 then
              I := fGliphs.ImageIndexCheck;
            if I = -1 then
              I := fGliphs.ImageIndexCheckHot;
            if I = -1 then
              I := fGliphs.ImageIndexNormalHot;
            if I = -1 then
              I := fGliphs.ImageIndexNormal;
          end;
        end;
      end;
    end
    else
    begin
      if Pushed and Enabled then
      begin
        I := fGliphs.ImageIndexPush;
        updateDefault;
      end;
      if I = -1 then
      begin
        if Hot then
        begin
          I := fGliphs.ImageIndexNormalHot;
          if Border = CepXPBorder then
            fDefaultIndex := false
          else
            updateDefault;
          if I = -1 then
            I := fGliphs.ImageIndexNormal;
        end
        else
        begin
          if Enabled then
          begin
            I := fGliphs.ImageIndexNormal;
            updateDefault;
            if I = -1 then
              I := fGliphs.ImageIndexNormalHot;
          end
          else
          begin
            I := fGliphs.ImageIndexDisable;
            updateDefault;
            if I = -1 then
              I := fGliphs.ImageIndexNormal;
            if I = -1 then
              I := fGliphs.ImageIndexNormalHot;
          end;
        end;
      end;
    end;
    Updating;
    try
      fList.Adjusted := not fDefaultIndex;
      fList.Index := I;
      fList.CepButtonBorderEx := cbbNormal;
      if ThemeEnabled and (Border in [CepSingleBorder, CepFlatBorder]) then
      begin
        if (Style in [cbsDropDown, cbsDropRight]) then
          fList.CepButtonBorderEx := cbbNoRigth;
      end;
    finally
      Updated;
    end;
  end
  else
  begin
    Updating;
    try
      fList.Index := -integer(ButtonKind);
      fList.Adjusted := True;
      if ThemeEnabled and (ButtonKind in [CepBKRightArrow, CepBKDownArrow]) and
        (Owner is TSpeedButtonCep) and (Width > 10) then
        fList.CepButtonBorderEx := cbbNoLeft;
    finally
      Updated;
    end;
  end;
end;

procedure TSpeedButtonCep.SetGliphs(const Value: TGliphs);
begin
  BeginUpdate;
  try
    if Value <> nil then
    begin
      fGliphs.Assign(Value);
    end
    else
    begin
      with fGliphs do
      begin
        fImageIndexNormal := -1;
        fImageIndexPush := -1;
        fImageIndexCheck := -1;
        fImageIndexNormalHot := -1;
        fImageIndexCheckHot := -1;
        fImageIndexDisable := -1;
        fImageIndexCheckDisable := -1;
      end;
    end;
  finally
    EndUpdate;
  end;
end;

//    

procedure TSpeedButtonCep.WMLButtonUp(var Message: TWMLButtonUp);
begin
  // if csClicked in ControlState then begin
  Pushed := false;
  // end;
  inherited;
end;

//    

procedure TSpeedButtonCep.MouseDown(Button: TMouseButton; Shift: TShiftState;
  X, Y: integer);
begin
  if (Enabled) and (Button = mbLeft) then
    Pushed := True;
  inherited;
end;

//        

procedure TSpeedButtonCep.Clicks;
begin
  if @fClicks <> nil then
  begin
    fIsClicks := True;
    fClicks(self);
  end;
end;

procedure TSpeedButtonCep.Click;
begin
  if not fIsClicks then
    inherited;
end;

//        .
type
  TCepLink = class(TControlActionLink)
  protected
    FClient: TSpeedButtonCep;
    procedure AssignClient(AClient: TObject); override;
    function IsCheckedLinked: boolean; override;
    procedure SetChecked(Value: boolean); override;
    function IsHelpContextLinked: boolean; override;
    procedure SetHelpContext(Value: THelpContext); override;
  end;

function TSpeedButtonCep.GetActionLinkClass: TControlActionLinkClass;
begin
  result := TCepLink;
end;

procedure TSpeedButtonCep.ActionChange(Sender: TObject; CheckDefaults: boolean);
begin
  inherited ActionChange(Sender, CheckDefaults);
  if Sender is TCustomAction then
    with TCustomAction(Sender) do
    begin
      BeginUpdate;
      try
        if (not CheckDefaults) and (ActionList.Images <> nil) then
        begin
          ImageList := ActionList.Images;
          fGliphs.ImageIndexNormalHot := ImageIndex;
          fGliphs.ImageIndexCheckHot := -1;
          fGliphs.ImageIndexPush := -1;
          fGliphs.ImageIndexCheck := -1;
          fGliphs.ImageIndexDisable := -1;
          fGliphs.ImageIndexCheckDisable := -1;
        end;
        if not CheckDefaults or (self.Checked = false) then
          self.Checked := Checked;
      finally
        EndUpdate;
      end;
    end;
end;

//    

procedure TSpeedButtonCep.SetButtonKind(const Value: TCepButtonKind);
begin
  if fButtonKind <> Value then
  begin
    fButtonKind := Value;
    if fButtonKind <> CepBKImage then
      fList.Index := -integer(fButtonKind)
    else
      fList.Index := fImageIndex;
  end;
end;

procedure TSpeedButtonCep.HotChanged;
begin
  if @fHotChanged <> nil then
    fHotChanged(self);
end;

//  

procedure TSpeedButtonCep.WMSETTEXT(var Message: TWMSETTEXT);
begin
  with message do
  begin
    fList.Caption := Text;
    SendDockNotification(Msg, Unused, integer(Text));
  end;
end;

//  

procedure TSpeedButtonCep.WMGETTEXT(var Message: TWMGETTEXT);
var
  P: PChar;
begin
  with Message do
  begin
    if fList.Caption <> '' then
      P := PChar(fList.Caption)
    else
      P := '';
    result := StrLen(StrLCopy(Text, P, TextMax - 1));
  end;
end;

//   

procedure TSpeedButtonCep.WMGETTEXTLENGTH(var Message: TWMGETTEXTLENGTH);
begin
  with Message do
    if fList.Caption = '' then
      result := 0
    else
      result := Length(fList.Caption);
end;

//  

procedure TSpeedButtonCep.CMFontChanged(var Message: TMessage);
begin
  ClearHasButtonBitmap;
  Invalidate;
end;

//    

function TSpeedButtonCep.GetLayout: TButtonLayout;
begin
  result := fList.Layout;
end;

procedure TSpeedButtonCep.SetLayout(const Value: TButtonLayout);
begin
  fList.Layout := Value;
end;

//      

function TSpeedButtonCep.GetSpacing: byte;
begin
  result := fList.Spacing;
end;

procedure TSpeedButtonCep.SetSpacing(const Value: byte);
begin
  fList.Spacing := Value;
end;

//        

procedure TSpeedButtonCep.DropDown;
begin
  if @fDropDown <> nil then
    fDropDown(self);
end;

//    

procedure TSpeedButtonCep.SetStyle(const Value: TCepButtonStyle);
begin
  if Value <> fStyle then
  begin
    fStyle := Value;
    UpdateChildButton;
  end;
end;

//   

function TSpeedButtonCep.CreateChildButton(Style: TCepButtonStyle)
  : TGraphicControl;
begin
  result := TSpeedButtonCep.Create(self);
  TSpeedButtonCep(result).BeginUpdate;
  try
    TSpeedButtonCep(result).OnClick := ClickChild;
    TSpeedButtonCep(result).Border := Border;
    TSpeedButtonCep(result).ParentShowHint := false;
    TSpeedButtonCep(result).ShowHint := false;
    TSpeedButtonCep(result).ThemeEnabled := ThemeEnabled;
    case fStyle of
      cbsDropDown:
        begin
          TSpeedButtonCep(result).ButtonKind := CepBKDownArrow;
        end;
      cbsDropRight:
        begin
          TSpeedButtonCep(result).ButtonKind := CepBKRightArrow;
        end;
      cbsDrop:
        begin
          TSpeedButtonCep(result).ButtonKind := CepBKDownArrow;
          TSpeedButtonCep(result).Transparent := True;
          TSpeedButtonCep(result).onHotChanged := ChildHotChanged;
        end;
    end;
  finally
    TSpeedButtonCep(result).EndUpdate;
  end;
end;

procedure TSpeedButtonCep.UpdateChildButton;
begin
  FreeAndNil(fChildButton);
  if fStyle <> cbsNormal then
  begin
    fChildButton := CreateChildButton(fStyle);
    TTMPCont(fChildButton).Updating;
    try
      fChildButton.Parent := Parent;
      TTMPCont(fChildButton).Color := Color;
      if fChildButton is TSpeedButtonCep then
      begin
        if fStyle = cbsDrop then
          TSpeedButtonCep(fChildButton).BtnFrameColor := SelectedColor
        else
          TSpeedButtonCep(fChildButton).BtnFrameColor := BtnFrameColor;
        TSpeedButtonCep(fChildButton).SelectedColor := SelectedColor;
      end;
      UpdateChildBlend;
      DoResize;
    finally
      TTMPCont(fChildButton).Updated;
    end;
  end
  else
    DoResize;
end;

procedure TSpeedButtonCep.ClickChild(Sender: TObject);
begin
  if Sender = fChildButton then
    DropDown;
end;

procedure TSpeedButtonCep.SbbFromEdit(Control: TWinControl);
var
  R, RNP: TRect;
  W: integer;

  MM, M, WParam: DWORD;
begin
  if Align in [AlLeft, AlRight] then
  begin
    M := GetWindowLong(Control.Handle, GWL_STYLE);
    if (M and ES_MULTILINE) = M then
    begin
      Windows.GetWindowRect(Control.Handle, R);
      OffsetRect(R, -R.Left, -R.Top);
      SendMessage(Control.Handle, EM_GETRECT, 0, LongInt(@RNP));
      W := (RNP.Right - RNP.Left) - R.Right;
      if W > Width - 4 then
      begin
        if Align = AlRight then
          inc(RNP.Right, Width)
        else
          dec(RNP.Left, Width);
        SendMessage(Control.Handle, EM_SETRECTNP, 0, LongInt(@RNP));
        SendMessage(Control.Handle, EM_SCROLLCARET, 0, 0);
      end;
    end
    else
    begin
      M := SendMessage(Control.Handle, EM_GETMARGINS, 0, 0);
      R.Left := LoWord(M);
      R.Right := HiWord(M);
      if Align = AlRight then
      begin
        dec(R.Right, Width);
        WParam := EC_RIGHTMARGIN;
      end
      else
      begin
        dec(R.Left, Width);
        WParam := EC_LEFTMARGIN;
      end;
      MM := (R.Right) shl (16);
      M := (MM) or (DWORD(R.Left) and ($FFFF));
      SendMessage(Control.Handle, EM_SETMARGINS, WParam, M);
      SendMessage(Control.Handle, EM_SCROLLCARET, 0, 0);
    end;
  end;
end;

procedure TSpeedButtonCep.AddToEdit(Control: TWinControl);
var
  R, RNP: TRect;
  MM, M, WParam: DWORD;
begin
  if Align in [AlLeft, AlRight] then
  begin
    M := GetWindowLong(Control.Handle, GWL_STYLE);
    if (M and ES_MULTILINE) = M then
    begin
      SendMessage(Control.Handle, EM_GETRECT, 0, LongInt(@RNP));
      if Align = AlRight then
        dec(RNP.Right, Width)
      else
        inc(RNP.Left, Width);
      SendMessage(Control.Handle, EM_SETRECTNP, 0, LongInt(@RNP));
      SendMessage(Control.Handle, EM_SCROLLCARET, 0, 0);
    end
    else
    begin
      M := SendMessage(Control.Handle, EM_GETMARGINS, 0, 0);
      R.Left := LoWord(M);
      R.Right := HiWord(M);
      if Align = AlRight then
      begin
        inc(R.Right, Width);
        WParam := EC_RIGHTMARGIN;
      end
      else
      begin
        inc(R.Left, Width);
        WParam := EC_LEFTMARGIN;
      end;
      MM := (R.Right) shl (16);
      M := (MM) or (DWORD(R.Left) and ($FFFF));
      SendMessage(Control.Handle, EM_SETMARGINS, WParam, M);
      SendMessage(Control.Handle, EM_SCROLLCARET, 0, 0);
      InvalidateRect(Control.Handle, nil, True);
    end;
  end;
end;

//        
//    

procedure TSpeedButtonCep.SetParent(AParent: TWinControl);
var
  I: integer;
  function IsParentClass(AParent: TWinControl; Name: string): boolean;
  var
    C: TClass;
    S: string;
  begin
    result := false;
    if AParent = nil then
      Exit;
    C := AParent.ClassType;
    Name := UpperCase(Name);
    repeat
      C := C.ClassParent;
      if C <> nil then
      begin
        S := UpperCase(C.ClassName);
        result := S = NAME;
      end;
    until (C = nil) or (result);
  end;

begin
  if IsParentClass(Parent, 'TCustomMaskEdit') then
    SbbFromEdit(Parent);
  inherited;
  Invalidate;
  for I := 0 to ComponentCount - 1 do
    if Components[I] is TGraphicControl then
      TGraphicControl(Components[I]).Parent := AParent;
  if IsParentClass(AParent, 'TCustomMaskEdit') then
    AddToEdit(AParent);
end;

procedure TSpeedButtonCep.ChildHotChanged(Sender: TObject);
begin
  if (Sender = fChildButton) then
    UpdateChildBlend;
end;

//  ,     

procedure TSpeedButtonCep.DoResize;
var
  W, H, D, DD: integer;
begin
  W := Width;
  H := Height;
  DD := GetSystemMetrics(SM_CXHSCROLL);
  if fStyle in [cbsDropDown, cbsDropRight] then
    D := (W + 2) div (3)
  else
    D := 0;
  if D > DD then
    D := DD;
  W := W - D;
  if (W <> fList.Width) or (H <> fList.Height) then
  begin
    BeginUpdate;
    try
      fList.Width := W;
      fList.Height := H;
    finally
      EndUpdate;
    end;
  end;
  if fChildButton <> nil then
  begin
    case fStyle of
      cbsDropDown:
        begin
          fChildButton.SetBounds(Left + W, Top, D, Height);
        end;
      cbsDropRight:
        begin
          fChildButton.SetBounds(Left + W, Top, D, Height);
        end;
      cbsDrop:
        begin
          D := MinSize;
          if Border <> CepSingleBorder then
            inc(D);
          fChildButton.SetBounds(Left + fList.Width - D - 1,
            Top + fList.Height - D - 1, D, D);
        end;
    end;
  end;
end;

procedure TSpeedButtonCep.Loaded;
begin
  inherited;
  UpdateImageIndex;
  DoResize;
  Invalidate;
end;

procedure TSpeedButtonCep.Resize;
begin
  DoResize;
  inherited;
end;

{ TCepLink }

procedure TCepLink.AssignClient(AClient: TObject);
begin
  inherited AssignClient(AClient);
  FClient := AClient as TSpeedButtonCep;
end;

function TCepLink.IsHelpContextLinked: boolean;
begin
{$IFDEF VER130}
  result := false;
{$ELSE}
  result := IsHelpLinked;
{$ENDIF}
end;

procedure TCepLink.SetHelpContext(Value: THelpContext);
begin
  inherited SetHelpContext(Value);
end;

function TCepLink.IsCheckedLinked: boolean;
begin
  result := inherited IsCheckedLinked and
    (FClient.Checked = (Action as TCustomAction).Checked);
end;

procedure TCepLink.SetChecked(Value: boolean);
begin
  if IsCheckedLinked then
    FClient.Checked := Value;
end;

end.
