unit UMainExpertCep;
(*
 * Module:      ,        Delphi
 * Version:    1.1.0.0 (24.09.2008)
 * Author:      
 *
 * Copyright:   2008 Cep Po
 *
 * Version:    1.1.0.0 (24.09.2008)
 * Realized:     Delphi 2009
 *)
interface
{$I Directives.inc}
uses Windows, SysUtils, Classes, ToolsAPI, Menus, IniFiles,
  RegisterIdeMenu, uIDEutl, TextUtlCep, uBaseForm, ufSpecInst;
resourcestring
  Res_MainMenuName = ' .';
  Res_PasteMenuName = '   |    ' + #13#10 +
                      '      ';  // Alt + V
  Res_CopyMenuName = '   |     ' + #13#10 +
                      '  ';    // Alt + C
  Res_SpecNeedShowForm = ' |      ';
  Res_ToolBarCaption = ' ';
const
  DefaultToolBarName = 'UsefulLotion';
type
  TExpertCep = class(TObject)
  private
    fFormSpecIns: TFormSpecIns;
    fTextW: WideString;
    fOldSelStart: LongInt;
    fOldSelLength: Integer;
    fIndexNeedShow: array [boolean] of integer;
    procedure PasteSpecial(InCode, CopyAfterShow: boolean; ShowForm: boolean= true);
  protected
  public
    constructor Create;
    destructor Destroy; override;
    procedure DoPaste(Sender: TObject);
    procedure DoCopy(Sender: TObject);
    procedure DoMainMenu(Sender: TObject);
    procedure DoNeedShowForm(Sender: TObject);
    procedure DoUpdateNeedShowForm(Sender: TObject);
    procedure ChangeSelection(Sender: TObject);
    procedure Insert(Sender: TObject);
  end;

procedure RefreshNeedShowForm;
procedure UpdateNeedShowForm;

//procedure Register;

implementation
uses ActnList;

const
  MAIN_MENU = 'EditMenu'; //    Edit
  EDITSELALL_MENU = 'EditSelectAll'; //   Select All
  CategoryIDE = 'ExpertCep';
  PrefixActionName = 'actCep';

  SpecMain = 'MainSpecPaste';
  SpecPaste = 'SpecPasteCode';
  SpecCopy = 'SpecCopyCode';
  SpecNeedShowForm = 'SpecNeedShowForm';

var
  ExpertCep: TExpertCep;
  NeedShowForm: boolean;

{function IsFirst: boolean;
const AtomName: ansistring = 'dstfqrcvsadfjlw';
begin
  result := GlobalFindAtom(PAnsiChar(AtomName)) = 0;
  if result then
  begin
    if GlobalAddAtom(PAnsiChar(AtomName)) = 0 then
      raiseLastOsError;
  end;
end;}

procedure InitMenuItems;
begin
  if ExpertCep = nil then
    ExpertCep := TExpertCep.Create;
end;

{procedure Register;
begin
end;}

{ TCepIdeMain }

procedure TExpertCep.ChangeSelection(Sender: TObject);
var
  hRes: HResult;
  EditorServices: IOTAEditorServices;
  Editor: IOTASourceEditor;
  Buffer: IOTAEditBuffer;
  View: IOTAEditView;
begin
  hRes := BorlandIDEServices.QueryInterface(IOTAEditorServices, EditorServices);
  if hRes <> S_OK then exit;
  if EditorServices = nil then exit;

  Editor := EditorServices.TopBuffer;
  if (Editor = nil) or (Editor.EditViewCount = 0) then
  begin
    MessageBox(0, PChar(StrNoCurWnd), nil, MB_ICONINFORMATION or MB_TOPMOST);
    exit;
  end;
  Editor.QueryInterface(IOTAEditBuffer, Buffer);
  if (Buffer = nil) then Exit;
  View := Editor.GetEditView(0);
  fOldSelStart := fFormSpecIns.SelStart;
  fOldSelLength := fFormSpecIns.SelLength;
end;

procedure TExpertCep.Insert(Sender: TObject);
var
  hRes: HResult;
  EditorServices: IOTAEditorServices;
  Editor: IOTASourceEditor;
  function FirstBackSpaces: WideString;
  var I: integer;
  begin
    result := '';
    I := 1;
    while (fOldSelStart - I >= 0) and
          (not (Word(fTextW[fOldSelStart - I]) in [13, 10])) do inc(I);
    while I + Length(result) <= fFormSpecIns.SelColumn do result := result + ' ';
  end;
begin
  if (fFormSpecIns = nil) then
    Exit;
  hRes := BorlandIDEServices.QueryInterface(IOTAEditorServices, EditorServices);
  if hRes <> S_OK then exit;
  if EditorServices = nil then exit;

  Editor := EditorServices.TopBuffer;
  if (Editor = nil) or (Editor.EditViewCount = 0) then
  begin
    MessageBox(0, PChar(StrNoCurWnd), nil, MB_ICONINFORMATION or MB_TOPMOST);
    exit;
  end;
  fFormSpecIns.BeginWait;
  if fOldSelLength > 0 then
  begin
    inc(fOldSelStart);
    System.Delete(fTextW, fOldSelStart, fOldSelLength);
  end;
  System.Insert(FirstBackSpaces + fFormSpecIns.TokenText, fTextW, fOldSelStart);
  WriteToIDE(Editor, fTextW);
end;

constructor TExpertCep.Create;
begin
  inherited;
  RegisterMenuItem(MenuItemRec(MAIN_MENU,
                               EDITSELALL_MENU,
                               SpecMain,
                               CategoryIDE,
                               PrefixActionName,
                               Res_MainMenuName,
                               '',
                               False,
                               0,
                               '',
                               '',
                               DoMainMenu));

  RegisterMenuItem(MenuItemRec(SpecMain,
                               '',
                               SpecPaste,
                               CategoryIDE,
                               PrefixActionName,
                               Res_PasteMenuName,
                               SpecPaste,
                               False,
                               'V',
                               [ssAlt],
                               DefaultToolBarName,
                               Res_ToolBarCaption,
                               DoPaste));

  RegisterMenuItem(MenuItemRec(SpecMain,
                               '',
                               SpecCopy,
                               CategoryIDE,
                               PrefixActionName,
                               Res_CopyMenuName,
                               SpecCopy,
                               False,
                               'C',
                               [ssAlt],
                               DefaultToolBarName,
                               Res_ToolBarCaption,
                               DoCopy));
  RefreshNeedShowForm;
  fIndexNeedShow[True] := RegisterImage(SpecNeedShowForm+'y', SpecNeedShowForm+'y');
  fIndexNeedShow[False] := RegisterImage(SpecNeedShowForm+'n', SpecNeedShowForm+'n');
  RegisterMenuItem(MenuItemRec(SpecMain,
                               '',
                               SpecNeedShowForm,
                               CategoryIDE,
                               PrefixActionName,
                               Res_SpecNeedShowForm,
                               '',
                               NeedShowForm,
                               'V',
                               [ssAlt, ssCtrl],
                               DefaultToolBarName,
                               Res_ToolBarCaption,
                               DoNeedShowForm,
                               DoUpdateNeedShowForm));
end;

destructor TExpertCep.Destroy;
begin
  FreeAndNil(fFormSpecIns);
  UnregisterMenuItem(SpecMain);
  inherited;
end;

procedure RefreshNeedShowForm;
var Ini: TIniFile;
begin
  try
    Ini := TIniFile.Create(DefaultIniFileName(FormSettingsName));
    try
      NeedShowForm := Ini.ReadBool(SpecMain, SpecNeedShowForm, NeedShowForm);
    finally
      FreeAndNil(Ini);
    end;
  except
  end;
end;

procedure UpdateNeedShowForm;
var Ini: TIniFile;
begin
  try
    Ini := TIniFile.Create(DefaultIniFileName(FormSettingsName));
    try
      Ini.WriteBool(SpecMain, SpecNeedShowForm, NeedShowForm);
    finally
      FreeAndNil(Ini);
    end;
  except
  end;
end;

procedure TExpertCep.DoMainMenu(Sender: TObject);
begin
  //        
  RefreshNeedShowForm;
end;

procedure TExpertCep.DoCopy(Sender: TObject);
begin
  PasteSpecial(False, False, NeedShowForm);
end;

procedure TExpertCep.DoPaste(Sender: TObject);
begin
  PasteSpecial(True, True, NeedShowForm);
end;

procedure TExpertCep.DoUpdateNeedShowForm(Sender: TObject);
begin
  if Sender is TAction then
  begin
    TAction(Sender).Checked := NeedShowForm;
    TAction(Sender).ImageIndex := fIndexNeedShow[TAction(Sender).Checked];
  end;
end;

procedure TExpertCep.DoNeedShowForm(Sender: TObject);
begin
  if Sender is TAction then
  begin
    RefreshNeedShowForm;
    NeedShowForm := not NeedShowForm;
    TAction(Sender).Checked := NeedShowForm;
    UpdateNeedShowForm;
  end;
end;

procedure TExpertCep.PasteSpecial(InCode, CopyAfterShow: boolean; ShowForm: boolean= true);
var
  hRes: HResult;
  EditorServices: IOTAEditorServices;
  Editor: IOTASourceEditor;
  Buffer: IOTAEditBuffer;
  LT: TLiteralText;
  View: IOTAEditView;
  PosStart, PosEnd: TOTACharPos;
  X1, X2: Longint;
  Col: integer;
begin
  if fFormSpecIns = nil then
    fFormSpecIns := TFormSpecIns.Create(nil);
  try
    hRes := BorlandIDEServices.QueryInterface(IOTAEditorServices, EditorServices);
    if hRes <> S_OK then exit;
    if EditorServices = nil then exit;

    Editor := EditorServices.TopBuffer;
    if (Editor = nil) or (Editor.EditViewCount = 0) then
    begin
      MessageBox(0, PChar(StrNoCurWnd), nil, MB_ICONINFORMATION or MB_TOPMOST);
      exit;
    end;
    fFormSpecIns.BeginWait;
    Editor.QueryInterface(IOTAEditBuffer, Buffer);
    if (Buffer = nil) then Exit;
    if (Buffer.IsReadOnly) and (InCode and CopyAfterShow) then Exit;

    fTextW := ReadFromIDE(Editor);

    fFormSpecIns.InCode := InCode;
    fFormSpecIns.CopyAfterShow := CopyAfterShow;
    LT := TLiteralText.Create(PWideChar(fTextW));
    try
      fFormSpecIns.onChangeSelection := ChangeSelection;
      fFormSpecIns.onInsert := Insert;
      fFormSpecIns.LiteralText := LT;
      View := Editor.GetEditView(0);

      PosStart := Editor.BlockStart;
      PosEnd := Editor.BlockAfter;
      if (PosStart.CharIndex = PosEnd.CharIndex) and
        (PosStart.Line = PosEnd.Line) then
      begin
        PosStart.CharIndex := View.Position.Column - 1;
        PosStart.Line := View.Position.Row - 1;
        PosEnd := PosStart;
      end
      else
      begin
        Dec(PosStart.Line);
        Dec(PosEnd.Line);
      end;
      X1 := GetTextCursorPos(fTextW, PosStart.CharIndex, PosStart.Line, Col) + 1;
      PosStart.CharIndex := Col;
      X2 := GetTextCursorPos(fTextW, PosEnd.CharIndex, PosEnd.Line, Col) + 1;
      PosEnd.CharIndex := Col;

      fFormSpecIns.SetSel(X1, X2 - X1, PosStart.CharIndex);
      if ShowForm then
        fFormSpecIns.ShowModal
      else
      begin
        fFormSpecIns.DoInit;
        fFormSpecIns.actDefault.Execute;
      end;
      ChangeSelection(nil);
    finally
      View := nil;
      fFormSpecIns.LiteralText := nil;
      fFormSpecIns.onInsert := nil;
      fFormSpecIns.onChangeSelection := nil;
      FreeAndNil(LT);
    end;
  finally
    if fFormSpecIns <> nil then
      fFormSpecIns.StopWait;
  end;
end;

initialization
  NeedShowForm := True;
  ExpertCep := nil;
  InitMenuItems;

finalization
  FreeAndNil(ExpertCep);

end.
