unit USplashIcon;

interface
{$I Directives.inc}
uses Windows, Graphics, Types, WindowThread;

{$IFDEF DELPHI_2005_UP}
{$R 'SPLASHICON.dcr'}
procedure Register;
{$ENDIF}

implementation
{$IFDEF DELPHI_2005_UP}uses ToolsAPI, DesignIntf; {$ENDIF}

{$IFDEF DELPHI_2005_UP}

procedure RegisterWithSplashScreen;
const
  {$IFDEF DELPHI_2007_UP}
    {$IFDEF DELPHI_2009_UP}
      SizeIcon = 24;
    {$ELSE}
      SizeIcon = 24;
    {$ENDIF}
  {$ELSE}
    SizeIcon = 24;
  {$ENDIF}
var
  Bmp: TBitmap;
  Icon: HIcon;
begin
  Icon := LoadImage(hInstance, 'SPLASHICON', IMAGE_ICON, SizeIcon, SizeIcon, LR_LOADTRANSPARENT or LR_LOADMAP3DCOLORS);
  try
    Bmp := TBitmap.Create;
    try
      Bmp.PixelFormat := pf24Bit;
      Bmp.Width := SizeIcon;
      Bmp.Height := SizeIcon;
      Bmp.Transparent := True;
      {$IFDEF DELPHI_2007_UP}
        {$IFDEF DELPHI_2010_UP}
          Bmp.TransparentColor := $00020202;
        {$ELSE}
          Bmp.TransparentColor := $00FFFFFF;
        {$ENDIF}
      {$ELSE}
      Bmp.TransparentColor := 0;
      {$ENDIF}
      Bmp.Canvas.Brush.Color := Bmp.TransparentColor;
      Bmp.Canvas.FillRect(Rect(0, 0, Bmp.Width, Bmp.Height));
      Bmp.TransparentMode := tmFixed;
      DrawIconEx(Bmp.Canvas.Handle, 0, 0, Icon, SizeIcon, SizeIcon, 0, 0, DI_NORMAL);
      SplashScreenServices.AddPluginBitmap('Useful lotion',
                                           Bmp.Handle,
                                           False,
                                           'www.roschinspb.narod.ru',
                                           '');
    finally
      Bmp.Free;
    end;
  finally
    DestroyIcon(Icon);
  end;
end;

procedure Register;
begin
  RegisterWithSplashScreen;
  ForceDemandLoadState(dlDisable);
end;
{$ENDIF}

end.

