unit VerUtils;


(*
 * Module:         ,  
 *               .
 * Version:    001.00 (26.10.2006)
 * Author:      
 * Comments:    res .
 *
 * Copyright:   2006 .
 *
 * Version:    001.00 (27.10.2006)
 * Author:      
 *
 * Version:    001.2
 * Prod:       iuu
 * Realized:   iuiui
 * Author:     iui
 *)
interface
uses Windows,
  Classes;

type
  TVS_VERSIONINFO = packed record
    wLength: WORD;
    wValueLength: WORD;
    wType: WORD;
    szKey: array[0..15] of WideChar;
    Padding1: WORD;
    Value: tagVS_FIXEDFILEINFO;
    Padding2: WORD;
    Children: WORD;
  end;

  //     .
  TVersion = packed record
    case integer of
      0: (MajorVersion, MinorVersion, Release, Build: WORD);
      1: (Version: DWORD; SubVersion: DWORD);
      2: (W: array[0..3] of Word);
      3: (QW: int64);
  end;

  TVerPropKind = (vpkStringFileInfo,
    vpkCompanyName,
    vpkFileDescription,
    vpkFileVersion,
    vpkInternalName,
    vpkLegalCopyright,
    vpkOriginalFilename,
    vpkProductName,
    vpkProductVersion,
    vpkComments,
    vpkModuleAuthor, //  
    vpkModuleName,
    vpkGroupName,
    vpkGroupFolder);

  TPropValues = array[TVerPropKind] of WideString;

const
  KeyNames: TPropValues = ('StringFileInfo',
    'CompanyName',
    'FileDescription',
    'FileVersion',
    'InternalName',
    'LegalCopyright',
    'OriginalFilename',
    'ProductName',
    'ProductVersion',
    'Comments',
    'ModuleAuthor',
    'ModuleName',
    'GroupName',
    'GroupFolder');
  L_ID = 'Locale Id';
  C_Pg = 'Code Page';
  Exts: array[0..3] of string = ('exe', 'res', 'dll', 'ocx');


  //     S       
  // Version.  Version<>nil,    .
  // ProductVersion, FileVersion    
  // .
  //  ,    Version,  0.
function LoadVersionFromStream(S: TStream; var Version: Pointer; var ProductVersion, FileVersion: TVersion): integer;
//,        FileName.
function LoadVersionFromFile(FileName: string; var Version: Pointer; var ProductVersion, FileVersion: TVersion):
  integer;
//         .
//Size   . Offset    . Buffer  ,
//  LoadVersionFromStream, LoadVersionFromFile
function VersionKeyValue(Key: WideString; var Buffer; Offset, Size: integer): WideString;
function FindVersionInfo(const ProjectName: string;
  var ProductVersion, FileVersion: TVersion;
  var Values: TPropValues): boolean;


implementation
uses SysUtils;

const MaxSizeVersion = 65535;
  NameResourceVer: WideString = 'VS_VERSION_INFO';
  SignVer = $FEEF04BD;

  //    

function FindInMemory(Value: DWORD; var Buffer; Size: DWord): Integer; assembler; asm
  push eSi
  push eCx

  cmp  eCx,0
  je   @NO
  cmp  eDx,0
  je   @NO
  mov  eSi,eDx
 @Cikl:
   cmp  eAx,DS:DWORD ptr [eSi]
   je   @Ok
   Add  eSi,1
   Sub  eCx,1
   jb   @NO
   jmp  @CIKL
@Ok:
  mov  eAx,eSi
  SUB  eAx,eDx
  jmp  @ENDS
@NO:
  mov  eAx,-1
@ENDS:
  pop  eCx
  pop  eSi
end;

//   

function FindWideString(SubStr: WideString; var Buffer; Offset, Size: integer): integer;
var P: Pointer;
  DW: DWORD;
  I: integer;
begin
  result := -1;
  if Length(SubStr) > 0 then
  begin
    Move(SubStr[1], DW, SizeOf(DW));
    P := @Buffer;
    while (Size - Offset) > (Length(SubStr) + 1) * 2 do
    begin
      Size := Size - Offset;
      P := Pointer(Integer(P) + Offset);
      I := FindInMemory(DW, P^, Size);
      if I >= 0 then
      begin
        if CompareMem(@SubStr[1], Pointer(Integer(P) + I), (Length(SubStr) + 1) * 2) then
        begin
          result := Integer(P) - Integer(@Buffer) + I;
          exit;
        end
        else
        begin
          Offset := I + 4;
        end;
      end
      else
        exit;
    end;
  end;
end;

function VersionKeyValue(Key: WideString; var Buffer; Offset, Size: integer): WideString;
var PW: PWideChar;
  I, j: integer;
begin
  result := '';
  repeat
    I := FindWideString(Key, Buffer, Offset, Size);
    if I >= 0 then
    begin
      PW := PWideChar(Integer(@Buffer) + I + (Length(Key) + 1) * 2);
      if PW[0] = #0 then Inc(PW);

      if PW <> '' then
      begin
        if (Key = KeyNames[vpkStringFileInfo]) then
        begin
          inc(PW, 1);
          j := 0;
          while (PW[0] = #0) and (J <= 5) do
          begin
            inc(j);
            inc(PW, 1);
          end;
          if PW[0] <> #0 then
          begin
            if result <> '' then result := result + #13#10;
            result := Result + L_ID + ': ';
            while (PW[0] <> #0) and (J <= 5) do
            begin
              result := result + PW[0];
              inc(j);
              inc(PW, 1);
            end;
            while (PW[0] = #0) and (J <= 9) do
            begin
              inc(j);
              inc(PW, 1);
            end;
            if PW[0] <> #0 then
            begin
              Result := Result + '; ' + C_Pg + ': ';
              while (PW[0] <> #0) and (J <= 9) do
              begin
                result := result + PW[0];
                inc(j);
                inc(PW, 1);
              end;
            end;
          end;
        end
        else
        begin
          if result <> '' then result := result + #13#10;
          result := result + PW;
        end;
      end;
      Offset := I + (Length(Key) + 1 + Length(PW)) * 2;
    end;
  until I = -1;
end;

//     

function FindVersionInStream(S: TStream; var Version: Pointer; var ProductVersion, FileVersion: TVersion): integer;
var P: Pointer;
  SizeBuffer, Size, I, J, PosInFile, Siz: integer;
  Buf: DWORD;
  OldPos: int64;
  VerInfo: TVS_VERSIONINFO;
  Found: boolean;
begin
  result := 0;
  reallocMem(Version, 0);
  if S = nil then Exit;
  SizeBuffer := 2048 + sizeOf(Buf);
  P := nil;
  Buf := 0;
  try
    ReallocMem(P, SizeBuffer);
    FillChar(P^, SizeBuffer, 0);
    FillChar(VerInfo, SizeOf(VerInfo), 0);
    PosInFile := S.Position - sizeOf(Buf);
    repeat
      Move(Buf, P^, SizeOf(Buf));
      Size := S.Read(Pointer(Integer(P) + sizeOf(Buf))^, SizeBuffer - sizeOf(Buf));
      Move(Pointer(Integer(P) + Size)^, Buf, SizeOf(Buf));
      J := 0;
      found := false;
      repeat
        I := FindInMemory(SignVer, Pointer(Integer(P) + J)^, Size - J) + J;
        if I >= 0 then
        begin
          J := I + 4;
          found := true;
          FillChar(VerInfo, SizeOf(VerInfo), 0);
          if I >= 40 then
          begin
            Move(Pointer(Integer(P) - 40 + I)^, VerInfo, SizeOf(VerInfo));
          end
          else
          begin
            OldPos := S.Position;
            try
              S.Position := PosInFile + I - 40;
              S.Read(VerInfo, SizeOf(VerInfo));
            finally
              S.Position := OldPos;
            end;
          end;
          if (VerInfo.wLength > 40) then
          begin
            if VerInfo.szKey = NameResourceVer then
            begin
              OldPos := S.Position;
              S.Position := PosInFile + I - 40;
              ReallocMem(Version, VerInfo.wLength);
              FillChar(Version^, VerInfo.wLength, 0);
              Siz := S.Read(Version^, VerInfo.wLength);
              if Siz <> VerInfo.wLength then
              begin
                ReallocMem(Version, 0);
                S.Position := OldPos;
              end
              else
              begin
                result := Siz;
                FileVersion.MajorVersion := HiWord(VerInfo.Value.dwFileVersionMS);
                FileVersion.MinorVersion := LoWord(VerInfo.Value.dwFileVersionMS);
                FileVersion.Release := HiWord(VerInfo.Value.dwFileVersionLS);
                FileVersion.Build := LoWord(VerInfo.Value.dwFileVersionLS);
                ProductVersion.MajorVersion := HiWord(VerInfo.Value.dwProductVersionMS);
                ProductVersion.MinorVersion := LoWord(VerInfo.Value.dwProductVersionMS);
                ProductVersion.Release := HiWord(VerInfo.Value.dwProductVersionLS);
                ProductVersion.Build := LoWord(VerInfo.Value.dwProductVersionLS);
              end;
            end;
          end;
        end;
      until (not found) or (result > 0);
      inc(PosInFile, Size);
    until (Size < SizeBuffer - sizeOf(Buf)) or (result > 0);
  finally
    ReallocMem(P, 0);
  end;
end;

function FindVersionInFile(F: hFile; var Version: Pointer; var ProductVersion, FileVersion: TVersion): integer;
var P: Pointer;
  SizeBuffer, Size, Siz, J, PosInFile, I: DWORD;
  Buf: DWORD;
  OldPos: int64;
  VerInfo: TVS_VERSIONINFO;
  Found: boolean;
begin
  result := 0;
  reallocMem(Version, 0);
  if (F = 0) or (F = INVALID_HANDLE_VALUE) then Exit;
  SizeBuffer := 8192 + sizeOf(Buf);
  P := nil;
  Buf := 0;
  try
    ReallocMem(P, SizeBuffer);
    FillChar(P^, SizeBuffer, 0);
    FillChar(VerInfo, SizeOf(VerInfo), 0);
    PosInFile := SetFilePointer(F, 0, nil, FILE_CURRENT);
    PosInFile := PosInFile - sizeOf(Buf);
    repeat
      Move(Buf, P^, SizeOf(Buf));
      ReadFile(F, Pointer(Integer(P) + sizeOf(Buf))^, SizeBuffer - sizeOf(Buf), Size, nil);
      Move(Pointer(DWORD(P) + Size)^, Buf, SizeOf(Buf));
      J := 0;
      repeat
        I := DWORD(FindInMemory(SignVer, Pointer(DWORD(P) + J)^, Size - J)) + J;
        if I >= J then
        begin
          J := I + 4;
          found := true;
          FillChar(VerInfo, SizeOf(VerInfo), 0);
          if I >= 40 then
          begin
            Move(Pointer(DWORD(P) - 40 + I)^, VerInfo, SizeOf(VerInfo));
          end
          else
          begin
            OldPos := SetFilePointer(F, PosInFile + I - 40, nil, FILE_BEGIN);
            try
              ReadFile(F, VerInfo, SizeOf(VerInfo), Siz, nil);
            finally
              SetFilePointer(F, OldPos, nil, FILE_BEGIN);
            end;
          end;
          if (VerInfo.wLength > 40) then
          begin
            if VerInfo.szKey = NameResourceVer then
            begin
              OldPos := SetFilePointer(F, PosInFile + I - 40, nil, FILE_BEGIN);
              ReallocMem(Version, VerInfo.wLength);
              FillChar(Version^, VerInfo.wLength, 0);
              ReadFile(F, Version^, VerInfo.wLength, Siz, nil);
              if Siz <> VerInfo.wLength then
              begin
                ReallocMem(Version, 0);
                SetFilePointer(F, OldPos, nil, FILE_BEGIN);
              end
              else
              begin
                result := Siz;
                FileVersion.MajorVersion := HiWord(VerInfo.Value.dwFileVersionMS);
                FileVersion.MinorVersion := LoWord(VerInfo.Value.dwFileVersionMS);
                FileVersion.Release := HiWord(VerInfo.Value.dwFileVersionLS);
                FileVersion.Build := LoWord(VerInfo.Value.dwFileVersionLS);
                ProductVersion.MajorVersion := HiWord(VerInfo.Value.dwProductVersionMS);
                ProductVersion.MinorVersion := LoWord(VerInfo.Value.dwProductVersionMS);
                ProductVersion.Release := HiWord(VerInfo.Value.dwProductVersionLS);
                ProductVersion.Build := LoWord(VerInfo.Value.dwProductVersionLS);
              end;
            end;
          end;
        end
        else
          found := false;
      until (not found) or (result > 0);
      inc(PosInFile, Size);
    until (Size < SizeBuffer - sizeOf(Buf)) or (result > 0);
  finally
    ReallocMem(P, 0);
  end;
end;

function LoadVersionFromStream(S: TStream; var Version: Pointer; var ProductVersion, FileVersion: TVersion): integer;
var OldPos: int64;
begin
  result := 0;
  if S = nil then exit;
  ReallocMem(Version, 0);
  OldPos := S.Position;
  if S.Size - S.Position > 2048 * 4 then
  begin
    S.Position := S.Size - 2048;
    result := FindVersionInStream(S, Version, ProductVersion, FileVersion);
  end;
  if result = 0 then
  begin
    S.Position := OldPos;
    result := FindVersionInStream(S, Version, ProductVersion, FileVersion);
  end;
end;

function LoadVersionFromFile(FileName: string; var Version: Pointer; var ProductVersion, FileVersion: TVersion):
  integer;
var F: hFile;
  Size: DWORD;
begin
  result := 0;
  ReallocMem(Version, 0);
  F := CreateFile(PChar(FileName), GENERIC_READ, FILE_SHARE_READ, nil, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
  if (F = 0) or (F = INVALID_HANDLE_VALUE) then
  begin
    {$IFDEF VER130}
    raiseLastWin32Error;
    {$ELSE}
    raiseLastOsError;
    {$ENDIF}
  end;
  try
    Size := GetFileSize(F, nil);
    if Size > 2048 * 4 then
    begin
      SetFilePointer(F, Size - 2048, nil, FILE_BEGIN);
      result := FindVersionInFile(F, Version, ProductVersion, FileVersion);
    end;
    if result = 0 then
    begin
      SetFilePointer(F, 0, nil, FILE_BEGIN);
      result := FindVersionInFile(F, Version, ProductVersion, FileVersion);
    end;
  finally
    CloseHandle(F);
  end;
end;

function FindVersionInfo(const ProjectName: string;
  var ProductVersion, FileVersion: TVersion;
  var Values: TPropValues): boolean;
var Ext: string;
  i: integer;
  function LoadVerFromFile(FileName: string): boolean;
  var P: Pointer;
    Size: integer;
    pk: TVerPropKind;
  begin
    result := false;
    P := nil;
    if FileExists(FileName) then
    begin
      Size := 0;
      try
        Size := LoadVersionFromFile(FileName, P, ProductVersion, FileVersion);
        if Size > 0 then
        begin
          for pk := Low(Values) to High(Values) do
          begin
            Values[pk] := VersionKeyValue(KeyNames[pk], P^, 44, Size);
          end;
        end;
      finally
        ReallocMem(P, 0);
        result := Size > 0;
      end;
    end;
  end;
begin
  result := false;
  if ProjectName <> '' then
  begin
    Ext := LowerCase(ExtractFileExt(ProjectName));
    if Ext <> '' then
      result := LoadVerFromFile(ProjectName);
    i := 0;
    while (not Result) and (i <= High(Exts)) do
    begin
      if Ext <> '.' + LowerCase(Exts[i]) then
        result := LoadVerFromFile(ChangeFileExt(ProjectName, '.' + Exts[i]));
      inc(i);
    end;
  end;
end;

end.

