unit uIDEutl;
(*
 * Module:           IDE
 * Version:    1.2.0.0 (08.10.2008)
 *
 * Copyright:   2008 Cep Po
 *)
interface
{$I Directives.inc}
uses Windows,
  ToolsAPI,
  Sysutils,
  ufSpecInst,
  TextUtlCep,
  Classes;

const
  BUF_SIZE = 10240; // 10 kb   

resourcestring
  StrNoCurWnd = '  ';


function EditorBufSize(const EditorReader: IOTAEditReader): integer;
function ReadFromIDE(const Editor: IOTASourceEditor; var pwBuf: PWideChar): integer; overload;
function ReadFromIDE(const Editor: IOTASourceEditor): WideString; overload;
procedure WriteToIDE(const Editor: IOTASourceEditor; const pwBuf: PWideChar; const CharCount: integer = -1); overload;
procedure WriteToIDE(const Editor: IOTASourceEditor; const Text: WideString); overload;
function GetTextCursorPos(const pwBuf: PWideChar; const Col, Row: integer; var TrueCol: integer): integer; overload;
function GetTextCursorPos(const Text: WideString; const Col, Row: integer; var TrueCol: integer): integer; overload;

implementation

{procedure SaveToLog(FileName: string; Text: string);
var H: THandle;
  N: Cardinal;
begin
  H := CreateFile(PChar(FileName), GENERIC_WRITE, FILE_SHARE_READ, nil,
    CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);
  if (H = $FFFFFFFF) or (H = 0) then
    MessageBox(0, PChar('   ' + FileName + #13#10 + SysErrorMessage(GetLastError)), nil, 0);
  WriteFile(H, Text[1], Length(Text), N, nil);
  CloseHandle(H);
end;
procedure SaveStringToFile(S:WideString; FileName: String);
var Stream: TMemoryStream;
begin
  Stream := TMemoryStream.Create;
  try
    Stream.WriteBuffer(S[1], Length(S) * SizeOf(S[1]));
    Stream.SaveToFile(FileName);
  finally
    FreeAndNil(Stream);
  end;
end;}

//   
//  lciEditorReader.GetText     
// ,  Delphi 5

function ReaderGetText(const EditorReader: IOTAEditReader; Position: Longint; Buffer: PAnsiChar; Count: Longint):
  Longint;
begin
  FillChar(Buffer^, Count, 0);
  {$IFDEF DELPHI_2005_UP}
  result := 0;
  EditorReader.GetText(Position, Buffer, Count);
  while (result < Count) and (Buffer[result] <> #0) do
    inc(result);
  {$ELSE}
  Result := EditorReader.GetText(Position, Buffer, Count);
  {$ENDIF}
end;

//    .
//    Delphi 5

function EditorBufSize(const EditorReader: IOTAEditReader): integer;
var N: integer;
  P: PAnsiChar;
begin
  result := 0;
  GetMem(P, (BUF_SIZE + 2) * 2);
  try
    repeat
      N := ReaderGetText(EditorReader, result, P, BUF_SIZE);
      if N > 0 then inc(result, N);
    until (BUF_SIZE - N) > 0;
  finally
    FreeMem(P);
  end;
end;

//      
function ReadFromIDE(const Editor: IOTASourceEditor; var pwBuf: PWideChar): integer;
var
  EditorReader: IOTAEditReader;
  paBuf: PAnsiChar;
  ActualSize: integer;
  Size: integer;
  {$IFDEF DELPHI_2005_UP}
  Len, wSize: integer;
  {$ELSE}
  TmpStr: AnsiString;
  TmpWStr: WideString;
  {$ENDIF}
begin
  result := 0;
  ReallocMem(pwBuf, result);
  if Editor = nil then exit;
  EditorReader := Editor.CreateReader;
  if EditorReader = nil then Exit;
  paBuf := nil;
  {$IFDEF DELPHI_2005_UP}
  //    delphi2005  ,      ,
  // ..          
  //     ,    
  //       
  Size := EditorBufSize(EditorReader) + 2;
  wSize := Size * 2;
  {$ELSE}
  Size := BUF_SIZE; //BUF_SIZE = 10240; 10 kb   
  {$ENDIF}
  //  
  reallocmem(paBuf, Size);
  try
    try
      {$IFDEF DELPHI_2005_UP}
      //   BDS,       UTF8
      ActualSize := ReaderGetText(EditorReader, Result, paBuf, Size);
      ReallocMem(pwBuf, wSize);
      Len := Utf8ToUnicode(pwBuf, Size, paBuf, ActualSize);
      ReallocMem(pwBuf, (Len + 1) * 2);
      Result := Len;
      {$ELSE}
      repeat
        ActualSize := ReaderGetText(EditorReader, Result, paBuf, Size);
        ReallocMem(pwBuf, (Result + ActualSize + 1) * 2);
        SetString(TmpStr, paBuf, ActualSize);
        TmpWStr := TmpStr;
        Move(TmpWStr[1], pwBuf[Result], ActualSize * 2);
        inc(Result, ActualSize);
      until ActualSize < Size;
      {$ENDIF}
      pwBuf[Result] := #0;
      while (Result > 0) and (Ord(pwBuf[Result - 1]) in [13, 10]) do
      begin
        Dec(Result);
        pwBuf[Result] := #0;
      end;
    except
      ReallocMem(pwBuf, 0);
      raise;
    end;
  finally
    reallocmem(paBuf, 0);
  end;
end;

function ReadFromIDE(const Editor: IOTASourceEditor): WideString;
var pwBuf: PWideChar;
    CharCount: Integer;
begin
  pwBuf := nil;
  Result := '';
  try
    CharCount := ReadFromIDE(Editor, pwBuf);
    if CharCount > 0 then Result := pwBuf;
  finally
    ReallocMem(pwBuf, 0);
  end;
end;

procedure WriteToIDE(const Editor: IOTASourceEditor; const pwBuf: PWideChar; const CharCount: integer = -1);
var
  EditorWriter: IOTAEditWriter;
  Len: integer;
  {$IFDEF DELPHI_2005_UP}
  paBuf: PAnsiChar;
  Size: integer;
  {$ELSE}
  S: string;
  {$ENDIF}
begin
  if (Editor = nil) or (pwBuf = nil) or (CharCount = 0) then exit;
  if CharCount < 0 then
    Len := Length(pwBuf)
  else
    Len := CharCount;
  if Len = 0 then Exit;
  EditorWriter := Editor.CreateUndoableWriter;
  if EditorWriter = nil then exit;
  EditorWriter.DeleteTo(High(integer));
  {$IFDEF DELPHI_2005_UP}
  paBuf := nil;
  try
    Size := (Len + 2) * 6;
    reallocmem(paBuf, Size);
    fillchar(paBuf^, Size, 0);
    UnicodeToUtf8(paBuf, Size, pwBuf, Len);
    EditorWriter.Insert(paBuf);
  finally
    reallocmem(paBuf, 0);
  end;
  {$ELSE}
  SetString(S, pwBuf, Len);
  EditorWriter.Insert(pchar(S));
  {$ENDIF}
  EditorWriter := nil;
end;

procedure WriteToIDE(const Editor: IOTASourceEditor; const Text: WideString);
begin
  WriteToIDE(Editor, PWideChar(Text));
end;

function GetTextCursorPos(const pwBuf: PWideChar; const Col, Row: integer; var TrueCol: integer): integer;
var I, Ofs, X, C, N: integer;
  paBuf: array[0..15] of AnsiChar;
begin
  result := -1;
  TrueCol := -1;
  I := 0;
  Ofs := 0;
  X := 0;
  FillChar(paBuf, SizeOf(paBuf), 0);

  while (I < Row) and (X >= 0) do begin
    X := FindEOS(pwBuf, Ofs);
    inc(I);
  end;
  if X >= 0 then begin
    if I > 0 then
      X := Ofs
    else
      X := 0;
    TrueCol := 0;
    C := 0;
    while (C <= Col) and (not (Ord(pwBuf[X]) in [13, 10, 0])) do begin
      //     Utf8
      {$IFDEF DELPHI_2005_UP}
      N := UnicodeToUtf8(@paBuf, SizeOf(paBuf), @pwBuf[X], 1) - 1;
      {$ELSE}
      N := 1;
      {$ENDIF}
      inc(C, N);
      inc(X);
      inc(TrueCol);
    end;
    Result := X - 1;
    if (Ord(pwBuf[X]) in [13, 10, 0]) and (Col >= C) then begin
      inc(TrueCol, Col - C + 1);
      inc(result);
    end;
    Dec(TrueCol);
    //MessageBox(0, PChar(Format('Col: %d; Row: %d; TrueCol: %d; Result: %d.', [Col, Row, TrueCol, Result])),nil, 0);
  end;
end;

function GetTextCursorPos(const Text: WideString; const Col, Row: integer; var TrueCol: integer): integer;
begin
  result := GetTextCursorPos(PWideChar(Text), Col, Row, TrueCol);
end;

end.
