unit ufImageIndex;
(*
 * Module:           
 *              TImageIndex
 * Version:    2.9 (01.07.2010)
 * Author:      
 * Comments:    y     .
 *             http://roschinspb.narod.ru
 *             http://www.delphikingdom.com/asp/users.asp?ID=1271
 *
 * Copyright:   2010 .
 *)
interface

{$I Directives.inc}

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ImgList,
  GraphUtilEx,
  {$IFDEF VER130}{$ELSE}GraphUtil,{$ENDIF} //  5   GraphUtil
  BitOp,
  StdCtrls,
  Mask,
  SpeedButtonCep,
  uBaseForm,
  ActnList,
  ImageListCep,
  ExtCtrls;

type
  TMaskEdit = class(Mask.TMaskEdit)
  private
    procedure CNKeyDown(var Message: TWMKeyDown); message CN_KEYDOWN;
  end;

  TfrmImageIndex = class(TBaseForm)
    IndexEdit: TMaskEdit;
    procedure IndexEditChange(Sender: TObject);
    procedure actDefaultUpdate(Sender: TObject);
    procedure actDefaultExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure IndexEditKeyPress(Sender: TObject; var Key: Char);
  private
    fInternalImageList: TImageList;
    FImageChangeLink: TChangeLink;
    fImageIndex: Integer;
    fOldImageIndex: Integer;
    fScroll: TScrollingWinControl;
    fMargin: integer;
    fonChange: TNotifyEvent;
    fImageListHandle: THandle;
    fInSetHandle: boolean;
    function GetImageList: TCustomImageList;
    procedure SetImageList(const Value: TCustomImageList);
    procedure SetImageIndex(const Value: Integer);
    procedure SetMargin(const Value: integer);
    procedure CMMouseWheel(var Message: TCMMouseWheel); message CM_MOUSEWHEEL;
    procedure SetImageListHandle(const Value: THandle);
    procedure CMDialogKey(var Message: TCMDialogKey); message CM_DIALOGKEY;
  protected
    procedure ImageListChange(Sender: TObject); virtual;
    procedure DoUpdate; virtual;
    procedure Resizing(State: TWindowState); override;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure DoShow; override;
    property Margin: integer read fMargin write SetMargin;
    //  
    property ImageList: TCustomImageList read GetImageList write SetImageList;
    property ImageIndex: Integer read fImageIndex write SetImageIndex;
    property ImageListHandle: THandle read fImageListHandle write SetImageListHandle;

    property onChange: TNotifyEvent read fonChange write fonChange;
  end;

implementation
uses Commctrl;

{$R *.DFM}

type
  TScrollingWinControlEx = class(Forms.TScrollingWinControl)
  private
    fImg: TRichImageList;
    fHotIndex: Integer;
    fColCount: integer;
    fRowCount: integer;
    fRange: integer;
    fImgHandle: integer;
    fW: integer;
    fH: integer;
    fN: integer;
    procedure WMEraseBkgnd(var Message: TWmEraseBkgnd); message WM_ERASEBKGND;
    procedure WMHScroll(var Message: TWMHScroll); message WM_HSCROLL;
    procedure WMVScroll(var Message: TWMVScroll); message WM_VSCROLL;
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
    procedure CMMouseWheel(var Message: TCMMouseWheel); message CM_MOUSEWHEEL;
    procedure SetHotIndex(const Value: Integer);
    function IndexByCoord(X, Y: integer): integer;
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure Resizing(State: TWindowState); override;
    procedure SetParent(AParent: TWinControl); override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure Click; override;
    procedure DblClick; override;
    function DrawImg(Sender: TRichImageList; Bitmap: TBitmap; ARect: TRect): boolean;
  public
    procedure UpdateRange;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property HotIndex: Integer read fHotIndex write SetHotIndex;
  end;

  { TScrollingWinControlEx }

procedure TScrollingWinControlEx.Click;
begin
  inherited;
  if (Owner is TfrmImageIndex) and (HotIndex >= 0) then
  begin
    if HotIndex = fN then
      TfrmImageIndex(Owner).ImageIndex := -1
    else
      TfrmImageIndex(Owner).ImageIndex := HotIndex;
  end;
end;

procedure TScrollingWinControlEx.DblClick;
begin
  inherited;
  if (Owner is TfrmImageIndex) and (HotIndex >= 0) then
  begin
    TfrmImageIndex(Owner).ActDefault.Update;
    if TfrmImageIndex(Owner).ActDefault.Enabled then
      TfrmImageIndex(Owner).ActDefault.Execute;
  end;
end;

procedure TScrollingWinControlEx.CMMouseLeave(var Message: TMessage);
begin
  HotIndex := -1;
  fImg.Pushed := False;
  inherited;
end;

procedure TScrollingWinControlEx.CMMouseWheel(var Message: TCMMouseWheel);
begin
  if VertScrollBar.Range > Height then
  begin
    if Message.WheelDelta < 0 then
      VertScrollBar.Position := VertScrollBar.Position + fH;
    if Message.WheelDelta > 0 then
      VertScrollBar.Position := VertScrollBar.Position - fH;
  end;
  Message.Result := 1;
end;

constructor TScrollingWinControlEx.Create(AOwner: TComponent);
begin
  inherited;
  fHotIndex := -1;
  fIMG := TRichImageList.Create;
  fIMG.Adjusted := True;
  fIMG.Border := CepXPBorder;
  fIMG.ThemeEnabled := True;
  fIMG.Transparent := False;
  fIMG.Enabled := True;
  fIMG.OnDrawImage := DrawImg;
  ctl3d := False;
end;

destructor TScrollingWinControlEx.Destroy;
begin
  FreeAndNil(fImg);
  inherited;
end;

function TScrollingWinControlEx.DrawImg(Sender: TRichImageList;
  Bitmap: TBitmap; ARect: TRect): boolean;
const D = 4;

begin
  Result := True;
  if (Sender <> nil) and (Sender.ImageList <> nil) then
  begin
    if Sender.Index = Sender.ImageList.Count then
    begin
      Bitmap.Canvas.Pen.Color := clWindowText;
      Bitmap.Canvas.Pen.Width := 2;
      Bitmap.Canvas.MoveTo(Bitmap.Width - D - 1, D - 1);
      Bitmap.Canvas.LineTo(D - 1, Bitmap.Height - D - 1);
      Bitmap.Canvas.MoveTo(D - 1, D - 1);
      Bitmap.Canvas.LineTo(Bitmap.Width - D - 1, Bitmap.Height - D - 1);
      Result := True;
    end;
  end;
end;

function TScrollingWinControlEx.IndexByCoord(X, Y: integer): integer;
begin
  result := -1;
  if (fIMG <> nil) and (fImg.ImageList <> nil) and (Owner is TfrmImageIndex) then
  begin
    UpdateRange;
    if (fW > 0) and (fH > 0) then
    begin
      X := (X + HorzScrollBar.Position);
      Y := (Y + VertScrollBar.Position);
      if (X < fColCount * fW) and (Y < fRowCount * fH) then
      begin
        result := (X div fW) +
          (Y div fH) * fColCount;
        if Result > fN then Result := -1;
      end;
    end;
  end;
end;

procedure TScrollingWinControlEx.MouseDown(Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  if (Button = mbLeft) and (IndexByCoord(X, Y) >= 0) then
  begin
    fImg.Pushed := true;
    Invalidate;
  end;
end;

procedure TScrollingWinControlEx.MouseMove(Shift: TShiftState; X,
  Y: Integer);
begin
  inherited;
  HotIndex := IndexByCoord(X, Y);
end;

procedure TScrollingWinControlEx.MouseUp(Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  if (Button = mbLeft) and fImg.Pushed then
  begin
    fImg.Pushed := False;
    Invalidate;
  end;
end;

procedure TScrollingWinControlEx.Resizing(State: TWindowState);
begin
  inherited;
  UpdateRange;
  Invalidate;
end;

procedure TScrollingWinControlEx.SetHotIndex(const Value: Integer);
begin
  if fHotIndex <> Value then
  begin
    fHotIndex := Value;
    Invalidate;
  end;
end;

procedure TScrollingWinControlEx.SetParent(AParent: TWinControl);
begin
  inherited;
  if AParent <> nil then
    UpdateRange;
end;

procedure TScrollingWinControlEx.UpdateRange;
var Top, BevelWidth: integer;
  RangeChanged: boolean;
  procedure UpdateRange(Width: integer);
  begin
    if fW > 0 then
    begin
      fColCount := Width div fW;
      if fColCount < 1 then fColCount := 1;
    end;
    fRowCount := (fN + fColCount) div (fColCount);
    fRange := fRowCount * fH;
  end;
begin
  fColCount := 1;
  fRowCount := 1;
  if (fImg = nil) or
    (fImg.ImageList = nil) or
    (not (Owner is TfrmImageIndex)) then
  begin
    fImgHandle := 0;
    fN := 0;
    fW := 0;
    fH := 0;
    fRange := 0;
    Exit;
  end;
  fImgHandle := fImg.ImageList.Handle;
  ImageList_GetIconSize(fImgHandle, fW, fH);
  fN := ImageList_GetImageCount(fImgHandle);
  fW := fW + 2 * TfrmImageIndex(Owner).Margin;
  fH := fH + 2 * TfrmImageIndex(Owner).Margin;
  Top := VertScrollBar.Position;
  if (fW > 0) and (fN >= 0) then
  begin
    BevelWidth := Height - ClientHeight;
    UpdateRange(Width - BevelWidth);
    if fRange > Height - BevelWidth then
      UpdateRange(Width - GetSystemMetrics(SM_CXVSCROLL) - BevelWidth);
    RangeChanged := VertScrollBar.Range <> fRange;
    if RangeChanged then
    begin
      if Top + Height > VertScrollBar.Range then
        Top := VertScrollBar.Range - Height;
      if Top < 0 then Top := 0;
    end;
  end
  else
  begin
    fRange := 0;
    RangeChanged := VertScrollBar.Range <> fRange;
    Top := 0;
  end;
  if RangeChanged then
  begin
    VertScrollBar.Range := fRange;
    VertScrollBar.Position := Top;
    Invalidate;
  end;
end;

procedure TScrollingWinControlEx.WMEraseBkgnd(var Message: TWmEraseBkgnd);
var DC: HDC;
  ImgHandle: THandle;
  I, W, H, N, X, Y, D: integer;
  Brush: HBrush;
  Canvas: TCanvas;
begin
  if Message.DC <> 0 then
    DC := Message.DC
  else
  begin
    DC := GetWindowDC(Handle);
  end;
  try
    if (Owner is TfrmImageIndex) and (fImg <> nil) and (fImg.ImageList <> nil) then
    begin
      Canvas := TCanvas.Create;
      try
        Canvas.Handle := DC;
        D := TfrmImageIndex(Owner).Margin;
        ImgHandle := fImg.ImageList.Handle;
        ImageList_GetIconSize(ImgHandle, W, H);
        N := ImageList_GetImageCount(ImgHandle);
        fIMG.Width := W + 2 * D;
        fIMG.Height := H + 2 * D;
        fIMG.BkColor := Color;

        X := -HorzScrollBar.Position;
        Y := -VertScrollBar.Position;
        for I := 0 to N do
        begin
          fIMG.Index := I;
          fIMG.Hot := (I = HotIndex);
          fIMG.Checked := (I = TfrmImageIndex(Owner).ImageIndex) or
            ((I = N) and (TfrmImageIndex(Owner).ImageIndex = -1));
          if fIMG.Checked then
          begin
            fIMG.SelectedColor := GetHighLightColor(clHighlight);
            fIMG.BorderColor := clHighlight;
          end
          else if fIMG.Hot then
          begin
            fIMG.SelectedColor := clNone;
            fIMG.BorderColor := clNone;
          end;
          if (Y + fIMG.Height >= 0) and (Y < Height) then
          begin
            Canvas.Draw(X, Y, fIMG);
            windows.ExcludeClipRect(DC, X, Y, X + fIMG.Width, Y + fIMG.Height);
          end;
          inc(X, fIMG.Width);
          if X + fIMG.Width > ClientWidth then
          begin
            inc(Y, fIMG.Height);
            X := -HorzScrollBar.Position;
          end;
        end;
      finally
        Canvas.Handle := 0;
        FreeAndNil(Canvas);
      end;
    end;
    Brush := CreateSolidBrush(ColorToRGB(Color));
    try
      windows.FillRect(DC, Rect(0, 0, Width, ClientHeight), Brush);
    finally
      DeleteObject(Brush);
    end;
  finally
    if Message.DC = 0 then
      ReleaseDC(Handle, DC);
    Message.Result := 1;
  end;
end;

procedure TScrollingWinControlEx.WMHScroll(var Message: TWMHScroll);
begin
  inherited;
  invalidate;
end;

procedure TScrollingWinControlEx.WMVScroll(var Message: TWMVScroll);
begin
  inherited;
  invalidate;
end;

procedure TScrollingWinControlEx.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.ExStyle := Params.ExStyle + WS_EX_CLIENTEDGE;
end;

{ TfrmImageIndex }

constructor TfrmImageIndex.Create(AOwner: TComponent);
begin
  inherited;
  DoubleBuffered := True;
  BorderWidth := 2;
  Constraints.MinWidth := 243;
  Constraints.MinHeight := 128;
  Width := 337;
  Height := 288;
  fMargin := 3;
  FImageChangeLink := TChangeLink.Create;
  FImageChangeLink.OnChange := ImageListChange;
  fScroll := TScrollingWinControlEx.Create(self);
  fScroll.Align := alNone;
  fScroll.Left := 0;
  fScroll.Top := 0;
  fScroll.Height := ClientHeight - (ImageList1.Height + 4 + fMargin);
  fScroll.Width := ClientWidth;
  fScroll.VertScrollBar.Visible := True;
  fScroll.VertScrollBar.Style := ssRegular;
  fScroll.VertScrollBar.Smooth := True;
  fScroll.VertScrollBar.Range := 0;
  fScroll.VertScrollBar.Tracking := True;
  fScroll.Anchors := [akLeft, akTop, akRight, akBottom];
  fScroll.Parent := self;

  ImageIndex := -1;
end;

destructor TfrmImageIndex.Destroy;
begin
  FreeAndNil(FImageChangeLink);
  FreeAndNil(fInternalImageList);
  inherited;
end;

procedure TfrmImageIndex.DoUpdate;
begin
  if fScroll is TScrollingWinControlEx then
  begin
    fScroll.Invalidate;
    TScrollingWinControlEx(fScroll).UpdateRange;
    fScroll.Invalidate;
  end;
  Invalidate;
end;

procedure TfrmImageIndex.ImageListChange(Sender: TObject);
begin
  if Sender = ImageList then
  begin
    DoUpdate;
  end;
end;

procedure TfrmImageIndex.SetImageList(const Value: TCustomImageList);
begin
  if ImageList <> Value then
  begin
    if ImageList <> nil then
    begin
      ImageList.UnRegisterChanges(FImageChangeLink);
      ImageList.RemoveFreeNotification(self);
    end;
    TScrollingWinControlEx(fScroll).fImg.ImageList := Value;
    TScrollingWinControlEx(fScroll).UpdateRange;
    if ImageList <> nil then
    begin
      ImageList.FreeNotification(Self);
      ImageList.RegisterChanges(FImageChangeLink);
    end;
    if (not fInSetHandle) and (ImageList <> fInternalImageList) then
    begin
      ImageListHandle := 0;
    end;
    DoUpdate;
  end;
end;

function TfrmImageIndex.GetImageList: TCustomImageList;
begin
  result := nil;
  if (fScroll is TScrollingWinControlEx) and
    (TScrollingWinControlEx(fScroll).fImg <> nil) then
    result := TScrollingWinControlEx(fScroll).fImg.ImageList;
end;

procedure TfrmImageIndex.SetImageIndex(const Value: Integer);
begin
  if fImageIndex <> Value then
  begin
    fImageIndex := Value;
    DoUpdate;
    if @IndexEdit.OnChange <> nil then
    begin
      IndexEdit.Text := Inttostr(fImageIndex);
      IndexEdit.SelectAll;
    end;
    if @onChange <> nil then onChange(self);
  end;
end;

procedure TfrmImageIndex.Resizing(State: TWindowState);
begin
  inherited;
  DoUpdate;
end;

procedure TfrmImageIndex.SetMargin(const Value: integer);
begin
  if fMargin <> Value then
  begin
    fMargin := Value;
    fScroll.Invalidate;
    Invalidate;
  end;
end;

procedure TfrmImageIndex.CMMouseWheel(var Message: TCMMouseWheel);
begin
  fScroll.Perform(Message.Msg, TMessage(Message).WParam, TMessage(Message).LParam);
  Message.Result := 1;
end;

procedure TfrmImageIndex.IndexEditChange(Sender: TObject);
var I, Code: integer;
begin
  IndexEdit.OnChange := nil;
  try
    Val(IndexEdit.Text, I, Code);
    if Code > 0 then
      I := -2
    else
    begin
      if (I < -1) then I := -2;
    end;
    ImageIndex := I;
  finally
    IndexEdit.OnChange := IndexEditChange;
  end;
end;

procedure TfrmImageIndex.actDefaultUpdate(Sender: TObject);
begin
  inherited;
  if Sender is TAction then
  begin
    TAction(Sender).Enabled := ImageIndex >= -1;
  end;
end;

procedure TfrmImageIndex.actDefaultExecute(Sender: TObject);
begin
  fOldImageIndex := ImageIndex;
  inherited;
  if fsModal in FormState then Close;
  ModalResult := IdOk;
end;

procedure TfrmImageIndex.FormShow(Sender: TObject);
begin
  fOldImageIndex := ImageIndex;
  {$IFDEF VER130}
  onShow := nil;
  try
    DoShow;
  finally
    onShow := FormShow;
  end;
  {$ENDIF}
end;

procedure TfrmImageIndex.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  ImageIndex := fOldImageIndex;
  inherited;
end;

procedure TfrmImageIndex.IndexEditKeyPress(Sender: TObject; var Key: Char);
begin
  if ((Key < '0') or (Key > '9')) and (Key <> #8) and (Key <> '-') then
  begin
    Key := #0;
    MessageBeep(0);
  end;
end;

procedure TfrmImageIndex.SetImageListHandle(const Value: THandle);
var I, W, H, N: integer;
  B: TBitmap;
begin
  if fImageListHandle <> Value then
  begin
    fInSetHandle := True;
    try
      if Value = 0 then
      begin
        if ImageList = fInternalImageList then
        begin
          ImageList := nil;
          FreeAndNil(fInternalImageList);
          ClearHasButtonBitmap;
        end;
      end
      else
      begin
        ImageList := nil;
        if fInternalImageList = nil then
          fInternalImageList := TImageList.Create(self);
        fInternalImageList.Clear;
        ClearHasButtonBitmap;
        ImageList_GetIconSize(Value, W, H);
        N := ImageList_GetImageCount(Value);
        fInternalImageList.Width := W;
        fInternalImageList.Height := H;
        if N > 0 then
        begin
          B := TBitmap.Create;
          try
            {$IFDEF DELPHI_2005_UP}
            B.SetSize(W, H);
            {$ELSE}
            B.Width := W;
            B.Height := H;
            {$ENDIF}
            B.Canvas.Brush.Color := $00FF00FF;
            for I := 0 to N - 1 do
            begin
              ImageList_DrawEx(Value, i, B.Canvas.Handle, 0, 0, W, H, $00FF00FF, CLR_DEFAULT, ILD_Normal);
              fInternalImageList.AddMasked(B, $00FF00FF);
            end;
          finally
            FreeAndNil(B);
          end;
        end;
        ImageList := fInternalImageList;
      end;
      fImageListHandle := Value;
      DoUpdate;
    finally
      fInSetHandle := False;
    end;
  end;
end;

procedure TfrmImageIndex.DoShow;
var D: integer;
begin
  inherited;
  D := ImageList1.Height + 4;
  SpeedButton1.Top := fScroll.Top + fScroll.Height + fMargin;
  SpeedButton2.Top := SpeedButton1.Top;

  SpeedButton2.Left := ClientWidth - D;
  SpeedButton2.Height := D;
  SpeedButton2.Width := D;

  SpeedButton1.Left := SpeedButton2.Left - fMargin - D;

  SpeedButton1.Height := D;
  SpeedButton1.Width := D;

  SpeedButton1.Anchors := [akRight, akBottom];
  SpeedButton2.Anchors := [akRight, akBottom];

  SpeedButton1.Border := CepXPBorder;
  SpeedButton2.Border := CepXPBorder;

  IndexEdit.Top := SpeedButton1.Top + (SpeedButton1.Height - IndexEdit.Height) div (2);
  IndexEdit.Left := fMargin;
end;

procedure TfrmImageIndex.CMDialogKey(var Message: TCMDialogKey);
begin
  if GetKeyState(VK_MENU) >= 0 then
    with Message do
      case CharCode of
        VK_UP: if ImageList <> nil then
          begin
            if ImageIndex = -1 then
              ImageIndex := ImageList.Count - 1
            else if ImageIndex > 0 then
              ImageIndex := ImageIndex - 1;
            Result := 1;
            Exit;
          end;
        VK_DOWN: if ImageList <> nil then
          begin
            if ImageIndex = ImageList.Count - 1 then
              ImageIndex := -1
            else if (ImageIndex < ImageList.Count) then
              ImageIndex := ImageIndex + 1;
            Result := 1;
            Exit;
          end;
      end;
  inherited;
end;

procedure TfrmImageIndex.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited;
  if (not (csDestroying in ComponentState)) and (Operation = opRemove) and (AComponent = ImageList) then
  begin
    ImageList := nil;
  end;
end;

{ TMaskEdit }

procedure TMaskEdit.CNKeyDown(var Message: TWMKeyDown);
begin
  if (GetKeyState(VK_MENU) >= 0) and (Owner is TfrmImageIndex) then
    with Message, TfrmImageIndex(Owner) do
      case CharCode of
        VK_UP: if ImageList <> nil then
          begin
            if ImageIndex = -1 then
              ImageIndex := ImageList.Count - 1
            else if ImageIndex > 0 then
              ImageIndex := ImageIndex - 1;
            Result := 1;
            Exit;
          end;
        VK_DOWN: if ImageList <> nil then
          begin
            if ImageIndex = ImageList.Count - 1 then
              ImageIndex := -1
            else if (ImageIndex < ImageList.Count) then
              ImageIndex := ImageIndex + 1;
            Result := 1;
            Exit;
          end;
      end;
  inherited;
end;

end.
